angular.module('globalVMSettingsModule', ['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])
    .controller('globalVMSettingsCtrl', ['$scope', '$rootScope', '$http','ngDialog', function($scope, $rootScope, $http, ngDialog) {


        $scope.applianceList=[];
        $scope.selectedSystem;
        $scope.overwrite = false;

        $scope.form = $();

        $scope.validateForm = function(form) {
            form.validate({
                rules: {
                    id_system: {
                        required: true
                    }
                },
                messages: {
                    id_system: {
                        required: gettext("Please select an appliance.")
                    }
                }
            })
        };

        $scope.saveGlobalVMSettings = function() {
            //if ($scope.form.valid()) {
                var url = "/api/quiesce/?sid=" + $scope.selectedSystem.system_id;
                var load = PHD.showLoadingIndicator("body", true, "Saving Settings");
                var obj = {};
                obj.quiesce_setting = $scope.quiesceSetting;
                obj.overwrite = $scope.overwrite;
                obj = JSON.stringify(obj);
                var resp = PHD.Ajax.put(url, obj, load, handleError);
                resp.done(function(data) {
                    if ($scope.overwrite) {
                        // If the user is overwriting settings of existing VMs, we need to reload assets.
                        $(document).trigger("assetChange");
                    }
                    $scope.closeThisDialog();
                });
            //}
        };

        function handleError(jqXHR, textStatus, errorThrown) {
            if (jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                    var message = data.result[0].message;
                    ngDialog.open({
                        dialogType: 'Error',
                        modelDialogId: 'global-vm-settings-error-dialog',
                        scope: $scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick: 'onConfirmError()'
                    });
                }
            } else {
                PHD.ajaxError(jqXHR, textStatus, errorThrown);
            }
        }

        $scope.changeSystem = function(){
            $scope.quiesceSetting = $scope.selectedSystem.quiesce_setting;
            switch ( $scope.quiesceSetting ) {
                case QUIESCE_SETTING_DISPLAY_NAME_APPLICATION_CONSISTENT:
                    $('#quiesce_app_consistent_radioselection').prop('checked','true');
                    break;
                case QUIESCE_SETTING_DISPLAY_NAME_CRASH_CONSISTENT:
                    $('#quiesce_crash_consistent_radioselection').prop('checked','true');
                    break;
            }
        };

        $scope.onConfirmError = function () {
            ngDialog.close('global-vm-settings-error-dialog');
        };

        $scope.closeGlobalVMSettingsDialog = function() {
            ngDialog.close("globalVMSettingsDialog");
        };

        $scope.getGlobalQuiesceSetting = function () {
            var url = "/api/quiesce/global/";
            var load = PHD.showLoadingIndicator("body", true, "Loading Settings");
            var resp = PHD.Ajax.get(url, load, handleError);
            resp.done(function(data) {
                $scope.applianceList = data.quiesce_settings;
                $scope.selectedSystem = $scope.applianceList[0];
                $scope.changeSystem();
                $scope.$apply($scope.applianceList);
            });
        };

        $scope.processDialog = function() {
            $scope.form = angular.element("#global-vm-settings-form");
            $scope.validateForm($scope.form);

            // Load current Quiesce settings.
            $scope.getGlobalQuiesceSetting();

            $scope.form.find(".definition").popover({
                appendTo: $scope.form
            });
        };

        // use instead of ngDialog load event.
        angular.element(document).ready(function () {
            $scope.processDialog();
        });

		
		$scope.showToolTipForQuiesceSettings = function(){
			console.log("in function:::");
            var form = angular.element("#global-vm-settings-form");
			console.log(form);
            form.find(".definition").popover({
                appendTo: form
            });
        };
		
		$scope.$on('ngDialog.opened', function() {
            $scope.showToolTipForQuiesceSettings();
        }); 
    }]);