angular.module('license-resource-module', ['ngDialog', 'ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','ngGrid','ui.grid.selection'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])
    .filter('show_limit', function() {
        return function (limit) {
            return (limit == -1) ? "Unlimited" : limit;
        }
    })
    .controller('licenseResourceCtrl', ['$scope', '$rootScope', '$http','ngDialog', '$window', '$timeout', '$compile', 'uiGridConstants',
        function($scope, $rootScope, $http, ngDialog, $window, $timeout, $compile, uiGridConstants) {

            $scope.resourceData = [];

            $scope.closeThisDialog = function() {
                // closing the wizard clears errors and state.
                $scope.PHD.currentMiniWizard.wizard("close");
            };

            $scope.resourcesGridData = {
                multiSelect: false,
                rowHeight: 30,
                gridMenuShowHideColumns:false,
                enableColumnMenus:false,
                enableHorizontalScrollbar: 0,
                data: []
            };

            var nameTemplate = '<div class="ui-grid-cell-contents" style="text-transform:capitalize">{{ row.entity.name }}</div>';

            var limitTemplate = '<div class="ui-grid-cell-contents">{{ row.entity.limit | show_limit }}</div>';

            $scope.resourcesGridData.columnDefs = [
                {
                    field: "name",
                    displayName: "Resource",
                    sortable : true,
                    sortingType : "string",
                    cellTemplate: nameTemplate,
                    sort: {
                        direction: uiGridConstants.ASC,
                        priority: 0
                    }
                },
                {
                    field: "limit",
                    displayName: "Limit",
                    sortable : true,
                    cellTemplate: limitTemplate,
                    sortingType : "string"
                },
                {
                    field: "usage",
                    displayName: "Usage",
                    sortable : true,
                    sortingType : "number"
                }
            ];

            $scope.loadResources = function() {
                $timeout(function() {
                    /*
                    "resources": {
                        "limits": {
                            "applications": -1,
                            "servers": -1,
                            "sockets": -1,
                            "vms": -1,
                            "workstations": -1
                        },
                        "usage": {
                            "applications": 1,
                            "servers": 2,
                            "sockets": 1,
                            "vms": 4,
                            "workstations": 1
                        }
                    },
                     */
                    var resources = $scope.resources;
                    var limits = resources.limits;
                    var usage = resources.usage;
                    $scope.resourceData = [];
                    for (var area in limits) {
                        var obj = {};
                        if (limits.hasOwnProperty(area)) {
                            obj.name = area;
                            obj.limit = limits[area];
                            obj.usage = usage[area];
                            $scope.resourceData.push(obj);
                        }
                    }
                    $scope.resourcesGridData.data = $scope.resourceData;
                });
            };

            // use instead of ngDialog load event.
            angular.element(document).ready(function () {
                $scope.loadResources();
            });


        }]);