editApplianceApp.controller('EmailCtrl', ['$scope', '$rootScope', '$http', '$analytics', 'gettextCatalog',
    function($scope, $rootScope, $http, $analytics, gettextCatalog) {

        function processEmailTab(PHD, window, $rootScope, $scope, $analytics) {

            var $form = $("#email-edit-form"),
                EmailForm,
                $required = $("#id_server_requires_credentials"),
                $credentials = $("#id_email_host_user, #id_email_host_password"),
                $btnTest = $(".btn-test-email"),
                $emailTest = $(".test-email"),
                $sendEmail = $("#id_send_email"),
                $btnTestCancel = $emailTest.find(".btn-test-email-cancel"),
                $btnTestSend = $emailTest.find(".btn-test-email-send"),
                EmailTable,
                isrepeat = (typeof(isrepeat) != 'undefined') ? isrepeat : false;

            function handleCreds() {
                $credentials.prop("disabled", !$required.prop("checked"));
            }

            function handleTest() {
                $btnTest.hide({
                    effect: "fade",
                    duration: "fast",
                    complete: function () {
                        $emailTest.show({effect: "slide", direction: "left", duration: "fast"});
                    }
                });
            }

            function handleCancel() {
                $emailTest.hide({
                    effect: "slide",
                    direction: "left",
                    duration: "fast",
                    complete: function () {
                        $btnTest.show({effect: "fade", duration: "fast"});
                    }
                });
            }

            function handleSend() {

                var url = "/api/mail-config/";
                var sid = (PHD.appliance_sid === null) ? "" : "?sid=" + PHD.appliance_sid;
                url += sid;
                var load = PHD.showLoadingIndicator("body", true, "Sending Test E-Mail...");

                if ($form.valid()) {
                    var submitData = form2js($form.attr("id"), '.', false);
                    var backendData = {};

                    if (submitData.smtp != undefined && submitData.smtp != null && submitData.smtp != '') {
                        backendData.smtp = submitData.smtp;
                    }
                    if (submitData.test_mail != undefined && submitData.test_mail != null && submitData.test_mail != '') {
                        backendData.test_mail = submitData.test_mail;
                    }
                    if (submitData.authinfo != undefined && submitData.authinfo != null && submitData.authinfo) {
                        backendData.authinfo = true;
                        backendData.user = submitData.user;
                        backendData.password = submitData.password;
                    }
                    /*
                     Do not send down these fields on a test.
                     backendData.schedule = "";
                     backendData.bp = "";
                     backendData.failure = "";
                     */
                    backendData = JSON.stringify(backendData);

                    //  console.log("submitData is " + backendData);

                    var resp = PHD.Ajax.put(url, backendData, load);

                    resp.done(function (data, textStatus, jqXHR) {
                        //PHD.alert("Test Email Successfully Sent.");
                        handleCancel();
                    });
                }
            }

            /*function handleEncryption() {
             var val = parseInt($encryption.val(), 10);
             $port.val(ports[val]);
             }

             function handlePort() {
             if($port.val() === "") {
             handleEncryption();
             }
             }*/

            function initForm() {

                $required.on("change", handleCreds).trigger("change");

                $btnTest.on("click", handleTest);
                $btnTestCancel.on("click", handleCancel);
                $btnTestSend.on("click", handleSend);
                //$encryption.on("change", handleEncryption);
                //$port.on("focus", handlePort);

                $sendEmail.on("change", function(evt) {
                    if($sendEmail.is(':checked')) {
                        $("#id_email_host").prop('disabled', $("#id_email_host").prop("checked"));
                    } else {
                        $("#id_email_host").prop('disabled', !$("#id_email_host").prop("checked"));
                    }
                });

                EmailForm = PHD.FormController($form, {})
                    .validate({
                        errorLabelContainer: ".email-dialog-error-list",
                        errorContainer: ".email-dialog-errors",
                        showErrors: function (errorMap, errorList) {
                            $(".email-dialog-errors").find(".summary")
                                .html(gettext("Correct the following errors:"));
                            this.defaultShowErrors();
                        },
                        rules: {
                            smtp: {
                                required: true
                            },

                            email_host: {
                                required: true
                            },
                            test_email: {
                                required: true,
                                email: true
                            },
                            email_host_user: {
                                required: "#id_server_requires_credentials:checked"
                            },
                            email_host_password: {
                                required: "#id_server_requires_credentials:checked"
                            }
                        },
                        messages: {
                            smtp: {
                                required: gettext("SMTP server is required")
                            },
                            email_host: {
                                required: gettext("SMTP server host is required")
                            },
                            test_email: {
                                required: gettext("Please enter test email recipient's email address"),
                                email: gettext("Please enter a valid email address")
                            },
                            email_host_user: {
                                required: gettext("Please enter your username")
                            },
                            email_host_password: {
                                required: gettext("Please enter your password")
                            }
                        }
                    })
                    .on("formcancel", function (event) {
                        PHD.currentDialog.wizard("close");
                    })
                    .on("formsubmit", function (event, data) {
                        console.log("Form submit: Data = " + JSON.stringify(data));
                        PHD.currentDialog.wizard("close");
                        /*if(data.result[0].code === AJAX_RESULT_SUCCESS) {
                         var formdata = {
                         "email_host": $form.find("[name=email_host]").val(),
                         "email_port": $form.find("[name=email_port]").val(),
                         "email_encryption": $form.find("[name=email_encryption] :selected").text(),
                         "send_email": $form.find("[name=send_email]").prop("checked")
                         };
                         //$(document).trigger("emailformsave", [formdata]);

                         PHD.currentDialog.wizard("close");
                         } else if(data.result[0].code === AJAX_RESULT_ERROR) {
                         PHD.throwError(data);
                         }*/
                    });

                EmailTable = PHD.EmailTable($form);
                EmailTable.$table.scrollTable({"height": 100, "resize": false});
                EmailTable.$table.on("emailtabledelete", function () {
                    EmailTable.$table.scrollTable({"height": 100, "resize": false});
                });

                EmailForm.submit = function () {
                    var self = this,
                        load = PHD.showLoadingIndicator("body", true, "Saving Mail Configuration...");

                    this.$buttons.blur().disable();

                    var submitData = form2js($form.attr("id"), '.', false);
                    //    console.log("in submit, submitData = " + JSON.stringify(submitData));
                    var backendData = {};


                    if (!backAuthInfo || submitData.user != backUser || submitData.smtp != backSmtp || submitData.password != "") {
                        if (submitData.smtp != undefined && submitData.smtp != null && submitData.smtp != '') {
                            backendData.smtp = submitData.smtp;
                        }
                    }
                    if (submitData.test_mail != undefined && submitData.test_mail != null && submitData.test_mail != '') {
                        backendData.test_mail = submitData.test_mail;
                    }

                    console.log(submitData.smtp != backSmtp);

                    if (!backAuthInfo || submitData.user != backUser || submitData.password != "") {
                        if (submitData.authinfo != undefined && submitData.authinfo != null && submitData.authinfo) {
                            backendData.authinfo = true;
                            backendData.user = submitData.user;
                            backendData.password = submitData.password;
                        }
                    }

                    backendData.schedule = "";
                    backendData.bp = "";
                    backendData.failure = "";
                    var i;
                    if (submitData.mail !== undefined) {
                        for (i = 0; i < submitData.mail.length; i++) {
                            var obj = submitData.mail[i];
                            if (obj.email != '') {
                                if (obj.jobs === true) {
                                    backendData.schedule = (backendData.schedule === "") ? obj.email : (backendData.schedule + " " + obj.email);
                                }
                                if (obj.system === true) {
                                    backendData.bp = (backendData.bp === "") ? obj.email : (backendData.bp + " " + obj.email);
                                }
                                if (obj.failures === true) {
                                    backendData.failure = (backendData.failure === "") ? obj.email : (backendData.failure + " " + obj.email);
                                }
                            }
                        }
                    }
                    backendData = JSON.stringify(backendData);
                    //     console.log("in submit, backendData = " + backendData);

                    var url = "/api/mail-config/";
                    var sid = (PHD.appliance_sid === null) ? "" : "?sid=" + PHD.appliance_sid;
                    url += sid;

                    PHD.Ajax
                        .put(url, backendData, load)
                        .done(function (data) {
                            self.$form.trigger("formsubmit", [data, self.$form, self]);
                        })
                        .always(function () {
                            self.$buttons.enable();
                            PHD.hideLoadingIndicator(load);
                        });

                    return this;
                }

                $('#edit-appliance').on("beforeactivationtab", function (event, ui) {
                    var EMAIL_INDEX = 1;
                    if (ui.oldTab.index() === EMAIL_INDEX) {
                        var currentData = jQuery.extend(true, {}, ui.currentData);
                        var editedDataObject = jQuery.extend(true, {}, currentData);
                        var submitData = form2js($form.attr("id"), '.', false);
                        var iscompare = true;

                        editedDataObject.smtp = submitData.smtp;
                        editedDataObject.user = submitData.user;

                        /*editedDataObject.schedule = "";
                         editedDataObject.bp = "";
                         editedDataObject.failure = "";
                         var i;
                         if (submitData.mail !== undefined) {
                         for (i = 0; i < submitData.mail.length; i++){
                         var obj = submitData.mail[i];
                         if (obj.email != '') {
                         if (obj.jobs === true){
                         editedDataObject.schedule = (editedDataObject.schedule === "") ?
                         obj.email : (editedDataObject.schedule + " " + obj.email);
                         }
                         if (obj.system === true){
                         editedDataObject.bp = (editedDataObject.bp === "") ?
                         obj.email : (editedDataObject.bp + " " + obj.email);
                         }
                         if (obj.failures === true){
                         editedDataObject.failure = (editedDataObject.failure === "") ?
                         obj.email : (editedDataObject.failure + " " + obj.email);
                         }
                         }
                         }
                         }*/

                        iscompare = compareTwoObjects(currentData, editedDataObject);
                        iscompare = ((submitData.test_mail) != '') ? false : iscompare;
                        iscompare = (typeof(submitData.password) != 'undefined') ? false : iscompare;

                        if (iscompare == false) {
                            event.preventDefault();
                            PHD.confirmDialog("<p>" + gettextCatalog.getString("Do you want to save your changes?") + "</p>",
                                {
                                    title: gettextCatalog.getString("Saving Alert")
                                }, gettextCatalog.getString("Yes"))
                                .done(function () {
                                    isrepeat = false;
                                    $('#edit-appliance').trigger('alertdialogyesclick', isrepeat);
                                })
                                .fail(function () {
                                    isrepeat = true;
                                    $(currentTarget).trigger('tabsactivateafterconfirm', ui);
                                })
                        } else {
                            isrepeat = true;
                            $(currentTarget).trigger('tabsactivateafterconfirm', ui);
                        }
                    }
                });
            }

            /* function initValues() {
             var sid = 1; // lmc - TODO
             console.log("appliance id is " + PHD.appliance_sid);
             var resp = PHD.Ajax.get("/api/mail-config/?sid=" + PHD.appliance_sid);

             resp.done(function (data) {
             data = data.data;
             if (data.smtp !== undefined) {
             $("#id_email_host").val(data.smtp);
             }
             if (data.authinfo !== undefined) {
             $("#id_server_requires_credentials").prop('checked', data.authinfo);
             }
             // add email recipients if set
             })
             }
             */

            /*
             *   DOM Ready Function
             */
            initForm();
        }

        angular.element(document).ready(function () {
            processEmailTab(PHD, window, $rootScope, $scope, $analytics);
        });
    }]);