angular.module('fcStorage', ['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])
    .controller('fcStorageController', ['$scope', '$rootScope', '$http','ngDialog','gettextCatalog', function($scope, $rootScope, $http,ngDialog, gettextCatalog) {

        var StorageEdit = false;
        var AddStorage;
        var $targetSelect = $("#id_target_list");
        var $lunSelect = $("#id_lun_list");

        $scope.initCtrl = function(obj){

            switch(obj.name){
                case 'FC-Archive':
                    $scope.fc = {};
                    $scope.fc.target = '';
                    $scope.type = "archive";
                    processDialog(PHD, window);
                    break;
                case 'FC-Edit-Archive':
                    $scope.fc = {};
                    fcData = $scope.ngDialogData;
                    $scope.type = "archive";
                    $scope.fc.name = fcData.name;
                    $("#title").text(gettextCatalog.getString('Edit FC Backup Copy Target'));
                    $("#id-name").disable();
                    $scope.fc.port = fcData.properties.port;
                    $scope.fc.target = fcData.properties.wwpn;
                    $scope.fc.lun = fcData.properties.lun;
                    StorageEdit = true;
                    break;
            }
        };

        function processDialog(PHD, window){
            var $port = $("#id_port"),
                portSpinnerOptions = {"min": 1, "max": 10000, "step": 1};

            $port.spinner(portSpinnerOptions);
        }

        $scope.submitForm = function () {
            var obj = {};
            var properties = {};
            if(!StorageEdit){
                obj.usage = $scope.type;
                obj.name = $scope.fc.name;
            }else{

            }

            obj.type = 2;
            properties.wwpn = $scope.fc.target;
            properties.lun = parseInt($scope.fc.lun);
            obj.properties = properties;

            var base_url = "/api/storage/";

            obj = JSON.stringify(obj);
            if(StorageEdit){
                base_url +=$scope.id + "/";
                AddStorage = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Saving..."));
                resp = PHD.Ajax.put(base_url + "?sid=" +  PHD.appliance_sid, obj, null, handleStorageError);
            }
            else{
                if($scope.type == "archive") {
                    AddStorage = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Adding and checking for existing Backup Copies.  Please wait..."));
                } else {
                    AddStorage = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Adding Storage..."));
                }
                resp = PHD.Ajax.post(base_url + "?sid=" +  PHD.appliance_sid, obj, null, handleStorageError);
            }

            resp.done(function(data) {
                PHD.hideLoadingIndicator(AddStorage);

                if($scope.type == "archive") {
                    var result = data.storage;
                    var dialogType = gettextCatalog.getString("Information");
                    if(result['messages'] != undefined && Array.isArray(result['messages'])) {
                        dialogType = "Warning";
                        var message = '';
                        for(var i=0; i<result['messages'].length;i++){
                            message = message +"<br>"+result.messages[i];
                        }
                    } else if (result['sets_needing_import'] == 0) {
                        message = gettextCatalog.getString('No backup copies found needing import');
                    } else {
                        message = gettextCatalog.getString('All backup copies imported successfully');
                    }

                    ngDialog.open({
                        dialogType:dialogType,
                        dialogMessage:message,
                        modelDialogId:'InfoDialog',
                        scope:$scope,
                        onConfirmOkButtonClick:'onConfirmInfo()'
                    });
                } else {
                    var result = data.result[0];
                    if(parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                        processDialog(PHD, window);
                        $scope.closeThisDialog();
                    } else if(parseInt(result.code) === AJAX_RESULT_ERROR) {
                        ngDialog.open({
                            dialogType: gettextCatalog.getString('ERROR'),
                            dialogMessage: data,
                            overlay:true
                        });
                    }
                }
                //PHD.currentDialog.wizard("close");
            });

        };

        $scope.TargetChange = function() {
            var selectedtarget = $targetSelect.val();
            console.log(selectedtarget);
            $scope.fc.target = selectedtarget;
        };

        $scope.ScanTargets = function() {
            $targetSelect = $("#id_target_list");
            var scan_url = "/api/storage/targets/";
            var ScanIndicator = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Searching for Targets..."));
            var resp = PHD.Ajax.get(scan_url + "?sid=" +  PHD.appliance_sid, ScanIndicator, handleStorageError);

            resp.done(function(data) {
                PHD.hideLoadingIndicator(ScanIndicator);
                var targets = data.targets;
                if(data.targets != null){
                    targetSelect = $targetSelect[0];
                    targetSelect.options.length = 0;
                    if (targets.length > 0) {
                        targets.forEach(function (target, index) {
                            targetSelect.options[index] = new Option(target);
                        })
                    }
                }
                else{
                    ngDialog.open({
                        dialogType:gettextCatalog.getString('Warning'),
                        modelDialogId:'SelectCredential',
                        dialogMessage: 'No targets were found.'
                    });
                }
            });
        };

        $scope.LUNChange = function() {
            var selectedLUN = $lunSelect.val();
            console.log(selectedLUN);
            $scope.fc.lun = selectedLUN;
        };

        $scope.ScanLUNs = function() {
            $lunSelect = $("#id_lun_list");
            var scan_url = "/api/storage/targets/";
            if ($scope.fc.target === "") {
                ngDialog.open({
                    dialogType:gettextCatalog.getString('Error'),
                    modelDialogId:'ErrorDialog',
                    scope:$scope,
                    dialogMessage: gettextCatalog.getString('The target field cannot be empty when scanning for LUNs.'),
                    onConfirmOkButtonClick:'onConfirmError()'
                });
                return;
            }
            var ScanIndicator = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Searching for Targets..."));
            var resp = PHD.Ajax.get(scan_url + $scope.fc.target +"/?sid=" +  PHD.appliance_sid, ScanIndicator, handleStorageError);

            resp.done(function(data) {
                PHD.hideLoadingIndicator(ScanIndicator);
                var luns = data.luns;
                if(data.luns != null){
                    lunSelect = $lunSelect[0];
                    lunSelect.options.length = 0;
                    if (luns.length > 0) {
                        luns.forEach(function (lun, index) {
                            lunSelect.options[index] = new Option(lun);
                        })
                    }
                }
                else{
                    ngDialog.open({
                        dialogType:gettextCatalog.getString('Warning'),
                        modelDialogId:'SelectCredential',
                        dialogMessage: gettextCatalog.getString('No targets were found.')
                    });
                }
            });
        };

        function handleStorageError(jqXHR, textStatus, errorThrown) {
            PHD.hideLoadingIndicator(AddStorage);
            if(jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                    var error = data.result[0].message;
                    ngDialog.open({
                        dialogType:gettextCatalog.getString('Error'),
                        modelDialogId:'ErrorDialog',
                        scope:$scope,
                        dialogMessage: error,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                } else {
                    PHD.throwError(data);
                }
            } else {
                PHD.ajaxError(jqXHR, textStatus, errorThrown);
            }
        }

        $scope.onConfirmError = function () {
            ngDialog.close('ErrorDialog');
        };

        $scope.onConfirmInfo = function () {
            ngDialog.close('InfoDialog');
            processDialog(PHD, window);
            $scope.closeThisDialog();
        };

        $scope.$on('ngDialog.opened', function(event, obj) { $scope.initCtrl(obj) });
    }]);

