
var protectTourModel =  angular.module('tourConfigureModel',['tour-module']);

protectTourModel.controller('tourConfigureCtrl', function ($scope, $rootScope, tourFactory){

    var $tour               = $("#configure-tour"),
        $configAppliances   = $("#tour-configure-appliances"), 
        $configAppliances   = $("#tour-configure-appliances"), 
        $applianceDetails   = $("#tour-appliance-details"),
        $manageAssets       = $("#tour-manage-assets"),
        $protectedAssets    = $("#tour-protected-assets");
    
        var configTarget  = $("#widget-configure-tour");
        $scope.$currentStep = $rootScope.user.tourStep;


    $scope.initTour = function() {
        $(window).off("resize.tour");
        $(window).on("resize.tour",  PHD.util.debounce($scope.positionTour));
        $scope.positionTour();
        $tour.addClass("active");
    }


    $scope.positionTour = function() {
        if (configTarget.length > 0) {
            $configAppliances.position({
                my: "center ",
                at: "center",
                of: configTarget,
                using: positionElement
            });

            $applianceDetails.position({
                my: "left center",
                at: "center+20 center+12",
                of: configTarget,
                using: positionElement
            });

            $manageAssets.position({
                my: "center",
                at: "center",
                of: configTarget,
                using: positionElement
            });

            $protectedAssets.position({
                my: "center",
                at: "center",
                of: configTarget,
                using: positionElement
            });
        } else {
            console.log("config tour init issue");           
        }
    };

    function positionElement(attr, obj) {
        obj.element.element.css({
            top: attr.top,
            left: attr.left,
            position: 'absolute'
        });
    }

    $scope.endTour = function() {
        $(window).off("resize.tour");
        $(".tour-position").css("z-index", "auto");
        $tour.remove();
        $scope.$currentStep = $rootScope.user.tourStep = 1;
    
        var putData = {};
        putData['show_help_overlay'] = 'false';
        
        var prefURL = '/api/preferences/' ;
        prefURL = prefURL + encodeURI($rootScope.user.name)+"/";
        tourFactory.sync('put',prefURL,1,putData).then(function(result){
            console.log("success >> configure");
        });
        
        $rootScope.user.showTour= false; 
        $scope.refreshPage();
         $("#configAppliance a").trigger('click');
    }

    /* 
     * Refresh App-main page
     */
     $scope.refreshPage = function(){
        var currentPage = angular.element(document.getElementById("app"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    $scope.reloadContent = function(){
        var currentPage = angular.element(document.getElementById("configure-tour"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    
    $scope.setNextTourStep = function() {
        
        if($scope.$currentStep === TOUR_STEP_CONFIG_END) {
            $scope.endTour();
            refreshPage();
            $scope.user.showTour = true;
            window.location.href = "#/dashboard/";
            
            setTimeout(function(){ 
               $("#header-nav").removeClass("tourHilighter"); 
            }, 500);
            
        }else{
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep+=1; 
            $scope.positionTour();
            
             switch(parseInt($scope.$currentStep)) {
                    case 22:
                        setTimeout(function(){
                          $("#configAppliance a").trigger('click');
                          $("#appliancetable").addClass("tourHilighter");
                        }, 500); 
                        break;
                    case 23:
                        setTimeout(function(){
                            $("#configAppliance a").trigger('click');
                            $(".appliance-details").addClass("tourHilighter");
                        }, 500);
                        break;
                    /*case 24:
                     
                        setTimeout(function(){
                            $("#protectedAssts a").trigger('click');
                            $( ".environment-header" ).addClass("tourHilighter");
                        }, 500);
                        break;*/
                    case 24:
                        setTimeout(function(){
                            $("#protectedAssts a").trigger('click');
                            $(".environment-assets").addClass("tourHilighter");
                        }, 500);
                     break;
                     
                     default: $scope.reloadContent();
                        break;
                }
        }
    }

    $scope.setPreviousTourStep = function() {
        if(parseInt($scope.$currentStep) === TOUR_STEP_CONFIG_START) {
            //have to set step change before going back
            $scope.$currentStep = $rootScope.user.tourStep -=1; 
            
            //go back to the protect page
            window.location.href = "#/reports/";
            
            setTimeout(function(){
                $(".report-section-right").addClass("tourHilighter");
            }, 500);
        } else {
            
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep -=1; 
            $scope.positionTour();
            
             switch(parseInt($scope.$currentStep)) {
                    case 22:
                        setTimeout(function(){
                            $("#configAppliance a").trigger('click');
                            $("#appliancetable").addClass("tourHilighter");
                        }, 500); 
                        break;
                    case 23:
                        setTimeout(function(){
                            $("#configAppliance a").trigger('click');
                            $(".appliance-details").addClass("tourHilighter");
                        }, 500);
                        break;
                    /*case 24:
                        setTimeout(function(){
                            $("#protectedAssts a").trigger('click');
                            $( ".environment-header" ).addClass("tourHilighter");
                        }, 500);
                        break;*/
                    case 24:
                        setTimeout(function(){
                            $("#protectedAssts a").trigger('click');
                            $(".environment-assets").addClass("tourHilighter");
                        }, 500);
                     break;
                     
                     default: $scope.reloadContent();
                        break;
                }      
        }
    }
    angular.element(document).ready(function () {
        $scope.initTour();
        $scope.positionTour();
    });
});

    
