(function($, PHD, window, undefined) {
    
    var $form = $("#auto-updates-form"),
        UpdateForm,
        $enableAutoUpdates = $("#id_enable_auto_updates"),
        $updateTimeHour = $("#id_update_time_hour"),
        $updateTimeAmPm = $("#id_update_time_am_pm");

    function enableOrDisableUpdateTime() {
        $updateTimeHour.prop("disabled", !$enableAutoUpdates.prop("checked"));
        $updateTimeAmPm.prop("disabled", !$enableAutoUpdates.prop("checked"));
    }

    function initForm() {
        UpdateForm = PHD.FormController($form, {})
            .validate({})
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                if(data.result[0].code === AJAX_RESULT_SUCCESS) {
                    var return_data = {
                        "set_or_not_set": $enableAutoUpdates.prop("checked") ? gettext("Auto Updates are Enabled") : gettext("Auto Updates are Not Enabled")
                    };
                    $(document).trigger("autoupdatesformsave", return_data);
                    PHD.currentDialog.wizard("close");
                } else if(data.result[0].code === AJAX_RESULT_ERROR) {
                    PHD.throwError(data);
                }
            });

        $enableAutoUpdates.on("change", enableOrDisableUpdateTime).trigger("change");
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        PHD.currentDialog.one("wizardfocus", function() {
            initForm();
        });
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
