angular.module('edit-useraccount-module', ['ngDialog', 'angulartics', 'angulartics.google.analytics'])

    .controller('editUserCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', '$analytics', 'gettextCatalog',
        function($scope, $rootScope, $http, ngDialog, $analytics, gettextCatalog) {

            var unbindHandler = null;
            var AccountForm;

            var username = $scope.ngDialogData.username;
            var user_privilege = $scope.ngDialogData.user_privilege;
            var user_role = $scope.ngDialogData.user_role;
            var user_id = $scope.ngDialogData.user_id;

            function processDialog() {

                var $form = $("#form-account"),
                    $passwordInputs = $form.find("input:password"),
                    $toggleCtrl = $form.find(".toggle"),
                    $icon = $toggleCtrl.find("i");

                function initForm() {
                    $passwordInputs.toggleDisabled();

                    AccountForm = PHD.FormController($form, {})
                        .validate({
                            errorLabelContainer: ".form-account-dialog-error-list",
                            errorContainer: ".form-account-dialog-errors",
                            showErrors: function(errorMap, errorList) {
                                $(".form-account-dialog-errors").find(".summary")
                                    .html(gettext("Correct the following errors:"));
                                this.defaultShowErrors();
                            },
                            rules: {
                                username: {
                                    required: true,
                                    maxlength: 32
                                },
                                current_password: {
                                    required: true
                                },
                                new_password: {
                                    required: true,
                                    minlength: 1,
                                    maxlength: MAX_PASSWORD_LENGTH
                                },
                                confirm_password: {
                                    minlength: 1,
                                    maxlength: MAX_PASSWORD_LENGTH,
                                    equalTo: "#id_password"
                                }
                            },
                            messages: {
                                username: {
                                    required: gettextCatalog.getString("Username is required"),
                                    maxlength: gettextCatalog.getString("Username must not be more than 32 characters")
                                },
                                current_password: {
                                    required: gettextCatalog.getString("Password is required")
                                },
                                new_password: {
                                    required: gettextCatalog.getString("New Password is required"),
                                    maxlength: gettextCatalog.getString("New Password must not be more than 48 characters")
                                },
                                confirm_password: {
                                    equalTo: gettextCatalog.getString("Your new password must be entered the same in both fields")
                                }
                            }
                        });

                    $toggleCtrl.on("click", function(event) {
                        var disabled = $icon.is(".icon-unlock");
                        disabled ? $icon.alterClass("icon-unlock", "icon-lock") : $icon.alterClass("icon-lock","icon-unlock");
                        $passwordInputs.prop("disabled", disabled);
                    });

                    AccountForm.submit = function() {
                        var submitData = form2js($form.attr("id"), '.', false);
                        $scope.saveUserAccount(submitData);
                    }
                }

                initForm();
            }

            $scope.closeThisDialog = function() {
                if ( _.isFunction(unbindHandler)) {
                    unbindHandler();
                }
                ngDialog.close('user-account-dialog');
            };

            $scope.saveUserAccount = function(submitData) {
                $http({
                    method: 'PUT',
                    url : '/api/users/' + user_id,
                    data: JSON.stringify(submitData)
                }).success(function(data, status, headers){
                    $scope.closeThisDialog();
                }).error(function(response) {
                    ngDialog.open({
                        dialogType:'Error',
                        dialogMessage:response.result[0].message,
                        modelDialogId: 'user-error-dialog',
                        scope: $scope,
                        onConfirmOkButtonClick: 'onConfirmError()'
                    })
                });
            };

            $scope.onConfirmError = function() {
                ngDialog.close('user-error-dialog');
            };

            $scope.initCtrl = function(obj) {

                switch(obj.name) {
                    case 'user-account-dialog':
                        processDialog();
                        $("#id_name").val(username);
                        $('#id_user_privilege').val(user_privilege);
                        $('#id_user_role').val(user_role);
                        $("#edit_object_id").text(user_id);

                        break;
                    default:
                        break;
                }
            };

            // Initialize the controller, returning the function to turn off the listener.
            unbindHandler = $scope.$on('ngDialog.opened', function(event, obj) { $scope.initCtrl(obj) });
        }
    ]);