angular.module('roles-access-module', ['ngDialog', 'angulartics', 'angulartics.google.analytics', 'inventory',
    'ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','ui.grid.selection'])
.config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {
            }
        });
    }])
.controller('rolesScopeCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', '$analytics', '$protectService','inventorysvc',
    function($scope, $rootScope, $http, ngDialog, $analytics, $protectService, inventorysvc) {

        $scope.title = "Configure Assets in Recovery Scope";
        $scope.isEdit = false;
        $scope.userName = $scope.ngDialogData.userName;
        $scope.user_role = $scope.ngDialogData.user_role;
        $scope.treeDataCache = $scope.ngDialogData.treeDataCache;
        $scope.ADuser = $scope.ngDialogData.ADuser;

        // Used to unbind the watched event on dialog close.
        var unbindHandler = null;

        var templateWithTooltip = '<div style="word-wrap:normal;font-size:1.2em;padding-top:5px;" title="{{row.getProperty(col.field)}}">{{row.getProperty(col.field)}}</div>';
        $scope.inventoryColumnDefs = [
            {field: 'id', visible:false},
            {field:'nodeId',displayName:'Node Id',visible:false},
            {field: 'name',displayName:'Name'}
        ];
        $scope.inventoryGridOptions={
            columnDefs: $scope.inventoryColumnDefs,
            data:'inventoryData',
            rowHeight: 30,
            virtualizationThreshold:200,
            enableHorizontalScrollbar:0,
            enableColumnMenus:false,
            resizable: true
        };

        var rootNodeObj={};
        var rootNodeArray=[];
        var finalTreeDataArray = [];


        $scope.filterInventory = function(){

            //$('#jstreeRoleScope').jstree(true).uncheck_all();

            $scope.selectedAsset =[];
            $scope.inventoryData =[];
            $scope.loadTreeData($http,$scope,$rootScope);
        };

        $scope.applyModelChanges = function() {

        };

        $scope.loadTreeData = function($http,$scope,$rootScope){
            $rootScope.treeData =[];
            finalTreeDataArray = [];
            rootNodeArray = [];

            for(var k=0;k<$scope.treeDataCache.length;k++){
                var nodeIcon = $protectService.getIconForType($scope.treeDataCache[k].type)+" icon";
                rootNodeObj={id:$scope.treeDataCache[k].id,parent:"#",text:$scope.treeDataCache[k].name,
                    icon:nodeIcon,state: { opened: true,disabled: true},data:{expanded:true,type:$scope.treeDataCache[k].type}};
                rootNodeArray.push(rootNodeObj);
                var isDisabled = true;
                var jsonTreeData = $scope.treeDataCache[k].nodes;

                var jsonData = $protectService.getSortedJson(jsonTreeData,"name");

                for(var i = 0; i< jsonData.length;i++){
                    isDisabled = false;
                    nodeIcon = $protectService.getIconForType(jsonData[i].type)+" icon";
                    rootNodeObj={id:jsonData[i].id,parent:$scope.treeDataCache[k].id,text:jsonData[i].name,
                        icon:nodeIcon,state: { opened: false,disabled: isDisabled},data:{expanded:false,type:jsonData[i].type}};
                    rootNodeArray.push(rootNodeObj);

                    if(jsonData[i].nodes instanceof Array){
                        $scope.getRecursivelyTreeData(jsonData[i]);
                    }
                }
            }
            finalTreeDataArray = rootNodeArray;
            $rootScope.treeData = finalTreeDataArray;
            /*if(!isEdit){ */
            var nodeTree =$('#jstreeRoleScope').jstree(true);
            if (nodeTree.settings != undefined && nodeTree.settings.core !== undefined) {
                nodeTree.settings.core.data=$rootScope.treeData;
            }
            if (nodeTree.refresh !== undefined) {
                nodeTree.refresh();
            }
            /* } */
        };

        $scope.getRecursivelyTreeData =function(data){
            var isDisabled = false;
            for(var j = 0; j< data.nodes.length;j++){
                var nodeIcon = $protectService.getIconForType(data.nodes[j].type)+" icon";
                rootNodeObj = {id:data.nodes[j].id, parent:data.id, text:data.nodes[j].name,
                    icon:nodeIcon, state: { opened: false,disabled: isDisabled}, data:{expanded:false, type:data.nodes[j].type, recovery_model: "hello"}};
                rootNodeArray.push(rootNodeObj);
                if(data.nodes[j].nodes instanceof Array){
                    $scope.getRecursivelyTreeData(data.nodes[j]);
                }
            }
        };


        $scope.treeConfig = {
            core : {
                multiple : true,
                animation: true,
                error : function(error) {console.log('treeCtrl: error from js tree - ' + angular.toJson(error));},
                check_callback : true,
                worker : true
            },
            types : {
                default : {icon : 'icon-hv-datacenter icon'},
                star : {icon : 'icon-hv-host icon'},
                cloud : {icon : 'icon-hv-host icon'}
            },
            checkbox: {
                keep_selected_style: false,
                three_state: false,
                cascade: 'down'
            },
            version : 1,
            plugins : ['types','checkbox','search']
        };

        $scope.readyTree=function(event){
            setTimeout(function(){
                $scope.checkNodesOnLoadEdit();
            }, 1000);
        };

        $scope.checkNodesOnLoadEdit=function(){
            var nodeIdArray =Object.keys($('#jstreeRoleScope').jstree(true)._model.data);
            var nodeNamesArray = _.pluck($('#jstreeRoleScope').jstree(true)._model.data, 'text');
            var arrayAssets = $scope.createAssetArray($scope.user_role.scope);
            $('#jstreeRoleScope').jstree(true).open_all();
            if(arrayAssets !=undefined){
                for(var i=0; i< arrayAssets.length ; i++){
                    var node_id='li#';
                    for(var j=0 ;j<nodeIdArray.length;j++){
                        if (nodeMatches(nodeIdArray[j], arrayAssets[i])) {
                            $scope.selectedAsset[nodeIdArray[j]] = {nodeId:nodeIdArray[j],name:nodeNamesArray[j],id:nodeToRoleId(nodeIdArray[j])};
                            node_id = node_id+nodeIdArray[j];
                            break;
                        }
                    }
                    node_id = inventorysvc.handleSpecialChars(node_id);
                    $('#jstreeRoleScope').jstree(true).check_node(node_id);
                }
                //$('#jstreeRoleScope').jstree(true).close_all();
            }
        };

        $scope.createAssetArray = function(restore_scope) {
            var assets = [];
            if (restore_scope !== undefined && restore_scope != '') {
                assets = restore_scope.split(',');
            }
            return assets;
        };

        function nodeMatches(node, asset) {
            var match = false;
            var assetParts = asset.split('_');
            var parts = node.split('_');
            // asset:  sid_cid
            // or: sid_cid_aid_iid
            if (assetParts.length >= 2) {
                match = (parts[2] == APP_ID_FILE_LEVEL) && (parts[0] == assetParts[0]) && (parts[1] == assetParts[1]);
                if (assetParts.length == 4) {
                    match = isNaN(parts[parts.length - 1]) ? false : (parts[2] == assetParts[2]) && (parts[parts.length - 1] == assetParts[3]);
                }
            }
            return match;
        }


        $scope.deslectNodeFun = function(e,item){
            if (hasChildren(item)) {
                delete $scope.selectedAsset[item.node.id];

                for(var k =0 ; k < item.node.children_d.length; k++){
                    if($scope.selectedAsset[item.node.children_d[k]] != null ||
                        $scope.selectedAsset[item.node.children_d[k]] != undefined){
                        delete $scope.selectedAsset[item.node.children_d[k]];
                    }
                }
            } else {
                if(item.selected.length == 0){
                    $scope.selectedAsset =[];
                }
                delete $scope.selectedAsset[item.node.id];
            }
            $scope.refreshInventoryData(false);
        };

        $scope.slectNodeFun = function(e,item){

            if (hasChildren(item)){

                $('#jstreeRoleScope').jstree(true).open_all(item.node);
                item.node.data.expanded = true;

                if (canBeChecked(item.node.data.type)) {
                    $scope.selectedAsset[item.node.id] = {nodeId:item.node.id,name:item.node.text,id:nodeToRoleId(item.node.id)};
                }

                for(var k =0 ; k < item.node.children_d.length; k++){
                    var id = item.node.children_d[k]+'_anchor';
                    if($scope.selectedAsset[item.node.children_d[k]] == null || $scope.selectedAsset[item.node.children_d[k]] == undefined){
                        if (!canBeChecked(item.node.children_d[k])) {
                            continue;
                        }
                        if (inventorysvc.isGroup(item.node.children_d[k]) ||
                            inventorysvc.isPoolOrVApp(item.node.children_d[k]) ||
                            isAppNode(item.node.children_d[k])) {
                            // If the child is a group, pool, or vApp, or app, do not add to the selected list.
                            continue;
                        }
                        var $el = $(document.getElementById(id));
                        $scope.selectedAsset[item.node.children_d[k]] = {nodeId:item.node.children_d[k],name:$el.text(), id:nodeToRoleId(item.node.children_d[k])};
                    }
                }
            } else {
                if($scope.selectedAsset[item.node.id] == null || $scope.selectedAsset[item.node.id] == undefined){
                    $scope.selectedAsset[item.node.id] = {nodeId:item.node.id,name:item.node.text};
                }
            }
            $scope.refreshInventoryData(false);
        };
        
        function hasChildren(item) {
            return item.node.children_d !== undefined;
        }

        function canBeChecked(type) {
            var checkIt = true;
            if (type === INVENTORY_ID_SQL_INSTANCE ||
                type === INVENTORY_ID_EXCHANGE_APPLICATION ||
                type === INVENTORY_ID_ORACLE_APPLICATION ||
                type === INVENTORY_ID_SHAREPOINT_APPLICATION ||
                type === INVENTORY_ID_HYPER_V_SERVER ||
                type === INVENTORY_ID_VMWARE_ESX_SERVER ||
                type === INVENTORY_ID_VMWARE_RESOURCE_POOL) {
                checkIt = false;
            }
            return checkIt;
        }

        function isAppNode(nodeId) {
            var pieces = nodeId.split('_');
            return pieces.length == 3;
        }

        function nodeToRoleId(nodeId) {
            var pieces = nodeId.split('_');
            var roleId = '';
            if (pieces.length >= 4) {
                roleId = pieces[0] + '_' + pieces[1] + '_' + pieces[2] + '_' + pieces[pieces.length - 1];
            }
            return roleId;
        }

        $scope.refreshInventoryData = function(assets){
            var assets = assets || false;
            if (assets) {
                $scope.selectedAsset = assets;
            }
            $scope.inventoryData =[];
            var nodeIdArray =Object.keys($scope.selectedAsset);
            for(var j=0 ;j<nodeIdArray.length;j++){
                var obj = $scope.selectedAsset[nodeIdArray[j]];
                $scope.inventoryData.push(obj);
            }
            $(window).resize();
        };

        $scope.searchIndex = 0;

        $scope.search = function(){
            setTimeout(function () {
                var v = $('#inventorySearchInputId').val();
                $('#jstreeRoleScope').jstree(true).search(v);
            }, 200);
        };

        $scope.goToSearchResult = function() {
            var el =  $('#jstreeRoleScope').jstree(true).get_node($scope.searchResults[$scope.searchIndex], true);
            if (el !== undefined) {
                el.children('.jstree-anchor').focus();
            }
            el.focus();
        };

        $scope.getSearchResults = function(event, obj) {
            setTimeout(function () {
                $scope.$apply(function() {
                    $scope.searchResults = obj.nodes;
                    $scope.searchIndex = 0;
                });
            });
        };

        $scope.next = function() {
            var len = $scope.searchResults.length;
            if ($scope.searchIndex + 1 > len - 1) {
                $scope.searchIndex = 0;
            } else {
                $scope.searchIndex++;
            }
            $scope.goToSearchResult();
        };

        $scope.previous = function() {
            var len = $scope.searchResults.length;
            if ($scope.searchIndex - 1 < 0) {
                $scope.searchIndex = len - 1;
            } else {
                $scope.searchIndex--;
            }
            $scope.goToSearchResult();
        };

        $scope.clearSearch = function() {
            $('#jstreeRoleScope').jstree(true).clear_search();
            $('#inventorySearchInputId').val("");
        };

        $scope.clearSearchResults = function() {
            $scope.searchIndex = 0;
            $scope.searchResults = undefined;
        };

        $scope.functiontofindIndexByKeyValue = function(arraytosearch, key, valuetosearch) {
            for (var i = 0; i < arraytosearch.length; i++) {
                if (arraytosearch[i][key] == valuetosearch) {
                    return i;
                }
            }
            return null;
        };

        $scope.saveRestoreScope = function(){

            var roleScopeArray = _.pluck(Object.values($scope.selectedAsset), 'id');
            var rolesString = roleScopeArray.toString();

            if ($scope.userName !== null) {
                var dataObj = {};
                dataObj.name =$scope.userName;
                dataObj.user_role = {scope: rolesString};
                dataObj.ADuser = $scope.ADuser;
                var payload = JSON.stringify(dataObj);

                $http({ method: 'put',
                    url : '/api/users/0',
                    data: payload
                }).success(function(data, status, headers){
                    $(document).trigger("rolesUpdated", [rolesString, null]);
                    $scope.closeThisDialog();
                }).error(function(response) {
                    var message = response !== undefined && response.result instanceof Array ? response.result[0].message : 'Unknown Server Error';
                    $analytics && $analytics.eventTrack('Failure: ' + message, {  category: 'Restore', label: 'Configure' });
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'restore-scope-error-dialog',
                        scope:$scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                });
            } else {
                $(document).trigger("rolesUpdated", [rolesString, null]);
                $scope.closeThisDialog();
            }
        };

        $scope.onConfirmError = function () {
            ngDialog.close('restore-scope-error-dialog');
        };

        $scope.closeThisDialog = function() {
            if ( _.isFunction(unbindHandler)) {
                unbindHandler();
            }
            ngDialog.close('edit-scope-dialog')
        };

        // Initialize the controller, returning the function to turn off the listener.
        unbindHandler = $scope.$on('ngDialog.opened', function(event, obj) { $scope.initCtrl(obj) });

        $scope.initCtrl = function(dlg){
            switch (dlg.name){
                // When putting an ngDialog above a UI Dialog, we need to adjust the vertical alignment (the default ngDialog top is 25%).
                case 'edit-scope-dialog':
                    $scope.filterInventory();
                    break;
                default:
                    // No action.
                    break;
            }
        };

}])
.controller('recoverOptionsCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', '$analytics', '$protectService','inventorysvc',
    function($scope, $rootScope, $http, ngDialog, $analytics, $protectService, inventorysvc) {

        $scope.title = "Recovery Options";
        $scope.isEdit = false;
        $scope.userName = $scope.ngDialogData.userName;
        $scope.user_role = $scope.ngDialogData.user_role;
        $scope.ADuser = $scope.ngDialogData.ADuser;

        // Used to unbind the watched event on dialog close.
        var unbindHandler = null;

        $scope.recoveryOptions = {
            files_only: false,
            orig_only: false,
            no_in_place: false,
            no_download: false,
            suffix: ''
        };


        $scope.saveRecoveryOptions = function(){

            var optionsError = $scope.checkOptions($scope.recoveryOptions);
            if (optionsError === null) {
                var recoveryOptionsString = buildOptionsString($scope.recoveryOptions);

                if ($scope.userName !== null) {
                    var dataObj = {};
                    dataObj.name = $scope.userName;
                    dataObj.ADuser = $scope.ADuser;
                    dataObj.user_role = {recover_options: recoveryOptionsString};
                    var payload = JSON.stringify(dataObj);

                    $http({ method: 'put',
                        url : '/api/users/0',
                        data: payload
                    }).success(function(data, status, headers){
                        $(document).trigger("rolesUpdated", [null, recoveryOptionsString]);
                        $scope.closeThisDialog();
                    }).error(function(response) {
                        var message = response !== undefined && response.result instanceof Array ? response.result[0].message : 'Unknown Server Error';
                        $analytics && $analytics.eventTrack('Failure: ' + message, {  category: 'Restore', label: 'Configure' });
                        ngDialog.open({
                            dialogType:'Error',
                            modelDialogId:'restore-scope-error-dialog',
                            scope:$scope,
                            dialogMessage: message,
                            onConfirmOkButtonClick:'onConfirmError()'
                        });
                    });
                } else {
                    $(document).trigger("rolesUpdated", [null, recoveryOptionsString]);
                    $scope.closeThisDialog();
                }
            } else {
                ngDialog.open({
                    dialogType:'Error',
                    modelDialogId:'restore-scope-error-dialog',
                    scope:$scope,
                    dialogMessage: optionsError,
                    onConfirmOkButtonClick:'onConfirmError()'
                });
            }
        };

        $scope.checkOptions = function(options) {
            var errorString = null;
            if (options.suffix !== undefined && options.suffix !== '') {
                var suffixString = options.suffix;
                if (suffixString.indexOf(':') == -1 && suffixString.indexOf(';') == -1) {
                    var suffixes = suffixString.split(',');
                    for (var i = 0; i < suffixes.length; i++) {
                        var thisSuffix = suffixes[i];
                        thisSuffix = thisSuffix.trim();
                        if (!thisSuffix.match(/^\*\.[a-zA-Z0-9]*$/)) {
                            errorString = "error in format of suffix " + thisSuffix;
                            break;
                        }
                    }
                } else {
                    errorString = "No ':' or ':' is allowed in a suffix";
                }
            }
            if (errorString !== null) {
                errorString += "; use formats such as *.doc,*.txt.";
            }
            return errorString;
        };

        $scope.setRecoveryOptions = function(role, recoveryOptions) {
            if (role !== undefined && role.recover_options !== undefined) {
                var options = role.recover_options;
                var parts = options.split(';');
                for (var i = 0; i < parts.length; i++) {
                    var part = parts[i];
                    if (part.indexOf('files_only') != -1) {
                        recoveryOptions.files_only = true;
                    } else if (part.indexOf('orig_only') != -1) {
                        recoveryOptions.orig_only = true;
                    } else if (part.indexOf('no_in_place') != -1) {
                        recoveryOptions.no_in_place = true;
                    } else if (part.indexOf('no_download') != -1) {
                        recoveryOptions.no_download = true;
                    } else if (part.indexOf('suffix') != -1) {
                        var suffix = part.split(':');
                        if (suffix.length > 1) {
                            recoveryOptions.suffix = suffix[1];
                        }
                    }
                }
            }
        };

        function buildOptionsString(recoveryOptions) {
            var restrictArray = [];
            for (var prop in recoveryOptions) {
                if (recoveryOptions.hasOwnProperty(prop)) {
                    if (recoveryOptions[prop] === true) {
                        restrictArray.push(prop);
                    } else if (_.isString(recoveryOptions[prop])) {
                        if (recoveryOptions[prop] != '') {
                            restrictArray.push(prop + ':' + recoveryOptions[prop]);
                        }
                    }
                }
            }
            return restrictArray.join(';');
        }

        $scope.onConfirmError = function () {
            ngDialog.close('restore-scope-error-dialog');
        };

        $scope.closeThisDialog = function() {
            if ( _.isFunction(unbindHandler)) {
                unbindHandler();
            }
            ngDialog.close('edit-recover-options-dialog')
        };

        // Initialize the controller, returning the function to turn off the listener.
        unbindHandler = $scope.$on('ngDialog.opened', function(event, obj) { $scope.initCtrl(obj) });

        $scope.initCtrl = function(dlg){
            switch (dlg.name){
                // When putting an ngDialog above a UI Dialog, we need to adjust the vertical alignment (the default ngDialog top is 25%).
                case 'edit-recover-options-dialog':
                    $scope.setRecoveryOptions($scope.user_role, $scope.recoveryOptions);
                    var form = angular.element("#recover-options-dialog");
                    form.find(".definition").popover({
                        appendTo: form
                    });
                    break;
                default:
                    // No action.
                    break;
            }
        };

}])
.service("rolesSvc", function() {
    this.getSuffixArray = function (options) {
        var suffixArray = [];
        if (options !== undefined) {
            var hasSuffixes = options.indexOf('suffix') != -1;
            if (hasSuffixes) {
                var optionArray = options.split(';');
                for (var i = 0; i < optionArray.length; i++) {
                    if (optionArray[i].indexOf('suffix') != -1) {
                        var suffixOption = optionArray[i];
                        var suffixes = suffixOption.split(':');
                        if (suffixes.length > 1) {
                            var items = suffixes[1];
                            // convert to array and trim whitespace
                            suffixArray = items.split(',');
                            for (var j = 0; j < suffixArray.length; j++) {
                                suffixArray[j] = suffixArray[j].trim();
                            }
                        }
                        break;
                    }
                }
            }
        }
        return suffixArray;
    };
    this.optionsTokenPresent = function(token, options) {
        var hasToken = false;
        if (options && options !== undefined) {
            if (options.indexOf(token) !== -1) {
                hasToken = true;
            }
        }
        return hasToken;
    };
    this.noDownloads = function(options) {
        return this.optionsTokenPresent('no_download', options);
    };
    this.noInPlace = function(options) {
        return this.optionsTokenPresent('no_in_place', options);
    };
    this.filesOnly = function(options) {
        return this.optionsTokenPresent('files_only', options);
    };
});