angular.module('alertWidgetModule', [])
    .directive('userPreference', function () {
        return {
            restrict: 'E',
            scope: {
                show: '='
            },
            replace: true, /* Replace with the template below */
            transclude: true, /*we want to insert custom content inside the directive*/
            link: function (scope, element, attrs) {
                scope.dialogStyle = {};
                if (attrs.width)
                    scope.dialogStyle.width = attrs.width;
                if (attrs.height)
                    scope.dialogStyle.height = attrs.height;
                scope.hideModal = function () {
                    scope.show = false;
                };
            },
            template: "<div class='ng-modal' ng-show='show'><div class='ng-alertUserprefrence-dialog' ng-style='dialogStyle'><div class='ng-alertUserprefrence-dialog-content' ng-transclude></div></div></div>"
        };
    })
    .controller('AlertWidgetContorller', ['$scope', '$rootScope', '$http', 'gettextCatalog', function ($scope, $rootScope, $http, gettextCatalog) {

        $scope.initCtrl = function () {
            processAlertsWidget(PHD, window);
        };

        $scope.widgetName = "Alerts";


        $scope.openDailog = false;
        $scope.toggleModal = function () {

            $scope.openDailog = !$scope.openDailog;
        };
        $scope.runReport = function (reportID, days, sid) {
            days = days || 0;
            sid = sid || 0;
            $scope.closeDailog();
            location.href = "#/reports/" + reportID + '/' + days + '/' + sid;
        };


        //(function($, PHD, window, undefined) {
        function processAlertsWidget(PHD, window) {
            var $widget = $("#widget-alerts-dailog"),
                $prefTrigger = $widget.find(".preference-trigger"),
                $btnDismissAll = $widget.find(".btn-dismiss-all-alert"),
                $alertsTable = $("#dashboard-alerts-dailog"),
                $alertsIcon = $("h1.alerts"),
                $alertDetail = $(),
                timestamp = 0,
                refreshRate = refreshRates.dash_alert_refresh,
                namespace = "alertswidget",
                AlertsTable, UserPreference, Timer;
            $rootScope.timestamp = 0;
            $scope.clickCount = 0;
            var severityArray = [];
            var alertIDArray = [];
            var rowPopover = '';

            var dataTableOptions = {
                select: true,
                multiselect: false,
                className: "alert",
                cellClasses: ["alert-severity", "alert-sname", "alert-time", "alert-message"],
                placeholder: gettext("There are no unresolved alerts")
            };

            $scope.closeDailog = function () {
                var scope = $("[ng-controller=GlobalCtrl]").scope();
                scope.toggleModal();
            }

            /* function will fixed the width of header and data rows of JQuery DataTable
             */
            function setHeaderWidth() {
                $('#dashboard-alerts-dailog .severity').css({
                    "width": "44px",
                    "max-width": "44px",
                    "min-width": "44px"
                });
                $('#dashboard-alerts-dailog .appliance').css({
                    "width": "118px",
                    "max-width": "118px",
                    "min-width": "118px"
                });
                $('#dashboard-alerts-dailog .time').css({"width": "151px", "max-width": "151px", "min-width": "151px"});
                $('#dashboard-alerts-dailog .message').css({
                    "width": "453px",
                    "max-width": "453px",
                    "min-width": "107px"
                });
                $('#dashboard-alerts-dailog .dismiss_row').css({
                    "width": "31px",
                    "max-width": "31px",
                    "min-width": "31px"
                });
                $('#dashboard-alerts-dailog .close_row').css({
                    "width": "31px",
                    "max-width": "31px",
                    "min-width": "31px"
                });
                $('#dashboard-alerts-dailog .alert-sname').css({
                    "width": "118px",
                    "max-width": "118px",
                    "min-width": "118px"
                });
                $('#dashboard-alerts-dailog .alert-severity').css({
                    "width": "44px",
                    "max-width": "44px",
                    "min-width": "44px"
                });
                $('#dashboard-alerts-dailog .alert-time').css({
                    "width": "151px",
                    "max-width": "151px",
                    "min-width": "151px"
                });
                $('#dashboard-alerts-dailog .alert-message').css({
                    "width": "480px",
                    "max-width": "480px",
                    "min-width": "480px"
                });
                $('#dashboard-alerts-dailog tbody').css({"height": "120px", "max-height": "120px"})

            }

            /* function will decide the highest priority of alert present in
             * the data and change alert background color based on that
             * An at-risk alert will always show the red/black count, regardless of priority.
             * At Risk  : Red/Black
             * Critical : Red    (HexCode: "#bc3d41")
             * Warning  : Yellow (HexCode: "#e8e460")
             * Notice   : Green  (HexCode: "#80bc3d")
             */


            function setColorOfAlert(alertSeverity, atRiskAlert) {

                if (alertSeverity == 'critical') {
                    if (atRiskAlert) {
                        $("#app-header .alert-count_1").css({"background-color": "#000", "color": "#bc3d41"});
                    } else {
                        $("#app-header .alert-count_1").css({"background-color": "#bc3d41", "color": "#fff"});
                    }
                }
                else if (alertSeverity == 'warning') {

                    if (atRiskAlert) {
                        $("#app-header .alert-count_1").css({"background-color": "#000", "color": "#bc3d41"});
                    } else {
                        $("#app-header .alert-count_1").css({"background-color": "#e8e460", "color": "#000"});
                    }
                }
                else {
                    if (atRiskAlert) {
                        $("#app-header .alert-count_1").css({"background-color": "#000", "color": "#bc3d41"});
                    } else {
                        $("#app-header .alert-count_1").css({"background-color": "#80bc3d", "color": "#000"});
                    }
                }

            }
            /*
            mmb - function to change the icon if there is a risk alert
            */
           function setAlertIcon(atRiskAlert){
                $rootScope.ransomwareAlert = atRiskAlert === true;

            }


            /* function equivalent to PHD.updateAlerts(true, data.length) in main.js
             instead of data.length we are taking up entire data to
             to store type of Alert(i.e.Critical,Warning and Notice)
             and id of Alert.
             */

            $scope.changeAlertCount = function (fromFunction, data) {
                if (fromFunction == 'fromUpdate') {
                    /*pushing severity and ids of Alerts in respective Arrays*/
                    for (var i = 0; i < data.length; i++) {
                        severityArray[i] = data[i].severity;
                        alertIDArray[i] = data[i].id;

                    }
                    //setColorOfAlert();

                    /* set the AlertCount based on number of alerts*/
                    $("#app-header .alert-count_1").text(data.length);

                }
                else {
                    /* called from dismiss-all alerts method
                     *color of background should be green
                     *alert count set to 0
                     */
                    severityArray = [];
                    alertIDArray = [];
                    $("#app-header .alert-count_1").css("background-color", "#80bc3d");
                    $("#app-header .alert-count_1").text(0);
                }


            };

            /*
             * equivalent to PHD.fetchStats() of mainJS;
             *decreases the existing count of alert by one
             *also mark the
             */

            $scope.fetchStats = function (alerID) {


                var currentvalue = parseInt($("#app-header .alert-count_1").text());
                var updatedValue = currentvalue - 1;

                if (updatedValue == 0) {
                    severityArray = [];
                    alertIDArray = [];
                    $("#app-header .alert-count_1").css("background-color", "#80bc3d");
                }
                else {
                    var index = alertIDArray.indexOf(alerID);
                    severityArray[index] = "deleted";
                    alertIDArray[index] = "deleted";
                    //setColorOfAlert();
                }
                $("#app-header .alert-count_1").text(updatedValue);
            };

            /*template used for pop-over*/
            var alertTmpl = _.template(
                '<p style="word-wrap:break-word;"><strong><%= message %></strong></p>' +
                '<% if(typeof(created) !== "undefined") { %><p><label>Date:</label><span><%= moment(created, "MMM DD, YYYY hh:mm a").format("MM/DD/YYYY hh:mm A") %></span></p><% } %>' +
                '<% if(typeof(updated) !== "undefined") { %><p><label>Updated:</label><span><%= moment(updated, "MMM DD, YYYY hh:mm a").format("MM/DD/YYYY hh:mm A") %></span></p><% } %>' +
                '<% if(typeof(alert_type) !== "undefined") { %><p><label>Alert Type:</label><span><%= alert_type %></span></p><% } %>' +
                '<% if(typeof(source_name) !== "undefined") { %><p><label>Alert Source:</label><span><%= source_name %></span></p><% } %>' +
                '<% if(typeof(sname) !== "undefined") { %><p><label>Appliance:</label><span><%= sname %></span></p><% } %>' +
                '<p><a href="<%= kburl %>" class="btn-alert-kb text-success" style="text-transform:capitalize; color: #80bc3d;" target="phdvbhelp"><i class="icon-bookalt" style="color:#80bc3d;" ></i>Knowledge Base</a>' +
                '<a href="/api/alerts/<%= id %>" class="btn-dismiss-alert text-critical" style="text-transform:capitalize; color:  #bc3d41;"><i class="icon-delete" style="color:#bc3d41;"></i> Dismiss Alert</a></p>'
            );

            var cellFormatter = {

                severity: function (value, row) {

                    var alert_severity = row.severity;
                    var iconclass = "icon-";

                    switch (alert_severity) {
                        case ALERT_SEVERITY_NOTICE:
                            iconclass += "upload";
                            break;
                        case ALERT_SEVERITY_CRITICAL:
                            iconclass += "exclamationsign";
                            break;
                        case ALERT_AT_RISK:
                            iconclass += "uui-skull";
                            break;
                        case ALERT_SEVERITY_WARNING:
                        default:
                            iconclass += "warningsign";
                            break;
                    }

                    return '<i class="' + iconclass + ' severity-icon" title="' + alert_severity + '"></i>';
                },
                created: function (value) {
                    var formatted_date;
                    switch ($rootScope.userLanguageCode){
                        case "fr":
                        case "en-gb":
                            formatted_date = value;
                            break;
                        case "en":
                        case "en-us":
                        default:
                            formatted_date = moment(value, "MMM DD, YYYY hh:mm a").format("MM/DD/YYYY hh:mm a");
                            break;
                    }
                    return formatted_date;
                }
            };
            $scope.updateCountAndColor = function (forceUpdate) {
                var force = forceUpdate || false;
                // If forcing, or no global data, or out of date global data.
                if (force || PHD.globalAlertCounts === undefined ||
                    PHD.globalAlertCounts.timestamp * 1000 + $rootScope.listOfTimer[3] < Date.now()) {
                    $http({
                        method: 'GET',
                        url: '/api/summary/current'
                    }).success(function (resultdata, status, headers) {
                        $("#app-header .alert-count_1").text(resultdata.alert_count);
                        setColorOfAlert(resultdata.max_severity, resultdata.at_risk_alert);
                        setAlertIcon(resultdata.at_risk_alert);
                        console.log("at_risk_alert::::: " + resultdata.at_risk_alert);
                    });
                } else {
                    var data = PHD.globalAlertCounts;
                    $("#app-header .alert-count_1").text(data.alert_count);
                    setColorOfAlert(data.max_severity, data.at_risk_alert);
                    setAlertIcon(data.at_risk_alert);
                }
            };
            /*Function to update the Alert widget*/
            function updateWidgetAlert(init) {
                var scope = $("[ng-controller=GlobalCtrl]").scope();
                if (!scope.user.loggedIn) {

                    return;
                }

                var url = API_DIR + '/alerts/open/?timestamp=' + $rootScope.timestamp + '&lang=' + $rootScope.userLanguageCode;
                var resp = PHD.Ajax.get(url);
                if (init === true) {
                    AlertsTable = PHD.DataTable($alertsTable, dataTableOptions).registerFormatters(cellFormatter);
                    $alertsTable.sortTable();

                }

                resp.done(function (data) {
                    $rootScope.timestamp = data.timestamp;

                    if (init === true) {

                        if (data.data.length > 50) {
                            $("#app-header .alert-count_1").css("width", "36px");
                            var splicedArray = data.data.slice(0, 51);
                            AlertsTable.load(splicedArray);
                        } else {
                            AlertsTable.load(data.data);
                            $("#app-header .alert-count_1").css("width", "18px");
                        }
                        //:ToDo AlertsTable.load(data.data);
                        //$scope.changeAlertCount('fromUpdate',data.data);


                    } else {
                        if (typeof(data.data) != 'undefined') {
                            //PHD.updateAlerts(true, data.length);
                            if (typeof(init) == 'undefined') {
                                //$scope.changeAlertCount('fromUpdate',data.data);

                                //:ToDoAlertsTable.update(data.data);
                                if (data.data.length > 50) {
                                    $("#app-header .alert-count_1").css("width", "36px");
                                    var splicedArray = data.data.slice(0, 51);
                                    AlertsTable.load(splicedArray);
                                } else {
                                    AlertsTable.load(data.data);
                                    $("#app-header .alert-count_1").css("width", "18px");
                                }
                            }

                        }
                    }

                    $alertsTable
                        .scrollTable({"height": 120, "resize": false});
                    $alertsTable.sortTable();
                    setHeaderWidth();

                });
            }

            $alertsTable
                .on("updatefinished", function (event, newRows) {
                    if (newRows) {
                        $alertsTable.sortTable();
                        $alertsIcon.animate({opacity: 0}, 500, function () {
                            $alertsIcon.animate({opacity: 1}, 500);
                        });
                    }
                })
                .on("rowselect", "tr", function (event, dbid, $row, DataTable, DataRow) {
                    DataTable.deselect();
                    if ($row.data('popover')) {
                        $row.data('popover').toggle();
                    } else {
                        var data = DataRow.data,
                            html;

                        data.kburl = alertURL(alert.source_id);
                        html = alertTmpl(data);

                        $alertDetail = $("<div>");
                        $alertDetail.html(html)
                            .on("click", ".btn-dismiss-alert", function (e) {
                                e.preventDefault();
                                if (data.severity == ALERT_SEVERITY_CRITICAL) {
                                    if ($row.data('popover')) {
                                        $row.data('popover').toggle();
                                    }
                                    PHD.confirmDialog("<p>" + gettextCatalog.getString("This alert is critical.  Are you sure you want to dismiss it?") + "</p>", {
                                        title: gettextCatalog.getString("Confirm Alert Dismissal")
                                    })
                                        .done(function () {
                                                doDelete($row, data, DataTable, true);
                                            }
                                        )
                                } else {
                                    doDelete($row, data, DataTable, true);

                                }
                            })
                            .popover({
                                anchor: $row,
                                appendTo: $widget,
                                popoverClass: 'alert-detail',
                                position: {
                                    my: "right top",
                                    at: "right top"
                                }
                            });

                        $row.data('popover').open();
                        rowPopover = $row.data('popover');
                    }
                });

            function doDelete($row, data, DataTable, fetch) {
                var sid = data.system_id;
                var id = data.id;
                var url = "/api/alerts/" + id + '/?sid=' + sid;
                var doFetch = fetch || false;


                PHD.Ajax
                    .delete(url)
                    .done(function (data) {
                        if ($row != null && rowPopover) {
                            rowPopover.destroy();
                        }
                        DataTable.deleteRow(id);
                        if (doFetch) {
                            $scope.updateCountAndColor(true);

                        }
                    });
            }

            function alertURL(type) {
                var url = $rootScope.isCE ? CE_KNOWLEDGE_BASE_URL : KNOWLEDGE_BASE_URL,
                    article = ALERT_HELP_LINKS.hasOwnProperty(type) ? ALERT_HELP_LINKS[type] : ALERT_HELP_LINKS[ALERT_TYPE_UNKNOWN];

                // -- need consolidation of this!! lmc return url + article;
                return url;
            }


            function handleDismissAll(event) {
                PHD.confirmDialog("<p>" + gettextCatalog.getString("Please take care when dismissing alerts, especially if some are critical.") + '</p>' +
                    "<p>" + gettextCatalog.getString("Dismissing does not fix the condition that caused the alert. An alert that has been dismissed \
									may display again if the alert condition has not been resolved.") + '</p>' +
                    '<p>' + gettextCatalog.getString("Are you sure you would like to dismiss all alerts?") + '</p>', {
                    title: gettextCatalog.getString("Confirm Alert Dismissal")
                })
                    .done(function () {

                        if (AlertsTable != 'undefined') {
                            AlertsTable.data.forEach(function (alert, i, array) {
                                doDelete(null, alert, AlertsTable, false);
                            });
                        }
                        $scope.updateCountAndColor(fetch);
                        updateWidgetAlert();

                    });
            }


            /*function to refresh AlertData
             *it will call updateWidgetAlert to update the
             *updateWidgetAlert
             */
            $rootScope.getAlertsRefereshData = function () {
                $scope.updateCountAndColor();
            };


            /* to Get User preference of refresh rate for Alert
             *  and also making call to manualRefreshControl method to show/hide refresh icon
             */
            $scope.userPrefernce = function () {

                $rootScope.manualRefreshControl($rootScope.listOfTimer[$rootScope.listOfWidgetName.indexOf("Alerts")] / 1000, $scope.widgetName);

            };


            $scope.$on("logged-in", function (event) {

                // lmc - we need the alert timer to be running regardless of subsystem.
                $scope.updateCountAndColor();
                $scope.userPrefernce();
            });


            /*Event will be triggered every time alert is clicked*/

            function clickEventofLI(event) {
                /*fetching the Global controller scope  */
                var scope = $("[ng-controller=GlobalCtrl]").scope();
                if (scope.modalShown == true) {
                    $scope.updateCountAndColor();
                    updateWidgetAlert(true)
                    // updateWidgetAlert('No refresh');

                    $scope.clickCount = $scope.clickCount + 1;
                    /*We need to refresh for the very first time click of Alert link*/
                    if ($scope.clickCount == 1) {


                    }
                }
                else {
                    $scope.clickCount = 0;
                }

            }

            function closeDailog() {
                var scope = $("[ng-controller=GlobalCtrl]").scope();
                if (scope.modalShown == true) {
                    scope.toggleModal();
                }
            }

            /*
             *   DOM Ready Function
             */

            $(document)
                .on("login", stopAll)
                .on("logout", stopAll)
                .on("uinav.protect", stopAll)
                .on("uinav.recover", stopAll)
                .on("uinav.jobs", stopAll)
                .on("uinav.configure", stopAll)
                .on("uinav.reports", stopAll)

            function stopAll(event) {
                $(document).off("uinav.protect", stopAll);
                $(document).off("uinav.recover", stopAll);
                $(document).off("uinav.jobs", stopAll);
                $(document).off("uinav.configure", stopAll);
                $(document).off("uinav.reports", stopAll);
                $(document).off("login", stopAll);
                $(document).off("logout", stopAll);
            }

            function startAlertTimer(event) {
                closeDailog();
                $rootScope.manualRefreshControl($rootScope.listOfTimer[$rootScope.listOfWidgetName.indexOf("Alerts")] / 1000, $scope.widgetName);
            }

            $(function () {
                /*Adding couple of event listener
                 * 1) handleDismissAll - Event to delete all alert
                 * 2) clickEventofLI - on alerts' click
                 */

                $btnDismissAll.on("click", handleDismissAll);
                $('.alerts-menu').on("click", clickEventofLI);
                $('#nav-dashboard').on("click", startAlertTimer);
                $('#nav-protect').on("click", closeDailog);
                $('#nav-recover').on("click", closeDailog);
                $('#nav-jobs').on("click", closeDailog);
                $('#nav-reports').on("click", closeDailog);
                $('#nav-configure').on("click", closeDailog);


            });

        }

    }]);
