/* Backup Widget Contorller */
angular.module('backupCopyWidgetWidgetModule', ['dynamicdashboardapp', 'ui.dashboard'])
    .controller('backupCopyWidgetContorller', function ($scope, $rootScope, $http, $timeout, gettextCatalog) {
        $scope.widgetName = "Backup Copy";
        $scope.modalShown = false;
        $scope.refreshKey = "dash_replication_refresh";
        $scope.daysArray = ["7/30", "7/31", "8/1", "8/2", "8/3", "8/4", "8/5"];
        $scope.maxValueArray = [];
        $scope.maxvalue = 6;
        $scope.maxValuewithUnits = "6 GB/s";
        $scope.dataValues = [[0, 0, 0, 0, 0, 0, 0]];
        $scope.units = "MB/s";
        $scope.colorArray = ["rgb(40,155,212)", "rgb(139,186,84)"];
        $scope.legends=[
            gettextCatalog.getString("Logical"),
            gettextCatalog.getString("Physical")   // data transferred
        ];
        $scope.reSizeGraph = true;
        $scope.toggleModal = function () {
            $scope.modalShown = !$scope.modalShown;
        };

        $rootScope.targetOptions = [
            {id: 0, name: "All Targets"}
        ]
        $rootScope.target = {
            id: 0
        };
        $scope.backupCopyProtected = 12;
        $scope.backupCopyErrors = 1;
        $scope.$on('dialogopenEvent', function (event, widget, index) {
            if (widget.name === 'BACKUP COPY - HOT TARGETS') {
                $scope.toggleModal();
                $("[id='id_backup copyRefresh']").val($rootScope.listOfTimer[6] / 1000);
                event.defaultPrevented = true;
            }
        });
        /* Event listener for manual;Refesh */
        $scope.$on('manualRefreshEvent', function (event, widget, index) {
            if (widget.name === 'BACKUP COPY - HOT TARGETS') {
                $rootScope.getBackupCopyRefereshData();
                event.defaultPrevented = true;

            }
        });
        /* Event listener for leaving the widget */
        $scope.$on('leaveWidget', function (event, widget, index) {
            if (widget.name === 'BACKUP COPY - HOT TARGETS') {
                if ($scope.modalShown) {
                    $scope.modalShown = false;
                    $timeout(function () {
                        $scope.$digest();
                    });
                }
            }
        });

        $rootScope.getBackupCopyRefereshData = function (days) {
            $http({
                method: 'GET',
                url: '/api/summary/counts/replication/'
            }).success(function (data, status, headers) {
                //var timestamp=data.timestamp *1000;
                $scope.timeStamp = data.last_updated;//getDateString(timestamp);
                $scope.errors = data.replication_errors;
                $scope.protected = data.replication_protected;
            }).error(function (data, status, headers) {

            });
        }
        $scope.getBackupCopyAverageSpeed = function (days) {
            //$scope.averageSpeed="1.56 TB";
            var total = 0;
            days = days || 7;
            url = '/api/summary/days/replication/?days=' + days;
            $http({
                method: 'GET',
                url: url
            }).success(function (data, status, headers) {
                var avgSpeedArray = data.data[0].replication_speed;
                var dataArray = [];
                var readArray = [];
                var daysArray = [];
                if (avgSpeedArray !== undefined) {
                    for (var i = 0; i < avgSpeedArray.length; i++) {
                        if (i == 0) {
                            $scope.units = avgSpeedArray[i].units;
                        }
                        total += avgSpeedArray[i].read;
                        dataArray[i] = avgSpeedArray[i].write;
                        readArray[i] = avgSpeedArray[i].read;
                        daysArray[i] = dateAxisLabel(avgSpeedArray[i].day, true);
                    }
                }

                $scope.averageSpeed = (total / 7).toFixed(1);
                $scope.dataValues = [readArray, dataArray];
                $scope.daysArray = daysArray;
                $scope.maxvalue = Math.max.apply(Math, readArray);
                $scope.maxValuewithUnits = $scope.maxvalue + $scope.units;
                var avgspeed_width = $('#backup-copy-graph-avgspeed').width();
                $('#backup-copy-graph-avgspeed').empty();

                plotWidgetBarGraph('#backup-copy-graph-avgspeed', $scope.dataValues, $scope.units, $scope.daysArray, $scope.colorArray,
                    $scope.legends, $scope.maxValuewithUnits, $scope.maxvalue, avgspeed_width);
            }).error(function (data, status, headers) {
                ;
            });

        };
        $(window).on("resize", function (event) {
            if ($scope.reSizeGraph === true) {
                var avgspeed_width = $('#backup-copy-graph-avgspeed').width();
                $('#backup-copy-graph-avgspeed').empty();

                plotWidgetBarGraph('#backup-copy-graph-avgspeed', $scope.dataValues, $scope.units, $scope.daysArray, $scope.colorArray,
                    $scope.legends, $scope.maxValuewithUnits, $scope.maxvalue, avgspeed_width);
            }
        });
        $scope.$on("languageChanged", function (event){
            if ($scope.reSizeGraph === true) {
                $scope.legends=[
                    gettextCatalog.getString("Logical"),
                    gettextCatalog.getString("Physical")   // data transferred
                ];
                $scope.getBackupCopyAverageSpeed();
            }
        });
        $scope.userPrefernce = function () {
            $rootScope.manualRefreshControl($rootScope.listOfTimer[6] / 1000, $scope.widgetName);
        }
        if ($scope.user.loggedIn) {
            $scope.userPrefernce();
            $rootScope.getBackupCopyRefereshData();
            $scope.getBackupCopyAverageSpeed();
        }
        $(document)
            .on("login", stopAll)
            .on("logout", stopAll)
            .on("uinav.protect", stopAll)
            .on("uinav.recover", stopAll)
            .on("uinav.jobs", stopAll)
            .on("uinav.configure", stopAll)
            .on("uinav.reports", stopAll);

        function stopAll(event) {
            clearInterval($rootScope.listOfTimerFunction[6]);
            $scope.reSizeGraph = false;
            $(document).off("uinav.protect", stopAll);
            $(document).off("uinav.recover", stopAll);
            $(document).off("uinav.jobs", stopAll);
            $(document).off("uinav.configure", stopAll);
            $(document).off("uinav.reports", stopAll);
            $(document).off("login", stopAll);
            $(document).off("logout", stopAll);
        }

    });