/* Backup Widget Contorller */
angular.module('backupCopyStorageWidgetModule', ['dynamicdashboardapp', 'ui.dashboard'])
    .controller('backupCopyWidgetStorageContorller', function ($scope, $rootScope, $http, $timeout, gettextCatalog) {
        $scope.widgetName = "Backup Copy Storage";
        $scope.modalShown = false;
        $scope.refreshKey = "dash_replication_refresh";
        $scope.daysArray = ["7/30", "7/31", "8/1", "8/2", "8/3", "8/4", "8/5"];
        $scope.maxValueArray = [];
        $scope.maxvalue = 6;
        $scope.maxValuewithUnits = "6 GB/s";
        $scope.dataValues = [[0, 0, 0, 0, 0, 0, 0]];
        $scope.units = "GB/s";
        $scope.colorArray = ["rgb(40,155,212)"];
        $scope.legends=[
            gettextCatalog.getString("Data Transferred")
        ];
        $scope.reSizeGraph = true;
        $scope.toggleModal = function () {
            $scope.modalShown = !$scope.modalShown;
        };
        $rootScope.targetOptions = [
            {id: 0, name: "All Targets"}
        ]
        $rootScope.target = {
            id: 0
        };
        $scope.backupCopyProtected = 12;
        $scope.backupCopyErrors = 1;
        $scope.$on('dialogopenEvent', function (event, widget, index) {
            if (widget.name === 'BACKUP COPY - COLD TARGETS') {
                $scope.toggleModal();
                $("[id='backup copy storage']").val($rootScope.listOfTimer[6] / 1000);
                event.defaultPrevented = true;
            }
        });
        /* Event listener for manual;Refesh */
        $scope.$on('manualRefreshEvent', function (event, widget, index) {
            if (widget.name === 'BACKUP COPY - COLD TARGETS') {
                $rootScope.getBackupCopyStorageRefereshData();
                event.defaultPrevented = true;

            }
        });
        /* Event listener for leaving the widget */
        $scope.$on('leaveWidget', function (event, widget, index) {
            if (widget.name === 'BACKUP COPY - COLD TARGETS') {
                if ($scope.modalShown) {
                    $scope.modalShown = false;
                    $timeout(function () {
                        $scope.$digest();
                    });
                }
            }
        });

        $rootScope.getBackupCopyStorageRefereshData = function (days) {
            $http({
                method: 'GET',
                url: '/api/summary/counts/archive/'
            }).success(function (data, status, headers) {
                //var timestamp=data.timestamp *1000;
                $scope.timeStamp = data.last_updated;//getDateString(timestamp);
                $scope.errors = data.archive_errors;
                $scope.protected = data.archive_protected;
            }).error(function (data, status, headers) {
                console.log('api_summary_days_replication_error');
            });
        }
        $scope.getBackupCopyStorageAverageSpeed = function (days) {
            days = days || 7;
            url = '/api/summary/days/archive/?days=' + days
            $http({
                method: 'GET',
                url: url
            }).success(function (data, status, headers) {
                var avgSpeedArray = data.data[1].archive_speed;
                var dataTransfered = data.data[0].archive_size;
                var dataArray = [];
                var daysArray = [];
                var total = 0;
                for (var i = 0; i < avgSpeedArray.length; i++) {
                    if (i == 0) {
                        $scope.units = dataTransfered[i].units;
                        $scope.speedUnits = avgSpeedArray[i].units;
                    }
                    dataArray[i] = dataTransfered[i].write;
                    daysArray[i] = dateAxisLabel(dataTransfered[i].day, true);
                    total += avgSpeedArray[i].avg_speed;
                }
                $scope.averageSpeed = (total / 7).toFixed(2);
                $scope.dataValues = [dataArray];
                $scope.daysArray = daysArray;
                $scope.maxvalue = Math.max.apply(Math, dataArray);
                $scope.maxValuewithUnits = $scope.maxvalue + $scope.units;
                var avgspeed_width = $('#backup-copy-storage-graph-avgspeed').width();
                $('#backup-copy-storage-graph-avgspeed').empty();
                plotWidgetBarGraph('#backup-copy-storage-graph-avgspeed', $scope.dataValues, $scope.units, $scope.daysArray, $scope.colorArray, $scope.legends, $scope.maxValuewithUnits, $scope.maxvalue, avgspeed_width);
            }).error(function (data, status, headers) {

            });

        }
        $(window).on("resize", function (event) {
            if ($scope.reSizeGraph === true) {
                var avgspeed_width = $('#backup-copy-storage-graph-avgspeed').width();
                $('#backup-copy-storage-graph-avgspeed').empty();
                plotWidgetBarGraph('#backup-copy-storage-graph-avgspeed', $scope.dataValues, $scope.units, $scope.daysArray, $scope.colorArray, $scope.legends, $scope.maxValuewithUnits, $scope.maxvalue, avgspeed_width);
            }
        });
        $scope.$on("languageChanged", function (event){
            if ($scope.reSizeGraph === true) {
                $scope.legends=[
                    gettextCatalog.getString("Data Transferred")
                ];
                $scope.getBackupCopyStorageAverageSpeed();
            }
        });
        $scope.userPrefernce = function () {
            $rootScope.manualRefreshControl($rootScope.listOfTimer[8] / 1000, $scope.widgetName);
        }
        if ($scope.user.loggedIn) {
            $scope.userPrefernce();
            $rootScope.getBackupCopyStorageRefereshData();
            $scope.getBackupCopyStorageAverageSpeed();
        }
        $(document)
            .on("login", stopAll)
            .on("logout", stopAll)
            .on("uinav.protect", stopAll)
            .on("uinav.recover", stopAll)
            .on("uinav.jobs", stopAll)
            .on("uinav.configure", stopAll)
            .on("uinav.reports", stopAll);

        function stopAll(event) {
            clearInterval($rootScope.listOfTimerFunction[8]);
            $scope.reSizeGraph = false;
            $(document).off("uinav.protect", stopAll);
            $(document).off("uinav.recover", stopAll);
            $(document).off("uinav.jobs", stopAll);
            $(document).off("uinav.configure", stopAll);
            $(document).off("uinav.reports", stopAll);
            $(document).off("login", stopAll);
            $(document).off("logout", stopAll);
        }

    });