/* Backup Widget Contorller */
angular.module('backupCopyTargetModule', ['dynamicdashboardapp', 'ui.dashboard'])
    .controller('backupCopyTargetWidgetContorller', function ($scope, $rootScope, $http, $timeout, gettextCatalog) {
        $scope.widgetName = "Backup Copy Target";
        $scope.modalShown = false;
        $scope.refreshKey = "dash_replication_refresh";
        $scope.daysArray = ["7/30", "7/31", "8/1", "8/2", "8/3", "8/4", "8/5"];
        $scope.maxValueArray = [];
        $scope.maxvalue = 6;
        $scope.maxValuewithUnits = "6 GB/s";
        $scope.dataValues = [[1, 1, 2, 3, 4, 5, 6]];
        $scope.units = "GB";
        $scope.colorArray = ["rgb(40,155,212)"];
        $scope.legends=[
            gettextCatalog.getString("Data Transferred")
        ];
        $scope.reSizeGraph = true;
        $scope.backupCopyTargetTableArray = [];
        $scope.viewLabel = "Table view";
        $scope.averageReplicatingSpeed = 0;
        $scope.toggleModal = function () {
            $scope.modalShown = !$scope.modalShown;
        };
        $scope.graphShow = true;
        $rootScope.targetOptions = [
            {id: 0, name: "All Targets"}
        ]
        $rootScope.target = {
            id: 0
        };

        // Fix bug in which the legend is not displayed on Backup Copy Target tile.
        // These are needed for plotting the labels.
        firstValue = [];
        lastValue = [];

        $scope.hideTable = function () {
            $('.toggle-table').hide();
        };
        $scope.toggleView = function () {
            //$(".toggle-graph-table").toggle();
            if ($scope.graphShow) {
                $scope.$broadcast('FLIP_EVENT_IN');
            } else {
                $scope.$broadcast('FLIP_EVENT_OUT');
            }
            $scope.graphShow = !$scope.graphShow;
            $scope.viewLabel = ($scope.graphShow === true ? "Table view" : "Summary view");

        };

        var $backupCopyTargetTable = $("#dashboard-recover-targets");
        var backupCopyTargetTable;
        var dtOptions = {
            select: false,
            multiselect: false,
            /*className: "active-jobs",*/
            /*cellClasses: ["long-text truncate", "long-text truncate", null, null], */
            placeholder: gettext("There are no active Backup Copy Targets")
        };

        var cellFormatter = {
            lastTransferred: function (value, row) {
                var strLastTransferred = row.lastTransferred;
                return '<div style="text-align:center;">' + strLastTransferred + '</div>';
            },
            avgSpeed: function (value, row) {
                var strAvgSpeed = row.avgSpeed;
                return '<div style="text-align:center;">' + strAvgSpeed + '</div>';
            },
            errors: function (value, row) {
                var strErrors = row.errors;
                return '<div style="text-align:center;">' + strErrors + '</div>';
            }
        };

        $scope.backupCopyProtected = 12;
        $scope.backupCopyErrors = 1;
        $scope.$on('dialogopenEvent', function (event, widget, index) {
            if (widget.name === 'BACKUP COPY - TARGET') {
                $scope.toggleModal();
                $("[id='id_backup copy targetRefresh']").val($rootScope.listOfTimer[9] / 1000);
                event.defaultPrevented = true;
            }
        });
        /* Event listener for manual;Refesh */
        $scope.$on('manualRefreshEvent', function (event, widget, index) {
            if (widget.name === 'BACKUP COPY - TARGET') {
                $rootScope.getBackupCopyTargetRefereshData();
                event.defaultPrevented = true;

            }
        });
        /* Event listener for leaving the widget */
        $scope.$on('leaveWidget', function (event, widget, index) {
            if (widget.name === 'BACKUP COPY - TARGET') {
                if ($scope.modalShown) {
                    $scope.modalShown = false;
                    $timeout(function () {
                        $scope.$digest();
                    });
                }
            }
        });

        $rootScope.getBackupCopyTargetRefereshData = function (days) {
            $http({
                method: 'GET',
                url: '/api/summary/counts/replicated_backup'
            }).success(function (data, status, headers) {
                //var timestamp=data.timestamp *1000;
                $scope.timeStamp = data.last_updated;//getDateString(timestamp);
                $scope.errors = data.replicated_backup_errors;
                $scope.protected = data.replicated_backup_protected;
            }).error(function (data, status, headers) {

            });
        };

        $scope.getBackupCopyTargetAverageSpeed = function (days) {
            var total = 0,
                days = days || 7,
                url = '/api/summary/target-days/?days=' + days;

            $backupCopyTargetTable = $("#dashboard-recover-targets");
            if ($backupCopyTargetTable.length) {
                backupCopyTargetTable = PHD.DataTable($backupCopyTargetTable, dtOptions).registerFormatters(cellFormatter);
            }

            $http({
                method: 'GET',
                url: url
            }).success(function (data, status, headers) {
                var avgSpeedArray = [];
                var averageSize = 0;
                var dataArray = [];
                var daysArray = [];
                var count = 0;

                /*   START: For Graph View    */
                for (var i = 0; i < 7; i++) {
                    for (key in data.data) {
                        if (i == 0) {
                            $scope.units = data.data[key][1].replicating_size[i].units;
                        }
                        count++;
                        console.log(key);
                        averageSize += data.data[key][1].replicating_size[i].write;
                        daysArray[i] = dateAxisLabel(data.data[key][1].replicating_size[i].day, true);
                    }
                    averageSize = (count != 0) ? (averageSize / 7) : 0;
                    dataArray[i] = averageSize.toFixed(2);
                }
                $scope.dataValues = [dataArray];
                $scope.daysArray = daysArray;
                $scope.maxvalue = Math.max.apply(Math, dataArray);
                $scope.maxValuewithUnits = $scope.maxvalue + $scope.units;
                $(window).resize();
                /*   END: For Graph View    */

                /*   START: For Table View    */
                var tempBackupCopyTargetArr = [];
                var totalOfAvgReplicatingSpeed = 0;
                var totalAppliance = 0;
                $scope.replicatingSpeedUnits = "MB/s";

                for (key in data.data) {
                    var backupCopyTargetObj = {};
                    var replicatingSpeed = 0;
                    $scope.replicatingSpeedUnits = data.data[key][0].replicating_speed[0].units;

                    totalAppliance += 1;
                    backupCopyTargetObj.sourceName = key;
                    backupCopyTargetObj.errors = 0;
                    backupCopyTargetObj.lastTransferred = (data.data[key][0].replicating_speed[6].write) + ' ' + $scope.replicatingSpeedUnits;

                    for (var i = 0; i < 7; i++) {
                        replicatingSpeed += data.data[key][0].replicating_speed[i].write;
                    }
                    backupCopyTargetObj.avgSpeed = (replicatingSpeed / 7).toFixed(2) + ' ' + $scope.replicatingSpeedUnits;
                    totalOfAvgReplicatingSpeed += (replicatingSpeed / 7);

                    tempBackupCopyTargetArr.push(backupCopyTargetObj);
                }
                $scope.averageReplicatingSpeed = (totalAppliance === 0) ? 0 : (totalOfAvgReplicatingSpeed / totalAppliance).toFixed(2);

                $scope.backupCopyTargetTableArray = tempBackupCopyTargetArr;
                if (backupCopyTargetTable !== undefined) {
                    backupCopyTargetTable.load($scope.backupCopyTargetTableArray);
                }

                /*   END: For Table View    */

            }).error(function (data, status, headers) {

            });

        };

        $scope.loadTable = function () {
            if (backupCopyTargetTable == undefined) {
                $backupCopyTargetTable = $("#dashboard-recover-targets");
                backupCopyTargetTable = PHD.DataTable($backupCopyTargetTable, dtOptions).registerFormatters(cellFormatter);
                backupCopyTargetTable.load($scope.backupCopyTargetTableArray);
            }
        };


        $(window).on("resize", function (event) {
            if ($scope.reSizeGraph == true) {
                var avgspeed_width = $('#backup-copy-target-graph-avgspeed').width();
                $('#backup-copy-target-graph-avgspeed').empty();
                plotWidgetBarGraph('#backup-copy-target-graph-avgspeed', $scope.dataValues, $scope.units, $scope.daysArray, $scope.colorArray, $scope.legends, $scope.maxValuewithUnits, $scope.maxvalue, avgspeed_width);
            }
        });
        $scope.$on("languageChanged", function (event){
            if ($scope.reSizeGraph === true) {
                $scope.legends=[
                    gettextCatalog.getString("Data Transferred")
                ];
                $scope.getBackupCopyTargetAverageSpeed();
            }
        });
        $scope.userPrefernce = function () {
            $rootScope.manualRefreshControl($rootScope.listOfTimer[9] / 1000, $scope.widgetName);
        };
        if ($scope.user.loggedIn) {
            $scope.userPrefernce();
            $rootScope.getBackupCopyTargetRefereshData();
            $scope.getBackupCopyTargetAverageSpeed();
        }
        $(document)
            .on("login", stopAll)
            .on("logout", stopAll)
            .on("uinav.protect", stopAll)
            .on("uinav.recover", stopAll)
            .on("uinav.jobs", stopAll)
            .on("uinav.configure", stopAll)
            .on("uinav.reports", stopAll);

        function stopAll(event) {
            clearInterval($rootScope.listOfTimerFunction[9]);
            $scope.reSizeGraph = false;
            $(document).off("uinav.protect", stopAll);
            $(document).off("uinav.recover", stopAll);
            $(document).off("uinav.jobs", stopAll);
            $(document).off("uinav.configure", stopAll);
            $(document).off("uinav.reports", stopAll);
            $(document).off("login", stopAll);
            $(document).off("logout", stopAll);
        }

    });