angular.module('dailyFeedWidgetModule',['dynamicdashboardapp','ui.dashboard','ngSanitize'])

/* getDailyFeedFactory factory class.
 * Define function to fetch unitrends forum posts from backend.
 */
.factory('getDailyFeedFactory', function ($http){
    return{
        getDailyFeed:function(url){
               var promise=$http({
               url: url, 
               method: "get"
               }).success(function(data, status, headers){

                  }).error(function(){
                   console.log("error in getting unitrends forum posts");
                  });
            return promise;
        }
    }
})

.filter('html_bind_text', ['$sce', function($sce){
        return function(text) {
            return $sce.trustAsHtml(text);
        };
}])

/* Daily Feed Widget Contorller */
.controller('DailyFeedWidgetController',function ($scope,$rootScope,$http,$timeout,getDailyFeedFactory, $window){
    $scope.refreshKey="dash_daily_feed_refresh";
    $scope.widgetName="Daily Feed";
	$scope.dailyFeedTimer=3000;
    $scope.dropdownvalue="0";
    $scope.feeds = [];
    $scope.widgetId = "591288303565025281";

    angular.element(document).ready(function () {
        if ($window.twttr === undefined) {
            $window.twttr = function(d,s,id){
                var js,fjs=d.getElementsByTagName(s)[0],
                    p=/^http:/.test(d.location)?'http':'https';
                if(!d.getElementById(id)){
                    js=d.createElement(s);
                    js.id=id;
                    js.src=p+"://platform.twitter.com/widgets.js";
                    fjs.parentNode.insertBefore(js,fjs);}
            }(document,"script","twitter-wjs");
        }
    });
  
    /*Function to load The Widget*/
    $rootScope.getDailyFeed = function(){
        getDailyFeedFactory.getDailyFeed("app/dynamic-dashboard/assets/data/DailyFeedData.json").then(function(result){
            $scope.feeds = result.data.data;
        });

    };
    
    //************************************** Refresh Forum Widget ************************

    /* Click Event Listener for open configure model dialog box  */
    $scope.modalShown=false;
    $scope.toggleModal=function(){
	        $scope.modalShown=!$scope.modalShown;
    };

    /* Event listener for dialogopenEvent */
    $scope.$on('dialogopenEvent', function (event, widget,index){
        if(widget.name === 'DAILY FEED'){
            $scope.toggleModal();
			$scope.dropdownvalue = $rootScope.dailyFeedTimer /1000;
			 $("[id='id_daily feedRefresh']").val($rootScope.listOfTimer[5]/1000);
			event.defaultPrevented = true;
        }
    });
    
    /* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
         if(widget.name === 'DAILY FEED'){
            $scope.getDailyFeed();
            event.defaultPrevented = true;
		    
         }
    });

    /* Event listener for leaving the widget */
    $scope.$on('leaveWidget', function (event, widget,index){
        if(widget.name === 'DAILY FEED'){
            if ($scope.modalShown) {
                $scope.modalShown = false;
                $timeout(function() {
                    $scope.$digest();
                });
            }
        }
    });

    /* Event listener for DashboardPreferenceChanged, propagated to the widgets */
    $scope.$on('DashBoardPreferenceChangedEvent', function (event, widgets,index) {
        if ($window.twttr !== undefined && widgets instanceof Array) {
            for (var i = 0; i < widgets.length; i++) {
                if (widgets[i].name === 'DAILY FEED') {
                    var timeline = document.getElementById("id-twitter-timeline");
                    var $timeline = angular.element(timeline);
                    if ($timeline.length > 0) {
                        $timeline.empty();
                        // The twitter timeline gets deleted on widget move, so re-create it.
                        // Use the same widgetID and options as defined in dailyFeedWidget.html
                        $window.twttr.widgets.createTimeline($scope.widgetId, timeline, { chrome: 'noheader' });
                    }
                    break;
                }
            }
        }
    });

    
    /*to Get User prefrence*/
    $scope.userPrefernce = function(){
        $rootScope.manualRefreshControl($rootScope.listOfTimer[5]/1000,$scope.widgetName);
        $("[id='IDDAILY FEED']").css("display","none");
        $("[id='toruidDAILY FEED'] .configwidget").css("display","none");
    };

    // Load twitter widget if defined.
    $scope.loadTwitterWidget = function() {
        if (typeof $window.twttr !== 'undefined') {
            //console.log("load twitter");
            var timeline = document.getElementById("id-twitter-timeline");
            var $timeline = angular.element(timeline);
            if ($timeline.length > 0) {
                $window.twttr.widgets.load(timeline);
            }
        }
    };

	if ($scope.user.loggedIn){
		$scope.getDailyFeed();
        // retry the twitter widget load if not available.
        $timeout($scope.loadTwitterWidget, 500);
    }
	
    $(document)
		.on("login", function (event){
			$scope.getDailyFeed();
            stopAll();
		})
        .on("logout", stopAll)
        .on("uinav.protect", stopAll)
        .on("uinav.recover", stopAll)
        .on("uinav.jobs", stopAll)
        .on("uinav.configure", stopAll)
        .on("uinav.reports", stopAll);

	function stopAll(){
	    clearInterval($rootScope.listOfTimerFunction[5]);
        $(document).off("uinav.protect", stopAll);
        $(document).off("uinav.recover", stopAll);
        $(document).off("uinav.jobs", stopAll);
        $(document).off("uinav.configure", stopAll);
        $(document).off("uinav.reports", stopAll);
        $(document).off("login");
        $(document).off("logout", stopAll);
	}

});