angular.module('dynamicDashboardUtilityModule',[])


/* Function for plot barGraph graph */
function plotBarGraph(r,width_default,yAixsValuesFirst,yAixsValuesSecond)
{
    var fin=function (){
        this.flag=r.popup(this.bar.x, this.bar.y, this.bar.value || "0").insertBefore(this);
    };
    
    var fout=function (){
        this.flag.animate({opacity: 0},0, function (){this.remove();});
    };
    
    if(yAixsValuesSecond.length > 0){
        r.barchart(10, 10, width_default,120, [yAixsValuesFirst, yAixsValuesSecond],{stacked: false, type: "soft"}).hover(fin, fout);    
    }else{
        r.barchart(10, 10, width_default, 120, [yAixsValuesFirst],{stacked: false, type: "soft"}).hover(fin, fout);    
    }
}

/* Function for plot line graph */
function plotLineGraph(r,width_default,yAixsValuesFirst,yAixsValuesSecond){ 
    var xAxisValues=[0,1,2,3,4,5,6];
    var tooltip =yAixsValuesFirst.concat(yAixsValuesSecond);
    var lineClasses=["line-blue", "line-green", "line-red"];

    var loadChart=r.linechart(10,10, width_default-50, 50, [xAxisValues ,xAxisValues], [yAixsValuesFirst,yAixsValuesSecond],{
        gutter   : 0,
        nostroke : false,
        axis     : "0 0 0 0",
        smooth   : true,
        shade    : false,
        symbol   : "circle",
        colors   : ["#204363","#80bc3d"],
        dots     : true
     });

    var lineClasses=["line-blue", "line-green", "line-red"];
    var NUM_POINTS=7;
    var c =0;
    
    loadChart.each(function(){
        var node=$(this.symbol.node),
            color=node.attr("fill"),
            arrIndex=Math.floor(c/NUM_POINTS);

        var tooltipValue=tooltip[c].toString()
            $(this.symbol.node)
                .attr("fill", "#fff")
                .attr("stroke", color)
                .css("cursor", "pointer")
                .tooltip({
                    content: tooltipValue,
                    items: "circle",
                    track: true,
                    tooltipClass: lineClasses[arrIndex],
                    position:{
                        my: "center bottom-5",
                        at: "center top"
                    }
                });
        c++;
    });
    loadChart.symbols.attr({r: 3, "stroke-weight": 1});
    loadChart.symbols.attr({ r: 4});
    loadChart.lines[0].animate({"stroke-width": 2}, 1000);
}
/* convert timeStamp in date String */
function getDateString(timeStamp){
    var dateString=new Date(timeStamp).toString();
    /*var index =dateString.indexOf('GMT');
    var timeStampTitle=dateString.substring(0,index);*/
    return dateString;
}