var storageWidgetModule = angular.module('storageWidgetModule',['dynamicdashboardapp','ui.dashboard']);

storageWidgetModule.controller('storageWidgetCtrl', ['$scope', '$rootScope', '$http', '$compile', '$timeout', 'gettextCatalog',
    function($scope, $rootScope, $http, $compile, $timeout, gettextCatalog){
    
			$scope.refreshKey="dash_storage_refresh";
			$scope.widgetName="Storage";
			$scope.dropdownvalue="0";

            $scope.viewLabel = "Bar chart view";
            $scope.graphShow=false;

            $scope.hideTable = function() {
                $('.toggle-table').hide();
            };
            $scope.toggleView = function() {
                //$(".toggle-graph-table").toggle();
                if ($scope.graphShow) {
                    $scope.$broadcast('FLIP_EVENT_OUT');
                } else {
                    $scope.$broadcast('FLIP_EVENT_IN');
                    $scope.resetFlipSide();
                    $scope.showGraph();
                }
                $scope.graphShow = !$scope.graphShow;
                $scope.viewLabel = ($scope.graphShow === true ? "Table view" : "Bar chart view");
                /*
                 $(window).resize();
                 */
            };

            $scope.showGraph = function() {
                $("#flot_holder").show();
                createBarChartData($scope.graphData, gettextCatalog, "dash-storage-barchart", "graph-container-xlarge", 800, 20,
                    gettextCatalog.getString("BACKUP STORAGE USAGE"), 200, true);
            };

            $scope.resetFlipSide = function() {
              $("#flot_holder").hide();
              $("#flot_holder").empty();
            };


            var statelessInfo = PHD.Ajax.get("/api/storage/stateless/?sid=" + PHD.appliance_sid);

            statelessInfo.done(function(dataStateless) {
                $scope.isStateless = dataStateless.stateless;
            });

            var $widget = $("#widget-storage"),
                $prefTrigger = $widget.find(".preference-trigger"),
                $storageTable = $("#dashboard-storage"),
                $storageTotalProgress = $("#storage-widget-total-progress"),
                refreshRate = refreshRates.dash_storage_refresh,
                namespace = "storagewidget",
                StorageTable, UserPreference,
                threshold_lookup = [];

            var dtOptions = {
                select: false,
                multiselect: false,
                className: "storage",
                cellClasses: ["long-text truncate", "long-text truncate", null, "table-icon-small", null, null]
            };


             function usageLookup(usage) {
                var icon = '<i class="icon-uui-backup' + ' icon-large text-standard" title="' + 'Backup' + '"></i> ';
                if (usage == 'archive') {
                    icon = '<i class="icon-uui-backup-copy icon-large text-standard" title="' + 'Backup Copy' + '"></i> ';
                }
                return icon;
            }

            var storage_icon_map = {};
            storage_icon_map[""] = "harddrive";
            storage_icon_map["internal"] = "harddrive";
            storage_icon_map["stateless"] = "harddrive";
            storage_icon_map["disk"] = "harddrive";
            storage_icon_map["iscsi"] = "harddrive";
            storage_icon_map["added_internal"] = "harddrive";

            function getStorageType(row) {
                var type = 'attached';
                var icon_name = 'harddrive';
                if (row.type === 'nas') {
                    if (row.properties !== undefined && row.properties != null) {
                        icon_name = type = row.properties.protocol;
			         }
                } else {
				    icon_name = storage_icon_map[row.type];
			    }
			    var icon = '<i class="icon-uui-' + icon_name + ' icon-large text-standard" title="' + type + '"></i>';
                return icon;
            }
            var cellFormatter = {
				/*
				 * Create hyperlinks from storage to Configure page, with routeParams to select the storage by appliance, usage, and id.
				 */
                name: function (value, row) {
                    var html = '';
                    if ($rootScope.configureDisabled) {
                        html = '<span class="truncates item-name">' + value + '</span>';
                    } else {
                        html = '<span class="truncates item-name" title="Click to go to the Configure page"><a href ng-click="selectStorage(' +
                            row.id + ', ' +
                            '\'' + row.usage + '\', ' +
                            row.sid + ')">' +
                            value + '</a></span>';
                    }
                    return html;
                },

                icon_type: function(value, row){
                    var usageIcon = usageLookup(row.usage),
                        stoIcon = getStorageType(row);
                    return usageIcon + stoIcon;
                },
                mb_free: function (value, row) {
                    var used_allocated = "";
                    var percent_used = 0;
                    var state = "storage-";
                    if (row.mb_size !== undefined) {
                        var sizeVal = row.mb_size;
                        var freeVal = row.mb_free;
                        if (sizeVal === 0) {
                            used_allocated = "Not Available";
                            state += "unknown";
                            percent_used = 100;
                        } else {
                            var size = PHD.util.formatMB(sizeVal);
                            var used = PHD.util.formatMB(sizeVal - freeVal);
                            used_allocated = "" + used + " / " + size;
                            percent_used = ((sizeVal - freeVal) * 100.0) / sizeVal;
                            if (percent_used < STORAGE_WARNING_THRESHOLD) state += "ok";
                            if (percent_used >= STORAGE_WARNING_THRESHOLD && percent_used < STORAGE_CRITICAL_THRESHOLD) state += "warn";
                            if (percent_used >= STORAGE_CRITICAL_THRESHOLD) state += "critical";
                        }
                    }
                    return '<div class="progress-bar" title="' + used_allocated + '">' +
                        '<div class="progress-meter ' + state + '" style="width:' + percent_used + '%;"></div></div>';
                },
                status: function (value, row) {
                    var iconClass = value === "online" ? "okcircle" : "forbidden";
                    var iconColor="";
                    if(value=="online"){
                        iconColor = '#80bc3d';
                    }else if(value != "online"){
                        iconColor = 'hsl(358, 51%, 49%)';
                    }
                    
                    var statusIcon = '<i class="icon-'+ iconClass +' icon-large"  title="' + value + '"></i>';
                    if (row.is_purging === true) {
                        var purge_title = "Purging " + PHD.util.formatMB(row.mb_to_purge);
                        statusIcon = '<i class="icon-phd-sync icon-large" title="' + purge_title + '"></i>';
                    }
                    return '<span style="color:' + iconColor + ';margin-right:2px;" class="storage-status">' + statusIcon + '</span>';
                }
            };
            
        
    
            $rootScope.getStorageData = function(init) {
              
                var resp;

                if (init === true) {
                    StorageTable = PHD.DataTable($storageTable, dtOptions);
                    StorageTable.registerFormatters(cellFormatter);
                    // Once the table is loaded, compile the elements to that name click calls selectStorage function.
                    StorageTable.on("loadfinished updatefinished", function (event, newRows) {
                        var elements = angular.element(document.getElementById("dashboard-storage"));
                        $compile(elements.contents())($scope);
                        $scope.$digest();
                    });
                }
                resp = PHD.Ajax.get("/api/storage/?usage=backup,archive");

                resp.done(function (data) {
                    var i;
                    if (typeof data.storage !== 'undefined') {
                        if (init === true) {

                            // Storage 30-day history
                            var history = createHistory(data.storage);
                            StorageTable.load(data.storage);
                            $scope.graphData = {data: {data: history}};
                        } else {
                            history = createHistory(data.storage);
                            StorageTable.update(data.storage, true);
                            $scope.graphData = {data: {data: history}};
                        }
                    }

                    $storageTable.scrollTable({"height": ".widget-content"});

                    totals = data.totals;
                    if (typeof totals !== 'undefined') {
                        $("[data-source-total]").each(function (index) {
                            var $el = $(this),
                                key = $el.attr("data-source-total");

                            if (totals.hasOwnProperty(key)) {
                                $el.text(totals[key]);
                            }
                        });

                        $storageTotalProgress
                            .attr("title", totals["used_allocated"])
                            .children(".progress-meter").css("width", totals["percent_used"] + "%");
                    }
                    $("#dashboard-storage .storage-status" ).parent().css( "text-align", "center" );
				});
            };

            function createHistory(storage) {
                var history = [];

                for (i = 0; i < storage.length; ++i) {
                    var id = storage[i].id;
                    threshold_lookup[id] = {
                        warn_threshold: (typeof storage[i] !== 'undefined') ? storage[i].warn_threshold : 0,
                        stop_threshold: (typeof storage[i] !== 'undefined') ? storage[i].stop_threshold : 0
                    };

                    // Create history of each non-archive storage, in a format consuable by the report charting function.
                    var usage = storage[i].usage;
                    if (usage !== 'archive') {
                        var size_history = storage[i].storage_history;
                        for (var j = 0; j < size_history.length; j++) {
                            size_history[j].day = size_history[j].date;
                        }
                        history.push({size_history: size_history});
                    }
                }
                return history;
            }

            $scope.userPrefernce = function(){
                 $rootScope.manualRefreshControl($rootScope.listOfTimer[2]/1000,$scope.widgetName);
                $("#dashboard-storage .storage-status" ).parent().css( "text-align", "center" );
            };

            $scope.cancelRefreshChange = function() {
                $rootScope.userPreferenceParentCancel($rootScope.listOfTimer[2]/1000, $scope.widgetName);
            };

           if ($scope.user.loggedIn) {
                $scope.userPrefernce();
                $scope.getStorageData(true);
               
            }
            $(document)
                .on("login", function (event) {
                    $scope.getStorageData(true);
                    stopAll();
                })
                .on("logout", stopAll)
                .on("uinav.protect", stopAll)
                .on("uinav.recover", stopAll)
                .on("uinav.jobs", stopAll)
                .on("uinav.configure", stopAll)
                .on("uinav.reports", stopAll);

            function stopAll() {
                clearInterval($rootScope.listOfTimerFunction[2]);
                $(document).off("uinav.protect", stopAll);
                $(document).off("uinav.recover", stopAll);
                $(document).off("uinav.jobs", stopAll);
                $(document).off("uinav.configure", stopAll);
                $(document).off("uinav.reports", stopAll);
                $(document).off("login");
                $(document).off("logout", stopAll);
            }  
            
            $scope.modalShown=false;
            $scope.toggleModal=function(){
                $scope.modalShown= !$scope.modalShown;
            };

            /* Click Event Listener for open configure model dialog box  */
            $scope.$on('dialogopenEvent', function (event, widget, index){
               
                if(widget.name === 'STORAGE'){
                    $scope.toggleModal();
                    $scope.widgetID='ID'+index;
                    $scope.dropdownvalue = $rootScope.backupTimer /1000;
                    $('#id_storageRefresh').val($rootScope.listOfTimer[2]/1000);
					event.defaultPrevented = true;
                    $("#dashboard-storage .storage-status" ).parent().css( "text-align", "center" );
                    
                }
            });

			/* Event listener for manual;Refesh */
			$scope.$on('manualRefreshEvent', function (event, widget,index){
			    if(widget.name === 'STORAGE'){
					$scope.getStorageData(true);
					event.defaultPrevented = true;
                    $("#dashboard-storage .storage-status" ).parent().css( "text-align", "center" );
				}
			});

            /* Event listener for drilldown to protect status */
            $scope.$on('drilldownEvent', function (event, widget, index){
                if(widget.name === 'STORAGE'){
                    $scope.runReport(5, 6);
                }
            });

            /* Event listener for leaving the widget */
            $scope.$on('leaveWidget', function (event, widget,index){
                if(widget.name === 'STORAGE'){
                    if ($scope.modalShown) {
                        $scope.modalShown = false;
                        $timeout(function() {
                            $scope.$digest();
                        });
                    }
                }
            });

            /*
             *  On selection of storage, use route parameters to select it on the configure page.
             *  See routeParams for ConfigCtrl.
             */
            $scope.selectStorage = function(id, usage, sid) {
                var e = $.Event('uinav.configure');
                $(document).trigger(e);
                location.href = "#/configure/" + id + '/' + usage + '/' + sid;
            };

}]);