
/********************** Validation for Add Forum Account *********************/
function isAddFormValid(gettextCatalog){
    addAccemailValidator(gettextCatalog);
    isAddEmailCorrectFormat(gettextCatalog);
     $("#form-add-account").validate({
         errorLabelContainer: ".add-forum-list",
            errorContainer: ".createforum-dialog-errors",
            showErrors: function(errorMap, errorList) {
                $(".datetime-dialog-errors").find(".summary")
                    .html(gettextCatalog.getString("Correct the following errors:"));
                this.defaultShowErrors();
        },
        rules: {  
            txtAcEmailname: {
                required: true,
                isAddEmailValid:true
            },
            add_acc_password_name: {
                required: true
            },
            confirm_acc_password_name: {
                required: true,
                isPasswordMatch:true
            }

        },
        messages: {
                txtAcEmailname: {
                    required:gettextCatalog.getString("Email is required.")
                },
                add_acc_password_name:gettextCatalog.getString("Password is required."),
                confirm_acc_password_name:{
                    required: gettextCatalog.getString("Confirm password is required.")
            }
        }
    });
    if((!$('#form-add-account').valid())) {
        return false;
    }else{
        return true;
    }
 }

function addAccemailValidator(gettextCatalog){
            var addAccountPsw = $("#add_acc_password").val();
            var confimPasswdEmail = $("#confirm_acc_password").val();
       $.validator.addMethod("isPasswordMatch", function(value, element) { 
              if(addAccountPsw === confimPasswdEmail)
                      return true;
                else
                    return false;

    }, gettextCatalog.getString("Confirm password and password, do not match."));
}
/********************** Create Forum Account *********************/
function isCreateForumFormValid(gettextCatalog){
    createAccemailValidator(gettextCatalog);
    isCreateEmailCorrectFormat(gettextCatalog);
     $("#form-create-forum-account").validate({
         
        errorLabelContainer: ".create-forum-list",
        errorContainer: ".create-forum-dialog-errors",
        showErrors: function(errorMap, errorList) {
            $(".datetime-dialog-errors").find(".summary")
                .html(gettextCatalog.getString("Correct the following errors:"));
            this.defaultShowErrors();
        },
        rules: {  
            txtNickName: {
                required: true
            },
            txtFirstName: {
                required: true
            },
             txtLastName: {
                required: true
            },
             txtEmail: {
                required: true,
                 isCreateEmailValid:true
            },
             create_forum_password: {
                required: true
            },
            create_confirm_password: {
                required: true,
                isCreatePasswordMatch:true
            }

        },
        messages: {
                txtNickName: gettextCatalog.getString("Nickname is required."),
                txtFirstName: gettextCatalog.getString("First name is required."),
                txtLastName: gettextCatalog.getString("Last name is required."),
                txtEmail:{
                    required: gettextCatalog.getString("Email is required.")
                },
                create_forum_password:gettextCatalog.getString("Password is required."),
            
                create_confirm_password:{
                    required: gettextCatalog.getString("Confirm password is required.")
            }
        }
    });
    if((!$('#form-create-forum-account').valid())) {
        return false;
    }else{
        return true;
    }
 }

function createAccemailValidator(gettextCatalog){
            var createAccountPsw = $("#create_forum_password").val();
            var changeConfimPasswdEmail = $("#create_confirm_password").val();
       $.validator.addMethod("isCreatePasswordMatch", function(value, element) { 
              if(createAccountPsw === changeConfimPasswdEmail)
                      return true;
                else
                    return false;

    }, gettextCatalog.getString("Confirm password and password, do not match."));
}

/********************** Change Forum Account *********************/
function isChangeFormValid(gettextCatalog){
    
    changeAccemailValidator(gettextCatalog);
    isChangeEmailCorrectFormat(gettextCatalog);
     $("#form-create-account").validate({
        errorLabelContainer: ".change-forum-list",
        errorContainer: ".change-dialog-errors",
        showErrors: function(errorMap, errorList) {
            $(".datetime-dialog-errors").find(".summary")
                .html(gettextCatalog.getString("Correct the following errors:"));
            this.defaultShowErrors();
        },
        rules: {
            txtchangeAccEmail: {
                required: true,
                isEmailValid: true
            },
            change_acc_password: {
                required: true
            },
            change_confirm_password: {
                required: true,
                isChangePasswordMatch:true
            }

        },
        messages: {
                txtchangeAccEmail: {
                    required: gettextCatalog.getString("Email is required.")
                },
                change_acc_password: gettextCatalog.getString("Password is required."),
                change_confirm_password:{
                    required: gettextCatalog.getString("Confirm password is required.")
            }
        }
    });
    if((!$('#form-create-account').valid())) {
        return false;
    }else{
        return true;
    }
 }

function changeAccemailValidator(gettextCatalog){
            var changeAccountPsw = $("#change_acc_password").val();
            var ChangeConfimPasswdEmail = $("#change_confirm_password").val();
       $.validator.addMethod("isChangePasswordMatch", function(value, element) { 
              if(changeAccountPsw === ChangeConfimPasswdEmail)
                    return true;
                else
                    return false;

    }, gettextCatalog.getString("Confirm password and password, do not match."));
}
/*************************** Refresh dashbord wizards **********************/
function refreshPage(){
    var currentPage = angular.element(document.getElementById("app-main"));

            var injector = currentPage.injector();
            var route = injector.get('$route');
            route.reload();
}

function refreshPageAndReloadTour(){
    refreshPage();
    setTimeout(function(){
        var $scope = $("[ng-controller=GlobalCtrl]").scope();
        $scope.user.showTour = true;
        window.location.href = "#/dashboard/";
        resetTour = false;

    }, 1000);
}


function isCreateEmailCorrectFormat(gettextCatalog){
    
     $.validator.addMethod("isCreateEmailValid", function(value, element) { 
        var testEmail = /^[A-Z0-9._%+-]+@([A-Z0-9-]+\.)+[A-Z]{2,4}$/i;
         var createEmail =  $("#txtEmailId").val();
            if (testEmail.test(createEmail))
                return true;
            else 
                return false;
          }, gettextCatalog.getString("Please enter a valid email address."));
}

function isChangeEmailCorrectFormat(gettextCatalog){
    
     $.validator.addMethod("isEmailValid", function(value, element) { 
        var testEmail = /^[A-Z0-9._%+-]+@([A-Z0-9-]+\.)+[A-Z]{2,4}$/i;
         var email =  $("#txtchangeAccEmail").val();
            if (testEmail.test(email))
                return true;
            else 
                return false;
          }, gettextCatalog.getString("Please enter a valid email address."));
}

function isAddEmailCorrectFormat(gettextCatalog){
    
     $.validator.addMethod("isAddEmailValid", function(value, element) { 
        var testEmail = /^[A-Z0-9._%+-]+@([A-Z0-9-]+\.)+[A-Z]{2,4}$/i;
         var addEmail =  $("#txtAcEmailId").val();
            if (testEmail.test(addEmail))
                return true;
            else 
                return false;
          }, gettextCatalog.getString("Please enter a valid email address."));
}