var topforumModule = angular.module('topForumPostsWidgetModule',['dynamicdashboardapp','ui.dashboard','angulartics', 'angulartics.google.analytics']);

var load=null;

topforumModule.factory('topForumFactory', function($http) {
    return {
        getForumPosts: function(method,url,enviornmentID,dataObj) {
            var params = {};
            if (enviornmentID != 0) {
                params.sid = enviornmentID;
            }
            var promise = $http({
                url: url,
                data: JSON.stringify(dataObj),
                method: method,
                params: params
            }).success(function(data, status, headers){
                PHD.hideLoadingIndicator(load);
                load=null;
            }).error(function(response){
                window.PHD.throwError({"result": [{"message": gettext(response.result[0].message)}]});
                PHD.hideLoadingIndicator(load);
                load=null;
            });
            return promise;
        }
    };
});

/* Top Forum Widget Widget Contorller */
topforumModule.controller('TopForumPostsWidgetCtrl', function ($scope,$rootScope,$http,topForumFactory, $analytics, $window, $timeout, gettextCatalog){
    
    $scope.refreshKey="dash_forum_posts_refresh";
    $scope.widgetName="Post";
	$scope.forumpostTimer=3000;
    $scope.dropdownvalue="0";
    
    $scope.feeds = [];
    $scope.modalShown=false;
    $scope.isForumPostsshow=true;
    $scope.salesforce_id = null;
    $scope.userName = "";
    
    /* Click Event Listener for open configure model dialog box  */
    $scope.toggleModal=function(eventToTrack){
        var analyticsEvent = eventToTrack || false;
        if (analyticsEvent) {
            $analytics && $analytics.eventTrack(analyticsEvent, {  category: 'Forum', label: 'Forum Posts' });
        }
        $scope.modalShown=!$scope.modalShown;
    };

    /* Event listener for dialogopenEvent */
    $scope.$on('dialogopenEvent', function (event, widget,index){
        if(widget.name === 'COMMUNITY'){
            $scope.toggleModal();
            //$scope.dropdownvalue = $rootScope.forumpostTimer /1000;
			$('#id_postRefresh').val($rootScope.listOfTimer[4]/1000);
			event.defaultPrevented = true;
        }
    });
    
    /* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
     if(widget.name === 'COMMUNITY'){
		$scope.getTopForumPosts();
		event.defaultPrevented = true;
		    
        }
    });

    /* Event listener for drilldown to protect status */
    $scope.$on('drilldownEvent', function (event, widget, index){
        if(widget.name === 'COMMUNITY'){
            var forumLink = $rootScope.isCE ? CE_BROWSER_URL : DOCUMENTATION_URL;
            $window.open(forumLink);
        }
    });

    /* Event listener for leaving the widget */
    $scope.$on('leaveWidget', function (event, widget,index){
        if(widget.name === 'COMMUNITY'){
            if ($scope.modalShown) {
                $scope.modalShown = false;
                $timeout(function() {
                    $scope.$digest();
                });
            }
        }
    });
    
    /*Function to load The Widget*/
	var allUserURL ="/api/forum/users/user/";
    $rootScope.getTopForumPosts = function(){
        topForumFactory.getForumPosts('get',allUserURL,1,"").then(function(result){
            for(var i= 0; i<result.data.data.length;i++){
                if(result.data.data[i].id === 1){
                    if(result.data.data[i].credentials.salesforce_id != null && result.data.data[i].credentials.salesforce_id !== ""){
                        $scope.salesforce_id = result.data.data[i].credentials.salesforce_id;
                        $scope.userName = result.data.data[i].credentials.username;
                    }
                    break;
                }
            }
            var forumPostURL =  "/api/forum/posts/";
            if($rootScope.isCE){
                forumPostURL = forumPostURL+"ce";
            }else {
                forumPostURL = forumPostURL+"ueb";
            }
            topForumFactory.getForumPosts('get',forumPostURL,0,"").then(function(result){
                $scope.isForumPostsshow = true;
                $scope.feeds = result.data.posts;
                $timeout(function () {
                    $scope.$apply();
                }, 0);
            });
        });
    };

    $scope.getUserForumPosts = function() {
        $rootScope.getTopForumPosts();
    };
    
    $scope.openCreateForumAccountWZ = function(){
        $("#txtEmailId").val("");// Making field blank on UI.
        $("#create_forum_password").val("");// Making field blank on UI.
        $("#create_confirm_password").val("");// Making field blank on UI.
        
         if($(".control-group").hasClass("error")){
            $("#create-forum-widget #dialog-errors").css("display", "none");
            $(".control-group").removeClass("error");
        }

        $("#create-forum-widget").dialog({
            modal: true,
            draggable: true,
            resizable: false,
            title:gettextCatalog.getString("Create a Forum Account"),
            width: 450,
            height:500,
            dialogClass: 'ui-dialog-osx',
            buttons: [
                {
                    text: gettextCatalog.getString("Create"),
                    click: function () {
                        if(isCreateForumFormValid(gettextCatalog)){
                            load = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Saving..."));
                            var forumUserURL =  "/api/forum/users/user/";
                            var account ={};

                            account.user_id =1;
                            account.email =$("#txtEmailId").val();
                            account.password =$("#create_forum_password").val();
                            account.nickname =$("#txtNickName").val();
                            account.first_name =$("#txtFirstName").val();
                            account.last_name =$("#txtLastName").val();

                            topForumFactory.getForumPosts('post',forumUserURL,1,account).then(function(result){
                                $scope.getUserForumPosts();
                                $analytics && $analytics.eventTrack('Create Account', {  category: 'Forum', label: 'Forum Posts' });
                                $("#create-forum-widget").dialog("close");// once response return success then dialog will close.
                                //refreshPage();
                            });
                        }
                    }
                },
                {
                    text: gettextCatalog.getString("Cancel"),
                    click: function () {
                        $analytics && $analytics.eventTrack('Cancel Create Account', {  category: 'Forum', label: 'Forum Posts' });
                        $(this).dialog("close");
                        $("#form-errors").hide();
                    }
                }
            ]
        });
    };
   
    
    $scope.addForumAccount = function(){ 
        $("#txtAcEmailId").val("");// Making field blank on UI.
        $("#add_acc_password").val("");// Making field blank on UI.
        $("#confirm_acc_password").val("");// Making field blank on UI.
        
         if($(".control-group").hasClass("error")){
            $("#add-forum-widget #dialog-errors").css("display", "none");
            $(".control-group").removeClass("error");
        }
        
        $scope.toggleModal();
        $("#add-forum-widget").dialog({
            modal: true,
            draggable: true,
            resizable: false,
            title: gettextCatalog.getString("Add a Forum Account"),
            width: 450,
            height:350,
            dialogClass: 'ui-dialog-osx',
            buttons: [
                {
                    text: gettextCatalog.getString("Add"),
                    click: function () {
                        if(isAddFormValid(gettextCatalog)){
                            load = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Saving..."));

                            var connectNowURL = "/api/forum/authenticate/";
                            var connectNow = {};
                            connectNow.user_id = 1;
                            connectNow.email = $("#txtAcEmailId").val();
                            connectNow.password = $("#add_acc_password").val();

                            topForumFactory.getForumPosts('post',connectNowURL,1,connectNow).then(function(result){
                                $scope.getUserForumPosts();
                                $analytics && $analytics.eventTrack('Add Account', {  category: 'Forum', label: 'Forum Posts' });
                                $("#add-forum-widget").dialog("close");// once response return success then dialog will close.
                                //refreshPage();
                            });
                        }
                    }
                },
                {
                    text: gettextCatalog.getString("Cancel"),
                    click: function () {
                        $analytics && $analytics.eventTrack('Cancel Add Account', {  category: 'Forum', label: 'Forum Posts' });
                        $(this).dialog("close");
                        $("#form-errors").hide();
                    }
                }
            ]
        });
    };
    
    //************************************** Change Forum account ************************
    $scope.openChangeForumDialog = function(){
        $("#txtchangeAccEmail").val("");
        $("#change_acc_password").val("");
        $("#change_confirm_password").val("");
        
        if($(".control-group").hasClass("error")){
            $("#form-create-account #dialog-errors").css("display", "none");
            $(".control-group").removeClass("error");
        }
        $scope.toggleModal();
        
        $("#change-forum-widget").dialog({
            modal: true,
            draggable: true,
            resizable: false,
            title: gettextCatalog.getString("Change Forum Account"),
            width: 450,
            height:350,
            dialogClass: 'ui-dialog-osx',
            buttons: [
                {
                    text: gettextCatalog.getString("Change"),
                    click: function () {
                        var $self = $(this);
                        if (isChangeFormValid(gettextCatalog)) {
                            load = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Saving..."));

                            var connectNowURL = "/api/forum/authenticate/";
                            var connectNow = {};
                            connectNow.user_id = 1;
                            connectNow.email = $("#txtchangeAccEmail").val();
                            connectNow.password = $("#change_acc_password").val();

                            topForumFactory.getForumPosts('post',connectNowURL,1,connectNow).then(function(result){
                                $scope.getUserForumPosts();
                                $analytics && $analytics.eventTrack('Change Account', {  category: 'Forum', label: 'Forum Posts' });
                                $self.dialog("close");// once response return success then dialog will close.
                                //refreshPage();
                            });
                        }
                    }
                },
                {
                    text: gettextCatalog.getString("Cancel"),
                    click: function () {
                        $(this).dialog("close");
                    }
                }
            ]
        });
    };
    
    
    //************************************** Refresh Forum Widget ************************
    
    /*to Get User prefrence*/
	$scope.userPrefernce = function(){
	       $rootScope.manualRefreshControl($rootScope.listOfTimer[4]/1000,$scope.widgetName);
	};
	
	
	if ($scope.user.loggedIn){
		$scope.userPrefernce();
		$scope.getTopForumPosts();
    }
	
    $(document)
		.on("login", function (event){
			$scope.getTopForumPosts();
			stopAll();
		})
        .on("logout", stopAll)
        .on("uinav.protect", stopAll)
        .on("uinav.recover", stopAll)
        .on("uinav.jobs", stopAll)
        .on("uinav.configure", stopAll)
        .on("uinav.reports", stopAll);

	function stopAll(){
	    clearInterval($rootScope.listOfTimerFunction[4]);
        $(document).off("uinav.protect", stopAll);
        $(document).off("uinav.recover", stopAll);
        $(document).off("uinav.jobs", stopAll);
        $(document).off("uinav.configure", stopAll);
        $(document).off("uinav.reports", stopAll);
        $(document).off("login");
        $(document).off("logout", stopAll);
	} 
});