var dynamicDashboardTourModel =  angular.module('tourDashModel',['tour-module', 'configAssets']);

dynamicDashboardTourModel.controller('tourDynamicDashboardCtrl', function ($scope, $rootScope,tourFactory){
   $scope.HEADER_NAVIGATION = 1;
   $scope.GLOBAL            = 2;
    $scope.TILE             = 3;
    $scope.BACKUP_SUMMARY   = 4;
    $scope.STORAGE          = 5;
    $scope.ACTIVE_JOB       = 6;
    $scope.isXen = $rootScope.isXen;
    
    var $headerTarget = $("#widget-tour-dynamic");
    $scope.$currentStep = $rootScope.user.tourStep;

    if ($rootScope.isCE) {
        $scope.tourTitleHtml = 'Unitrends Free<sup class="free-sup">TM</sup>' + ($rootScope.isGoogle ? ' for Google Cloud Platform' : '');
    } else if ($rootScope.isUEB) {
        $scope.tourTitleHtml = 'Unitrends Backup';
    } else {
        $scope.tourTitleHtml = 'Unitrends Recovery Series';
    }

    $scope.initTour = function() {
        $(window).off("resize.tour");
        $(window).on("resize.tour",  PHD.util.debounce($scope.positionTour));
        $scope.positionTour();
       $("#dashboard-tour").addClass("active");
    }

    $scope.positionTour = function() {
        if ($headerTarget.length > 0) {
            // console.log("Enter in tour position fun");
            var $header = $("#tour-header");
            $header !== undefined && $header.position({
                my: "center",
                at: "center",
                of: $headerTarget,
                using: positionElement
            });
            var $global = $("#tour-global");
            $global !== undefined && $global.position({
                my: "right top",
                at: "right-200 top+80",
                of: $headerTarget,
                using: positionElement,

            });
            var $tiles = $("#tour-tiles");
            $tiles !== undefined && $tiles.position({
                my: "center",
                at: "center",
                of: $headerTarget,
                using: positionElement

            });
            var $backup = $("#tour-backup");
            $backup !== undefined && $backup.position({
                my: "left top-110",
                at: "left+166 center",
                of: $headerTarget,
                using: positionElement
            });
            var $storage = $("#tour-storage");
            $storage !== undefined && $storage.position({
                my: "center top+125",
                at: "right-450",
                of: $headerTarget,
                using: positionElement
            });
            var $active = $("#tour-active");
            $active !== undefined && $active.position({
                my: "center top-100",
                at: "right-450",
                of: $headerTarget,
                using: positionElement
            });
        } else {
            console.log("dashboard tour init issue");
        }
    };

    function positionElement(attr, obj) {
        obj.element.element.css({
            top: attr.top,
            left: attr.left,
            position: 'absolute'
        });
    }

    $scope.endTour = function() {
        $(window).off("resize.tour");
        $(".tour-position").css("z-index", "auto");
        $("#dashboard-tour").remove();
        $scope.$currentStep = $rootScope.user.tourStep = 1;
    
        var putData = {};
        putData['show_help_overlay'] = 'false';
        
        var prefURL = '/api/preferences/' ;
            prefURL = prefURL + encodeURI($rootScope.user.name)+"/";
          
            tourFactory.sync('put',prefURL,1,putData).then(function(result){
                $(".app-main").removeClass("tourHilighter");
                $("#header-nav").removeClass("tourHilighter");
            });
        
        $rootScope.user.showTour= false; 
        $scope.refreshPage();
     }

/*
* Refresh App-main page 
*/
$scope.refreshPage = function(){
        var currentPage = angular.element(document.getElementById("app"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
}
 
$scope.setNextTourStep = function () {
        if($scope.$currentStep === TOUR_STEP_DASHBOARD_END) {
            if ($rootScope.backupDisabled) {
                if ($rootScope.recoverDisabled) {
                    $scope.$currentStep = $rootScope.user.tourStep = TOUR_STEP_JOBS_START;
                    //go to the jobs page
                    window.location.href = "#/jobs/";
                    setTimeout(function(){
                        $("#activeJob a").trigger('click');
                        $("#jobPane").addClass("tourHilighter");
                    }, 700);
                } else {
                    $scope.$currentStep = $rootScope.user.tourStep = TOUR_STEP_RECOVER_START;
                    //go to the jobs page
                    window.location.href = "#/recover/";
                    setTimeout(function(){
                        $("#recover-backup-table").addClass("tourHilighter");
                    }, 1000);
                }
            } else {
                //have to set the step before moving to the next page
                $scope.$currentStep = $rootScope.user.tourStep += 1;
                //go to the protect page
                window.location.href = "#/protect/";
                setTimeout(function(){
                    $("#protect-inventory-buttons").addClass("tourHilighter");
                    $(".app-main").removeClass("tourHilighter");
                }, 700);
            }
        } else {
            $scope.reloadContent();
            $scope.$currentStep =$rootScope.user.tourStep +=1; 
            $scope.positionTour();
          
            switch (parseInt($scope.$currentStep)) {
                case $scope.HEADER_NAVIGATION:
                    setTimeout(function(){ 
                       $("#header-nav").removeClass("tourHilighter"); 
                    }, 500);
                    break;
                case $scope.GLOBAL:
                    setTimeout(function(){ 
                       $("#header-nav").addClass("tourHilighter");
                    }, 500);
                    break;
                case $scope.TILE:
                    setTimeout(function(){ 
                        $("#header-nav").removeClass("tourHilighter");
                        $(".app-main").addClass("tourHilighter");
                    }, 500);
                    break;
                case $scope.BACKUP_SUMMARY:
                    setTimeout(function(){ 
                        $(".app-main").removeClass("tourHilighter");
                        $("[id='toruidBACKUP SUMMARY']").find(".panel-default").addClass("tourHilighter");
                    }, 500);
                    break;
                case $scope.STORAGE:
                    setTimeout(function(){ 
                        $("[id='toruidBACKUP SUMMARY']").removeClass("tourHilighter");
                        $("#toruidSTORAGE").find(".panel-default").addClass("tourHilighter");
                    }, 500);
                    break;
                case $scope.ACTIVE_JOB:
                    setTimeout(function(){ 
                        $("#toruidSTORAGE").removeClass("tourHilighter");
                        $("[id='toruidACTIVE JOBS']").find(".panel-default").addClass("tourHilighter");
                    }, 600);
                    break;
                default: $scope.reloadContent();
                    break;
            }
            
        }
}
$scope.reloadContent = function(){
    var currentPage = angular.element(document.getElementById("dashboard-tour"));
    var injector = currentPage.injector();
    var route = injector.get('$route');
    route.reload();
}

$scope.setPreviousTourStep = function() {
        
    $scope.$currentStep = $rootScope.user.tourStep -=1 ;
    $scope.reloadContent();
    $scope.positionTour();

    switch (parseInt($scope.$currentStep)) {
        case $scope.HEADER_NAVIGATION:
            setTimeout(function(){ 
                $("#header-nav").removeClass("tourHilighter");
            }, 500);
            break;
        case $scope.GLOBAL:
            setTimeout(function(){ 
                $(".app-main").removeClass("tourHilighter");
                $("#header-nav").addClass("tourHilighter");
            }, 500);
            break;
        case $scope.TILE:
            setTimeout(function(){ 
                $(".app-main").addClass("tourHilighter");
            }, 500);
            break;
        case $scope.BACKUP_SUMMARY:
            setTimeout(function(){
                $("[id='toruidBACKUP SUMMARY']").find(".panel-default").addClass("tourHilighter");
            }, 500);
            break;
        case $scope.STORAGE:
            setTimeout(function(){
                $("[id='toruidBACKUP SUMMARY']").removeClass("tourHilighter");
                $("#toruidSTORAGE").find(".panel-default").addClass("tourHilighter");
            }, 500);
            break;
        case $scope.ACTIVE_JOB:
            setTimeout(function(){
                $("[id='toruidACTIVE JOBS']").find(".panel-default").addClass("tourHilighter");
            }, 500);
            break;
        default:$scope.reloadContent();
            break;
    }
}

$scope.addStorage = function(){
    $scope.endTour();
    window.location.href = "#/configure/#0";

    resetTour = true;
};

$scope.createBackupJob = function(){
    $scope.endTour();
    window.location.href = "#/protect/";
    setTimeout(function(){
        $("#backupjob a").trigger('click');
    }, 1000); 
    resetTour = true;
};

$scope.registerHost = function(){
    $scope.endTour();
    window.location.href = "#/configure/#1";
    $("#protectedAssts a").trigger('click');
    
    
    setTimeout(function(){
        $("#addHostBtn a").trigger('click');
    }, 1000);
   resetTour = true;
};

$scope.registerPhysicalServerHost = function(){
    $scope.endTour();
    window.location.href = "#/configure/#1";
    
    setTimeout(function(){
        $("#addServerBtn a").trigger('click');
    }, 1000);
    resetTour = true;
};
	
$scope.registerNASServerHost = function(){
    $scope.endTour();
    window.location.href = "#/configure/#1";
    
    setTimeout(function(){
        $("#addNASBtn a").trigger('click');
    }, 1000);
    resetTour = true;
};	
	
angular.element(document).ready(function () {
        $scope.initTour();
        $scope.positionTour();
    });
});


