angular.module('certifyBackupJobModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics',
    'ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','fileBrowserDialogApp','ngGrid','ui.bootstrap','inventory','checklist-model','ui.grid.selection', 'backup-now-dialog'])
.config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {
            }
        });
}])
.controller('certifyBackupJobController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc', '$q', 'gettextCatalog',
        function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc, $q, gettextCatalog) {

            //Referenced to backupJobController.js
            // Getting loadindicator reference (Declared in protect.js) and hiding it once DCA wizard is loaded
            var loadingIndicator = $scope.ngDialogData;
            PHD.hideLoadingIndicator(loadingIndicator);

            $scope.assetTypeList=[
                { name: "VMware + Windows Replica", hypervisor:"1" ,id:INVENTORY_TYPE_FAMILY_VMWARE},
                { name: "Hyper-V + Windows Replica", hypervisor:"2" ,id:INVENTORY_TYPE_FAMILY_HYPER_V}
            ];
            $scope.assetType={};
            $scope.assetType.id= $scope.assetTypeList[0].id;
            $scope.hypervisorTypeChanged = false;
            $scope.certifyJobName='Data Copy Access Job1';
            $scope.certifyBackupJobNameModel=gettextCatalog.getString('Data Copy Access Job');
            $scope.isScheduled = true;
            $scope.inventoryColumnDefs = [
                {
                    field:'id',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('Id'),
                    visible:false
                },
                {
                    field:'nodeId',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('Node Id'),
                    visible:false
                },
                {
                    field: 'name',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('Name'),
                    width:'100%'
                }
            ];
            $scope.certifyInventoryGridOptions={
                columnDefs: $scope.inventoryColumnDefs,
                data:'inventoryData',
                rowHeight: 32,
                enableHorizontalScrollbar:0,
                enableVerticalScrollbar:2,
                gridMenuShowHideColumns:false,
                enableColumnMenus:false,
                enableColumnResizing: true
            };
            $scope.profile = {};
            $scope.profile.id = 1;
            $scope.selectedProfile = {};
            $scope.joboptions = {};
            $scope.joboptions.power_on_timeout = 15;
            $scope.joboptions.powerOnSelect = 1; // default to minutes
            $scope.powerOnTime=[{id:0,name:gettextCatalog.getString('Hour(s)')},{id:1,name:gettextCatalog.getString('Minutes')}];
            var MIN_PER_HOUR = 60;
            var MAX_MINUTES = 1440;
            var MAX_HOURS = 24;

            $scope.joboptions.suffix_name = '.copy';
            $scope.post_custom_script = "";
            $scope.joboptions.post_custom_script_arguments = "";
            $scope.vmwareLocations = null;
            $scope.hypervLocations = null;
            $scope.certifyVMsColumnDefs = [
                {
                    field:'id',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('Id'),
                    visible:false
                },
                {
                    field:'nodeId',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('Node Id'),
                    visible:false
                },
                {
                    field:'edit',
                    headerCellFilter: 'translate',
                    displayName:'',
                    cellTemplate: '<div style="padding-left:5px;padding-top:5px;" ng-click="openEditSettingCertifiedVMDialog(row.entity,row.getProperty(col.field), col.field)"><img src="assets/images/edit_pencil.png" style="height:11.5px;cursor:pointer;"/><span style="font-size:11px;padding-left:5px;font-weight:bold"><span></div>',width:'2%'
                },
                {
                    field: 'name',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('NAME'),
                    width:'12%'
                },
                {
                    field: 'boot_order',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('BOOT'),
                    width:'5%'
                },
                {
                    field: 'delay',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('DELAY'),
                    width:'5%'
                },
                {
                    field: 'power_on',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('POWER ON'),
                    width:'7%'
                },
                {
                    field: 'credentials',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('CREDENTIALS'),
                    width:'9%'
                },
                {
                    field: 'tests',
                    headerCellFilter: 'translate',
                    displayName:'TESTS',
                    width:'5%'
                },
                {
                    field: 'host',
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString('HOST'),
                    width:'13%'
                },
                {
                    field: 'resource_pool_name',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('RESOURCE'),
                    width:'9%'
                },
                {
                    field: 'datastore_name',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('STORAGE'),
                    width:'7%'
                },
                {
                    field: 'recovery_network_name',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('RECOVERY NETWORK'),
                    width:'12%'
                },
                {
                    field: 'test_network',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('TEST NETWORK'),
                    width:'10%'
                },
                {
                    field: 're_ip',
                    headerCellFilter: 'translate',
                    displayName:gettextCatalog.getString('RE-IP'),
                    width:'4%'}
            ];
            $scope.CertifyInventoryGridOptions={columnDefs: $scope.certifyVMsColumnDefs,data:'inventoryData', rowHeight: 32, enableHorizontalScrollbar:0,enableVerticalScrollbar:2,resizable: true,enableColumnResize:true};

            $scope.certifyjoborder={};
            $scope.certifyjoborder.name = "Data Copy Access Job"; //TODO init to textfield from HTML
            $scope.certifyjoborder.type = "Certification";
            $scope.scheduleTypeSelection = {
                name: 'Scheduled'
            };
            $scope.recursTime=[{id:0,name:'Hour(s)'},{id:1,name:'Minutes'}];
            $scope.isScheduled = true;
            $scope.certifyjoborder.email_report = true;
            $scope.certifyjoborder.failure_report = true;
            $scope.currentSchedule = {};
            $scope.currentSchedule.calendar = {};
            $scope.calendarDays=[

                    {'name':gettextCatalog.getString('Sun'), 'value' : "0"},
                    {'name':gettextCatalog.getString('Mon'), 'value' : "1"},
                    {'name':gettextCatalog.getString('Tue'), 'value' : "2"},
                    {'name':gettextCatalog.getString('Wed'), 'value' : "3"},
                    {'name':gettextCatalog.getString('Thu'), 'value' : "4"},
                    {'name':gettextCatalog.getString('Fri'), 'value' : "5"},
                    {'name':gettextCatalog.getString('Sat'), 'value' : "6"}

            ];

            $scope.PM_ADJUST = 12;
            $scope.PM_ADJUST_EXTRA  = 13;
            $scope.defineScheduleVisited = $scope.defineVMOptionsVisited = false;
            var systemID, profileID;

            if($scope.isEdit){
                $http({
                    method: 'get',
                    url : '/api/joborders/'+$scope.jobId + "/?lang=" + $rootScope.userLanguageCode
                }).success(function(data, status, headers){
                    $scope.certifyjoborder = data.data[0];
                    $scope.selectedAsset = [];
                    console.log($scope.certifyjoborder);
                    $scope.certifyBackupJobNameModel = $scope.certifyjoborder.name;
                    $scope.assetType.id= $scope.getAssetType($scope.certifyjoborder);
                    $scope.hypervisor_type = ($scope.assetType.id == INVENTORY_TYPE_FAMILY_VMWARE) ? "VMware" : "HyperV";
                    $protectService.loadCertifyTreeData($http,$scope,$rootScope,$scope.assetType.id,false);
                }).error(function(response){
                    ngDialog.open({
                        dialogType:'Error',
                        dialogMessage:response.result[0].message
                    })
                });

            }else{
                $scope.selectedAssetType = INVENTORY_TYPE_FAMILY_VMWARE;
                $scope.assetType.id= parseInt($scope.selectedAssetType);
                setTimeout(function(){
                    $scope.filterCertifyInventory();}, 1000);
            }

            $scope.getAssetType = function(joborder){
                if(joborder.service_profile.server_type === "VMware"){
                    return INVENTORY_TYPE_FAMILY_VMWARE;
                }
                else{
                    return INVENTORY_TYPE_FAMILY_HYPER_V;
                }
            };

            $scope.readyTree=function(event){
                if($scope.isEdit){
                    setTimeout(function(){
                        $scope.checkNodesOnLoadEdit();
                    }, 200);
                }
            };

            $scope.filterCertifyInventory = function(){
                $('#certifyBackupJstreeDivId').jstree(true).uncheck_all();
                $scope.currentSchedule.calendar = [];
                $scope.certifyjoborder.email_report = true;
                $scope.certifyjoborder.failure_report = true;

                $rootScope.treeData=[];
                $scope.selectedAsset =[];
                $scope.inventoryData =[];
                $scope.instanceIdToRetrieveTargets = "";
                $scope.hypervisor_type = ($scope.assetType.id == INVENTORY_TYPE_FAMILY_VMWARE) ? "VMware" : "HyperV";
                if($scope.hypervisor_type == "VMware")
                    $scope.profileList = ($scope.vmwareProfileList == null || $scope.vmwareProfileList == undefined) ? null : $scope.vmwareProfileList;
                else
                    $scope.profileList = ($scope.hypervProfileList == null || $scope.hypervProfileList == undefined) ? null : $scope.hypervProfileList;

                $protectService.loadCertifyTreeData($http,$scope,$rootScope,$scope.assetType.id,false);
            };

            $scope.checkNodesOnLoadEdit=function(){
                var nodeIdArray =Object.keys($('#certifyBackupJstreeDivId').jstree(true)._model.data);
                var arrayAssets = $scope.getDCAInstances($scope.certifyjoborder);
                if(arrayAssets !=undefined){
                    for(var i=0; i< arrayAssets.length ; i++){
                        var node_id='li#';
                        for(var j=0 ;j<nodeIdArray.length;j++){
                            if (nodeMatches(nodeIdArray[j], arrayAssets[i], $scope.certifyjoborder)) {
                                $('#certifyBackupJstreeDivId').jstree(true).check_node(nodeIdArray[j]);
                                var parent = $('#certifyBackupJstreeDivId').jstree(true).get_parent(nodeIdArray[j]);
                                if(!$('#certifyBackupJstreeDivId').jstree(true).is_open(parent)){
                                    var grandparent = $('#certifyBackupJstreeDivId').jstree(true).get_parent(parent);
                                    if(!$('#certifyBackupJstreeDivId').jstree(true).is_open(grandparent)){
                                        $('#certifyBackupJstreeDivId').jstree(true).open_all(grandparent);
                                    }
                                    else{
                                        $('#certifyBackupJstreeDivId').jstree(true).open_all(parent);
                                    }
                                }
                                break;
                            }
                        }
                    }
                }
            };

            /*
            * This function will compare instanceID's from RDR inventory and "id" param returned from api/joborders/jobID apiDataObject->certification_target->instances->id
            * Since instanceID's are unique there is no need to construct nodeID and compare it with every nodeID in RDR inventory tree
            * */
            function nodeMatches(node, asset, joborder) {
                var match = false;
                var nodeArray = node.split("_");
                var asset_node = joborder.sid + "_";
                if(nodeArray.length >= 4){
                    var nodeJson = $('#certifyBackupJstreeDivId').jstree(true).get_node(node, false);
                    if( asset.vm_type === "vm_replica" || asset.vm_type === "vm_wir"  ){
                        if(parseInt(nodeArray[nodeArray.length - 1]) === asset.id && nodeJson.text === asset.name){
                            match = true;
                        }
                    }
                    else{
                        if(parseInt(nodeArray[nodeArray.length - 1]) === asset.id){
                            match = true;
                        }
                    }
                }
                return match;
            }

            $scope.getDCAInstances = function(joborder){
                if (joborder !== undefined && joborder.certification_target !== undefined) {
                    return joborder.certification_target.instances;
                }
            };

            $scope.search = function(){
                var to = false;
                if(to) { clearTimeout(to); }
                to = setTimeout(function () {
                    var v = $('#certifyInventorySearchInputId').val();
                    $('#certifyBackupJstreeDivId').jstree(true).search(v);
                }, 200);
            };

            $scope.treeConfig = {
                core : {
                    multiple : !$scope.isNAS, //TODO check if it needs to single select in case of NAS
                    animation: true,
                    error : function(error) {$log.error('treeCtrl: error from js tree - ' + angular.toJson(error));},
                    check_callback : true,
                    worker : true
                },
                types : {
                    default : {icon : 'icon-hv-datacenter icon'},
                    star : {icon : 'icon-hv-host icon'},
                    cloud : {icon : 'icon-hv-host icon'}
                },
                version : 1,
                plugins : ['types','checkbox','search']
            };

            $scope.selectNodeFun = function(e,item){
                $scope.defineScheduleVisited = $scope.defineVMOptionsVisited = false;
                var currentParentNodeArray = item.node.parent.split("_");
                if(item.node.data.type === INVENTORY_ID_NAVGROUP || item.node.data.type === INVENTORY_ID_SYSTEM){
                    if(item.selected.length > 1){
                        var selectedAssetsSystem = inventorysvc.nodeToObject(item.node.id).system_id;
                        if($scope.certifyjoborder.sid == selectedAssetsSystem){
                            if(item.node.data.expanded == false){
                                $('#certifyBackupJstreeDivId').jstree(true).open_all(item.node);
                                item.node.data.expanded =true;
                            }
                            for(var k =0 ; k < item.node.children_d.length; k++){
                                var id = '#'+item.node.children_d[k]+'_anchor';
                                if($scope.selectedAsset[item.node.children_d[k]] ==null || $scope.selectedAsset[item.node.children_d[k]] == undefined){
                                    if(inventorysvc.nodeToObject(item.node.children_d[k]).client_id === "backupcopies"){
                                        continue;
                                    }
                                    var child = $('#certifyBackupJstreeDivId').jstree(true).get_node(item.node.children_d[k]);
                                    $scope.selectedAsset[item.node.children_d[k]] ={nodeId:item.node.children_d[k],name:$(id).text(),id:inventorysvc.nodeToObject(item.node.children_d[k]).client_id,guest_os:child.data.guest_os};
                                }
                            }
                        }else{
                            $scope.uncheckNotEligibleNode(item.node.id);
                        }
                    }
                    else{
                        $scope.certifyjoborder.sid = inventorysvc.nodeToObject(item.node.id).system_id;
                        if(item.node.data.expanded == false){
                            $('#certifyBackupJstreeDivId').jstree(true).open_all(item.node);
                            item.node.data.expanded =true;
                        }
                        for(var k =0 ; k < item.node.children_d.length; k++){
                            var id = '#'+item.node.children_d[k]+'_anchor';
                            if($scope.selectedAsset[item.node.children_d[k]] ==null || $scope.selectedAsset[item.node.children_d[k]] == undefined){
                                if(inventorysvc.nodeToObject(item.node.children_d[k]).client_id === "backupcopies"){
                                    continue;
                                }
                                var child = $('#certifyBackupJstreeDivId').jstree(true).get_node(item.node.children_d[k]);
                                $scope.selectedAsset[item.node.children_d[k]] ={nodeId:item.node.children_d[k],name:$(id).text(),id:inventorysvc.nodeToObject(item.node.children_d[k]).client_id,guest_os:child.data.guest_os};
                            }
                        }
                    }
                    $scope.inventoryData =[];
                    var nodeIdArray =Object.keys($scope.selectedAsset);
                    for(var j=0 ;j<nodeIdArray.length;j++){
                        var obj = $scope.selectedAsset[nodeIdArray[j]];
                        $scope.inventoryData.push(obj);
                    }
                    $scope.instanceIdToRetrieveTargets = nodeIdArray[0];
                    $(window).resize();
                }
                else{
                    if(item.selected.length>1){
                        var selectedAssetsSystem = inventorysvc.nodeToObject(item.node.id).system_id;
                        if(item.node.parent.split("_").length>2){
                            selectedAssetsSystem = currentParentNodeArray[0];
                        }
                        if($scope.certifyjoborder.sid == selectedAssetsSystem){
                            if($scope.selectedAsset[item.node.id] ==null || $scope.selectedAsset[item.node.id] == undefined){
                                $scope.selectedAsset[item.node.id] ={nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id,guest_os:item.node.data.guest_os};
                            }
                        }else{
                            $scope.uncheckNotEligibleNode(item.node.id);
                        }
                    }else{
                        if(item.node.parent.split("_").length>2){
                            $scope.certifyjoborder.sid = currentParentNodeArray[0];
                        }
                        else{
                            $scope.certifyjoborder.sid = inventorysvc.nodeToObject(item.node.id).system_id;
                        }
                        $scope.certifyjoborder.app_id = inventorysvc.nodeToObject(item.node.id).app_id;
                        if (item.node.data !== undefined && item.node.data.type === INVENTORY_ID_VMWARE_ESX_SERVER) {
                            $scope.isHypervisorHostSelected = true;
                            $rootScope.certifyjoborderHypervisorID = item.node.id;
                        } else {
                            if($scope.selectedAsset[item.node.id] == undefined ||$scope.selectedAsset[item.node.id] ==null){
                                $scope.selectedAsset[item.node.id] ={nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id,guest_os:item.node.data.guest_os};
                            }
                        }
                    }

                    $scope.inventoryData =[];
                    var nodeIdArray =Object.keys($scope.selectedAsset);
                    $scope.instanceIdToRetrieveTargets = nodeIdArray[0];

                    for(var j=0 ;j<nodeIdArray.length;j++){
                        var obj = $scope.selectedAsset[nodeIdArray[j]];
                        $scope.inventoryData.push(obj);
                    }
                    $(window).resize();
                }
                $scope.inventoryValidation();
            };

            $scope.uncheckNotEligibleNode=function(uncheckNodeId){
                var node_id='li#'+uncheckNodeId;
                $('#certifyBackupJstreeDivId').jstree(true).uncheck_node(node_id);
            }

            $scope.deselectNodeFun = function(e,item){
                $scope.defineScheduleVisited = $scope.defineVMOptionsVisited = false;
                if(item.node.data.type === INVENTORY_ID_NAVGROUP || item.node.data.type === INVENTORY_ID_SYSTEM){
                    for(var k =0 ; k < item.node.children_d.length; k++){
                        var id = '#'+item.node.children_d[k]+'_anchor';
                        if($scope.selectedAsset[item.node.children_d[k]] !=null || $scope.selectedAsset[item.node.children_d[k]] != undefined){
                            delete $scope.selectedAsset[item.node.children_d[k]];
                        }
                    }
                    $scope.inventoryData =[];
                    var nodeIdArray =Object.keys($scope.selectedAsset);
                    for(var j=0 ;j<nodeIdArray.length;j++){
                        var obj = $scope.selectedAsset[nodeIdArray[j]];
                        $scope.inventoryData.push(obj);
                    }
                    $scope.instanceIdToRetrieveTargets = nodeIdArray[0];
                    $(window).resize();
                }
                else{
                    if(item.selected.length == 0){
                        $scope.certifyjoborder.clients =[];
                        $scope.selectedAsset =[];
                    }
                    var currentParentNodeArray = item.node.parent.split("_");
                    var selectedAssetsSystem = inventorysvc.nodeToObject(item.node.id).system_id;
                    if(currentParentNodeArray.length>2){
                        selectedAssetsSystem = currentParentNodeArray[0];
                    }
                    if($scope.certifyjoborder.sid == selectedAssetsSystem){
                        delete $scope.selectedAsset[item.node.id];
                    }
                    $scope.inventoryData =[];
                    var nodeIdArray =Object.keys($scope.selectedAsset);
                    for(var j=0 ;j<nodeIdArray.length;j++){
                        var obj = $scope.selectedAsset[nodeIdArray[j]];
                        $scope.inventoryData.push(obj);
                    }
                    $scope.instanceIdToRetrieveTargets = nodeIdArray[0];
                    $(window).resize();
                }
                $scope.inventoryValidation();
            };

            $scope.hoverNode = function(e, item){
                if (item.node.data.rdr_supported !== undefined && item.node.data.rdr_supported === false) {
                    var hoverTip = "Data Copy Access jobs are not supported for this appliance";
                    var $el = $(document.getElementById(item.node.id));
                    $el.prop('title', hoverTip);
                }
            };

            $scope.CertifyJobHelpDialog = function(){
                $scope.inventoryDataError = false;
                $("#CertifyStaging").hide();
                $("#CertifyJobHelp").show();
            };

            $scope.launchProfileManager = function() {
                ngDialog.open({
                    template: 'app/joborders/certify-backups/ManageProfile.html',
                    scope: $scope,
                    overlay:true,
                    name: 'Profile-Manager',
                    ngDialogStyle:'width:700px; height:550px;',
                    data: $scope.profileList,
                    closeByDocument: false,
                    closeByEscape: true
                });
            };

            isLetters = function(str){
                return /^[a-zA-Z()]+$/.test(str);
            };

            $scope.validateGuestOS = function(){
                var VMwithoutGuestOS = [];
                var guestOSDefined = true;
                for(var i=0 ;i<$scope.inventoryData.length;i++){
                    if( $scope.inventoryData[i].guest_os == null){
                        guestOSDefined = false;
                        VMwithoutGuestOS.push($scope.inventoryData[i].name);
                    }
                }
                if(!guestOSDefined){
                    var message = gettextCatalog.getString('Please select "Guest OS" from "Options" tab by clicking on "Edit settings" icon for following VMs:') + '\n\n';
                    if(VMwithoutGuestOS.length > 5){
                        var additional = VMwithoutGuestOS.length - 5;
                        VMwithoutGuestOS.length = 5;
                        var VMnames = VMwithoutGuestOS.join('\r\n');
                        message += VMnames + '\n\n';
                        message += '... and ' + additional + ' more.';
                    }
                    else if(VMwithoutGuestOS.length > 0 && VMwithoutGuestOS.length <= 5){
                        var VMnames = VMwithoutGuestOS.join('\r\n');
                        message += VMnames;
                    }
                    ngDialog.open({
                        dialogType:gettextCatalog.getString('Warning'),
                        modelDialogId:'SelectGuestOS',
                        dialogMessage: message,
                        scope:$scope,
                        onConfirmOkButtonClick:'onConfirmWarning()'
                    });
                    return false;
                }
                return true;
            };

            $scope.onConfirmWarning = function () {
                ngDialog.close('SelectGuestOS');
            };

            $scope.saveCertifyBackupJobData = function() {
                if(!$scope.validateGuestOS()){
                    return;
                }
                var obj = {};
                obj.name = $scope.certifyBackupJobNameModel;
                obj.type = $scope.certifyjoborder.type;
                obj.calendar = [];
                if($scope.isScheduled){
                    obj.calendar[0] = {};
                    //obj.calendar = $scope.certifyjoborder.calendar;
                    if($scope.currentSchedule.calendar.recursCheck){
                        if ($scope.currentSchedule.calendar.recursTimeSelect == 0 ){
                            //$scope.currentSchedule.calendar.recurrence =$scope.currentSchedule.calendar.recurrence * 60;
                            obj.calendar[0].recurrence = $scope.currentSchedule.calendar.recurrence * 60;
                        }
                        else{
                            obj.calendar[0].recurrence = $scope.currentSchedule.calendar.recurrence;
                        }
                        obj.calendar[0].end_hour = $scope.getHourFromString($scope.currentSchedule.calendar.end_hour);
                    } else {
                        obj.calendar[0].recurrence = null;
                    }
                    $scope.currentSchedule.calendar.start_date = DateTimeHandler.getUSDateString($rootScope.userLanguageCode,$scope.currentSchedule.calendar.start_date);
                    obj.calendar[0].start_time = $scope.currentSchedule.calendar.start_time;
                    obj.calendar[0].start_date = $scope.currentSchedule.calendar.start_date;
                    obj.calendar[0].schedule_run = $scope.currentSchedule.calendar.schedule_run;
                    obj.calendar[0].run_on = $scope.currentSchedule.calendar.run_on;
                }
                obj.certification_options = {};
                obj.certification_options.service_profile_id = $scope.selectedProfile.id;
                var timeout = $scope.joboptions.power_on_timeout;
                if ($scope.joboptions.powerOnSelect === 0) {
                    // If the user has selected hours, convert timeout to minutes before saving.
                    timeout *= MIN_PER_HOUR;
                }
                obj.certification_options.power_on_timeout = timeout;
                obj.certification_options.post_custom_script = $scope.joboptions.post_custom_script;
                obj.certification_options.post_custom_script_arguments = $scope.joboptions.post_custom_script_arguments;
                obj.certification_options.suffix_name = $scope.joboptions.suffix_name;


                obj.certification_target = {};
                obj.certification_target.instances =[];
                for(var j=0 ;j<$scope.inventoryData.length;j++){
                    var instanceObj = {};

                    //Advanced options tab data
                    instanceObj.id =  parseInt(inventorysvc.nodeToObject($scope.inventoryData[j].nodeId).instance_id);
                    instanceObj.name = $scope.inventoryData[j].name;
                    instanceObj.os_type = $scope.inventoryData[j].guest_os;
                    // pass in vm_id when editing the DCA job
                    if ($scope.isEdit == true) {
                        instanceObj.vm_id = $scope.inventoryData[j].vm_id;
                    }
                    var nodeLetters = isLetters($scope.inventoryData[j].nodeId.split("_")[1]);
                    if (nodeLetters) {
                        var nodeText = $scope.inventoryData[j].nodeId.split("_")[1];
                        if (nodeText !== "replica") {
                            instanceObj.vm_type = "vm_wir";
                        } else if (nodeText === "replica") {
                            instanceObj.vm_type = "vm_replica";
                        }
                        if (typeof $scope.inventoryData[j].max_recovery_point === "undefined") {
                            instanceObj.max_recovery_point = 3;
                        } else {
                            instanceObj.max_recovery_point = $scope.inventoryData[j].max_recovery_point;
                        }
                    } else{
                        instanceObj.vm_type = "vm_backup";
                    }
                    instanceObj.is_failover = false;
                    if($scope.inventoryData[j].power_on === 'Yes'){
                        instanceObj.power_on = true;
                    }
                    else{
                        instanceObj.power_on = false;
                    }
                    instanceObj.boot_order = $scope.inventoryData[j].boot_order;
                    instanceObj.delay = $scope.inventoryData[j].delay;
                    instanceObj.credential_id = $scope.inventoryData[j].credential_id;
                    instanceObj.num_cpu = $scope.inventoryData[j].num_cpu;
                    instanceObj.memory_mb = $scope.inventoryData[j].memory_mb;

                    //Locations Tab data
                    instanceObj.resource_pool_name = $scope.inventoryData[j].resource_pool_name;
                    instanceObj.resource_pool_ref = $scope.inventoryData[j].resource_pool_ref;
                    instanceObj.datastore_name = $scope.inventoryData[j].datastore_name;
                    instanceObj.datastore_ref = $scope.inventoryData[j].datastore_ref;
                    instanceObj.recovery_network_name = $scope.inventoryData[j].recovery_network_name;
                    instanceObj.recovery_network_ref = $scope.inventoryData[j].recovery_network_ref;

                    //Reconfigure IP tab data
                    instanceObj.networks = [];
                    if($scope.inventoryData[j].re_ip === 'Yes'){
                        $scope.inventoryData[j].networks.forEach(function(network){
                            var item = {};
                            item.name = network.name;
                            item.ip_address = network.ip_address;
                            item.gateway = network.gateway;
                            item.mask = network.mask;
                            item.dns1 = network.dns1;
                            item.dns2 = network.dns2;
                            instanceObj.networks.push(item);
                        });
                    }

                    //Application tests tab data
                    instanceObj.application_tests = [];
                    if($scope.inventoryData[j].tests > 0){
                        $scope.inventoryData[j].application_tests.forEach(function(test, index){
                            var apptest = {};
                            if(test.command !== null){
                                apptest.command = test.command;
                            }
                            apptest.is_custom = test.is_custom;
                            apptest.name = test.name;
                            apptest.priority = test.priority;
                            apptest.timeout_min = test.timeout_min;
                            apptest.app_test_id = test.id;
                            apptest.parameters = [];
                            test.app_test_params.forEach(function(testParams){
                                var nvpItem = {};
                                nvpItem.name = testParams.name;
                                nvpItem.value = testParams.value;
                                apptest.parameters.push(nvpItem);
                            });
                            instanceObj.application_tests.push(apptest);
                        });
                    }
                    obj.certification_target.instances[j] = instanceObj;
                }
                obj.email_report = $scope.certifyjoborder.email_report;
                obj.failure_report = $scope.certifyjoborder.failure_report;
                obj.legal_hold_backups = false;
                obj.email_addresses = "";
                var dataObj = JSON.stringify(obj);
                if($scope.isEdit == true){
                    var loadJobindicator = PHD.showLoadingIndicator("body", true, "Saving...");
                    httpMethod = 'put';
                    jobOrderUrl = '/api/joborders/'+$scope.certifyjoborder.id+'/?sid='+$scope.certifyjoborder.sid;

                }
                else{
                    var loadJobindicator = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Creating Job..."));
                    jobOrderUrl = '/api/joborders/?sid='+$scope.certifyjoborder.sid;
                    httpMethod = 'post';
                }
                $http({ method: httpMethod,
                    url : jobOrderUrl,
                    data: dataObj
                }).success(function(data, status, headers){
                    PHD.hideLoadingIndicator(loadJobindicator);
                    var message = $scope.isEdit ? gettextCatalog.getString("Data Copy Access Job updated successfully!" ):
                        gettextCatalog.getString("Data Copy Access Job created successfully!") +
                        "<br/><br/>" +
                        gettextCatalog.getString("While running, you can view the additional details") + " " +
                        gettextCatalog.getString("about the data copy access VMs in the Instant Recovery tab.");
                    ngDialog.open({
                        dialogType: gettextCatalog.getString('Success'),
                        dialogMessage: message,
                        ngDialogStyle:'width:550px;'
                    });
                }).error(function(response) {
                    var message = response.result[0].message;
                    $analytics && $analytics.eventTrack('Failure: ' + message, {  category: 'Backup', label: 'Protect' });
                    PHD.hideLoadingIndicator(loadJobindicator);
                    ngDialog.open({
                        dialogType:gettextCatalog.getString('Error'),
                        modelDialogId:'CertifyBackupPostErrorDialog',
                        scope:$scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                });

            };

            $scope.onConfirmError = function () {
                ngDialog.close('CertifyBackupPostErrorDialog');
                $scope.jobErrorDialog = false;
                $scope.currentSchedule.calendar.start_date = DateTimeHandler.getUSDateString($rootScope.userLanguageCode,$scope.currentSchedule.calendar.start_date);

            };

            $scope.getHourFromString =function(hourString){
                var hourStringArray = hourString.split(" ");
                var hourArray = hourStringArray[0].split(":");
                var Hour  = parseInt(hourArray[0]);
                var Minute = parseInt(hourArray[1]);
                if (hourStringArray[1] === "pm"){
                    if (Hour < 12) {
                        Hour += $scope.PM_ADJUST;
                    }
                } else {
                    if (Hour == 12) {
                        Hour -= $scope.PM_ADJUST;
                    }
                }
                if (Minute == 59) {
                    Hour++;
                }
                return Hour;
            };

            $scope.changeProfiles = function() {
                $scope.profileList.forEach(function(profile){
                    if(profile.id === $scope.profile.id && $scope.profile.id !== '-1'){
                        $scope.selectedProfile = profile;
                        if($scope.selectedProfile.rpo === 0 && $scope.selectedProfile.rto === 0){
                            $scope.selectedProfile.displayRpo = "--";
                            $scope.selectedProfile.displayRto = "--";
                        }
                        else{
                            $scope.selectedProfile.displayRpo = $scope.selectedProfile.rpo.toString() + " " + $scope.selectedProfile.rpo_frequency.toString() + "(s)";
                            $scope.selectedProfile.displayRto = $scope.selectedProfile.rto.toString() + " " + $scope.selectedProfile.rto_frequency.toString() + "(s)";
                        }
                    }
                    if($scope.profile.id == '-1'){
                        $scope.selectedProfile.displayRpo = "--";
                        $scope.selectedProfile.displayRto = "--";
                    }
                });
            };

            $scope.getCredentials = function(systemID) {
                //$scope.credentialsList will be shared between child controllers to avoid unnecessary api calls.
                var deferred = $q.defer();
                $scope.credentialsList = [];
                var resp = PHD.Ajax.get('/api/credentials/?sid=' + systemID);
                resp.done(function(data){
                    var credentials = data.data;
                    var credential = [];
                    credential.id = 0;
                    credential.name = "None";
                    $scope.credentialsList.push(credential);
                    credentials.forEach(function (item, index) {
                        var credential = [];
                        credential.id = item.credential_id;
                        credential.name = item.display_name;
                        //console.log(credential);
                        $scope.credentialsList.push(credential);
                    });
                    deferred.resolve($scope.credentialsList);
                });
                return deferred.promise;
            };

            $scope.populateCertifiedVMData = function(){
                if($scope.isEdit){
                    if(!$scope.defineVMOptionsVisited) {
                        $scope.defineVMOptionsVisited = true;
                        for(var j = 0 ;j < $scope.inventoryData.length; j++){
                            for(var k = 0 ; k < $scope.certifyjoborder.certification_target.instances.length; k++){
                                var nodeArray = $scope.inventoryData[j].nodeId.split("_");
                                // check VM ID cause name might have changed
                                if(parseInt(nodeArray[nodeArray.length - 1]) === $scope.certifyjoborder.certification_target.instances[k].id){
                                    angular.extend($scope.inventoryData[j], $scope.certifyjoborder.certification_target.instances[k]);
                                    $scope.inventoryData[j].power_on = $scope.inventoryData[j].power_on == true ? 'Yes' : 'No';
                                    // use the name returned from the API in case the name has been changed
                                    $scope.inventoryData[j].name = $scope.certifyjoborder.certification_target.instances[k].name;
                                    if($scope.inventoryData[j].credential_id === 0){
                                        $scope.inventoryData[j].credentials = '(None)';
                                    }
                                    else{
                                        for(var cred in $scope.credentialsList){
                                            if($scope.credentialsList[cred].id === $scope.inventoryData[j].credential_id){
                                                $scope.inventoryData[j].credentials = $scope.credentialsList[cred].name;
                                            }
                                        }
                                    }
                                    $scope.inventoryData[j].tests = typeof $scope.inventoryData[j].application_tests == "undefined" ? 0 : $scope.inventoryData[j].application_tests.length ;
                                    $scope.inventoryData[j].host = $scope.selectedProfile.host_name;
                                    $scope.inventoryData[j].test_network = $scope.selectedProfile.test_network_name;
                                    if($scope.profileChange){
                                        $scope.inventoryData[j].resource_pool_name = $scope.selectedProfile.resource_pool_name;
                                        $scope.inventoryData[j].resource_pool_ref = $scope.selectedProfile.resource_pool_ref;
                                        $scope.inventoryData[j].datastore_name = $scope.selectedProfile.datastore_name;
                                        $scope.inventoryData[j].datastore_ref = $scope.selectedProfile.datastore_ref;
                                        $scope.inventoryData[j].recovery_network_name = $scope.selectedProfile.recovery_network_name;
                                        $scope.inventoryData[j].recovery_network_ref = $scope.selectedProfile.recovery_network_ref;
                                    }
                                    else{
                                        $scope.inventoryData[j].resource_pool_name = $scope.inventoryData[j].resource_pool_name == $scope.selectedProfile.resource_pool_name ? $scope.selectedProfile.resource_pool_name : $scope.inventoryData[j].resource_pool_name;
                                        $scope.inventoryData[j].resource_pool_ref = $scope.inventoryData[j].resource_pool_ref == $scope.selectedProfile.resource_pool_ref ? $scope.selectedProfile.resource_pool_ref : $scope.inventoryData[j].resource_pool_ref;
                                        $scope.inventoryData[j].datastore_name = $scope.inventoryData[j].datastore_name == $scope.selectedProfile.datastore_name ? $scope.selectedProfile.datastore_name : $scope.inventoryData[j].datastore_name;
                                        $scope.inventoryData[j].datastore_ref = $scope.inventoryData[j].datastore_ref == $scope.selectedProfile.datastore_ref ? $scope.inventoryData[j].datastore_ref : $scope.inventoryData[j].datastore_ref;
                                        $scope.inventoryData[j].recovery_network_name =  $scope.inventoryData[j].recovery_network_name == $scope.selectedProfile.recovery_network_name ? $scope.selectedProfile.recovery_network_name : $scope.inventoryData[j].recovery_network_name;
                                        $scope.inventoryData[j].recovery_network_ref = $scope.inventoryData[j].recovery_network_ref == $scope.selectedProfile.recovery_network_ref ? $scope.selectedProfile.recovery_network_ref : $scope.inventoryData[j].recovery_network_ref;

                                    }
                                    $scope.inventoryData[j].guest_os = $scope.inventoryData[j].os_type;
                                    $scope.inventoryData[j].re_ip = typeof $scope.inventoryData[j].networks === "undefined" || $scope.inventoryData[j].networks.length === 0 ? 'No' : 'Yes';
                                    if($scope.inventoryData[j].application_tests){
                                        for( var i = 0; i < $scope.inventoryData[j].application_tests.length; i++ ) {
                                            if($scope.inventoryData[j].application_tests[i].app_test_id){
                                                $scope.inventoryData[j].application_tests[i].id = $scope.inventoryData[j].application_tests[i].app_test_id;
                                                $scope.inventoryData[j].application_tests[i].app_test_params = $scope.inventoryData[j].application_tests[i].parameters;
                                            }
                                        }
                                    }
                                }
                                // New VM's added while editing will be assigned default values. Here 'j' represents newly added VMs index and 'k' is existing VMs index in current Job selected for editing
                                else if( j > k ){
                                    $scope.inventoryData[j].boot_order = 1;                                                         //Default value
                                    $scope.inventoryData[j].delay = 0;                                                              //Default value
                                    $scope.inventoryData[j].power_on = 'Yes';                                                       //Default value
                                    $scope.inventoryData[j].credentials = '(None)';                                                 //Default value
                                    $scope.inventoryData[j].tests = 0;                                                              //Default value
                                    $scope.inventoryData[j].host = $scope.selectedProfile.host_name;
                                    $scope.inventoryData[j].resource_pool_name = $scope.selectedProfile.resource_pool_name;
                                    $scope.inventoryData[j].resource_pool_ref = $scope.selectedProfile.resource_pool_ref;
                                    $scope.inventoryData[j].datastore_name = $scope.selectedProfile.datastore_name;
                                    $scope.inventoryData[j].datastore_ref = $scope.selectedProfile.datastore_ref;
                                    $scope.inventoryData[j].recovery_network_name = $scope.selectedProfile.recovery_network_name;
                                    $scope.inventoryData[j].recovery_network_ref = $scope.selectedProfile.recovery_network_ref;
                                    $scope.inventoryData[j].test_network = $scope.selectedProfile.test_network_name;
                                    $scope.inventoryData[j].re_ip = 'No';                                                           //Default value
                                    $scope.inventoryData[j].networks = [];
                                    $scope.inventoryData[j].application_tests = [];
                                }
                            }
                        }
                    }
                    else if($scope.profileChange){
                        for(var j=0 ;j<$scope.inventoryData.length;j++){
                            $scope.inventoryData[j].host = $scope.selectedProfile.host_name;
                            $scope.inventoryData[j].resource_pool_name = $scope.selectedProfile.resource_pool_name;
                            $scope.inventoryData[j].resource_pool_ref = $scope.selectedProfile.resource_pool_ref;
                            $scope.inventoryData[j].datastore_name = $scope.selectedProfile.datastore_name;
                            $scope.inventoryData[j].datastore_ref = $scope.selectedProfile.datastore_ref;
                            $scope.inventoryData[j].recovery_network_name = $scope.selectedProfile.recovery_network_name;
                            $scope.inventoryData[j].recovery_network_ref = $scope.selectedProfile.recovery_network_ref;
                            $scope.inventoryData[j].test_network = $scope.selectedProfile.test_network_name;
                        }
                    }
                }
                else{
                    if(!$scope.defineVMOptionsVisited){
                        $scope.defineVMOptionsVisited = true;
                        for(var j=0 ;j<$scope.inventoryData.length;j++){
                            $scope.inventoryData[j].boot_order = 1;                                                         //Default value
                            $scope.inventoryData[j].delay = 0;                                                              //Default value
                            $scope.inventoryData[j].power_on = 'Yes';                                                       //Default value
                            $scope.inventoryData[j].credentials = '(None)';                                                 //Default value
                            $scope.inventoryData[j].tests = 0;                                                              //Default value
                            $scope.inventoryData[j].host = $scope.selectedProfile.host_name;
                            $scope.inventoryData[j].resource_pool_name = $scope.selectedProfile.resource_pool_name;
                            $scope.inventoryData[j].resource_pool_ref = $scope.selectedProfile.resource_pool_ref;
                            $scope.inventoryData[j].datastore_name = $scope.selectedProfile.datastore_name;
                            $scope.inventoryData[j].datastore_ref = $scope.selectedProfile.datastore_ref;
                            $scope.inventoryData[j].recovery_network_name = $scope.selectedProfile.recovery_network_name;
                            $scope.inventoryData[j].recovery_network_ref = $scope.selectedProfile.recovery_network_ref;
                            $scope.inventoryData[j].test_network = $scope.selectedProfile.test_network_name;
                            $scope.inventoryData[j].re_ip = 'No';                                                           //Default value
                            $scope.inventoryData[j].networks = [];
                            $scope.inventoryData[j].application_tests = [];
                        }
                    }
                    else if($scope.profileChange){
                        for(var j=0 ;j<$scope.inventoryData.length;j++){
                            $scope.inventoryData[j].host = $scope.selectedProfile.host_name;
                            $scope.inventoryData[j].resource_pool_name = $scope.selectedProfile.resource_pool_name;
                            $scope.inventoryData[j].resource_pool_ref = $scope.selectedProfile.resource_pool_ref;
                            $scope.inventoryData[j].datastore_name = $scope.selectedProfile.datastore_name;
                            $scope.inventoryData[j].datastore_ref = $scope.selectedProfile.datastore_ref;
                            $scope.inventoryData[j].recovery_network_name = $scope.selectedProfile.recovery_network_name;
                            $scope.inventoryData[j].recovery_network_ref = $scope.selectedProfile.recovery_network_ref;
                            $scope.inventoryData[j].test_network = $scope.selectedProfile.test_network_name;
                        }
                    }
                    else if($scope.originalHypervisorType === $scope.selectedProfile.server_type){
                        for(var j=0 ;j<$scope.inventoryData.length;j++){
                            $scope.inventoryData[j].host = $scope.selectedProfile.host_name;
                            $scope.inventoryData[j].resource_pool_name = $scope.inventoryData[j].resource_pool_name == $scope.selectedProfile.resource_pool_name ? $scope.selectedProfile.resource_pool_name : $scope.inventoryData[j].resource_pool_name;
                            $scope.inventoryData[j].resource_pool_ref = $scope.inventoryData[j].resource_pool_ref == $scope.selectedProfile.resource_pool_ref ? $scope.selectedProfile.resource_pool_ref : $scope.inventoryData[j].resource_pool_ref;
                            $scope.inventoryData[j].datastore_name = $scope.inventoryData[j].datastore_name == $scope.selectedProfile.datastore_name ? $scope.selectedProfile.datastore_name : $scope.inventoryData[j].datastore_name;
                            $scope.inventoryData[j].datastore_ref = $scope.inventoryData[j].datastore_ref == $scope.selectedProfile.datastore_ref ? $scope.inventoryData[j].datastore_ref : $scope.inventoryData[j].datastore_ref;
                            $scope.inventoryData[j].recovery_network_name =  $scope.inventoryData[j].recovery_network_name == $scope.selectedProfile.recovery_network_name ? $scope.selectedProfile.recovery_network_name : $scope.inventoryData[j].recovery_network_name;
                            $scope.inventoryData[j].recovery_network_ref = $scope.inventoryData[j].recovery_network_ref == $scope.selectedProfile.recovery_network_ref ? $scope.selectedProfile.recovery_network_ref : $scope.inventoryData[j].recovery_network_ref;
                            $scope.inventoryData[j].test_network = $scope.selectedProfile.test_network_name;
                        }
                    }
                }
            };

            $scope.openEditSettingCertifiedVMDialog = function(row,cell,column){
                console.log("edit settings", row, cell, column);
                for(var j=0 ;j<$scope.inventoryData.length;j++){
                    if($scope.inventoryData[j].nodeId === row.nodeId){
                        $scope.currentVMForAdvancedSettings = $scope.inventoryData[j];      //Creates deep copy
                    }
                }
                $scope.selectedAssetName = $scope.currentVMForAdvancedSettings.name;

                ngDialog.open({
                    template: 'app/joborders/certify-backups/editCertifiedVM.html',
                    scope: $scope,
                    overlay:true,
                    modelDialogId:'edit-certifiedVM-dailog',
                    ngDialogStyle:'width:600px;height:520px;',
                    preCloseCallback: function (value) {}
                });
            };

            $scope.getSchedulePresets = function() {
                if($scope.scheduleTypeSelection.name == "On Demand") {
                    var jobName=$scope.certifyBackupJobNameModel;
                    $scope.certifyjoborderName=jobName;
                    $scope.isScheduled = false;
                    $scope.dayError = false;
                    $scope.errorField = false;
                } else {
                    $scope.isScheduled = true;
                    if ($scope.certifyBackupJobNameModel == 'On-Demand'){
                        $scope.certifyBackupJobNameModel=(typeof($scope.certifyjoborderName) !='undefined')?$scope.certifyjoborderName:'Data Copy Access Job';
                    }
                    $scope.dayError = false;
                    $scope.errorField = false;
                    if(!$scope.isEdit){
                        $scope.currentSchedule.calendar=[];
                        $scope.currentSchedule.calendar={
                            start_date:new Date().toLocaleDateString($rootScope.userLanguageCode),
                            start_time:"03:00:00 am",
                            recursCheck:false,
                            recursTimeSelect:0,
                            recurrence:1,
                            schedule_run: 0,
                            end_hour:24
                        };
                        $scope.currentSchedule.calendar.run_on = ["0"];
                        $scope.setCalendarEntryEndHour();
                        var timerId="#recurs_spinner_field";
                        $(timerId).spinner({min: 1, max: 12});
                    }
                }
            };

            $scope.recurstimeModeChange = function(timeSelect){
                var timerId="#recurs_spinner_field";
                if(timeSelect == 0){
                    $(timerId).spinner({min: 1, max: 12});
                }else{
                    $(timerId).spinner({min: 1, max: 60});
                }
                $scope.recursTimeValidity();
            };

            $scope.recursTimeValidity = function(){
                if($scope.currentSchedule.calendar.recursTimeSelect === 0){
                    $scope.currentSchedule.calendar.recurrence = Math.min(Math.max($scope.currentSchedule.calendar.recurrence, 1), 12);
                }
                else if($scope.currentSchedule.calendar.recursTimeSelect === 1){
                    $scope.currentSchedule.calendar.recurrence = Math.min(Math.max($scope.currentSchedule.calendar.recurrence, 1), 60);
                }
            };

            // Called when the Power on timeout Hours/Minutes dropdown is changed.
            // Passes id of 0 if hours and 1 if minutes.
            $scope.powerOnSelectChange = function(timeSelect){
                powerOnSetMinMax(timeSelect);
                $scope.powerOnValidity();
            };

            // Sets the power-on timeout spinner min/max values.
            function powerOnSetMinMax(timeSelect) {
                var timerId="#id_power_on_timeout";
                if(timeSelect === 0){
                    $(timerId).spinner({min: 1, max: MAX_HOURS});
                }else{
                    $(timerId).spinner({min: 1, max: MAX_MINUTES});
                }
            }

            // Sets the power on timeout to a valid value based on the min/max allowed.
            $scope.powerOnValidity = function(){
                if($scope.joboptions.powerOnSelect === 0){
                    $scope.joboptions.power_on_timeout = Math.min(Math.max($scope.joboptions.power_on_timeout, 1), MAX_HOURS);
                }
                else if($scope.joboptions.powerOnSelect === 1){
                    $scope.joboptions.power_on_timeout = Math.min(Math.max($scope.joboptions.power_on_timeout, 1), MAX_MINUTES);
                }
            };

            $scope.setCalendarEntryEndHour = function() {
                var minute = "59";
                var ampm = " pm";
                if ($scope.currentSchedule.calendar !== undefined) {
                    var endHour = parseInt($scope.currentSchedule.calendar.end_hour);
                    if (endHour > 13){
                        endHour -= $scope.PM_ADJUST_EXTRA;
                        $scope.currentSchedule.calendar.end_hour = endHour+":"+minute+ampm;
                    } else {
                        ampm = (endHour == 13) ? " pm" : " am";
                        endHour--;
                        $scope.currentSchedule.calendar.end_hour = endHour+":"+minute+ampm;
                    }
                }
            };

            $scope.loadProfilesInDropDown = function(serviceProfiles){
                var profileLoad = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Loading Profiles..."));
                if(serviceProfiles == null) {
                    $scope.profileList = [];
                    if($scope.hypervisor_type == "VMware"){
                        $scope.vmwareProfileList = [];
                    }
                    else{
                        $scope.hypervProfileList = [];
                    }

                    var resp = PHD.Ajax.get("/api/certification/serviceprofile/?sid=" + $scope.certifyjoborder.sid, profileLoad);
                    resp.done(function (data) {
                        serviceProfiles = data.service_profiles;
                        if (serviceProfiles && serviceProfiles.length > 0) {
                            serviceProfiles.forEach(function (profile, index) {
                                if (profile.server_type == $scope.hypervisor_type) {
                                    if ($scope.hypervisor_type == "VMware") {
                                        $scope.vmwareProfileList.push(profile);
                                    }
                                    else {
                                        $scope.hypervProfileList.push(profile);
                                    }
                                }
                            });
                            if($scope.hypervisor_type == "VMware") {
                                $scope.profileList = $scope.vmwareProfileList;
                            }
                            else {
                                $scope.profileList = $scope.hypervProfileList;
                            }
                        }
                        if($scope.profileList !== null && $scope.profileList.length > 0 && $scope.profileList[0].id !== '-1') {
                            if(!$scope.isEdit){
                                $scope.profile.id = $scope.profileList[0].id;
                            }
                        }
                        else {
                            $("#id_serviceProfile").attr("title", gettextCatalog.getString("No Profiles available. Click 'Manage Lab Profiles' to create"));
                            $scope.profileList.push({name:gettextCatalog.getString('Click Manage to add Profile'), id:'-1'});
                            $scope.profile.id = $scope.profileList[0].id;
                        }
                        $scope.changeProfiles();
                        $(window).resize();
                        $scope.originalHypervisorType = $scope.profileList[0].server_type;
                    });
                }
                else
                {
                    PHD.hideLoadingIndicator(profileLoad);
                    $scope.profileList = serviceProfiles;
                    //$scope.$apply();
                    if (serviceProfiles && serviceProfiles.length > 0 && $scope.profileList[0].id !== '-1') {
                        if(!$scope.isEdit){
                            $scope.profile.id = $scope.profileList[0].id;
                        }
                    }
                    else {
                        $("#id_serviceProfile").attr("title", gettextCatalog.getString("No Profiles available. Click 'Manage Lab Profiles' to create"));
                        $scope.profileList.push({name:gettextCatalog.getString('Click Manage to add Profile'), id:'-1'});
                        $scope.profile.id = $scope.profileList[0].id;
                    }
                    $scope.changeProfiles();
                    $(window).resize();
                }
            };

            $scope.validateStartDate = function (date) {
                return DateTimeHandler.dateNotValid(date, $rootScope.userLanguageCode);
            };

            $scope.validateSchedule = function() {
                $scope.errorField=false;
                $scope.startDateFormatError=false;
                $scope.dayError=false;
                $scope.startTimeError=false;
                $scope.recursEveryError = false;
                $scope.endHourError =false;

                if(!$scope.isScheduled){
                    $scope.dayError = false;
                    $scope.errorField = false;
                    return true;
                }
                else{
                    if($scope.currentSchedule.calendar.run_on.length <=0){
                        $scope.errorField=true;
                        $scope.dayError=true;
                    }
                    else {
                        $scope.dayError = false;
                        $scope.errorField = false;
                    }
                    if(typeof($scope.currentSchedule.calendar.start_time) == 'undefined' || $scope.currentSchedule.calendar.start_time === '' || $scope.currentSchedule.calendar.start_time === null || $scope.currentSchedule.calendar.start_time == 0){
                        $scope.errorField=true;
                        $scope.startTimeError=true;
                    }
                    if($scope.validateStartDate($scope.currentSchedule.calendar.start_date)){
                        $scope.errorField = true;
                        $scope.startDateFormatError = true;
                    }
                    if($scope.currentSchedule.calendar.recursCheck){
                        if(typeof($scope.currentSchedule.calendar.recurrence) === 'undefined'  || $scope.currentSchedule.calendar.recurrence === null || $scope.currentSchedule.calendar.recurrence === "" || $scope.currentSchedule.calendar.recurrence == 0 ){
                            $scope.errorField=true;
                            $scope.recursEveryError=true;
                        }
                        if(typeof($scope.currentSchedule.calendar.end_hour) === 'undefined') {
                            $scope.errorField=true;
                            $scope.endHourError=true;
                        }
                        var start_hour = $scope.getHourFromString($scope.currentSchedule.calendar.start_time);
                        var end_hour = $scope.getHourFromString($scope.currentSchedule.calendar.end_hour);
                        if (start_hour >= end_hour) {
                            $scope.errorField=true;
                            $scope.endHourError=true;
                        }
                    }

                    return !$scope.errorField;

                }

            };

            $scope.inventoryValidation = function(){
                $scope.inventoryDataError = false;
                if( Object.keys($scope.selectedAsset).length == 0){
                    $scope.inventoryDataError = true;
                    return false;
                }
                return true;
            };

            $scope.nextWizard = function($event){
                if(wizardTitle == gettextCatalog.getString("Select Assets")){
                    console.log($scope.selectedAsset);
                    if($("#CertifyJobHelp").is(':visible')){
                        $("#CertifyStaging").show();
                        $("#CertifyJobHelp").hide();
                        return;
                    }
                    if(!$scope.inventoryValidation()){
                        return;
                    }
                    $scope.profileError = false;
                    var systemChange = false;
                    if(systemID == null || systemID != $scope.certifyjoborder.sid){
                        systemID = $scope.certifyjoborder.sid;
                        systemChange = true;
                    }
                    $rootScope.$broadcast("nextBtnClick");
                    if($scope.hypervisor_type == "VMware"){
                        $scope.profileList = $scope.vmwareProfileList;
                    }
                    else{
                        $scope.profileList = $scope.hypervProfileList;
                    }
                    if($scope.isEdit){
                        if($scope.originalHypervisorType == null){
                            profileID = $scope.profile.id = $scope.certifyjoborder.service_profile.id;
                        }
                        var timeout = $scope.certifyjoborder.certification_options.power_on_timeout;
                        if (timeout > MIN_PER_HOUR && ((timeout % MIN_PER_HOUR) === 0)) {
                            $scope.joboptions.power_on_timeout = timeout / MIN_PER_HOUR;
                            $scope.joboptions.powerOnSelect = 0;
                        } else {
                            $scope.joboptions.power_on_timeout = timeout;
                            $scope.joboptions.powerOnSelect = 1;
                        }
                        $scope.joboptions.post_custom_script  = $scope.certifyjoborder.certification_options.post_custom_script;
                        $scope.joboptions.post_custom_script_arguments  = $scope.certifyjoborder.certification_options.post_custom_script_arguments;
                        $scope.joboptions.suffix_name  = $scope.certifyjoborder.certification_options.suffix_name;
                    }
                    powerOnSetMinMax($scope.joboptions.powerOnSelect);
                    if(systemChange || $scope.originalHypervisorType == null ||  $scope.profileList == null){
                        $scope.loadProfilesInDropDown();
                    }
                }
                if(wizardTitle == gettextCatalog.getString("Define Job Options")){
                    $scope.profileError = false;
                    if( Object.keys($scope.profileList).length == 0 || $scope.profile.id == '-1'){
                        $scope.profileError = true;
                        return;
                    }
                    if(!$scope.defineScheduleVisited){
                        $scope.defineScheduleVisited = true;
                        if($scope.isEdit){
                            if(typeof $scope.certifyjoborder.calendar !== "undefined" ){
                                $scope.scheduleTypeSelection.name = "Scheduled";
                                $scope.currentSchedule.calendar.start_time = $scope.certifyjoborder.calendar[0].start_time;
                                $scope.currentSchedule.calendar.start_date = $scope.certifyjoborder.calendar[0].start_date;
                                $scope.currentSchedule.calendar.run_on = [];
                                for(var i = 0;i < $scope.certifyjoborder.calendar[0].run_on.length ; i++){
                                    var runOnDay = $scope.certifyjoborder.calendar[0].run_on[i].toString();
                                    $scope.currentSchedule.calendar.run_on.push(runOnDay);
                                }
                                if($scope.certifyjoborder.calendar[0].recurrence){
                                    $scope.currentSchedule.calendar.recursCheck = true;
                                    if($scope.certifyjoborder.calendar[0].recurrence < 60){
                                        $scope.currentSchedule.calendar.recursTimeSelect=1;
                                        $scope.currentSchedule.calendar.recurrence = $scope.certifyjoborder.calendar[0].recurrence;
                                        var timerId="#recurs_spinner_field";
                                        $(timerId).spinner({min: 1, max: 60});
                                    }else{
                                        $scope.currentSchedule.calendar.recurrence = $scope.certifyjoborder.calendar[0].recurrence/60;
                                        $scope.currentSchedule.calendar.recursTimeSelect=0;
                                        var timerId="#recurs_spinner_field";
                                        $(timerId).spinner({min: 1, max: 12});
                                    }
                                    $scope.currentSchedule.calendar.end_hour = $scope.certifyjoborder.calendar[0].end_hour;
                                    $scope.setCalendarEntryEndHour();
                                }
                                else{
                                    $scope.currentSchedule.calendar.recursTimeSelect = 0;
                                    $scope.currentSchedule.calendar.recurrence = 1;
                                    $scope.currentSchedule.calendar.end_hour = 24;
                                    $scope.setCalendarEntryEndHour();
                                    var timerId="#recurs_spinner_field";
                                    $(timerId).spinner({min: 1, max: 12});
                                }
                            }
                            else{
                                $scope.scheduleTypeSelection.name = "On Demand";
                                $scope.isScheduled = false;
                                $scope.currentSchedule.calendar={
                                    start_date:new Date().toLocaleDateString('en-US'),
                                    start_time:"03:00:00 am",
                                    recursCheck:false,
                                    recursTimeSelect:0,
                                    recurrence:1,
                                    end_hour:24
                                };
                                $scope.currentSchedule.calendar.run_on = ["0"];
                                $scope.setCalendarEntryEndHour();
                            }
                        }
                        else{
                            $scope.getSchedulePresets();
                        }
                    }
                    $rootScope.$broadcast("nextBtnClick");
                }
                if(wizardTitle == gettextCatalog.getString("Define Schedule")){
                    console.log($scope.certifyjoborder);
                    if( !$scope.validateSchedule()){
                        return;
                    }
                    $scope.profileChange = false;
                    if(profileID == null || profileID != $scope.profile.id){
                        profileID = $scope.profile.id;
                        $scope.profileChange = true;
                    }
                    $scope.getCredentials($scope.certifyjoborder.sid).then(function(){
                        $scope.populateCertifiedVMData();
                    });
                    $rootScope.$broadcast("nextBtnClick");
                }
            };
}])

.controller('editCertifiedVMController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc','dataToBeShared','includeExcludeLabelService','$timeout','uiGridConstants','$sce','$compile', '$q', 'gettextCatalog',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,dataToBeShared,includeExcludeLabelService, $timeout , uiGridConstants , $sce , $compile , $q, gettextCatalog) {
        $scope.tab = 1;
        $scope.currentTab = 1;
        $scope.ADVANCED_TAB = 3;
        $scope.credential_id = 0;
        $scope.dataStoresPools  = [];
        $scope.reconfigureCPU = false;
        $scope.network = [];
        $scope.networksArray = [];
        $scope.appTest = [];
        $scope.gotResourcePoolsAndDataStores = false;
        $scope.gotRecoveryNetwork = false;
        $scope.ReIPErrors = false;
        $scope.selectedNetwork = null;
        $scope.selectedTest = null;
        $scope.EditNetwork = false;
        $scope.TestsArray = [];
        $scope.AppTestErrors = false;
        $scope.editTest = false;
        $scope.closeDialogAfterSaving = true;

        $scope.osList = [
            {type:'Linux'},
            {type:'Windows'}
        ];

        $scope.showtoolTip = function(){
            var element = angular.element("#power_on_checkbox");
            element.find(".definition").popover({
                appendTo: element
            });
        };

        $scope.showGuestOsToolTip = function(){
            var element = angular.element("#guest_os_selection");
            element.find(".definition").popover({
                appendTo: element
            });
        };

        $scope.showDelayToolTip = function(){
            var element = angular.element("#delay-in-minutes");
            element.find(".definition").popover({
                appendTo: element
            });
        };

        $scope.osList.selected_guest_os = '';

        $scope.networksGridColumnDefs = [
            {
                field: "name",
                headerCellFilter: 'translate',
                displayName: gettextCatalog.getString("Adapter"),
                sortable : true,
                sortingType : "string",
                sort: {
                    direction: uiGridConstants.ASC,
                    priority: 0
                }
            },
            {
                field: "ip_address",
                headerCellFilter: 'translate',
                displayName: gettextCatalog.getString("IP Address"),
                sortable : true,
                sortingType : "string"
            }
        ];
        $scope.networksGrid={
            columnDefs: $scope.networksGridColumnDefs,
            data:'networksArray',
            rowHeight: 32,
            enableHorizontalScrollbar:0,
            enableVerticalScrollbar:2,
            resizable: true,
            multiSelect: false,
            enableFullRowSelection : true,
            enableSelectAll: false,
            gridMenuShowHideColumns:false,
            enableColumnMenus:false,
            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;
                gridApi.selection.on.rowSelectionChanged($scope, function(rows){
                    var selectedItems = gridApi.selection.getSelectedRows();
                    if (selectedItems.length > 0) {
                        $scope.selectedNetwork = selectedItems[0];
                    } else if (selectedItems.length == 0) {
                        $scope.selectedNetwork = null;
                    }
                });
            }
        };

        $scope.testsGridColumnDefs = [
            {
                field: "name",
                headerCellFilter: 'translate',
                displayName: gettextCatalog.getString("Test Name"),
                sortable : true,
                sortingType : "string",
                sort: {
                    direction: uiGridConstants.ASC,
                    priority: 0
                }
            },
            {
                field: "app_tests",
                headerCellFilter: 'translate',
                displayName: gettextCatalog.getString("Test type"),
                sortable : true,
                sortingType : "string"
            },
            {
                field: "priority",
                headerCellFilter: 'translate',
                displayName: gettextCatalog.getString("Priority"),
                sortable : true,
                sortingType : "number"
            },
            {
                field: "timeout_min",
                headerCellFilter: 'translate',
                displayName: gettextCatalog.getString("Timeout"),
                sortable : true,
                sortingType : "number"
            }
        ];
        $scope.testsGrid={
            columnDefs: $scope.testsGridColumnDefs,
            data:'TestsArray',
            rowHeight: 32,
            enableHorizontalScrollbar:0,
            enableVerticalScrollbar:2,
            resizable: true,
            multiSelect: false,
            enableFullRowSelection : true,
            enableSelectAll: false,
            gridMenuShowHideColumns:false,
            enableColumnMenus:false,
            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;
                gridApi.selection.on.rowSelectionChanged($scope, function(rows){
                    var selectedItems = gridApi.selection.getSelectedRows();
                    if (selectedItems.length > 0) {
                        $scope.selectedTest = selectedItems[0];
                    } else if (selectedItems.length == 0) {
                        $scope.selectedTest = null;
                    }
                });
            }
        };

        $scope.reconfigureClicked = function(reconfigure){
            if(!reconfigure){
                $scope.num_cpu = '';
                $scope.memory_mb = '';
            }
        };

        $scope.setResourceNameAndRef = function() {
            if(!$scope.gotResourcePoolsAndDataStores){
                var nodeIDArray = $scope.currentVMForAdvancedSettings.nodeId.split('_');
                console.log($scope.currentVMForAdvancedSettings.nodeId.split('_'));
                if(nodeIDArray[1] === "virtual"){
                    var type = $scope.selectedProfile.server_type == "HyperV" ? "Hyper-V" : $scope.selectedProfile.server_type;
                    var Load = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Loading Data..."));
                    var resp = PHD.Ajax.get('/api/virtual_clients/targets/?sid=' + $scope.certifyjoborder.sid + "&os_id=39" + "&type=" + type);
                    resp.done(function(data){
                        PHD.hideLoadingIndicator(Load);
                        console.log($scope.dataStores,$scope.selectedProfile.host_name, data.targets);
                        data.targets.forEach(function (item, index) {
                            if(item.id == $scope.selectedProfile.host_ref){
                                if($scope.selectedProfile.server_type === "VMware") {
                                    console.log(item.groups.VG);
                                    var resourcePools = item.groups.VG;
                                    $scope.dataStoresPools = [];
                                    if(resourcePools != null){
                                        resourcePools.forEach(function (pool, index) {
                                            $scope.dataStoresPools.push({name: pool.Name, value: pool.Key});
                                        });
                                    }
                                    $scope.resource_pool = $scope.currentVMForAdvancedSettings.resource_pool_ref;
                                    $timeout(function(){
                                        angular.element("#id_resource").triggerHandler('click');
                                    },100);
                                }
                                var datastores = item.datastores;
                                $scope.dataStores = [];
                                if($scope.selectedProfile.server_type === "VMware") {
                                    datastores.forEach(function (dataStore, index) {
                                        $scope.dataStores.push({name:dataStore.name, value: dataStore.datastore_identifier});
                                    });
                                }
                                else{
                                    // for Hyper-V, assign a unique index to each datastore as there isn't any ID being returned from the API
                                    datastores.forEach(function (dataStore, index) {
                                        $scope.dataStores.push({name:dataStore.name, value: index});
                                    });
                                }
                                if ($scope.selectedProfile.server_type === "VMware") {
                                    $scope.datastore = $scope.currentVMForAdvancedSettings.datastore_ref;
                                } else {
                                    for (var i = 0; i < $scope.dataStores.length; i++) {
                                        // datastore_ref is the datastore name in case of Hyper-V
                                        if ($scope.dataStores[i].name == $scope.currentVMForAdvancedSettings.datastore_ref) {
                                            $scope.datastore = $scope.dataStores[i].value;
                                            $scope.datastorename = $scope.dataStores[i].name;
                                            $scope.datastoreid = $scope.datastore;
                                        }
                                    }
                                }
                                $timeout(function(){
                                    angular.element("#id_datastore").triggerHandler('click');
                                },100);
                            }
                        });
                    });
                }
                else{
                    // Get the instanceID from the node, for either VMware or Hyper-V servers.
                    var instanceID = inventorysvc.nodeToObject($scope.currentVMForAdvancedSettings.nodeId).instance_id;
                    var Load = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Loading Data..."));
                    var resp = PHD.Ajax.get('/api/restore/targets/?sid=' + $scope.certifyjoborder.sid + "&instance_id=" + instanceID);
                    resp.done(function(data){
                        PHD.hideLoadingIndicator(Load);
                        console.log($scope.dataStores,$scope.selectedProfile.host_name, data.targets);
                        data.targets.forEach(function (item, index) {
                            if(item.id == $scope.selectedProfile.host_ref){
                                if($scope.selectedProfile.server_type === "VMware") {
                                    console.log(item.groups.VG);
                                    var resourcePools = item.groups.VG;
                                    $scope.dataStoresPools = [];
                                    if(resourcePools != null){
                                        resourcePools.forEach(function (pool, index) {
                                            $scope.dataStoresPools.push({name: pool.Name, value: pool.Key});
                                        });
                                    }
                                    $scope.resource_pool = $scope.currentVMForAdvancedSettings.resource_pool_ref;
                                    $timeout(function(){
                                        angular.element("#id_resource").triggerHandler('click');
                                    },100);
                                }
                                var datastores = item.datastores;
                                $scope.dataStores = [];
                                if($scope.selectedProfile.server_type === "VMware") {
                                    datastores.forEach(function (dataStore, index) {
                                        $scope.dataStores.push({name:dataStore.name, value: dataStore.identifier});
                                    });
                                }
                                else{
                                    // for Hyper-V, assign a unique index to each datastore as there isn't any ID being returned from the API
                                    datastores.forEach(function (dataStore, index) {
                                        $scope.dataStores.push({name:dataStore.name, value: index});
                                    });
                                }
                                if ($scope.selectedProfile.server_type === "VMware") {
                                    $scope.datastore = $scope.currentVMForAdvancedSettings.datastore_ref;
                                } else {
                                    for (var i = 0; i < $scope.dataStores.length; i++) {
                                        // datastore_ref is the datastore name in case of Hyper-V
                                        if ($scope.dataStores[i].name == $scope.currentVMForAdvancedSettings.datastore_ref) {
                                            $scope.datastore = $scope.dataStores[i].value;
                                            $scope.datastorename = $scope.dataStores[i].name;
                                            $scope.datastoreid = $scope.datastore;
                                        }
                                    }
                                }
                                $timeout(function(){
                                    angular.element("#id_datastore").triggerHandler('click');
                                },100);
                            }
                        });
                    });
                }
                $scope.gotResourcePoolsAndDataStores = true;
            }
        };

        $scope.loadDatastore = function() {
            console.log("Change DataStore");
            if($scope.selectedProfile.server_type !== "VMware") {
                $scope.setResourceNameAndRef();
            }
        };

        $scope.loadRecoveryNetworks = function() {
            if(!$scope.gotRecoveryNetwork){
                var type = $scope.selectedProfile.server_type == "HyperV" ? "Hyper-V" : $scope.selectedProfile.server_type;
                var hypervisorIdentifier = $scope.selectedProfile.server_type == "HyperV" ? $scope.selectedProfile.host_name : $scope.selectedProfile.host_ref ;
                var Load = PHD.showLoadingIndicator("body", true, "Loading Data...");
                var resp = PHD.Ajax.get('/api/networks/hypervisor-switch/info/?sid=' + $scope.certifyjoborder.sid + "&hypervisor_type=" + type + "&hypervisor=" +hypervisorIdentifier);
                resp.done(function(data){
                    PHD.hideLoadingIndicator(Load);
                    var switches = data.switches;
                    $scope.recoveryNetworks = [];
                    switches.forEach(function(network, index){
                        $scope.recoveryNetworks.push({name:network.name, value: network.network_identifier});
                    })
                    $scope.gotRecoveryNetwork = true;
                    $scope.recoveryNetwork = $scope.currentVMForAdvancedSettings.recovery_network_ref;
                    $timeout(function(){
                        angular.element("#id_datastore").triggerHandler('click');
                    },100);
                });
                PHD.hideLoadingIndicator(Load);
            }
        };

        $scope.addNetworkBtn = function() {
            $scope.network = [];
            $scope.network.name = "";
            $scope.reconfigureIPButtonText = gettextCatalog.getString("Add");
            ngDialog.open({
                template: 'app/joborders/certify-backups/ReconfigureIP.html',
                scope: $scope,
                overlay:true,
                name: 'Reconfigure-IP',
                modelDialogId:'Reconfigure-IP',
                ngDialogStyle:'width:500px; height:450px;',
                closeByDocument: false,
                closeByEscape: false
            });
        };

        $scope.editNetworkBtn = function() {
            console.log("Edit networks", $scope.selectedNetwork);
            if($scope.selectedNetwork !== null){
                ngDialog.open({
                    template: 'app/joborders/certify-backups/ReconfigureIP.html',
                    scope: $scope,
                    overlay:true,
                    name: 'Reconfigure-IP',
                    modelDialogId:'Reconfigure-IP',
                    ngDialogStyle:'width:500px; height:450px;',
                    closeByDocument: false,
                    closeByEscape: false
                });
                $scope.EditNetwork = true;
                $scope.reconfigureIPButtonText = gettextCatalog.getString("Update");
                $scope.network.name = $scope.selectedNetwork.name;
                $scope.network.ip_address = $scope.selectedNetwork.ip_address;
                $scope.network.gateway = $scope.selectedNetwork.gateway;
                $scope.network.mask = $scope.selectedNetwork.mask;
                $scope.network.dns1 = $scope.selectedNetwork.dns1;
                $scope.network.dns2 = $scope.selectedNetwork.dns2;
            }
        };

        $scope.removeNetworkBtn = function() {
            console.log("Delete networks");
            //$scope.networksArray = {};
            ngDialog.open({
                dialogType:gettextCatalog.getString('Confirmation'),
                modelDialogId:'RemoveNetwork',
                dialogMessage: gettextCatalog.getString('Are you sure you want to delete the selected Network Interface?'),
                scope:$scope,
                onConfirmOkButtonClick:'onConfirmDeleteNetworkWarning()'
            });
        };

        $scope.onConfirmDeleteNetworkWarning = function () {
            ngDialog.close('RemoveNetwork');
            $scope.networksArray.forEach(function(item, index){
                if($scope.selectedNetwork.name === item.name){
                    $scope.networksArray.splice(index,1);
                }
            });
            $scope.closeDialogAfterSaving = false;
            $scope.saveVMSettingsData();
            $scope.closeDialogAfterSaving = true;
        };

        isValidIP = function(str){
            return /^(?!0)(?!.*\.$)((1?\d?\d|25[0-5]|2[0-4]\d)(\.|$)){4}$/.test(str);
        };

        $scope.validateReIP = function() {
            $scope.ReIPErrors = false;
            $scope.IPFormatError = false;
            if(!isValidIP($scope.network.ip_address)){
                $scope.ReIPErrors = true;
                $scope.IPFormatError = true;
                $scope.ReIPField = "IP Address";
                return $scope.ReIPErrors;
            }
            else if(!isValidIP($scope.network.gateway)){
                $scope.ReIPErrors = true;
                $scope.IPFormatError = true;
                $scope.ReIPField = "Gateway";
                return $scope.ReIPErrors;
            }
            else if(!isValidIP($scope.network.mask)){
                $scope.ReIPErrors = true;
                $scope.IPFormatError = true;
                $scope.ReIPField = "Subnet";
                return $scope.ReIPErrors;
            }
            else if(!isValidIP($scope.network.dns1) && $scope.network.dns1!== '' && $scope.network.dns1!== null && typeof $scope.network.dns1 !== 'undefined'){
                console.log($scope.network.dns1);
                $scope.ReIPErrors = true;
                $scope.IPFormatError = true;
                $scope.ReIPField = "Preferred DNS";
                return $scope.ReIPErrors;
            }
            else if(!isValidIP($scope.network.dns2) && $scope.network.dns2!== '' && $scope.network.dns2!== null && typeof $scope.network.dns2 !== 'undefined'){
                $scope.ReIPErrors = true;
                $scope.IPFormatError = true;
                $scope.ReIPField = "Alternate DNS";
                return $scope.ReIPErrors;
            }
            return $scope.ReIPErrors;
        };

        $scope.saveNetwork = function() {
            if($scope.validateReIP()){
                return;
            }
            var newNetwork = {};
            newNetwork = $scope.network;
            console.log("Save network",newNetwork, $scope.selectedNetwork);
            if($scope.EditNetwork){
                $scope.networksArray.forEach(function(network){
                    if(network.name === $scope.selectedNetwork.name){
                        network.name = $scope.network.name;
                        network.ip_address = $scope.network.ip_address;
                        network.gateway = $scope.network.gateway;
                        network.mask = $scope.network.mask;
                        network.dns1 = $scope.network.dns1;
                        network.dns2 = $scope.network.dns2;
                    }
                });
                $scope.EditNetwork = false;
            }
            else{
                $scope.networksArray.push(newNetwork);
            }
            ngDialog.close('Reconfigure-IP');
            $scope.networksGrid.data = $scope.networksArray;
            $scope.network = [];
            $scope.closeDialogAfterSaving = false;
            $scope.saveVMSettingsData();
            $scope.closeDialogAfterSaving = true;
        };

        $scope.getTests = function(systemID) {
            var deferred = $q.defer();          //We need promise to make sure  $scope.applicationTestsList is populated first
            $scope.applicationTestsList = [];
            if(typeof $scope.currentVMForAdvancedSettings.guest_os == "undefined" && typeof $scope.osList.selected_guest_os.type == "undefined"){
                ngDialog.open({
                    dialogType:gettextCatalog.getString('Warning'),
                    modelDialogId:'SelectGuestOS',
                    dialogMessage: gettextCatalog.getString('Please select "Guest OS" from "Options" tab before adding application tests.'),
                    scope:$scope,
                    onConfirmOkButtonClick:'onConfirmWarning()'
                });
                return;
            }

            var guestOS = typeof ($scope.currentVMForAdvancedSettings.guest_os) == "undefined" ? $scope.osList.selected_guest_os.type.toLowerCase() : $scope.currentVMForAdvancedSettings.guest_os.toLowerCase();
            if(guestOS.indexOf("windows") > -1){
                guestOS = "windows";
            }
            else {
                guestOS = "linux";
            }
            var resp = PHD.Ajax.get('/api/certification/tests/?guest_os=' + guestOS);
            resp.done(function(data){
                console.log("GET test list", systemID);
                var tests = data.tests;
                tests.forEach(function (item, index) {
                    item.app_tests.forEach(function (appTest, index) {
                        var test = [];
                        test.id = appTest.id;
                        test.app_tests = appTest.title;
                        test.name = item.name;
                        test.app_test_params = sortByProperty(appTest.app_test_params, "order");        //Arrange UI elements according to order
                        test.command = appTest.command;
                        test.is_custom = appTest.is_custom;
                        $scope.applicationTestsList.push(test);
                    });
                });
                deferred.resolve($scope.applicationTestsList);
            });
            return deferred.promise;
        };

        function sortByProperty(array, propertyName) {
            return array.sort(function (a, b) {
                return a[propertyName] - b[propertyName];
            });
        }

        $scope.addTestBtn = function() {
            $scope.editTest = false;
            $scope.applicationTestDialogTitle = gettextCatalog.getString("Add Test");
            $scope.applicationTestsButtonText = gettextCatalog.getString("Add");
            $scope.appTest.selectedTestFromDropdown = 0;
            $scope.appTest.priority = 1;
            $scope.appTest.timeout_min = 5;
            $scope.appTest.testName = "";
            $scope.AppTestErrors = false;
            $scope.appTestError = false;
            ngDialog.open({
                template: 'app/joborders/certify-backups/ApplicationTests.html',
                scope: $scope,
                overlay:true,
                modelDialogId: 'AddTest',
                ngDialogStyle:'width:700px; height:570px;',
                closeByDocument: false,
                closeByEscape: false
            });
        };

        $scope.editTestBtn = function() {
            $scope.editTest = true;
            $scope.applicationTestDialogTitle = gettextCatalog.getString("Edit Test");
            $scope.applicationTestsButtonText = gettextCatalog.getString("Update");
            $scope.AppTestErrors = false;
            $scope.appTestError = false;
            ngDialog.open({
                template: 'app/joborders/certify-backups/ApplicationTests.html',
                scope: $scope,
                overlay:true,
                modelDialogId: 'AddTest',
                ngDialogStyle:'width:700px; height:570px;',
                closeByDocument: false,
                closeByEscape: false
            });
            $scope.appTest.hashKey = $scope.selectedTest.$$hashKey;
            $scope.appTest.selectedTestFromDropdown = $scope.selectedTest.id;
            $scope.appTest.priority = $scope.selectedTest.priority;
            $scope.appTest.timeout_min = $scope.selectedTest.timeout_min;
            $scope.appTest.testName = $scope.selectedTest.name;
            $timeout(function(){
                $scope.appTestChanged();
            },100);
        };

        $scope.removeTestBtn = function() {
            ngDialog.open({
                dialogType:gettextCatalog.getString('Confirmation'),
                modelDialogId:'RemoveTest',
                dialogMessage: gettextCatalog.getString('Are you sure you want to delete the selected test?'),
                scope:$scope,
                onConfirmOkButtonClick:'onConfirmDeleteTestWarning()'
            });
        };

        $scope.onConfirmDeleteTestWarning = function () {
            ngDialog.close('RemoveTest');
            $scope.TestsArray.forEach(function(item, index){
                if($scope.selectedTest.name === item.name){
                    $scope.TestsArray.splice(index,1);
                }
            });
            $scope.selectedTest = null;
            $scope.closeDialogAfterSaving = false;
            $scope.saveVMSettingsData();
            $scope.closeDialogAfterSaving = true;
        };

        /*$scope.AppTest object contains user input Data binded through ng-model
         *$scope.currentTest object is object which is a created from part of json returned from REST api which will be used for validation
         */

        $scope.appTestChanged = function() {
            $scope.AppTestErrors = false;
            $scope.appTest.timeout_min = $scope.selectedTest === null ? 5 : $scope.selectedTest.timeout_min;
            $scope.appTest.priority = $scope.selectedTest === null ? 1: $scope.selectedTest.priority;
            var aForm = (angular.element(document.getElementById('appType')));
            aForm.html('');
            $scope.myHTML = "";
            $scope.appTest.testName = "";
            $scope.applicationTestsList.forEach(function(test){
                if($scope.appTest.selectedTestFromDropdown === test.id){
                    console.log(test, $scope.editTest);
                    $scope.tests = $scope.currentTest = {};
                    angular.extend($scope.currentTest, test);               //Create shallow copy so that $scope.applicationTestsList remains untouched
                    $scope.appTest.testName = $scope.currentTest.name = $scope.editTest ?  $scope.selectedTest.name : test.app_tests;
                    test.app_test_params.forEach(function(viewItem, index){
                        if(viewItem.attributes !== null && viewItem.attributes.indexOf("Hidden:True") > -1){
                            return;
                        }
                        if(viewItem.control_type === "TextBox"){
                            var label = '';
                            if(test.name.toLowerCase().indexOf("service") > -1){
                                label = viewItem.name.charAt(0).toUpperCase()+ viewItem.name.slice(1);
                            }
                            else{
                                label = viewItem.text;
                            }
                            //There could be better ways to implement this but for time being I am using index to create key-value pairs - MSG.
                            //This will be better for time complexity while Editing a Test. O(1) : (array key based on index) vs O(n squared) : (array key based on name). Not that it matters to us :P
                            $scope.tests['key'+index] = viewItem.name;
                            if($scope.editTest){
                                $scope.tests['value'+index] = $scope.selectedTest.app_test_params[index].value;
                            }
                            $scope.myHTML +=
                                '<div class="control-row">'+
                                '<div class="control-group" style="width:100%;">'+
                                '<label class="label" style="width:200px;padding-left:10px;float:left;">'+ label +'</label>'+
                                '<input type="text" ng-model = "tests.value'+index + '" style="width:65%;float:left;" placeholder = "'+ viewItem.text +'">'+
                                '</div>'+
                                '</div>';
                        }
                        else if(viewItem.control_type === "TextArea"){
                            var label = '';
                            if(test.name.toLowerCase().indexOf("service") > -1){
                                label = viewItem.name.charAt(0).toUpperCase()+ viewItem.name.slice(1);
                            }
                            else{
                                label = viewItem.text;
                            }
                            $scope.tests['key'+index] = viewItem.name;
                            if($scope.editTest){
                                $scope.tests['value'+index] = $scope.selectedTest.app_test_params[index].value;
                            }
                            $scope.myHTML +=
                                '<div style="margin-top:10px; margin-bottom: 10px;">'+
                                '<div style="width:100%;">'+
                                '<label class="label" style="width:200px;padding-left:10px;float:left;font-size:12px;">'+ label +'</label>'+
                                '<textarea type="text" style="resize: none;width:65%;float:left;margin-bottom: 10px; font-size: 12px;" rows="3" ng-model = "tests.value'+index + '" style="width:50%;float:left;"></textarea>'+
                                '</div>'+
                                '</div>';
                        }
                        else if(viewItem.control_type === "TextPassword"){
                            var label = '';
                            if(test.name.toLowerCase().indexOf("service") > -1){
                                label = viewItem.name.charAt(0).toUpperCase()+ viewItem.name.slice(1);
                            }
                            else{
                                label = viewItem.text;
                            }
                            $scope.tests['key'+index] = viewItem.name;
                            if($scope.editTest){
                                $scope.tests['value'+index] = $scope.selectedTest.app_test_params[index].value;
                            }
                            $scope.myHTML +=
                                '<div class="control-row">'+
                                '<div class="control-group" style="width:100%;">'+
                                '<label class="label" style="width:200px;padding-left:10px;float:left;">'+ viewItem.text +'</label>'+
                                '<input type="password" ng-model = "tests.value'+index + '"  style="width:65%;float:left;">'+
                                '</div>'+
                                '</div>';
                        }
                        else if(viewItem.control_type === "CheckBox"){
                            $scope.tests['key'+index] = viewItem.name;
                            $scope.tests['value'+index] = false;
                            if($scope.editTest){
                                $scope.tests['value'+index] = $scope.selectedTest.app_test_params[index].value;
                            }
                            $scope.myHTML +=
                                '<div class="control-row">'+
                                '<div class="control-group" style="width:100%;">'+
                                '<input type="checkbox" ng-model = "tests.value'+index + '" style="width:50px;float:left;margin-left: -5px;" type="checkbox">'+
                                '<label class="label" for="id_test_failover" style="padding-left:10px;float:left;">'+ viewItem.text+' </label>'+
                                '</div>'+
                                '</div>';
                        }
                    });
                    aForm.append($scope.myHTML);
                    $compile(aForm)($scope);
                }
            });
        };

        $scope.validateTestInputs = function() {
            $scope.AppTestErrors = false;
            $scope.appTestError = false;
            $scope.appTestErrorText = "";
            var newTest = $scope.currentTest;
            if($scope.appTest.selectedTestFromDropdown == 0 || $scope.appTest.selectedTestFromDropdown == null){
                $scope.appTestError = true;
                $scope.AppTestErrors = true;
                $scope.appTestErrorText = gettextCatalog.getString("Please select the type of application test");
                return true;
            }
            if($scope.appTest.testName === ""){
                $scope.appTestError = true;
                $scope.AppTestErrors = true;
                $scope.appTestErrorText = gettextCatalog.getString("Please enter valid test name");
                return true;
            }
            for (var index = 0;index < newTest.app_test_params.length; index++){
                if(newTest.app_test_params[index].name === $scope.tests['key'+index] && (newTest.app_test_params[index].attributes !== null)){
                    var paramValidations = newTest.app_test_params[index].attributes.split(';');
                    var maxLength = 0;
                    var currentPartParamValidations = paramValidations[0].split(':');
                    if(typeof $scope.tests['value'+index] == "undefined" || $scope.tests['value'+index] == ""){
                        if(currentPartParamValidations[0] !== "Required" && currentPartParamValidations[1] !== "False"){
                            $scope.appTestError = true;
                            $scope.AppTestErrors = true;
                            $scope.appTestErrorText = gettextCatalog.getString("Please enter : " + newTest.app_test_params[index].text);
                            break;
                        }
                    }
                    if(currentPartParamValidations[0] === "MaxLength"){
                        maxLength = parseInt(currentPartParamValidations[1]);
                    }
                    else{
                        var nextPartParamValidations = paramValidations[1].split(':');
                        if(nextPartParamValidations[0] === "MaxLength"){
                            maxLength = parseInt(nextPartParamValidations[1]);
                        }
                    }
                    if( typeof $scope.tests['value'+index] !== "undefined" && $scope.tests['value'+index].length > maxLength){
                        $scope.appTestError = true;
                        $scope.AppTestErrors = true;
                        $scope.appTestErrorText = gettextCatalog.getString("Max length allowed for "+ newTest.app_test_params[index].text+ " is "+ maxLength);
                        break;
                    }
                }
            }
            if($scope.AppTestErrors === true){
                return true;
            }
            else{
                return false;
            }
        };

        $scope.saveAppTest = function() {
            var appTestPresent = false;
            var count = 0;
            var warningMessage = "";
            if($scope.validateTestInputs()){
                return;
            }
            var newTest = {};
            angular.copy($scope.currentTest, newTest);

            $scope.TestsArray.forEach(function(test){
                if(test.name == $scope.appTest.testName){
                    if($scope.editTest){
                        count ++;
                        if(count > 1){
                            appTestPresent = true;
                            warningMessage = gettextCatalog.getString("A test with this name already exists, please enter a new name.");
                        }
                    }
                    else{
                        appTestPresent = true;
                        warningMessage = gettextCatalog.getString("A test with this name already exists, please enter a new name.");
                    }
                }
            });

            if(appTestPresent){
                ngDialog.open({
                    dialogType:gettextCatalog.getString('Warning'),
                    modelDialogId:'SameTestPresentWarning',
                    dialogMessage: warningMessage,
                    scope:$scope,
                    onConfirmOkButtonClick:'onConfirmTestWarning()'
                });
            }
            else{
                if($scope.editTest){
                    $scope.TestsArray.forEach(function(test){
                        if(test.id === $scope.currentTest.id && test.$$hashKey === $scope.appTest.hashKey){
                            test.app_test_params.forEach(function(viewItem, index){
                                if(viewItem.name === $scope.tests['key'+index]){
                                    viewItem.value = $scope.tests['value'+index];
                                }
                                if(viewItem.attributes !== null && viewItem.attributes.indexOf("Hidden:True") > -1){
                                    var paramValue = viewItem.attributes.split(';');
                                    paramValue = paramValue[0].split(':');
                                    viewItem.value = paramValue[1];
                                }
                            });
                            test.timeout_min = $scope.appTest.timeout_min;
                            test.priority = $scope.appTest.priority;
                            test.name = $scope.appTest.testName;
                        }
                    });
                }
                else{
                    newTest.app_test_params.forEach(function(viewItem, index){
                        if(viewItem.name === $scope.tests['key'+index]){
                            viewItem.value = $scope.tests['value'+index];
                        }
                        if(viewItem.attributes !== null && viewItem.attributes.indexOf("Hidden:True") > -1){
                            var paramValue = viewItem.attributes.split(';');
                            paramValue = paramValue[0].split(':');
                            viewItem.value = paramValue[1];
                        }
                    });
                    newTest.timeout_min = $scope.appTest.timeout_min;
                    newTest.priority = $scope.appTest.priority;
                    newTest.name = $scope.appTest.testName;
                    $scope.TestsArray.push(newTest);
                }
                ngDialog.close('AddTest');
                $scope.editTest = false;
                $scope.testsGrid.data = $scope.TestsArray;
                console.log($scope.TestsArray);
                $scope.closeDialogAfterSaving = false;
                $scope.saveVMSettingsData();
                $scope.closeDialogAfterSaving = true;
            }
        };

        $scope.onConfirmTestWarning = function(){
            ngDialog.close('SameTestPresentWarning');
        };

        $scope.populateAdvancedOptionsData = function(){
            if($scope.currentTab === 1){
                $scope.recovery_name = $scope.currentVMForAdvancedSettings.name;
                $scope.boot_order = $scope.currentVMForAdvancedSettings.boot_order;
                $scope.delay = $scope.currentVMForAdvancedSettings.delay;
                $scope.power_on = $scope.currentVMForAdvancedSettings.power_on;
                $scope.num_cpu = typeof $scope.currentVMForAdvancedSettings.num_cpu == "undefined" || $scope.currentVMForAdvancedSettings.num_cpu == 0 ? '' : $scope.currentVMForAdvancedSettings.num_cpu;
                $scope.memory_mb = typeof $scope.currentVMForAdvancedSettings.memory_mb == "undefined" || $scope.currentVMForAdvancedSettings.memory_mb == 0  ? '' : $scope.currentVMForAdvancedSettings.memory_mb;
                if($scope.num_cpu || $scope.memory_mb){
                    $scope.reconfigureCPU = true;
                }
                $scope.credentials = $scope.currentVMForAdvancedSettings.credentials;
                $scope.credential_id = typeof $scope.currentVMForAdvancedSettings.credential_id == "undefined" ? 0 : $scope.currentVMForAdvancedSettings.credential_id;
            }
            else if($scope.currentTab === 2){
                console.log($scope.selectedProfile);
                $scope.setResourceNameAndRef();
                $scope.loadRecoveryNetworks();
                $scope.resource_pool = $scope.currentVMForAdvancedSettings.resource_pool_ref;
                if ($scope.selectedProfile.server_type === "VMware") {
                    $scope.datastore = $scope.currentVMForAdvancedSettings.datastore_ref;
                } else {
                    // assign the datastore id in case of Hyper-V as 'datastore_ref' is datastore name
                    $scope.datastore = $scope.datastoreid;
                }
                $scope.recoveryNetwork = $scope.currentVMForAdvancedSettings.recovery_network_ref;
            }
            else if($scope.currentTab === 3){

                $scope.network.name = "";
                //$scope.networksArray = typeof $scope.currentVMForAdvancedSettings.networks == "undefined" ? [] :  $scope.currentVMForAdvancedSettings.networks;
                if(typeof $scope.currentVMForAdvancedSettings.networks == "undefined" ||  $scope.currentVMForAdvancedSettings.networks == []){
                    $scope.networksArray = [];
                }
                else{
                    $scope.networksArray = [];
                    for( var i = 0; i < $scope.currentVMForAdvancedSettings.networks.length; i++ ) {
                        $scope.networksArray.push($scope.currentVMForAdvancedSettings.networks[i]);
                    }
                }
            }
            else if($scope.currentTab === 4){
                $scope.TestsArray = [];
                $scope.appTest.timeout_min = 5;
                $scope.appTest.priority = 1;
                $scope.getTests($scope.certifyjoborder.sid).then(function(){
                    if(typeof $scope.currentVMForAdvancedSettings.application_tests == "undefined" ||  $scope.currentVMForAdvancedSettings.application_tests == []){
                        $scope.TestsArray = [];
                    }
                    else{
                        $scope.TestsArray = [];
                        for( var i = 0; i < $scope.currentVMForAdvancedSettings.application_tests.length; i++ ) {
                            if($scope.currentVMForAdvancedSettings.application_tests[i].app_test_id){
                                $scope.applicationTestsList.forEach(function(test){
                                    if($scope.currentVMForAdvancedSettings.application_tests[i].app_test_id === test.id){
                                        $scope.currentVMForAdvancedSettings.application_tests[i].app_tests = test.app_tests;
                                        //App_test_params may not be in correct order so we go through both arrays and match according to item name. Once matched we merge those 2 arrays.
                                        for( var j = 0; j < $scope.currentVMForAdvancedSettings.application_tests[i].app_test_params.length; j++ ) {
                                            for( var k = 0; k < test.app_test_params.length; k++ ) {
                                                if($scope.currentVMForAdvancedSettings.application_tests[i].app_test_params[j].name === test.app_test_params[k].name){
                                                    angular.extend($scope.currentVMForAdvancedSettings.application_tests[i].app_test_params[j], test.app_test_params[k]);
                                                    continue;
                                                }
                                            }
                                        }
                                        $scope.currentVMForAdvancedSettings.application_tests[i].app_test_params = sortByProperty($scope.currentVMForAdvancedSettings.application_tests[i].app_test_params, "order");
                                    }
                                });
                            }
                            $scope.TestsArray.push($scope.currentVMForAdvancedSettings.application_tests[i]);
                        }
                    }
                });

                $scope.TestsArray = typeof $scope.currentVMForAdvancedSettings.application_tests == "undefined" ? [] : $scope.currentVMForAdvancedSettings.application_tests;
            }
        };

        $scope.populateAdvancedOptionsData();

        $scope.savingAlert = function() {
            $scope.saveClicked = false;
            ngDialog.open({
                dialogType:gettextCatalog.getString('Confirmation'),
                modelDialogId:'savingAlertConfirmation',
                dialogMessage: gettextCatalog.getString('Do you want to save your changes?'),
                scope:$scope,
                onConfirmOkButtonClick:'closeAlertAfterSaving()',
                preCloseCallback: function (value) {
                    if(!$scope.saveClicked){
                        $scope.showCurrentTab($scope.tabSelected);
                    }
                }
            });
        };

        $scope.closeAlertAfterSaving = function () {
            $scope.saveClicked = true;
            $scope.closeDialogAfterSaving = false;
            ngDialog.close('savingAlertConfirmation');
            $scope.saveVMSettingsData();
            $scope.closeDialogAfterSaving = true;
        };

        $scope.tabsDisabled = function(checkTab) {
            var changes = false;
            $scope.tabSelected = checkTab;
            if($scope.currentTab === 1 && checkTab !== 1){
                if($scope.recovery_name !== $scope.currentVMForAdvancedSettings.name){
                    changes = true;
                }
                else if($scope.boot_order !== $scope.currentVMForAdvancedSettings.boot_order){
                    changes = true;
                }
                else if($scope.delay !== $scope.currentVMForAdvancedSettings.delay){
                    changes = true;
                }
                else if($scope.power_on !== $scope.currentVMForAdvancedSettings.power_on){
                    changes = true;
                }
                else if($scope.reconfigureCPU && $scope.num_cpu !== $scope.currentVMForAdvancedSettings.num_cpu){
                    changes = true;
                }
                else if($scope.reconfigureCPU && $scope.memory_mb !== $scope.currentVMForAdvancedSettings.memory_mb){
                    changes = true;
                }
                else if(!(typeof $scope.currentVMForAdvancedSettings.credential_id === "undefined" && $scope.credential_id === 0) &&
                    ($scope.credential_id !== $scope.currentVMForAdvancedSettings.credential_id)){
                    changes = true;
                }
                else if(!$scope.currentVMForAdvancedSettings.guest_os){
                    if($scope.currentVMForAdvancedSettings.guest_os !== $scope.osList.selected_guest_os.type){
                        changes = true;
                    }
                }
            }
            else if($scope.currentTab === 2 && checkTab !== 2){
                if($scope.selectedProfile.server_type === 'VMware' && $scope.currentVMForAdvancedSettings.resource_pool_ref !== $scope.resource_pool){
                    changes = true;
                }
                // for VMware, 'datastore_ref' is the datastore ID
                else if($scope.selectedProfile.server_type === 'VMware' && $scope.currentVMForAdvancedSettings.datastore_ref !== $scope.datastore){
                    changes = true;
                }
                // for Hyper-V, comparing the already stored datastore ID with the currently selected one
                else if($scope.selectedProfile.server_type !== 'VMware' && $scope.datastoreid !== $scope.datastore){
                    changes = true;
                }
                else if($scope.currentVMForAdvancedSettings.recovery_network_ref !== $scope.recoveryNetwork){
                    changes = true;
                }
            }
            if(changes){
                $scope.savingAlert();
                return true;
            }
            return false;
        };

        $scope.showCurrentTab = function(currentTab){
            console.log(currentTab, $scope.buttonClicked);
            $scope.buttonClicked = false;
            $scope.currentTab = currentTab;
            $scope.tab = currentTab;
            $scope.populateAdvancedOptionsData();
            $(window).resize();
        };

        $scope.selectTab = function (setTab){
            $scope.tab = setTab;
        };
        $scope.isSelected = function(checkTab) {
            return $scope.tab === checkTab;
        };

        $scope.launchCredentialManager = function() {
            ngDialog.open({
                template: 'app/configure/credentials/credentials.html',
                scope: $scope,
                overlay:true,
                name: 'Credential-Manager',
                modelDialogId : 'credential-manager-dialog',
                ngDialogStyle:'width:700px; height:550px;',
                closeByDocument: false,
                closeByEscape: false,
                data: $scope.certifyjoborder.sid,
                preCloseCallback: function (value) {
                    //Calling getCredentials function in parent controller
                    $scope.getCredentials($scope.certifyjoborder.sid).then(function(){});
                }
            });
        };

        $scope.saveVMSettingsData = function(){
            if($scope.currentTab === 1){
                $scope.currentVMForAdvancedSettings.name = $scope.recovery_name;
                $scope.currentVMForAdvancedSettings.boot_order = $scope.boot_order;
                $scope.currentVMForAdvancedSettings.delay = $scope.delay;
                $scope.currentVMForAdvancedSettings.power_on = $scope.power_on;
                if($scope.reconfigureCPU){
                    if($scope.num_cpu === ''){
                        $scope.num_cpu = 0;
                    }
                    if($scope.memory_mb === ''){
                        $scope.memory_mb = 0;
                    }
                    var mem = $scope.memory_mb;
                    if(mem % 4 !== 0){
                        mem += (4 - (mem % 4));           //If user enters any value which is not multiple of 4 update it to next multiple of 4
                    }
                    $scope.memory_mb = mem;
                    $scope.currentVMForAdvancedSettings.num_cpu = $scope.num_cpu;
                    $scope.currentVMForAdvancedSettings.memory_mb = $scope.memory_mb;
                }
                else{
                    $scope.currentVMForAdvancedSettings.num_cpu = 0;
                    $scope.currentVMForAdvancedSettings.memory_mb = 0;
                }
                if(!$scope.currentVMForAdvancedSettings.guest_os){
                   $scope.currentVMForAdvancedSettings.guest_os = $scope.osList.selected_guest_os.type;
                }
                $scope.currentVMForAdvancedSettings.credential_id = $scope.credential_id;
                $scope.credentialsList.forEach(function(item){
                    if(item.id === $scope.credential_id){
                        $scope.currentVMForAdvancedSettings.credentials = item.name;
                    }
                })
            }
            else if($scope.currentTab === 2){
                if($scope.dataStoresPools.length>0){
                    $scope.dataStoresPools.forEach(function(resourcePool){
                        if($scope.resource_pool === resourcePool.value){
                            $scope.currentVMForAdvancedSettings.resource_pool_name = resourcePool.name;
                            $scope.currentVMForAdvancedSettings.resource_pool_ref = resourcePool.value;
                        }
                    });
                }
                $scope.dataStores.forEach(function(dataStore){
                    if($scope.datastore === dataStore.value){
                        $scope.currentVMForAdvancedSettings.datastore_name = dataStore.name;
                        if ($scope.selectedProfile.server_type === "VMware") {
                            $scope.currentVMForAdvancedSettings.datastore_ref = dataStore.value;
                        } else {
                            // for Hyper-V, 'datastore_ref' should also be the datastore name
                            $scope.currentVMForAdvancedSettings.datastore_ref = dataStore.name;
                        }
                    }
                });
                $scope.recoveryNetworks.forEach(function(network){
                    if($scope.recoveryNetwork === network.value){
                        $scope.currentVMForAdvancedSettings.recovery_network_name = network.name;
                        $scope.currentVMForAdvancedSettings.recovery_network_ref = network.value;
                    }
                });
            }
            else if($scope.currentTab === 3){
                if($scope.networksArray.length >0){
                    $scope.currentVMForAdvancedSettings.re_ip = "Yes";
                    $scope.currentVMForAdvancedSettings.networks = $scope.networksArray;
                }
                else{
                    $scope.currentVMForAdvancedSettings.re_ip = "No";
                    $scope.currentVMForAdvancedSettings.networks = [];
                }
            }
            else if($scope.currentTab === 4){
                console.log($scope.TestsArray);

                if($scope.TestsArray.length >0){
                    $scope.currentVMForAdvancedSettings.tests = $scope.TestsArray.length;
                    $scope.currentVMForAdvancedSettings.application_tests = $scope.TestsArray;
                }
                else{
                    $scope.currentVMForAdvancedSettings.tests = 0;
                    $scope.currentVMForAdvancedSettings.application_tests = [];
                }

            }
            if($scope.closeDialogAfterSaving){
                ngDialog.close('edit-certifiedVM-dailog');
            }
        };


}]);


