/**
 * Created by mgadge on 10/28/2016.
 */
angular.module('certifyJobDetailsModule',['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])

    .controller('CertifyJobDetailsCtrl', ['$scope', '$rootScope', '$http','ngDialog', 'gettextCatalog', function($scope, $rootScope, $http, ngDialog, gettextCatalog) {

        $scope.expanding_property = {
            field: "name",
            headerCellFilter: "translate",
            displayName: gettextCatalog.getString("Recovery Step"),
            filterable: true
        };

        $scope.jobDetailsColumnDefs = [
            {
                field:'status',
                headerCellFilter: "translate",
                displayName:gettextCatalog.getString('Result'),
                cellTemplate:'<div ng-animate-disabled ng-cloak style=\'line-height: inherit;\' ng-cloak ng-class="row.branch[col.field] ==\'Successful\'? \'icon-oksign icon-large greencolor\' : row.branch[col.field] ==\'Cancelled\'? \'icon-phd-canceled icon-large \'' +
                ': row.branch[col.field] ==\'Failed\' ? \'icon-phd-error icon-large redcolor\' : row.branch[col.field] ==\'Paused\' ? \'icon-pause icon-large\' : row.branch[col.field] ==\'Skip\' || row.branch[col.field] ==\'Warning\' ? \'icon-phd-warning icon-large\' :'+
                ' \'icon-hourglass icon-large\' " ><span style="font-family: Helvetica; font-size: 12px;"> {{row.branch[col.field]}}</span></div>'
            },
            {
                field:'percent_complete',
                headerCellFilter: "translate",
                displayName:gettextCatalog.getString('Progress(%)'),
                cellTemplate:'<div class="progress-bar" style="height: 16px!important;box-shadow: 0 2px 5px rgba(0, 0, 0, 0.25) inset;" ng-cloak ng-animate-disabled title="{{row.branch[col.field]}}%">' +
                '<div class="progress-meter stripes" ng-class="row.branch[col.field] != \'100\' ? \'progress-bar-animate\' : \'\'" style="width:{{row.branch[col.field]}}%; height: 14px!important;box-shadow: 0 1.5px 1.5px rgba(242, 243, 255, 0.67) inset;"><span class="progress-count" style="color: #ffffff; font-size: 9px;text-align: center;"> {{row.branch[col.field]}}%</span></div> </div></div>'
            },
            {
                field:'start_date',
                headerCellFilter: "translate",
                displayName:gettextCatalog.getString('Start Time')
            },
            {
                field:'end_date',
                headerCellFilter: "translate",
                displayName:gettextCatalog.getString('End Time')
            },
            {
                field:'description',
                headerCellFilter: "translate",
                displayName:gettextCatalog.getString('Description'),
                cellTooltip: true
            }
        ];

        $scope.loadSettings = function() {
            if(!$scope.DCAActiveJobDetails){       //When job is not in progress i.e. in case of job history we get ngDialog data
                $scope.selectedDCAJob = [];
                if ($scope.ngDialogData.history != undefined && $scope.ngDialogData.history != "" && $scope.ngDialogData.history != null) {
                    var treeData = $scope.ngDialogData.history.detail;
                    if (treeData != undefined && treeData != "" && treeData != null) {
                        $scope.DCAJobName = treeData.name !== "" ? treeData.name : gettextCatalog.getString("Details - Data Copy Access Job");
                        treeData.server_type = $scope.ngDialogData.history.server_type;
                        $scope.selectedDCAJob.push(treeData);
                    }
                }
            }
        };

        angular.element(document).ready(function () {
            $scope.loadSettings();
        });

    }]);