angular.module('serviceProfiles',['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {
            }
        });
    }])

    .controller('profileControl', ['$scope', '$rootScope', '$http','$analytics','ngDialog', 'wirFactory', 'networkDataFactory', '$timeout', 'uiGridConstants', '$q', 'gettextCatalog',
        function($scope, $rootScope, $http, $analytics, ngDialog, wirFactory, networkDataFactory, $timeout , uiGridConstants, $q, gettextCatalog) {

            var ProfilesTable = null;
            var profileRowData = null;
            var base_url = "/api/certification/serviceprofile/";
            $scope.selectedProfileId;
            $scope.selectedProfile = null;
            $scope.hostObj = "";
            $scope.hyperVisorTypeObj = {};
            $scope.networksLoaded = false;
            $scope.applianceNetworksLoaded = false;
            var sid = $scope.certifyjoborder.sid;
            $scope.preSelectedHyperVisorType = $scope.hypervisor_type;
            $scope.profileTableLoaded = false;
            $scope.profileEdit = false;

            $scope.profilesGridColumnDefs = [
                {
                    field: "name",
                    displayName: gettextCatalog.getString("PROFILE NAME"),
                    sortable : true,
                    sortingType : "string",
                    sort: {
                        direction: uiGridConstants.ASC,
                        priority: 0
                    }
                },
                {
                    field: "server_type",
                    displayName: gettextCatalog.getString("HYPERVISOR"),
                    sortable : true,
                    sortingType : "string"
                },
                {
                    field: "rpo",
                    displayName: gettextCatalog.getString("RPO"),
                    sortable : true,
                    sortingType : "string"
                },
                {
                    field: "rto",
                    displayName: gettextCatalog.getString("RTO"),
                    sortable: true,
                    sortingType : "string"
                }
            ];

            $scope.profilesGrid={
                columnDefs: $scope.profilesGridColumnDefs,
                data:'profileListDisplay',
                rowHeight: 32,
                enableHorizontalScrollbar:0,
                enableVerticalScrollbar:2,
                resizable: true,
                multiSelect: false,
                enableFullRowSelection : true,
                gridMenuShowHideColumns:false,
                enableColumnMenus:false,
                onRegisterApi: function (gridApi) {
                    $scope.gridApi = gridApi;
                    gridApi.selection.on.rowSelectionChanged($scope, function(rows){
                        var selectedItems = gridApi.selection.getSelectedRows();
                        if (selectedItems.length > 0) {
                            $scope.selectedProfile = selectedItems[0];
                            $scope.selectedProfileId = $scope.selectedProfile.id;
                        } else if (selectedItems.length == 0) {
                            $scope.selectedProfile = null;
                        }
                    });
                }
            };

            $scope.launchProfileAdder = function() {
                $scope.dialogTitle = gettextCatalog.getString("Add Lab Profile");
                $scope.profileEdit = false;
                $scope.hostObj = "";
                $("#id_rpo_value").attr("title", "Allowed range 1-99");
                $("#id_rto_value").attr("title", "Allowed range 1-99");
                $scope.hypervisorTypeDisplay = ($scope.hypervisor_type == 'VMware') ? "VMware Host" : "Hyper-V Host";
                if ($scope.hypervisor_type == 'VMware') {
                    if (($scope.vmwareLocations == null || $scope.vmwareLocations == undefined)) {
                        $scope.hypervisorTypeOnChange($scope.hypervisor_type);
                    }
                    else {
                        $scope.locations = $scope.vmwareLocations;
                    }
                }
                else {
                    if ($scope.hypervLocations == null || $scope.hypervLocations == undefined) {
                        $scope.hypervisorTypeOnChange($scope.hypervisor_type);
                    }
                    else {
                        $scope.locations = $scope.hypervLocations;
                    }
                }
                $scope.preSelectedHyperVisorType = $scope.hypervisor_type;
                $scope.profile = {};
                ngDialog.open({
                    template: 'app/joborders/certify-backups/AddProfile.html',
                    scope: $scope,
                    overlay:true,
                    name: 'Profile-Add',
                    ngDialogStyle:'width:600px;',
                    ngDialogPostionStyle:'top:15%;',
                    closeByDocument: false,
                    closeByEscape: true,
                    modelDialogId:'add-profile-dialog'
                });
            };

            $scope.launchProfileEditor = function() {
                $scope.profileEdit = true;
                $scope.editProfileWarningGiven = false;
                if ($scope.selectedProfile) {
                    $scope.dialogTitle = gettextCatalog.getString("Edit Lab Profile");
                    $scope.hypervisorTypeDisplay = ($scope.hypervisor_type == 'VMware') ? "VMware Host" : "Hyper-V Host";
                    if ($scope.hypervisor_type == 'VMware') {
                        if (($scope.vmwareLocations == null || $scope.vmwareLocations == undefined)) {
                            $scope.hypervisorTypeOnChange($scope.hypervisor_type).then(function(){
                                $scope.collectDataProfileToEdit();
                            });
                        }
                        else {
                            $scope.locations = $scope.vmwareLocations;
                            $scope.collectDataProfileToEdit();
                        }
                    }
                    else {
                        if ($scope.hypervLocations == null || $scope.hypervLocations == undefined) {
                            $scope.hypervisorTypeOnChange($scope.hypervisor_type).then(function(){
                                $scope.collectDataProfileToEdit();
                            });
                        }
                        else {
                            $scope.locations = $scope.hypervLocations;
                            $scope.collectDataProfileToEdit();
                        }
                    }
                    $scope.preSelectedHyperVisorType = $scope.hypervisor_type;
                    $scope.profile = {};
                    ngDialog.open({
                        template: 'app/joborders/certify-backups/AddProfile.html',
                        name: 'Profile-Edit',
                        scope: $scope,
                        overlay:true,
                        ngDialogStyle:'width:600px;',
                        ngDialogPostionStyle:'top:15%;',
                        modelDialogId : 'edit-profile-dialog',
                        closeByDocument: false,
                        closeByEscape: true,
                        showClose: false
                    });
                } else {
                    ngDialog.open({
                        dialogType:'Warning',
                        modelDialogId:'SelectProfile',
                        dialogMessage: gettextCatalog.getString('Select a profile to edit.'),
                        scope:$scope,
                        onConfirmOkButtonClick:'onConfirmWarning()'
                    });
                }
            };

            $scope.collectDataProfileToEdit = function(){
                console.log("selectedProfileId to Edit "+$scope.selectedProfileId);
                $scope.hostsLoaded = false;
                $scope.poolsLoaded = false;
                $scope.datastoreLoaded = false;
                var url = "/api/certification/serviceprofile/"+$scope.selectedProfileId+"/?sid=" + $scope.certifyjoborder.sid;
                $http({ method: 'get',
                    url : url
                }).success(function(data, status, headers){
                    var profile = data.service_profiles;
                    $scope.profile.name = profile.name;

                    $scope.locationOnChange(profile.host_ref);
                    if ($scope.hypervisor_type == "VMware") {
                        //$scope.hostObj = profile.host_name;
                        $scope.setResourceNameAndRef(profile.resource_pool_ref);
                        $scope.profile.resource = profile.resource_pool_ref;
                    }
                    $scope.setDatastoreNameAndRef(profile.datastore_ref);
                    $scope.profile.datastore = profile.datastore_ref;
                    $scope.setRecoveryNetworkNameAndRef(profile.recovery_network_ref);
                    $scope.profile.selectedRecoveryNetwork = profile.recovery_network_ref;
                    $scope.setTestNetworkNameAndRef(profile.test_network_ref);
                    $scope.profile.selectedTestNetwork = profile.test_network_ref;
                    $scope.loadApplianceNetworks().then(function(){
                        $scope.setApplianceNetwork(profile.appliance_network);
                        $scope.profile.selectedApplianceNetwork = profile.appliance_network;
                    });
                    $scope.profile.isComplianceEnabled = profile.is_compliance_enabled;
                    if(profile.rpo !== 0){
                        $scope.profile.rpo = profile.rpo;
                        $scope.profile.rpo_period = profile.rpo_frequency;
                    }
                    if(profile.rto !== 0){
                        $scope.profile.rto = profile.rto;
                        $scope.profile.rto_period = profile.rto_frequency;
                    }
                });
            };

            $scope.deleteProfile = function() {
                if ($scope.selectedProfile) {
                    ngDialog.open({
                        dialogType: gettextCatalog.getString('Confirmation'),
                        dialogMessage: gettextCatalog.getString("Are you sure you want to delete the selected profile?"),
                        scope: $scope,
                        overlay:true,
                        modelDialogId:'DeleteProfileConfirmation',
                        onConfirmOkButtonClick:'onConfirmDelete()'
                    });
                } else {
                    ngDialog.open({
                        dialogType: gettextCatalog.getString('Warning'),
                        modelDialogId:'NoProfileSelected',
                        dialogMessage: gettextCatalog.getString("Select a profile to delete."),
                        scope: $scope,
                        overlay:true,
                        onConfirmOkButtonClick:'onConfirmNoneSelected()'
                    });
                }
            };

            $scope.onConfirmNoneSelected = function() {
                ngDialog.close('NoProfileSelected');
            };

            $scope.onConfirmDelete = function() {
                ngDialog.close('DeleteProfileConfirmation');
                var base_url = "/api/certification/serviceprofile/" + $scope.selectedProfileId + "/?sid="+$scope.certifyjoborder.sid;
                console.log("Profile ID being deleted : " + $scope.selectedProfileId);
                $http({ method: 'delete',
                    url : base_url
                }).success(function(data, status, headers){
                    $scope.selectedProfile = null;
                    $scope.refreshProfileList(true);
                }).error(function(response) {
                    var message = response.result[0].message;
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'deleteProfileErrorDialog',
                        scope:$scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick:'onConfirmDeleteProfileError()'
                    });
                });
            };

            $scope.validateRecoveryAssuranceSettings = function(){
                console.log($scope.profile.rpo, $scope.profile.rpo_period, $scope.profile.rto, $scope.profile.rto_period);
                var message = "";
                if(($scope.profile.rpo != null && ($scope.profile.rpo_period == null || $scope.profile.rpo_period == "")) &&
                    ($scope.profile.rto != null && ($scope.profile.rto_period == null || $scope.profile.rto_period == ""))){
                    message = "Please select time unit for Recovery Point Objective(RPO) and Recovery Time Objective(RTO)";
                }
                else if($scope.profile.rpo != null && ($scope.profile.rpo_period == null || $scope.profile.rpo_period == "")){
                    message = "Please select time unit for Recovery Point Objective(RPO)";
                }
                else if($scope.profile.rpo != null && $scope.profile.rpo_period != null && $scope.profile.rto == null){
                    message = "Please enter time and select time unit for Recovery Time Objective(RTO)";
                }
                else if($scope.profile.rto != null && $scope.profile.rto_period != null && $scope.profile.rpo == null){
                    message = "Please enter time and select time unit for Recovery Point Objective(RPO)";
                }
                else if($scope.profile.rto != null && ($scope.profile.rto_period == null|| $scope.profile.rto_period == "")){
                    message = "Please select time unit for Recovery Time Objective(RTO)";
                }
                if(message != ""){
                    ngDialog.open({
                        dialogType:'Warning',
                        modelDialogId:'SelectRPORTO',
                        dialogMessage: message,
                        scope:$scope,
                        onConfirmOkButtonClick:'onConfirmWarningRPORTO()'
                    });
                    return false;
                }
                else if($scope.profileEdit && !$scope.editProfileWarningGiven){
                    $scope.editProfileWarningGiven = true;
                    message = "If any other Data Copy Access jobs are using this profile please update those jobs accordingly.";
                    ngDialog.open({
                        dialogType:'Warning',
                        modelDialogId:'SelectRPORTO',
                        dialogMessage: message,
                        scope:$scope,
                        onConfirmOkButtonClick:'onConfirmWarningRPORTO()'
                    });
                    return false;
                }
                return true;
            };

            $scope.onConfirmWarningRPORTO = function () {
                ngDialog.close('SelectRPORTO');
            };

            $scope.saveProfile = function() {
                if(!$scope.validateRecoveryAssuranceSettings()){
                    return;
                }
                console.log("Saving Profile..");
                var obj = {};
                obj.name = $scope.profile.name;
                obj.server_type = ($scope.hypervisor_type == "HyperV") ? "HyperV" : "VMware";
                obj.server_id = $scope.server_id;
                obj.datastore_name = $scope.selectedDatastoreName;
                obj.datastore_ref = $scope.selectedDatastoreRef;
                obj.test_network_name = $scope.selectedTestNetworkName;
                obj.test_network_ref = $scope.selectedTestNetworkRef;
                obj.recovery_network_name = $scope.selectedRecoveryNetworkName;
                obj.recovery_network_ref = $scope.selectedRecoveryNetworkRef;
                obj.resource_pool_name = $scope.selecteddataStorePoolName;
                obj.resource_pool_ref = $scope.selecteddataStorePoolRef;
                obj.host_name = $scope.selectedComputeName;
                obj.host_ref = $scope.selectedComputeRef;
                obj.appliance_network = $scope.profile.selectedApplianceNetwork;
                obj.is_compliance_enabled = $scope.profile.isComplianceEnabled;
                obj.rpo = $scope.profile.rpo == null ? undefined : $scope.profile.rpo;
                obj.rpo_frequency = $scope.profile.rpo_period == "" ? undefined : $scope.profile.rpo_period;
                obj.rto = $scope.profile.rto == null ? undefined : $scope.profile.rto;
                obj.rto_frequency = $scope.profile.rto_period == "" ? undefined : $scope.profile.rto_period;

                var resp;
                var url = "/api/certification/serviceprofile/";
                if($scope.profileEdit){
                    url += $scope.selectedProfileId + "/?sid=" + sid;
                    obj = JSON.stringify(obj);
                    var message;
                    $http({
                        method: 'put',
                        url : url,
                        data: obj
                    }).success(function(data, status, headers){
                        message = gettextCatalog.getString("Lab Profile updated successfully!");
                        ngDialog.open({
                            dialogType: 'Success',
                            dialogMessage: message,
                            scope:$scope,
                            modelDialogId:'editProfileSuccessDialog',
                            onConfirmOkButtonClick:'onConfirmEditSuccess()'
                        });
                        $timeout(function () {
                            $scope.refreshProfileList(true);
                        }, 500);
                    }).error(function(response) {
                        message = response.result[0].message;
                        ngDialog.open({
                            dialogType:'Error',
                            dialogMessage: message,
                            scope:$scope,
                            modelDialogId:'addProfileErrorDialog',
                            onConfirmOkButtonClick:'onConfirmAddProfileError()'
                        });
                    });
                }
                else{
                    url += "?sid=" + sid;
                    obj = JSON.stringify(obj);
                    var message;
                    $http({
                        method: 'post',
                        url : url,
                        data: obj
                    }).success(function(data, status, headers){
                        message = gettextCatalog.getString("Lab Profile created successfully!");
                        ngDialog.open({
                            dialogType: 'Success',
                            dialogMessage: message,
                            scope:$scope,
                            modelDialogId:'addProfileSuccessDialog',
                            onConfirmOkButtonClick:'onConfirmSuccess()'
                        });
                        $timeout(function () {
                            $scope.refreshProfileList(true);
                        }, 500);
                    }).error(function(response) {
                        message = response.result[0].message;
                        ngDialog.open({
                            dialogType:'Error',
                            dialogMessage: message,
                            scope:$scope,
                            modelDialogId:'addProfileErrorDialog',
                            onConfirmOkButtonClick:'onConfirmAddProfileError()'
                        });
                    });
                }
            };

            $scope.onConfirmAddProfileError = function () {
                ngDialog.close('addProfileErrorDialog');
            };

            $scope.onConfirmDeleteProfileError = function(){
                ngDialog.close('deleteProfileErrorDialog');
            };

            $scope.onConfirmSuccess = function () {
                ngDialog.close('addProfileSuccessDialog');
                ngDialog.close('add-profile-dialog');
            };

            $scope.onConfirmEditSuccess = function () {
                ngDialog.close('editProfileSuccessDialog');
                ngDialog.close('edit-profile-dialog');
            };

            $scope.locationsLoaded = false;
            $scope.hypervisorTypeOnChange = function(selectedType){
                var deferred = $q.defer();
                var load = PHD.showLoadingIndicator("body", true, "Loading...");
                $scope.locations        = []; //reset combo before get data .
                $scope.dataStores       = [];
                $scope.dataStoresPools  = [];
                $scope.networks         = [];
                $scope.collectDataStores = [];
                $scope.collectVMwareLocation = [];
                $scope.isSelecetedTypeVMware = false;
                $scope.server_id = "";

                var nodeIDArray = $scope.instanceIdToRetrieveTargets.split('_');
                if(nodeIDArray[1] === "virtual"){
                    var type = selectedType === "HyperV" ? "Hyper-V" : selectedType;
                    var url = '/api/virtual_clients/targets/?sid=' + $scope.certifyjoborder.sid + "&os_id=39" + "&type=" + type;
                }
                else{
                    var url = "/api/restore/targets/?sid=" + sid + "&instance_id=" + nodeIDArray[nodeIDArray.length - 1];
                }
                $http({ method: 'get',
                    url : url
                }).success(function(data, status, headers){
                    $scope.locations        = []; //reset combo before get data
                    $scope.dataStores       = [];
                    $scope.dataStoresPools  = [];
                    $scope.networks         = [];
                    $scope.applianceNetworks = [];

                    angular.forEach(data.targets, function(value, key) {
                        $scope.locationName = value.name;
                        var locationTempObj = {};
                        locationTempObj.value = String(value.id); // for Hyper-V converting int to string for it to match host_ref which is a string
                        locationTempObj.name = value.name;
                        locationTempObj.parent_id = value.parent_id;
                        $scope.locations.push(locationTempObj);
                        $scope.hyperVisorTypeObj={};
                        $scope.hypervisorId = ($scope.hypervisor_type == "HyperV") ? value.name : value.id;
                        $scope.collectDataStores = data.targets;
                        if( typeof(value.groups) !=="undefined"){
                            $scope.collectVMwareLocation = value;
                        }
                    });
                    if($scope.hypervisor_type == "VMware"){
                        $scope.vmwareLocations = $scope.locations;
                    }
                    else{
                        $scope.hypervLocations = $scope.locations;
                    }
                    deferred.resolve($scope.locations);
                    PHD.hideLoadingIndicator(load);
                }).error(function(response) {
                    var message = response.result[0].message;
                    PHD.hideLoadingIndicator(load);
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'ErrorDialog',
                        scope:$scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                });
                return deferred.promise;
            };

            $scope.setResourceNameAndRef = function(resource){
                for(var i=0; i<$scope.collectDataStores.length; i++){
                    if(typeof($scope.collectDataStores[i].groups) !== 'undefined'){
                        if($scope.collectDataStores[i].id  == $scope.hostObj){
                            angular.forEach($scope.collectDataStores[i].groups.VG, function(value, key) {
                                if(value.Key == resource) {
                                    $scope.selecteddataStorePoolName = value.Name;
                                    $scope.selecteddataStorePoolRef = value.Key;
                                }
                            });
                        }
                    }
                }
            };

            $scope.setComputeNameAndRef = function(location){
                for(var i=0; i<$scope.locations.length; i++){
                    if($scope.locations[i].value  == location){
                        $scope.selectedComputeName = $scope.locations[i].name;
                        $scope.selectedComputeRef = $scope.locations[i].value;
                        if(typeof $scope.locations[i].parent_id === "undefined"){
                            $scope.server_id = $scope.locations[i].value;
                        }
                        else{
                            $scope.server_id = $scope.locations[i].parent_id;
                        }
                        break;
                    }
                }
            };

            $scope.setDatastoreNameAndRef = function(dataStore){
                for(var i=0; i<$scope.dataStores.length; i++){
                    if($scope.dataStores[i].value  == dataStore){
                        $scope.selectedDatastoreName = $scope.dataStores[i].name;
                        $scope.selectedDatastoreRef = $scope.dataStores[i].value;
                        break;
                    }
                }
            };

            $scope.setRecoveryNetworkNameAndRef = function(network){
                for(var i=0; i<$scope.networks.length; i++){
                    if($scope.networks[i].value  == network){
                        $scope.selectedRecoveryNetworkName = $scope.networks[i].name;
                        $scope.selectedRecoveryNetworkRef = $scope.networks[i].value;
                        break;
                    }
                }
            };

            $scope.setTestNetworkNameAndRef = function(network){
                for(var i=0; i<$scope.networks.length; i++){
                    if($scope.networks[i].value  == network){
                        $scope.selectedTestNetworkName = $scope.networks[i].name;
                        $scope.selectedTestNetworkRef = $scope.networks[i].value;
                        break;
                    }
                }
            };

            $scope.setApplianceNetwork = function(network){
                for(var i=0; i<$scope.applianceNetworks.length; i++){
                    if($scope.applianceNetworks[i].name  === network){
                        $scope.selectedApplianceNetwork = $scope.applianceNetworks[i].name;
                        break;
                    }
                }
            };

            $scope.locationOnChange = function(location){
                $scope.setComputeNameAndRef(location);
                // reset all values when host is changed
                $scope.dataStoresPools = [];
                $scope.dataStores = [];
                $scope.networks = [];
                $scope.profile.resource = "";
                $scope.profile.datastore = "";
                $scope.profile.selectedRecoveryNetwork = "";
                $scope.profile.selectedTestNetwork = "";

                $scope.hostObj = location;
                if($scope.hostObj !=="" && typeof($scope.hostObj) !== "undefined"){
                    for(var i=0; i<$scope.collectDataStores.length; i++){
                        if(typeof($scope.collectDataStores[i].groups) !== 'undefined'){
                            if($scope.collectDataStores[i].id  == location){
                                $scope.selecteddataStorePool="";
                                angular.forEach($scope.collectDataStores[i].groups.VG, function(value, key) {
                                    var obj={
                                        name:value.Name,
                                        value:value.Key
                                    };
                                    $scope.dataStoresPools.push(obj);
                                });
                            }
                        }
                    }
                    if(typeof($scope.collectDataStores) != "undefined") {
                        for (var i = 0; i < $scope.collectDataStores.length; i++) {
                            if ($scope.collectDataStores[i].id == location) {
                                if (typeof($scope.collectDataStores[i].datastores) != "undefined") {
                                    angular.forEach($scope.collectDataStores[i].datastores, function(value, key) {
                                        var obj={};
                                        obj.name = value.name;
                                        if( $scope.hypervisor_type === 'VMware'){
                                            if($scope.instanceIdToRetrieveTargets.indexOf("virtual") !== -1){
                                                obj.value = value.datastore_identifier;
                                            }
                                            else{
                                                obj.value = value.identifier;
                                            }
                                        }
                                        else if($scope.hypervisor_type !== 'VMware'){
                                            obj.value = value.name;
                                        }
                                        $scope.dataStores.push(obj);
                                    });
                                }
                            }
                        }
                    }
                }

                //API Call for retrieving data of Network as per selection type.
                if($scope.hostObj) {
                    angular.forEach($scope.locations, function(value, key) {
                        if($scope.hostObj === value.value){
                            $scope.locationName = value.name;
                        }
                    });

                    $scope.hypervisorId = ($scope.hypervisor_type === "VMware") ? $scope.hostObj : $scope.locationName;
                    $scope.loadNetworks();
                    //While editing profile appliance networks array needs to be populated first and then assigned appropriate network.
                    //We use promise (Angular service) to make sure that api call is returned and data is populated in function loadApplianceNetworks which is called in function collectDataProfileToEdit
                    if(!$scope.profileEdit){
                        $scope.loadApplianceNetworks();
                    }
                }
            };

            $scope.loadNetworks = function(){
                var load = PHD.showLoadingIndicator("body", true, "Loading...");
                var hypervisorTypeToSend = $scope.hypervisor_type == "HyperV" ? "Hyper-V" : $scope.hypervisor_type;
                var networkURL ="/api/networks/hypervisor-switch/info/?" + "hypervisor=" + $scope.hypervisorId + "&hypervisor_type=" + hypervisorTypeToSend + "&sid=" + $scope.certifyjoborder.sid;
                $http({ method: 'get',
                    url : networkURL
                }).success(function(data, status, headers){
                    PHD.hideLoadingIndicator(load);
                    angular.forEach(data.switches, function (value, key) {
                        var network = {};
                        network.value = value.network_identifier;
                        network.name = value.name;
                        $scope.networks.push(network);
                    });
                }).error(function(response) {
                    var message = response.result[0].message;
                    PHD.hideLoadingIndicator(load);
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'ErrorDialog',
                        scope:$scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                });
                $scope.networksLoaded = true;
            };

            $scope.loadApplianceNetworks = function() {
                var deferred = $q.defer();
                var load = PHD.showLoadingIndicator("body", true, "Loading...");
                var networkURL ="/api/networks/?" + "sid=" + $scope.certifyjoborder.sid;
                $http({ method: 'get',
                    url : networkURL
                }).success(function(data, status, headers){
                    PHD.hideLoadingIndicator(load);
                    $scope.applianceNetworks = [];
                    angular.forEach(data.networks, function(value, key) {
                        var network = {};
                        network.value = value.id;
                        network.name = value.name;
                        $scope.applianceNetworks.push(network);
                    });
                    deferred.resolve($scope.locations);
                }).error(function(response) {
                    var message = response.result[0].message;
                    PHD.hideLoadingIndicator(load);
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'ErrorDialog',
                        scope:$scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                });
                $scope.applianceNetworksLoaded = true;
                return deferred.promise;
            };

            function handleError(jqXHR, textStatus, errorThrown) {
                if(jqXHR.status === 500) {
                    var data = jqXHR.responseJSON;
                    if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                        var error = data.result[0].message;
                        console.log("The error is:" + error);
                        ngDialog.open({
                            dialogType:'Error',
                            modelDialogId:'ErrorDialog',
                            scope:$scope,
                            dialogMessage: error,
                            onConfirmOkButtonClick:'onConfirmError()'
                        });
                    }
                } else {
                    PHD.ajaxError(jqXHR, textStatus, errorThrown);
                }
            }

            $scope.onConfirmError = function () {
                ngDialog.close('ErrorDialog');
            };

            $scope.onConfirmWarning = function () {
                ngDialog.close('SelectProfile');
            };

            $scope.extractProfileDataForDisplay = function(profileList, allProfiles) {
                profileList.forEach(function (profile, index) {
                    var item = {};
                    if(profile.id !== '-1') {
                        item.id = profile.id; //profile.id;
                        item.name = profile.name;
                        item.server_type = profile.server_type;
                        if(profile.rpo === 0 && profile.rto === 0){
                            item.rpo = "--";
                            item.rto = "--";
                        }
                        else{
                            item.rpo = profile.rpo + " " + profile.rpo_frequency + "(s)";
                            item.rto = profile.rto + " " + profile.rto_frequency + "(s)";
                        }
                        allProfiles.push(item);
                    }
                });
                $scope.profileListDisplay = allProfiles;
            };

            $scope.refreshProfileList = function(profileChangedNow){
                var profileList = $scope.ngDialogData;
                var allProfiles = [];
                if ( profileChangedNow || ($scope.hypervisor_type == "VMware" && ($scope.vmwareProfileList == null || $scope.vmwareProfileList == undefined)) ||
                                         ($scope.hypervisor_type !== "VMware" && ($scope.hypervProfileList == null || $scope.hypervProfileList == undefined)) ) {
                    var resp = PHD.Ajax.get(base_url+ "?sid=" + sid);
                    $scope.profileList = [];
                    if($scope.hypervisor_type == "VMware")
                        $scope.vmwareProfileList = [];
                    else
                        $scope.hypervProfileList = [];
                    resp.done(function(service_profiles) {
                        profileList = service_profiles.service_profiles;
                        $scope.profileList = profileList;
                        if (profileList && profileList.length > 0) {
                            profileList.forEach(function (profile, index) {
                                if (profile.server_type == $scope.hypervisor_type) {
                                    if ($scope.hypervisor_type == "VMware")
                                        $scope.vmwareProfileList.push(profile);
                                    else
                                        $scope.hypervProfileList.push(profile);
                                }
                            });
                        }
                        if($scope.hypervisor_type == "VMware"){
                            $scope.profileList = $scope.vmwareProfileList;
                        }
                        else{
                            $scope.profileList = $scope.hypervProfileList;
                        }
                        $scope.extractProfileDataForDisplay($scope.profileList, allProfiles);
                        $scope.loadProfilesInDropDown($scope.profileList);
                    });
                } else {
                    $scope.extractProfileDataForDisplay($scope.profileList, allProfiles);
                }
            };

            $scope.showToolTipForComplianceTracking = function(){
                var form = angular.element("#profileForm");
                form.find(".definition").popover({
                    appendTo: form
                });
            };

            $scope.refreshProfileList(false);
            $scope.showToolTipForComplianceTracking();

            /*$scope.$on('ngDialog.opened', function(event,obj) {
                $scope.initCtrl(obj);
                $scope.showToolTipForComplianceTracking();
            });*/

        }]);
