var optionsApp = angular.module('options', []);

optionsApp.factory('optionsFactory', function($http) {
    return {
        async: function(method,url,enviornmentID,dataObj) {
            var params = {};
            if (enviornmentID != 0) {
                params.sid = enviornmentID;
            }
            var promise = $http({
                url: url,
                data: JSON.stringify(dataObj),
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                PHD.hideLoadingIndicator(load);
                window.PHD.throwError({"result": [{"message": gettext(response.result[0].message)}]});

            });
            return promise;
        }
    };
});


optionsApp.controller('OptionsCtrl', ['$scope', '$http', '$location', 'optionsFactory', 'ngDialog', 'gettextCatalog',
    function($scope, $http, $location, optionsFactory, ngDialog, gettextCatalog) {

        $scope.startSync = function () {
            // need a base class or consistent way to apply credentials.
            $http.put('/api/inventory')
                .success(function (data, status, headers) {
                    // this should close the drop-down
                    // update the stats, which will reduce the timer interval while running
                    window.PHD.fetchStats();
                })
                .error(function (data, status, headers) {
                    window.PHD.throwError(data);
                })
        };

        $scope.launchLastStats = function (data){
            PHD.confirmDialog("<p>" + gettext( $(".inventory-sync-last-run").text()) + "</p>",
                {title: gettextCatalog.getString("Last Sync Details")}, gettextCatalog.getString("Inventory Sync"))
                .done(function() {
                    $scope.startSync();
                })

        };

        $scope.$on("logged-in", function(event) {
            window.PHD.fetchStats();
        });

        $scope.checkForUpdates = function () {

            $scope.load = PHD.showLoadingIndicator("#updates.html", true, gettext("Checking for available updates..."));
            optionsFactory.async('get', '/api/updates/', 0)
                .then(function (data) {
                    PHD.hideLoadingIndicator($scope.load);
                    displayUpdates(data.data);
                });
        };


        function displayUpdates(data) {
            ngDialog.open({
                template: 'app/options/updates.html',
                scope: $scope,
                overlay:true,
                name: 'updates-main-dialog',
                data: data,
                ngDialogStyle:'width:650px;height:auto;max-height:500px',
                closeByDocument: false,
                closeByEscape: true
            });
        }

       $scope.legacy_interface = switchInterface();
        function switchInterface() {
            hostURL = $location.host(); //returns the url of the host
            return "https://" + hostURL + "/recoveryconsole/";
        }

    }]
);
