angular.module('backup-copy-job-module', ['ngDialog', 'angulartics', 'angulartics.google.analytics',
    'ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','fileBrowserDialogApp','ngGrid','ui.bootstrap','inventory','checklist-model','ui.grid.selection', 'backup-now-dialog'])

.controller('backupCopyJobController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics',
    'fileBrowserDialogService','sharedGridData','$protectService','inventorysvc', 'gettextCatalog',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,gettextCatalog) {

        // Getting loadindicator reference (Declared in protect.js) and hiding it once Backup Job wizard is loaded
        var loadingIndicator = $scope.ngDialogData;
        if (loadingIndicator !== undefined) {
            PHD.hideLoadingIndicator(loadingIndicator);
        }
        var BT_ARCHIVE = "Archive";

        $scope.jobName='Backup Copy Job'; //default job name plaveholder
        $scope.backupJobNameModel='Backup Copy Job';
        $scope.isCustomJob = false;
        $scope.joborder={};
        //init empty joboredr
        $scope.joborder.name = gettextCatalog.getString("Backup Copy Job"); //TODO init to textfield from HTML
        $scope.joborder.type = "archive"; //this is either archive (cold) or replication (hot)
        $scope.joborder.verify = "none";
        $scope.joborder.app_id = APP_ID_ARCHIVE; //default id.
        $scope.joborder.sid = undefined; // default sid is not defined.
        $scope.joborder.instances = [];
        $scope.joborder.calendar = [];
        $scope.joborder.range_end = 0;
        $scope.joborder.range_size = 0;
        $scope.scheduleTypeSelection = {
                name: 'Scheduled'
        };
        $scope.errorField=false;
        $scope.startDateError=false;
        $scope.dayError=false;
        $scope.startDateOlderError = false;
        $scope.startTimeError=false;
        $scope.recuranceError=false;
        $scope.recurrenceBoundsError=false;
        $scope.recursTime=[{id:0,name:'Hour(s)'}]; //,{id:1,name:'Minutes'}];        // The archiving subsystem only handles Hour intervals at minimum.
        $scope.isScheduled = true;
        $scope.joborder.storage = null;
        $scope.PLACEHOLDER_BACKUP_TARGET = 'SelectBackupTarget';
        $scope.savedStorage = null;
		$scope.recursEveryError = false;
        $scope.startDateFormatError = false;

        $scope.showSlots = false;
        $scope.showThreshold = true;
        $scope.changer_slot_length = 0;
        $scope.is_changer = false;
        $scope.changer_slot_length = 0;
        $scope.is_tape = false;
        $scope.isReplicationTarget = false;
        
        $scope.isIncrementalOrDifferntial= false;

        $scope.joborder.options = {};
        $scope.joborder.email_report = true;
        $scope.joborder.options.failure_report = true;
        $scope.joborder.options.purge = true;
        $scope.joborder.options.append = true;
        $scope.joborder.options.encrypt = false;
        $scope.joborder.options.retention_days = 0;
        $scope.joborder.backupTypes = "Full";
        $scope.joborder.retentionAmount = 1;
        $scope.joborder.retentionPeriod = 1;
        /* dialog options, not part of the job per-se */
        $scope.dialog = {};
        $scope.dialog.retentionCheck = false;
        $scope.dialog.encryptionDisabled = true;
        $scope.dialog.purgeDisabled = false;

        $scope.selectedTreeNode = [];
        $scope.selectedAsset =[];
        $scope.calendarDays=[
            {'name':gettextCatalog.getString('Sun'), 'value' : "0"},
            {'name':gettextCatalog.getString('Mon'), 'value' : "1"},
            {'name':gettextCatalog.getString('Tue'), 'value' : "2"},
            {'name':gettextCatalog.getString('Wed'), 'value' : "3"},
            {'name':gettextCatalog.getString('Thu'), 'value' : "4"},
            {'name':gettextCatalog.getString('Fri'), 'value' : "5"},
            {'name':gettextCatalog.getString('Sat'), 'value' : "6"}
        ];
        $scope.backupModes = ["Standard", "Custom"];
        $scope.backupModesForNow=[BT_ARCHIVE];
        $scope.backupStrategies=[ {name: BT_ARCHIVE, backup_types: [BT_ARCHIVE]}];
        $scope.backup_types = {};
        $scope.backupModesforJob = {name: "Standard", original: "Standard"};
        $scope.scheduleForm = {};
        $scope.hideEdit=true;
        $scope.jobErrorDialog = false;
        $scope.isForSLAPolicy = false;      // a job created by an SLA Policy, recommended edit through the policy only.
        $scope.SLAPolicyName = "";

        $scope.showTest = true;
        $scope.disableTest = false;

        $scope.inventoryColumnDefs = [
            {
                field:'id',
                displayName:'Id',
                visible:false
            },
            {
                field:'nodeId',
                displayName:'Node Id',
                visible:false
            },
            {
                field: 'name',
                displayName:gettext("Name"),
                headerCellFilter: 'translate',
                headerCellClass: 'ui-grid-not-bold',
                cellTooltip: true,
                enableRowHeaderSelection: false,
                cellTemplate: '<div style="font-size:12px;padding-top:5px;padding-left:5px;cursor:pointer" ' +
                                'title="{{row.entity[col.field]}}"> ' +
                                '<span ng-if="row.entity.marked_offline === true"> ' +
                                    '<img src="assets/images/delete.png" style="height:14px;cursor:pointer" ' +
                                    ' title="Click to remove the unavailable asset" ' +
                                    'ng-click="grid.appScope.checkForDelete(row.entity)">' +
                                '</span>' +
                                ' {{row.entity[col.field]}}' +
                                '</div>'
            }
        ];
        $scope.inventoryGridOptions={
            columnDefs: $scope.inventoryColumnDefs,
            data:'inventoryData',
            rowHeight: 32,
            //virtualizationThreshold:200,
            enableHorizontalScrollbar:0,
            gridMenuShowHideColumns:false,
            enableColumnMenus:false,
            enableColumnResizing: false
        };
        $scope.assetType={id: 1};
        $scope.assetTypeList=[];

        $scope.PM_ADJUST_EXTRA  = 13;
        $scope.PM_ADJUST = 12;
        $scope.showtoolTipForEmailVerification = function(){
            var form = angular.element("#test-job-form");
            form.find(".definition").popover({
                appendTo: form
            });
        };
        if($scope.isEdit){
            $http({
                method: 'get',
                url : '/api/joborders/'+$scope.jobId + "/?lang=" + $rootScope.userLanguageCode
            }).success(function(data, status, headers){
                $scope.joborder=data.data[0];
                document.getElementById("backupJobID").value=$scope.joborder.name;
                $scope.hideEdit = true;
                $scope.isForSLAPolicy = ($scope.joborder.for_sla_policy !== false && $scope.joborder.for_sla_policy !== undefined && $scope.joborder.for_sla_policy.name !== undefined);
                if ($scope.isForSLAPolicy) {
                    $scope.SLAPolicyName = $scope.joborder.for_sla_policy.name;
                }
                $scope.isCustomJob = $scope.hasCustomCalendar($scope.joborder);
                if ($scope.joborder.type === 'replication') {
                    $scope.isReplicationTarget = true;
                    $scope.showTest = false;
                } else {
                    $scope.setRecurrenceModel();
                    $scope.setEndHour();
                    $scope.setRetentionDays($scope.joborder);
                    if ($scope.joborder.types !== undefined && $scope.joborder.types.length > 1) {
                        $scope.joborder.backupTypes = "All";
                    } else {
                        $scope.joborder.backupTypes = "Full";
                    }
                }
                var backupModeIndex = 0;
                if ($scope.isCustomJob) {
                    backupModeIndex = 1;
                    $scope.calendar_description = $scope.getCalendarDescription();
                }
                $scope.backupModesforJob.name = $scope.backupModes[backupModeIndex];
                $scope.backupModesforJob.original = $scope.backupModesforJob.name;

                $scope.useCopiedAssets = false;
                if ($scope.joborder.copied_assets === true) {
                    $scope.useCopiedAssets = true;
                    $scope.loadGrandClientInventory();
                } else {
                    $protectService.loadTreeData($http,$scope,$rootScope,$scope.assetType.id,false, $scope.jobId, true);
                }
            }).error(function(response){
                ngDialog.open({
                    dialogType:'Error',
                    dialogMessage:response.result[0].message
                })
            });

        }else{
            setTimeout(function(){
                $scope.filterInventory();}, 1000);
        }

        // If editing a job with grand clients, will need to load the copied assets.
        // Since we've loaded the inventory at the same time the job is opened, this means we re-load the cache.
        $scope.loadGrandClientInventory = function() {
            $rootScope.treeDataCache = [];
            var url = '/api/inventory/?uid='+ $rootScope.user.id + '&grandclient=1';
            $http({
                method: 'get',
                url : url
            }).success(function(data, status, headers) {
                $rootScope.treeDataCache = data.inventory;
                $protectService.loadTreeData($http,$scope,$rootScope,$scope.assetType.id,false, $scope.jobId, true);
            });
        };

        $scope.setRetentionDays = function(jobOptions) {
            if (jobOptions.options.retention_days !== undefined && jobOptions.options.retention_days !== 0) {
                if (jobOptions.options.retention_days % 365 == 0) {
                    $scope.joborder.retentionAmount = (jobOptions.options.retention_days / 365);
                    $scope.joborder.retentionPeriod = 365;
                } else if (jobOptions.options.retention_days % 30 == 0) {
                    $scope.joborder.retentionAmount = jobOptions.options.retention_days / 30;
                    $scope.joborder.retentionPeriod = 30;
                } else if (jobOptions.options.retention_days % 7 == 0) {
                    $scope.joborder.retentionAmount = jobOptions.options.retention_days / 7;
                    $scope.joborder.retentionPeriod = 7;
                } else {
                    $scope.joborder.retentionAmount = jobOptions.options.retention_days;
                    $scope.joborder.retentionPeriod = 1;
                }
                $scope.dialog.retentionCheck = true;
            } else {
                $scope.dialog.retentionCheck = false;
                $scope.joborder.retentionAmount = 1;
                $scope.joborder.retentionPeriod = 1;
            }
        };

        /*
         * Examines the calendar entries for the job, returning true if an element
         * requiring the job to be handled as custom (not handled with the regular calendar object)
         * has been encountered.
         */
        $scope.hasCustomCalendar = function(job) {
            var isCustom = false;
            var calendar = job.calendar;
            if (calendar instanceof Array && calendar.length > 0) {
                for (var i = 0 ; i < calendar.length ; i++){
                    var entry = calendar[i];
                    if (entry.custom === true) {
                        isCustom = true;
                        break;
                    }
                }
            }
            return isCustom;
        };

        /*
         * If an end hour is specified, recurrences run through that hour (minute 59).
         */
        $scope.setEndHour = function(){
            for (var i = 0 ; i < $scope.joborder.calendar.length ; i++){
                $scope.setCalendarEntryEndHour(i);
            }
        };

        /*
         * Set a user-friendly end-hour in the "until" field.
         */
        $scope.setCalendarEntryEndHour = function(i) {
            var minute = "59";
            var ampm = " pm";
            if (($scope.joborder.calendar[i] !== undefined) && (!isNaN($scope.joborder.calendar[i].end_hour))) {
                // If the end hour is a number, convert to a string, e.g., hour 24 is 11:59 pm.
                var endHour = parseInt($scope.joborder.calendar[i].end_hour);
                if (endHour > 13){
                    endHour -= $scope.PM_ADJUST_EXTRA;
                    $scope.joborder.calendar[i].end_hour = endHour+":"+minute+ampm;
                } else {
                    ampm = (endHour == 13) ? " pm" : " am";
                    endHour--;
                    $scope.joborder.calendar[i].end_hour = endHour+":"+minute+ampm;
                }
            }
        };

        $scope.setRecurrenceModel = function(){
            for (var i =0 ; i <$scope.joborder.calendar.length ; i ++){
             if(typeof($scope.joborder.calendar[i].recurrence) !=='undefined'){
                 $scope.joborder.calendar[i].recursCheck  =true;
                 if($scope.joborder.calendar[i].recurrence < 60){
                     $scope.joborder.calendar[i].recursTimeSelect=1;
                 }else{
                     $scope.joborder.calendar[i].recurrence = $scope.joborder.calendar[i].recurrence/60;
                     $scope.joborder.calendar[i].recursTimeSelect=0;
                 }
                 // Wrap with timeout so that recurs loads as a spinner.
                 (function(){const index = i;
                     setTimeout(function(){$scope.recurstimeModeChange(index,$scope.joborder.calendar[index].recursTimeSelect)},0,index);})();
             }else{
                 $scope.joborder.calendar[i].recursCheck = false;
                 // No recurrence, but initialize potential values in case the user wants recurrences.
                 $scope.joborder.calendar[i].recursTimeSelect = 0;
                 $scope.joborder.calendar[i].recurrence = 1;
                 $scope.joborder.calendar[i].end_hour = 24;
             }
            }
        };
        $scope.treeConfig = {
            core : {
                multiple : true,
                animation: true,
                error : function(error) {console.log('treeCtrl: error from js tree - ' + angular.toJson(error));},
                check_callback : true,
                worker : true
            },
            types : {
                default : {icon : 'icon-hv-datacenter icon'},
                star : {icon : 'icon-hv-host icon'},
                cloud : {icon : 'icon-hv-host icon'}
            },
            checkbox: {
                three_state: false,
                cascade: 'undetermined'
            },
            version : 1,
            plugins : ['types','checkbox','search']
        };

        $scope.filterInventory = function(){
            $('#jstreeDivId').jstree(true).uncheck_all();
            $scope.joborder={};
            //init empty joboredr
            $scope.joborder.name = "Backup Copy Job"; //TODO init to textfield from HTML
            $scope.joborder.type = "backup"; //this is always backup.
            $scope.joborder.verify = "none";
            $scope.joborder.app_id = APP_ID_ARCHIVE; //default assetType is server and hence app_id will be 1 i.e. file-level
            $scope.joborder.sid = undefined; // default sid is not defined.
            $scope.joborder.instances = [];
            $scope.joborder.calendar = [];
            $scope.joborder.range_end = 0;
            $scope.joborder.range_size = 0;
            $scope.joborder.email_report = true;
            $scope.joborder.failure_report = true;
            $scope.joborder.options = {};
            $scope.joborder.options.failure_report = true;
            $scope.joborder.options.purge = true;
            $scope.joborder.options.append = true;
            $scope.joborder.options.encrypt = false;
            $scope.joborder.options.retention_days = 0;
            $scope.joborder.storage = null;
            $scope.joborder.backupTypes = "Full";
            $scope.joborder.retentionAmount = 1;
            $scope.joborder.retentionPeriod = 1;
            $scope.dialog = {};
            $scope.dialog.retentionCheck = false;
            $scope.savedStorage = null;
            $scope.clearSearch();


            $scope.hideEdit = true;
            $rootScope.treeData=[];
            $scope.selectedAsset =[];
            $scope.inventoryData =[];
            $protectService.loadTreeData($http,$scope,$rootScope,$scope.assetType.id,false,undefined,true);
        };

        $scope.getClientOrInstance = function(joborder){
            return joborder.instances;
        };

        $scope.uncheckNotEligibleNode=function(uncheckNodeId){
            var node_id='li#'+uncheckNodeId;
            $('#jstreeDivId').jstree(true).uncheck_node(node_id);
        };

        $scope.readyTree=function(event){
            if($scope.isEdit){
                 setTimeout(function(){
                   $scope.checkNodesOnLoadEdit();
                }, 1000);
            } else {
                if($scope.selectedNodeList.length>0){
                    setTimeout(function(){
                       $scope.checkNodesOnPreSelect();
                    }, 1000);
                }
            }
        };

        $scope.checkNodesOnPreSelect=function(){
            $('#jstreeDivId').jstree(true).open_all();
            for(var i=0; i< $scope.selectedNodeList.length ; i++){
                var node_id='li#';
                node_id = node_id +$scope.selectedNodeList[i];
                $('#jstreeDivId').jstree(true).check_node(node_id);
            }
        };
        $scope.checkNodesOnLoadEdit=function(){
            var nodeIdArray =Object.keys($('#jstreeDivId').jstree(true)._model.data);
            // If the model data is not loaded yet, do not proceed.
            if (nodeIdArray.length <= 1) {
                return;
            }
            var arrayAssets = $scope.getClientOrInstance($scope.joborder);
            $('#jstreeDivId').jstree(true).open_all();
            if(arrayAssets !=undefined){
                for(var i=0; i< arrayAssets.length ; i++) {
                    if (nodeIdArray.length > 0) {
                        var node_id = 'li#';
                        for (var j = 0; j < nodeIdArray.length; j++) {
                            var foundInTree = false;
                            if (nodeMatches(nodeIdArray[j], arrayAssets[i], $scope.joborder)) {
                                foundInTree = true;
                                arrayAssets[i].name = arrayAssets[i].primary_name;
                                arrayAssets[i].nodeId = nodeIdArray[j];
                                $scope.selectedAsset[nodeIdArray[j]] = arrayAssets[i];
                                node_id = node_id + nodeIdArray[j];
                                break;
                            }
                        }
                        // If not found in tree, save as unavailable and create a selectedAsset entry.
                        // Set a flag so asset will only be added once for offline status.
                        if (!foundInTree && arrayAssets[i].marked_offline !== true) {
                            var nodeId = makeOfflineNode(arrayAssets[i].id);
                            arrayAssets[i].nodeId = nodeId;
                            arrayAssets[i].marked_offline = true;
                            arrayAssets[i].name = arrayAssets[i].primary_name + " (unavailable)";
                            if ($scope.inventoryData === undefined) {
                                $scope.inventoryData = [];
                            }
                            $scope.inventoryData.push(arrayAssets[i]);
                            $scope.selectedAsset[nodeId] = arrayAssets[i];
                        }
                        node_id = inventorysvc.handleSpecialChars(node_id);
                        $('#jstreeDivId').jstree(true).check_node(node_id);
                    }
                }
                $('#jstreeDivId').jstree(true).close_all();
            }
        };

        // Create a node for the instance not found in the tree.
        function makeOfflineNode(instance_id) {
            var cid = ($scope.joborder.client_id !== undefined) ? $scope.joborder.client_id :
                      ($scope.joborder.clients !== undefined && $scope.joborder.clients.length > 0) ? $scope.joborder.clients[0].id : 0;

            return $scope.joborder.sid + '_' + cid + '_' + $scope.joborder.app_id + '_' + instance_id;
        }

        function nodeMatches(node, asset, joborder) {
            var match = false;
            var parts;
            if (!$scope.useCopiedAssets) {
                var asset_node = joborder.sid + "_";
                if (node.indexOf(asset_node) === 0) {
                    parts = node.split('_');
                    if (parts.length >= 4) {
                        match = isNaN(parts[parts.length - 1]) ? false : (asset.id === parseInt(parts[parts.length - 1]));
                    }
                }
            } else {
                parts = node.split('_');
                if (parts.length >= 4) {
                    match = isNaN(parts[parts.length - 1]) ? false : (asset.id === parseInt(parts[parts.length - 1]));
                }
            }
            return match;
        }

        $scope.deslectNodeFun = function(e,item){
            if (hasChildren(item)) {
                delete $scope.selectedAsset[item.node.id];

                if (!canBeChecked(item.node.data.type)) {
                    for(var k =0 ; k < item.node.children_d.length; k++){
                        if($scope.selectedAsset[item.node.children_d[k]] != null ||
                            $scope.selectedAsset[item.node.children_d[k]] != undefined){
                            delete $scope.selectedAsset[item.node.children_d[k]];
                            $('#jstreeDivId').jstree(true).uncheck_node(item.node.children_d[k]);
                        }
                    }
                }
            } else {
                if(item.selected.length === 0){
                    $scope.joborder.instances =[];
                    $scope.selectedAsset =[];
                }
                if($scope.useCopiedAssets || ($scope.joborder.sid == inventorysvc.nodeToObject(item.node.id).system_id)){
                    delete $scope.selectedAsset[item.node.id];
                }
            }
            $scope.refreshInventoryData(false);
            // If creating a job and everything is de-selected, the sid is not defined.
            if ($scope.inventoryData.length === 0 && !$scope.isEdit) {
                $scope.joborder.sid = undefined;
            }
        };

        $scope.slectNodeFun = function(e,item){

            // If sid defined, the selected tree item may not be eligible (i.e., on another system).
            if (!$scope.useCopiedAssets && $scope.joborder.sid !== undefined) {
                if (!inventorysvc.isGroup(item.node.id) && ($scope.joborder.sid != inventorysvc.nodeToObject(item.node.id).system_id)) {
                    $scope.uncheckNotEligibleNode(item.node.id);
                    return;
                }
            }

            if (hasChildren(item)){

                $('#jstreeDivId').jstree(true).open_all(item.node);
                item.node.data.expanded = true;

                if ($scope.joborder.sid === undefined) {
                    $scope.joborder.sid = $scope.useCopiedAssets ? $rootScope.local.id : inventorysvc.nodeToObject(item.node.id).system_id;
                }

                if (canBeChecked(item.node.data.type)) {
                    $scope.selectedAsset[item.node.id] = {nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id};
                } else {
                    for(var k =0 ; k < item.node.children_d.length; k++){
                        var id = item.node.children_d[k]+'_anchor';
                        if($scope.selectedAsset[item.node.children_d[k]] == null || $scope.selectedAsset[item.node.children_d[k]] == undefined){
                            if (inventorysvc.isGroup(item.node.children_d[k]) ||
                                inventorysvc.isPoolOrVApp(item.node.children_d[k]) ||
                                isAppNode(item.node.children_d[k]) ||
                                isNotInstance(item.node.children_d[k])) {
                                // If the child is a group, pool, or vApp, or app, do not add to the selected list.
                                continue;
                            }
                            var $el = $(document.getElementById(id));
                            $scope.selectedAsset[item.node.children_d[k]] ={nodeId:item.node.children_d[k],name:$el.text(),id:inventorysvc.nodeToObject(item.node.children_d[k]).client_id};
                            $('#jstreeDivId').jstree(true).check_node(item.node.children_d[k]);
                        }
                    }
                }
            } else {
                if($scope.selectedAsset[item.node.id] == null || $scope.selectedAsset[item.node.id] == undefined){
                    $scope.selectedAsset[item.node.id] = {nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id};
                }
            }
            $scope.refreshInventoryData(false);
        };

        function hasChildren(item) {
            return item.node.children_d !== undefined;
        }

        function canBeChecked(type) {
            var checkIt = true;
            if (type === INVENTORY_ID_SQL_INSTANCE ||
                type === INVENTORY_ID_SQL_SERVER ||
                type === INVENTORY_ID_EXCHANGE_APPLICATION ||
                type === INVENTORY_ID_ORACLE_APPLICATION ||
                type === INVENTORY_ID_SHAREPOINT_APPLICATION ||
                type === INVENTORY_ID_HYPER_V_SERVER ||
                type === INVENTORY_ID_VMWARE_ESX_SERVER ||
                type === INVENTORY_ID_VMWARE_RESOURCE_POOL ||
                type === INVENTORY_ID_VMWARE_FOLDER ||
                type === INVENTORY_ID_XEN_POOL_MASTER ||
                type === INVENTORY_ID_XEN_SERVER_IN_A_POOL ||
                type === INVENTORY_ID_AHV_CLUSTER ||
                type === INVENTORY_ID_NDMP_CLIENT ||
                type === INVENTORY_ID_NAVGROUP) {
                checkIt = false;
            }
            return checkIt;
        }

        // format: <sid>_<cid>_<app_id>
        function isAppNode(nodeId) {
            var pieces = nodeId.split('_');
            return pieces.length === 3;
        }

        // format: <sid>_<cid>_<app_id>_<sql_instance>
        // you can differentiate from an instance ID as the last value is non-numeric.
        // could be a SQL instance, or an ESX host.
        function isNotInstance(nodeId) {
            var pieces = nodeId.split('_');
            return (pieces.length === 4 && isNaN(pieces[3]));
        }

        $scope.hoverNode = function(e, item){
            // For backup copies, no special instructions are needed o hover.
        };

        $scope.refreshInventoryData = function(assets){
            var assets = assets || false;
            if (assets) {
                $scope.selectedAsset = assets;
            }
            var selectedNodes = [];
            var nodeIdArray =Object.keys($scope.selectedAsset);
            for(var j=0 ;j<nodeIdArray.length;j++){
                var obj = $scope.selectedAsset[nodeIdArray[j]];
                selectedNodes.push(obj);
            }
            $scope.inventoryData = selectedNodes;
            $(window).resize();

        };

        $scope.getCalendarDescription = function() {
            return ($scope.joborder.calendar_str instanceof Array) ? $scope.joborder.calendar_str.join('\r\n') : gettextCatalog.getString("No calendar exists");
        };

        $scope.applyModelChanges = function() {
            if($scope.isScheduled){
                if(typeof($scope.backupModesforJob.name) !== 'undefined'){
                    $scope.getBackupTypeForSelectedStrategies($scope.backupModesforJob.name);
                    if ($scope.backupModesforJob.name === 'Custom') {
                        $scope.isCustomJob = true;
                        $scope.joborder.calendar = [];
                        $scope.calendar_description = $scope.getCalendarDescription();
                    } else {
                        $scope.isCustomJob = false;
                    }
                }
            }
        };

        $scope.searchIndex = 0;

        $scope.search = function(){
            setTimeout(function () {
                var v = $('#inventorySearchInputId').val();
                $('#jstreeDivId').jstree(true).search(v);
            }, 200);
        };

        $scope.goToSearchResult = function() {
            var el =  $('#jstreeDivId').jstree(true).get_node($scope.searchResults[$scope.searchIndex], true);
            if (el !== undefined) {
                el.children('.jstree-anchor').focus();
            }
            el.focus();
        };

        $scope.getSearchResults = function(event, obj) {
            setTimeout(function () {
                $scope.$apply(function() {
                    $scope.searchResults = obj.nodes;
                    $scope.searchIndex = 0;
                });
            });
        };

        $scope.next = function() {
            var len = $scope.searchResults.length;
            if ($scope.searchIndex + 1 > len - 1) {
                $scope.searchIndex = 0;
            } else {
                $scope.searchIndex++;
            }
            $scope.goToSearchResult();
        };

        $scope.previous = function() {
            var len = $scope.searchResults.length;
            if ($scope.searchIndex - 1 < 0) {
                $scope.searchIndex = len - 1;
            } else {
                $scope.searchIndex--;
            }
            $scope.goToSearchResult();
        };

        $scope.clearSearch = function() {
            $('#jstreeDivId').jstree(true).clear_search();
            $('#inventorySearchInputId').val("");
        };

        $scope.clearSearchResults = function() {
            $scope.searchIndex = 0;
            $scope.searchResults = undefined;
        };

        $scope.functiontofindIndexByKeyValue = function(arraytosearch, key, valuetosearch) {
            for (var i = 0; i < arraytosearch.length; i++) {
                if (arraytosearch[i][key] == valuetosearch) {
                  return i;
                 }
            }
                return null;
        };

        $scope.canShowFilter = false;

/*************************************************************************
2ndstep
*/
        $scope.validationForForm=function(){
            $scope.errorField=false;
            $scope.startDateError=false;
            $scope.dayError=false;
            $scope.startDateOlderError = false;
            $scope.startTimeError=false;
            $scope.recuranceError=false;
            $scope.recurrenceBoundsError = false;
            $scope.endHourError =false;
            $scope.recursEveryError = false;
            $scope.startDateFormatError = false;


            if ($scope.joborder.calendar === undefined || $scope.joborder.calendar.length == 0 ){
                return true;
            }else{
                for (var i =0 ; i < $scope.joborder.calendar.length ; i++){
                    if(!angular.isUndefined($scope.joborder.calendar[i].run_on)) {
                        if ($scope.joborder.calendar[i].run_on.length <= 0) {
                            $scope.errorField = true;
                            $scope.dayError = true;
                        }
                    }
                    if(typeof($scope.joborder.calendar[i].start_date) == 'undefined'){
                        $scope.errorField=true;
                        $scope.startDateError=true;
                    }
                    if(typeof($scope.joborder.calendar[i].start_time) == 'undefined'){
                        $scope.errorField=true;
                        $scope.startTimeError=true;
                    }
                    else{
                        var checkStartDateFormatError = $scope.validateStartDate($scope.joborder.calendar[i].start_date);
                        if(checkStartDateFormatError){
                            $scope.startDateFormatError = true;
                            $scope.errorField = true;
                        } else {
                            $scope.joborder.calendar[i].backup_type = BT_ARCHIVE;
                            $scope.joborder.calendar[i].start_date =
                                DateTimeHandler.getUSDateString($rootScope.userLanguageCode, $scope.joborder.calendar[i].start_date);
                            if (!$scope.isEdit) {
                                var checkStartDate = $scope.validateStart($scope.joborder.calendar[i].start_date);
                                if (checkStartDate) {
                                    $scope.startDateOlderError = true;
                                    $scope.errorField = true;
                                }
                            }
                        }
                    }
                    if( $scope.joborder.calendar[i].recursCheck){
                        if(typeof($scope.joborder.calendar[i].recurrence )==='undefined' ||
                            $scope.joborder.calendar[i].recurrence==null ||
                            $scope.joborder.calendar[i].recurrence==="" ||
                            $scope.joborder.calendar[i].recurrence==0 ){
                            $scope.errorField=true;
                            $scope.recuranceError=true;
                            $scope.recursEveryError=true;
                        } else {
                            var timerID = "#recurs_spinner_field" + i;
                            var isValid = $(timerID).spinner("isValid");
                            if (!isValid) {
                                $scope.errorField = true;
                                $scope.recurrenceBoundsError = true;
                            }
                        }
                    }
                    if( $scope.joborder.calendar[i].recursCheck){
                        if(typeof($scope.joborder.calendar[i].end_hour) == 'undefined') {
                            $scope.errorField=true;
                            $scope.endHourError=true;
                        }
                        var start_hour = $scope.getHourFromString($scope.joborder.calendar[i].start_time);
                        var end_hour = $scope.getHourFromString($scope.joborder.calendar[i].end_hour);
                        if (start_hour >= end_hour) {
                            $scope.errorField=true;
                            $scope.endHourError=true;
                        }
                    }

                    if($scope.errorField){
                        $scope.error_backupType =$scope.joborder.calendar[i].backup_type;
                        break;
                    }

                }

                return !$scope.errorField;
            }

        };

        $scope.validateStartDate = function (date) {
            return DateTimeHandler.dateNotValid(date, $rootScope.userLanguageCode);
        };

        $scope.validateStart = function(date) {
            if (date === '') {
                return true;
            }
            var today = new Date();
            today.setHours(0);
            today.setMinutes(0);
            today.setSeconds(0);
            if (Date.parse(today) > Date.parse(date)) {
                return true;
            }
            return false;
        };

        /*
         * If the standard strategies are in use, make sure any extras are deleted.
         * If a custom calendar, the joborder.calendar will not exist.
         */
        $scope.removeUnwantedKeys = function(){
            if ($scope.joborder.application_name !== undefined) {
                delete $scope.joborder.application_name;
            }
            if ($scope.joborder.client_name !== undefined) {
                delete $scope.joborder.client_name;
            }

            if ($scope.isReplicationTarget) {
                if ($scope.joborder.calendar !== undefined) {
                    delete $scope.joborder.calendar;
                }
                if ($scope.joborder.options !== undefined) {
                    delete $scope.joborder.options;
                }
            } else {
                if ($scope.joborder.calendar !== undefined) {
                    for (var i =0 ; i < $scope.joborder.calendar.length ; i++){
                        if(!$scope.joborder.calendar[i].recursCheck){
                            delete $scope.joborder.calendar[i].recurrence;
                        }
                        else if ($scope.joborder.calendar[i].recursTimeSelect == 0 ){
                            $scope.joborder.calendar[i].recurrence =$scope.joborder.calendar[i].recurrence * 60;
                        }
                        $scope.joborder.calendar[i].end_hour = $scope.getHourFromString($scope.joborder.calendar[i].end_hour);
                        delete $scope.joborder.calendar[i].$$hashKey;
                        delete $scope.joborder.calendar[i].recursTimeSelect;
                        delete $scope.joborder.calendar[i].recursCheck;
                        if ($scope.joborder.calendar[i].begin_hour !== undefined) {
                            delete $scope.joborder.calendar[i].begin_hour;
                        }
                    }
                }
            }
        };

        $scope.getHourFromString =function(hourString){
            var hourStringArray = hourString.split(" ");
            var hourArray = hourStringArray[0].split(":");
            var Hour  = parseInt(hourArray[0]);
            var Minute = parseInt(hourArray[1]);
            if (hourStringArray[1] === "pm"){
                if (Hour < 12) {
                    Hour += $scope.PM_ADJUST;
                }
            } else {
                if (Hour == 12) {
                    Hour -= $scope.PM_ADJUST;
                }
            }
            if (Minute == 59) {
                Hour++;
            }
            return Hour;
        };

        $scope.nextWizard = function($event){
            if(wizardTitle === gettextCatalog.getString("Select Items")){
		        console.log($scope.selectedAsset);
                if (!$scope.validateAssets()) {
                    return;
                }
                var nodeIdArray =Object.keys($scope.selectedAsset);
                $rootScope.$broadcast("nextBtnClick");
                if($scope.isEdit === true){
                    $scope.isScheduled = true;
                    $scope.scheduleTypeSelection.name ='Scheduled';
                }

                $scope.getEncryptionState($scope.useCopiedAssets);
                if ($scope.isEdit === true && $scope.isReplicationTarget) {
                    $scope.getReplicationTarget($scope.joborder);
                } else {
                    $scope.getTargets();
                    $scope.showtoolTipForEmailVerification();
                    $scope.initDateRangeCtrl($scope.joborder);
                    if (!$scope.isEdit){
                        $scope.getBackupMode();
                    }
                }
            }
            if(wizardTitle === gettextCatalog.getString("Define Job Settings")){
                if(document.getElementById("backupJobID").value === ""){
                    $scope.jobNameError=true;
                    return;
                }
                $scope.jobNameError=false;
                if (!$scope.validateBackupCopyTarget()) {
                    return;
                }
                if (!$scope.validateChangerSlots($scope.joborder.slots, $scope.changer_slot_length)) {
                    return;
                }
                if (!$scope.validateDateRange()) {
                    return;
                }
                if($scope.validationForForm()){
                    $scope.saveBackupCopyJobData(); //To save backupjob data.
                }else{
                    console.log('validation error');
                }
            }
        };

        $scope.handleBackupCopyTargetChange = function() {
            if ($scope.validateBackupCopyTarget()) {
                $scope.setAttributesForTarget($scope.joborder.storage);
            }
        };

        $scope.setAttributesForTarget = function(selectedTarget) {
            $scope.isReplicationTarget = selectedTarget !== undefined && selectedTarget.type === "replication_target";
            $scope.showTest = true;
            $scope.disableTest = false;
            if ($scope.isReplicationTarget) {
                $scope.showTest = false;
            }

            $scope.handleChanger(selectedTarget);
            $scope.handleTape(selectedTarget);
            $scope.changeOverwrite();
        };

        $scope.validateBackupCopyTarget = function() {
            var valid = true;
            if (typeof $scope.joborder.storage === 'object' && $scope.joborder.storage.value === $scope.PLACEHOLDER_BACKUP_TARGET){
                $scope.backuptarget=true;
                $scope.errorField=true;
                valid = false;
            } else {
                $scope.backuptarget = false;
                $scope.errorField = false;
            }
            return valid;
        };

        $scope.validateDateRange = function() {
            var valid = true;

            if (!$scope.isReplicationTarget) {
                // get and check date range.
                var dateRange = getBackupCopyDateRange();
                var message = gettextCatalog.getString("The date range is invalid.  Please ensure that the From: date is on or before the To: date.");
                if (dateRange === false) {
                    ngDialog.open({
                        dialogType: 'Retry',
                        dialogMessage: message
                    });
                    valid = false;
                } else {
                    // add the date range fields to joborder.
                    if ($scope.joborder !== undefined && $scope.joborder !== null) {
                        $scope.joborder.range_end = dateRange.range_end;
                        $scope.joborder.range_size = dateRange.range_size;
                    }
                }
            }

            return valid;
        };

        $scope.validateChangerSlots = function(test_string, changer_slot_length) {
            var valid = true;
            var message;
            if ($scope.is_changer) {
                if (!isNaN(test_string)) {
                    if (parseInt(test_string) > changer_slot_length) {
                        message = gettextCatalog.getString("A slot number entered is greater the number of available slots") + " (" + changer_slot_length + ").";
                        valid = false;
                    }
                } else if (test_string.indexOf("-") > -1) {
                    var test_range_string = test_string.split("-");
                    if (test_range_string.length > 2) {
                        message = gettextCatalog.getString("You cannot specify multiple slot ranges.") + " " +
                                    gettextCatalog.getString("You can use a range and/or a comma-separated list of slots, e.g., 1,2,5-8.");
                        valid = false;
                    } else {
                        if (parseInt(test_range_string[0]) > changer_slot_length || parseInt(test_range_string[1]) > changer_slot_length) {
                            message = gettextCatalog.getString("A slot number entered is greater the number of available slots") + " (" + changer_slot_length + ").";
                            valid = false;
                        }
                    }
                } else if (test_string.indexOf(",") > -1) {
                    var comma_flag = true;
                    var test_comma_string = test_string.split(",");
                    for (var i = 0; i < test_comma_string.length; i++) {
                        if (parseInt(test_comma_string[i]) > changer_slot_length) {
                            comma_flag = false;
                            break;
                        }
                    }
                    if (!comma_flag) {
                        message = gettextCatalog.getString("A slot number entered is greater the number of available slots") + " (" + changer_slot_length + ").";
                        valid = false;
                    }
                } else if (isNaN(test_string)) {
                    if (test_string.toLowerCase() === 'all') {
                        //donothing
                    } else {
                        message = gettextCatalog.getString("Please enter valid slot information.") + "  " +
                                    gettextCatalog.getString("You can use a range and/or a comma-separated list of slots, e.g., 1,2,5-8.");
                        valid = false;
                    }
                }
                if (!valid) {
                    ngDialog.open({
                        dialogType: 'Retry',
                        dialogMessage: message
                    });
                }
            }
            return valid;
        };


        function getBackupCopyDateRange() {
            var elem = angular.element(document.querySelector('[ng-controller=DateRangeCtrl]'));
            var $dtscope = elem.scope();
            var range = {};

            var dateRange = $dtscope.getDateRange();
            var isValid = $dtscope.checkDateRange();
            if (isValid) {
                if (dateRange.startDate == null && dateRange.endDate == null) {
                    range.range_end = 0;
                    range.range_size = 0;
                } else {
                    var end = moment(dateRange.endDate, DATE_DISPLAY_FORMAT).endOf('day').unix();
                    var start = moment(dateRange.startDate, DATE_DISPLAY_FORMAT).startOf('day').unix();
                    range.range_end = $dtscope.isCustomDate ? end : 0;
                    range.range_size = end - start;
                }
            }
            return isValid ? range : false;
        }

        $scope.validateAssets = function() {
            var valid = true;
            var selectedCount = Object.keys($scope.selectedAsset).length;
            if (selectedCount == 0){
                // At least one asset must be selected.
                valid = false;
            }
            return valid;
        };

        /*
         * Validate assets for saving from page 1.
         */
        $scope.validateAssetsAndSaveJobData = function() {
            if ($scope.validateAssets()) {
                $scope.handleDateFormats();
                $scope.saveBackupCopyJobData();
            }
        };

        /*
         * Validate for running test job.  We need to explicitly run validation as not using wizard next (can't for test).
         */
        $scope.validateAssetsAndTestJob = function() {
            if ($scope.validateAssets()) {
                if (!$scope.validateBackupCopyTarget()) {
                    return;
                }
                if (!$scope.validateChangerSlots($scope.joborder.slots, $scope.changer_slot_length)) {
                    return;
                }
                if (!$scope.validateDateRange()) {
                    return;
                }
                if($scope.validationForForm()){
                    $scope.handleDateFormats();
                    $scope.saveBackupCopyJobData(true);
                }
            }
        };

        $scope.saveBackupCopyJobData = function(runTest){
            var testing = runTest || false;
            $scope.joborder.name=document.getElementById("backupJobID").value;
            $scope.joborder.instances =[];
            var nodeIdArray =Object.keys($scope.selectedAsset);
            for(var j=0 ;j<nodeIdArray.length;j++){
                $scope.selectedAsset[nodeIdArray[j]].id = parseInt(inventorysvc.nodeToObject($scope.selectedAsset[nodeIdArray[j]].nodeId).instance_id);
                // push the instance IDs for backup copy jobs, not the entire instance object.
                $scope.joborder.instances.push($scope.selectedAsset[nodeIdArray[j]].id);
            }
            if (!$scope.isReplicationTarget) {
                /*
                 * Save as iCal if custom job
                 */
                if ($scope.isCustomJob) {
                    if ($scope.joborder.newiCal !== undefined) {
                        $scope.joborder.ical = $scope.joborder.newiCal;
                    }
                    if ($scope.joborder.ical !== undefined) {
                        delete $scope.joborder.calendar;
                        delete $scope.joborder.newiCal;
                    } else {
                        ngDialog.open({
                            dialogType:'Retry',
                            dialogMessage: gettextCatalog.getString('Custom calendars must contain at least one backup event.')
                        });
                        return;
                    }
                } else {
                    if ($scope.joborder.ical !== undefined) {
                        $scope.joborder.newiCal = $scope.joborder.ical;
                    }
                    delete $scope.joborder.ical;
                }
            }
            var jobOrderUrl='';
            var dataObj ={};
            var httpMethod='';
            var meassageforLoad = (testing) ? gettextCatalog.getString("Checking space needed for Backup Copy Job...") :
                (!$scope.isEdit)?gettextCatalog.getString("Creating Job"):gettextCatalog.getString("Updating Job");
            var loadJobindicator = PHD.showLoadingIndicator("body", true, meassageforLoad);
            // Get the joborder value - if an object, get its value.
            $scope.savedStorage = $scope.joborder.storage;
            $scope.joborder.storage = (typeof $scope.joborder.storage === 'object' && $scope.joborder.storage.value !== null) ?
                                        ($scope.joborder.storage.value !== -1 ? $scope.joborder.storage.value : $scope.joborder.storage.name) : $scope.joborder.storage;

            if ($scope.isReplicationTarget) {
                $scope.joborder.type = "replication";
                $scope.joborder.target_id = $scope.joborder.storage;
            } else {
                $scope.joborder.type = "archive";
                if ($scope.joborder.backupTypes === "All") {
                    $scope.joborder.types = ["Full", "Differential", "Incremental", "Selective", "Bare Metal", "Transaction"];
                } else {
                    $scope.joborder.types = ["Full"];
                }
                if ($scope.joborder.options.append === false) {
                    $scope.joborder.options.purge = false;
                }
                $scope.joborder.purge = $scope.joborder.options.purge;
                $scope.joborder.append = $scope.joborder.options.append !== undefined ? $scope.joborder.options.append : true;
                $scope.joborder.encrypt = $scope.joborder.options.encrypt !== undefined ? $scope.joborder.options.encrypt : false;
                $scope.joborder.options.retention_days = $scope.dialog.retentionCheck ? ($scope.joborder.retentionAmount * $scope.joborder.retentionPeriod) : 0;
                $scope.joborder.retention_days = $scope.joborder.options.retention_days;
            }

            if($scope.isScheduled && !testing){
                $scope.removeUnwantedKeys();
                $scope.convertBackupTypeforCalendar();
                if($scope.isEdit === true){
                    httpMethod = 'put';
                    jobOrderUrl = '/api/joborders/'+$scope.joborder.id + ($scope.useCopiedAssets === true ? '' : '/?sid='+$scope.joborder.sid);
                }else{
                    jobOrderUrl = ($scope.useCopiedAssets === true) ? "/api/joborders" : '/api/joborders/?sid='+$scope.joborder.sid;
                    httpMethod = 'post';
                }
                dataObj =JSON.stringify($scope.joborder);
                console.log($scope.joborder);
            }else{
                $scope.joborder.target = $scope.joborder.storage;
                console.log($scope.backupModesforJob.name);
                if(!testing && typeof ($scope.joborder.calendar) !== 'undefined'){
                    delete $scope.joborder.calendar;
                }
                $scope.joborder.backup_type = BT_ARCHIVE;
                $scope.joborder.options.email_report = $scope.joborder.email_report;
                console.log($scope.joborder);
                console.log("Archive Now or Test:");
                jobOrderUrl = ($scope.useCopiedAssets === true) ? "/api/archive" : "/api/archive/?sid=" + $scope.joborder.sid;
                if (testing) {
                    console.log("Archive Test");
                    jobOrderUrl = ($scope.useCopiedAssets === true) ? "/api/archive/check/" : "/api/archive/check/?sid=" + $scope.joborder.sid;
                }
                dataObj =JSON.stringify($scope.joborder);
                httpMethod = 'put';
            }

            $http({ method: httpMethod,
                url : jobOrderUrl,
                data: dataObj
            }).success(function(data, status, headers){
                PHD.hideLoadingIndicator(loadJobindicator);

                if(data[0]){
                    ngDialog.open({
                        dialogType: 'Error',
                        modelDialogId: 'error-dialog',
                        scope: $scope,
                        dialogMessage: data[0].message
                    });

                }else{
                    if (testing) {
                        var message = "Backup Copy Job size estimate not available.";
                        if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                            var result = data.result[0];
                            message = "The Job will be between " + PHD.util.formatMB(result.min) + " and " + PHD.util.formatMB(result.max) + " and most likely near " + PHD.util.formatMB(result.likely) + '.';
                            message += "<br/><br/>" + result.fit;
                        }
                        ngDialog.open({
                            modelDialogId:'backupCopyTestDialog',
                            dialogType: 'Success',
                            dialogMessage: message,
                            scope:$scope,
                            overlay:true,
                            ngDialogStyle:"width:500px",
                            onConfirmOkButtonClick: 'onCloseTestDialog()'
                        });
                        // restore storage
                        if ($scope.savedStorage !== undefined && $scope.savedStorage !== null) {
                            $scope.joborder.storage = $scope.savedStorage;
                        }
                        return;
                    }

                    if (!$scope.isScheduled) {
                        var nowLabel = (window.location.href.indexOf("#/protect") !== -1) ? 'Protect' : 'Jobs';
                        $analytics && $analytics.eventTrack('On Demand Backup Job', {  category: 'Backup', label: nowLabel });
                        var nowMessage = gettextCatalog.getString("On-Demand Job started successfully") + "!<br/><br/>" +
                            gettextCatalog.getString("Use the Active Jobs tab to view the backup copy jobs.");
                        if (nowLabel === 'Jobs') {
                            ngDialog.open({
                                dialogType: 'Success',
                                dialogMessage: nowMessage
                            });
                        } else {
                            ngDialog.open({
                                dialogType: 'Success',
                                scope:$scope,
                                tertiaryButton: true,
                                tertiaryButtonLabel: gettextCatalog.getString("View Jobs"),
                                onTertiaryButtonClick: 'viewJobs(0)',
                                dialogMessage: nowMessage
                            });
                        }
                    } else {
                        if (!$scope.isEdit) {
                            var pageLabel = (window.location.href.indexOf("#/protect") !== -1) ? 'Protect' : 'Jobs';
                            $analytics && $analytics.eventTrack('Add Backup Job', {  category: 'Backup', label: pageLabel });
                            var message = gettextCatalog.getString("Job created successfully") + "!<br/><br/>" +
                                gettextCatalog.getString("Use the Job Manager tab to view and manage your newly created job.");
                            console.log(data);
                            console.log(status);
                            console.log(headers);

                            if (pageLabel === 'Jobs') {
                                ngDialog.open({
                                    dialogType: 'Success',
                                    dialogMessage: message
                                });
                                $(document).trigger("editJob");
                            } else {
                                ngDialog.open({
                                    dialogType: 'Success',
                                    scope:$scope,
                                    tertiaryButton: true,
                                    tertiaryButtonLabel: gettextCatalog.getString("View Jobs"),
                                    onTertiaryButtonClick: 'viewJobs(1)',
                                    dialogMessage: message
                                });
                            }
                        } else {
                            $analytics && $analytics.eventTrack('Edit Backup Job', {  category: 'Backup', label: 'Jobs' });
                            ngDialog.close('backup-physical-dailog');
                            $(document).trigger("editJob");
                        }
                    }
                }
            }).error(function(response) {
                var message = response !== undefined && response.result instanceof Array ? response.result[0].message : 'Unknown Server Error';
                $analytics && $analytics.eventTrack('Failure: ' + message, {  category: 'Backup', label: 'Protect' });
                PHD.hideLoadingIndicator(loadJobindicator);
                $scope.outputTitle = "Backup Copy Job Error";
                $scope.outputData = message;
                $scope.onConfirmOkButtonClick = $scope.onConfirmError;
                ngDialog.open({
                    template: 'app/common/scroll-output.html',
                    modelDialogId:'BackupPostErrorDialog',
                    dialogMessage:message,
                    scope:$scope,
                    ngDialogStyle: 'width:650px;',
                    onConfirmOkButtonClick: 'onConfirmError()'
                });
                if ($scope.isScheduled) {
                    // re-set the elements deleted before the save.
                    if ($scope.joborder.calendar !== undefined) {
                        $scope.setRecurrenceModel();
                        $scope.setEndHour();
                    }
                    if ($scope.joborder.ical !== undefined) {
                        $scope.joborder.newiCal = $scope.joborder.ical;
                    } else if ($scope.joborder.newiCal !== undefined) {
                        $scope.joborder.ical = $scope.joborder.newiCal;
                    }
                }
                if ($scope.savedStorage !== undefined && $scope.savedStorage !== null) {
                    $scope.joborder.storage = $scope.savedStorage;
                }
            });
        };
        $scope.convertBackupTypeforCalendar = function() {
            if ($scope.joborder.calendar !== undefined) {
                if ($scope.joborder.calendar.length > 0) {
                    for (var i = 0; i < $scope.joborder.calendar.length; i++) {
                        $scope.joborder.calendar[i].backup_type = BT_ARCHIVE;
                    }
                }
            }
        };
        $scope.onCloseTestDialog = function() {
            ngDialog.close('backupCopyTestDialog');
        };
        $scope.handleDateFormats = function() {
            if ($scope.joborder.calendar !== undefined){
                for (var i = 0; i < $scope.joborder.calendar.length; i++) {
                    $scope.joborder.calendar[i].start_date =
                        DateTimeHandler.getUSDateString($rootScope.userLanguageCode, $scope.joborder.calendar[i].start_date);
                }
            }
        };
        $scope.viewJobs = function (tab) {
            var jobTab = tab;
            ngDialog.closeAll();
            window.location.href = "#/jobs/#" + jobTab;
        };
        $scope.onConfirmError = function () {
            ngDialog.close('BackupPostErrorDialog');
            $scope.jobErrorDialog = false;
            $scope.handleDateFormats(); // do this so that the date is swapped back for international formats
        };

         $scope.getBackupMode = function() {
            if($scope.scheduleTypeSelection.name === "Now") {
                var jobName=$scope.backupJobNameModel;
                $scope.jobOrderName=jobName;
                $scope.backupJobNameModel='On-Demand';
                $scope.jobNameError=false;    
                $scope.isScheduled = false;  
                $scope.joborder.calendar=[];
                $scope.backupModesforJob.name= $scope.backupModes[0];
                $scope.isCustomJob = false;
            } else {
                if ($scope.backupJobNameModel === 'On-Demand') {
                    $scope.backupJobNameModel = (typeof($scope.jobOrderName) !== 'undefined') ? $scope.jobOrderName : gettextCatalog.getString('Backup Copy Job');
                }
                $scope.isScheduled = true;
                var index = 0;
                $scope.backupModesforJob.name = $scope.backupModes[index];
                $scope.backupModesforJob.original = $scope.backupModesforJob.name;
                $scope.getBackupTypeForSelectedStrategies($scope.backupModes[index]);
            }
        };
        $scope.getBackupTypeForSelectedStrategies = function(backupStratiges){
            $scope.joborder.calendar=[];
            var dataArray=[];
            for (var i =0 ; i <$scope.backupStrategies.length ; i++ ){
                if(backupStratiges === $scope.backupStrategies[i].name){
                    dataArray =  $scope.backupStrategies[i].backup_types;
                }
            }
            // lmc TODO
            dataArray = $scope.backupStrategies[0].backup_types;
            for (j = 0 ; j < dataArray.length ; j++){
                var calendarObj={
                    start_date:new Date().toLocaleDateString($rootScope.userLanguageCode),
                    start_time:"03:00 AM",
                    backup_type: BT_ARCHIVE,
                    recursCheck:false,
                    recursTimeSelect:0,
                    recurrence:1,
                    schedule_run: 0,
                    end_hour:24
                };
                // Set up calendar frequencies based on type.
                switch (calendarObj.backup_type) {
                    case BT_ARCHIVE:
                        calendarObj.run_on = ["0", "1", "2", "3", "4", "5", "6"];
                        break;
                }
                $scope.joborder.calendar.push(calendarObj);
                // wrap the setTimeout function so that we can pass in the index
                (function(){
                    const index = j;
                    setTimeout(function(){$scope.recurstimeModeChange(index,$scope.joborder.calendar[index].recursTimeSelect)},0,index);
                })();

                $scope.setCalendarEntryEndHour(j);
            }
        };

        $scope.customOpen = false;      // prevent double-click error.
        $scope.editCustomCalendar = function() {
            if (!$scope.customOpen) {
                $scope.customOpen = true;
                $scope.joborder.app_id = APP_ID_ARCHIVE;
                ngDialog.open({
                    template: 'app/protect/custom-schedule/custom.html',
                    scope: $scope,
                    overlay: true,
                    data: {joborder: $scope.joborder, modes: ['Backup Copy'], calendarType: 'Backup Copy'},
                    modelDialogId: 'edit-custom-dialog',
                    name: 'edit-custom-dialog',
                    ngDialogStyle: 'width:900px;height:680px;',
                    preCloseCallback: function (value) {
                        $scope.customOpen = false;
                    }
                });
            }
        };
        $scope.recurstimeModeChange = function(index,timeSelect){
            var timmerId="#recurs_spinner_field"+index;
            if(timeSelect == 0){
                $(timmerId).spinner({min: 1, max: 12});
            }else{
                $(timmerId).spinner({min: 1, max: 60});
            }
        };

        $scope.getReplicationTarget = function(joborder) {
            $scope.backupTarget ={};
            $scope.backupTarget.targets = [];
            $scope.backupTarget.targets.push({name:joborder.target, value: joborder.target_id});
            $scope.joborder.storage = $scope.backupTarget.targets[0];
        };

        $scope.getEncryptionState = function(useCopiedAssets) {
            var encryption_url = "/api/encryption/?sid=";
            if (useCopiedAssets === true) {
                // On the copied assets tab, use the local system id instead of the listed sid.
                encryption_url += $rootScope.local.id;
            } else {
                encryption_url += $scope.joborder.sid;
            }
            $http.get(encryption_url)
                .then(function(response) {
                    if (response.data !== undefined) {
                        var data = response.data;
                        if ((data.data[0].state) !== "persist") {
                            $scope.dialog.encryptionDisabled = true;
                        } else {
                            $scope.dialog.encryptionDisabled = false;
                        }
                    }
                });
        };

        $scope.getTargets = function(){

            var storageApi;

            if ($scope.useCopiedAssets === true) {
                // On the copied assets tab, use the local system id instead of the listed sid.
                storageApi = "/api/backup-copy/connected_targets/"; ///api/archive/media/connected";
            } else {
                var showArchiving = (!$rootScope.showArchiving) ? "&showArchiving=false" : "";
                storageApi = "/api/backup-copy/connected_targets/?sid=" + $scope.joborder.sid + showArchiving;
            }

            $scope.backupTarget ={};
            $scope.backupTarget.targets = [];

            var loadTargets = PHD.showLoadingIndicator('body', true, gettextCatalog.getString("Getting list of backup copy targets...."));

            $http.get(storageApi)
                .then(function(response){
                    PHD.hideLoadingIndicator(loadTargets);
                    console.log(response.data.data.length);
                    var defaultStorageIndex = 0;
                    var storageIndex = 0;
                    var offset = 0;
                    if (response.data.data.length > 1){
                        $scope.backupTarget.targets.push({name:gettextCatalog.getString('Select Target'),value: $scope.PLACEHOLDER_BACKUP_TARGET});
                        // Add 1 to the index as the targets array includes the "Selection" entry.
                        offset = 1;
                    }

                    var badTargets = [];
                    for(var j=0;j<response.data.data.length ;j++){
                        if (response.data.data[j].target_id === -1) {
                            badTargets.push(response.data.data[j].name);
                        }
                        $scope.backupTarget.targets.push({name:response.data.data[j].name,value:response.data.data[j].target_id,type:response.data.data[j].type});
                        if ($scope.joborder.storage === response.data.data[j].name ||
                            ($scope.joborder.storage !== null && $scope.joborder.storage.name !== undefined && $scope.joborder.storage.name === response.data.data[j].name)) {
                            storageIndex = j + offset;
                        }
                    }

                    if (!$scope.isEdit){
                        $scope.joborder.storage = $scope.backupTarget.targets[defaultStorageIndex];
                    } else if ($scope.joborder.storage === "") {
                        $scope.joborder.storage = $scope.backupTarget.targets[defaultStorageIndex];
                    } else {
                        $scope.joborder.storage = $scope.backupTarget.targets[storageIndex];
                    }
                    $scope.setAttributesForTarget($scope.joborder.storage);

                    if (badTargets.length > 0) {
                        var targetString = badTargets.toString();
                        ngDialog.open({
                            dialogType: 'Error',
                            modelDialogId: 'backupCopyTargetErrorDialog',
                            scope: $scope,
                            dialogMessage: gettextCatalog.getString("One or more targets is currently unavailable") + ":  " + targetString,
                            onConfirmOkButtonClick: 'onConfirmTargetError()'
                        });
                    }

                },function(reason){
                    PHD.hideLoadingIndicator(loadTargets);
                    console.log(reason);
                    var response = reason.data;
                    ngDialog.open({
                        dialogType:'Error',
                        dialogMessage:response.result[0].message
                    })
                });
        };

        $scope.onConfirmTargetError = function() {
            ngDialog.close('backupCopyTargetErrorDialog');
        };

        $scope.handleChanger = function(target) {
            if (target.type === "changer") {
                $scope.is_changer = true;
                $scope.showSlots = true;
                $scope.joborder.options.purge = false;
                $scope.showThreshold = false;
                $scope.disableTest = true;

                var changer_info_url = '/api/archive/media/library/' + target.name + '/?sid=';
                if ($scope.isEdit === true && $scope.useCopiedAssets !== true){
                    changer_info_url += $scope.joborder.sid;
                } else {
                    changer_info_url += $rootScope.local.id;
                }
                var load = PHD.showLoadingIndicator('body', true, gettextCatalog.getString("Getting slots info for changer ...."));
                $http.get(changer_info_url)
                    .then(function(response) {
                        PHD.hideLoadingIndicator(load);
                        if (response.data !== undefined) {
                            var data = response.data;
                            $scope.changer_slot_length = data.data.slots.length;
                        }
                    },function(reason){
                        PHD.hideLoadingIndicator(load);
                        console.log(reason);
                        var response = reason.data;
                        ngDialog.open({
                            dialogType:'Error',
                            dialogMessage: response.result[0].message,
                            modelDialogId:'changerErrorDialog',
                            scope:$scope,
                            onConfirmOkButtonClick:'onConfirmChangerError()'
                        })
                    });
            } else {
                $scope.is_changer = false;
                $scope.showSlots = false;
                $scope.showThreshold = true;
            }
        };

        $scope.onConfirmChangerError = function() {
            ngDialog.close('changerErrorDialog');
        };

        $scope.handleTape = function(target) {
            if (target.type === "tape") {
                $scope.is_tape = true;
                $scope.joborder.options.purge = false;
                $scope.showThreshold = false;
                $scope.disableTest = true;
            } else {
                $scope.is_tape = false;
            }
        };

        $scope.checkForDelete = function(selectedAsset) {
            $scope.assetToDelete = null;
            if (selectedAsset !== undefined) {
                var assetName = selectedAsset.name;
                if (assetName.indexOf(' (unavailable)') !== -1) {

                    $scope.assetToDelete = selectedAsset;
                    var confirmText = gettextCatalog.getString("Do you want to delete this unavailable asset from the job?");

                    ngDialog.open({
                        dialogType: 'Confirmation',
                        dialogMessage: confirmText,
                        scope: $scope,
                        overlay:true,
                        modelDialogId:'delete-unavailable-asset',
                        onConfirmOkButtonClick:'onConfirmDeleteAsset()'
                    });
                }
            }
        };

        $scope.onConfirmDeleteAsset = function() {
            var asset = $scope.assetToDelete;
            var assetName = asset.name;
            for (var i = 0; i < $scope.inventoryData.length; i++) {
                if (assetName === $scope.inventoryData[i].name) {
                    $scope.inventoryData.splice(i, 1);
                }
            }
            delete $scope.selectedAsset[asset.nodeId];
            ngDialog.close('delete-unavailable-asset');
        };

        $scope.initDateRangeCtrl = function(jobOptions) {
            var elem = angular.element(document.querySelector('[ng-controller=DateRangeCtrl]'));
            var $dateScope = elem.scope();
            if ($dateScope !== undefined) {
                if (jobOptions !== null) {
                    $dateScope.setDateRange(jobOptions.range_end, jobOptions.range_size);
                } else {
                    $dateScope.setDateRange(0, 0);
                }
            }
        };

        $scope.changeOverwrite = function() {
            // If not a tape or changer, the storage threshold will be vislble.
            // When the user changes the overwrite option, enable/disable the storage/purge selections.
            // If a tape or changer, no need to do anything, as the selections won't be visible anyway.
            if (!$scope.is_changer && !$scope.is_tape) {
                if (!$scope.joborder.options.append) {
                    $scope.joborder.options.purge = false;
                    $scope.dialog.purgeDisabled = true;
                } else {
                    $scope.dialog.purgeDisabled = false;
                }
            }
        };

}]);