angular.module('backup-now-dialog', ['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])
    .controller('BackupNowDialogCtrl', ['$scope', '$rootScope', '$http','ngDialog',
        function($scope, $rootScope, $http,ngDialog) {

            $scope.viewJobs = function() {
                ngDialog.closeAll();
                window.location.href = "#/jobs/#0";
            };

            $scope.closeDialog = function() {
                ngDialog.close("backupNowDialog");
				ngDialog.close("backup-physical-dailog");
            };

            $scope.initCtrl = function(){
                processDialog(PHD, window);
            };

            var $jobLogTable, LogTable, url;
            var $form;

            var cellFormatter = {
                output: function (value, row) {
                    return 'Start Date: ' + row.start_time + '<br />' + value.replace(/\n/g, "<br />");
                }
            };

            function processDialog(PHD, window) {


                $jobLogTable = $("#job-log-table");
                $form = $("#backup-now-form");

                LogTable = PHD.DataTable($jobLogTable, {
                    dynamic: false,
                    tableScrollOptions: {"height": "article"},
                    select: false,
                    sortable: true,
                    sortOnLoad: false,
                    sortOnHeader: true,
                    cellClasses: [null, null, "full-text"]
                }).registerFormatters(cellFormatter);

                updateTable();

            }

            function updateTable() {
                var backupNowReturn = $scope.ngDialogData;
                console.log("load log table with: " + JSON.stringify(backupNowReturn));
                var jobList = [];
                backupNowReturn.forEach(function (job, index) {
                    var obj = job;
                    obj.id = index + 1;
                    obj.server_name = job.client_name != undefined ? job.client_name : job.host_name;
                    obj.message = job.job_id > 0 ? ("Success: backup job " + job.job_id + " queued") : job.message;
                    jobList.push(obj);
                });
                console.log("Job list is " + JSON.stringify(jobList));
                LogTable.load(jobList);
            }

            $scope.$on('ngDialog.opened', function(event, obj) { $scope.initCtrl(obj) });
        }
    ]);
