angular.module('fileBrowserDialogApp', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','backupJobModule'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
		  });
    	}])

.service('fileBrowserDialogService',['$rootScope','$http','ngDialog','dataToBeShared',function($rootScope,$http,ngDialog,dataToBeShared){
        this.getfileBrowserTreeData= function(dataObject){
            $rootScope.fileBrowserTreeNodeUrl = dataObject.fileBrowserTreeNodeUrl;
            var load = PHD.showLoadingIndicator("body", true, "Loading...");
            $http({
				method: 'get',
				url : dataObject.url
            }).success(function(data, status, headers){
				var jsonData = data.data;
				var treeObj = {};
				var treeArray = []; 
				var childDummayDataArray = [];
		        var finalTreeDataArray = [];

                for(var i=0;i<jsonData.length;i++){
                    var nodeName = jsonData[i].name;
                    var nodeId = jsonData[i].id;
                    var lastChar = nodeName.substr(nodeName.length - 1);
                    if (lastChar != undefined && lastChar != "/") {
                        nodeName = jsonData[i].name+"/";
                        nodeId = jsonData[i].id+"/";
                    }

                    treeObj = {id:nodeId,parent:"#",text:nodeName,icon:(jsonData[i].isBranch == true)? "icon-hv-folder icon" : "icon-file icon",state: { opened: false},data:{expanded:false}};
                    treeArray.push(treeObj);

                    var id = nodeId+"...";
                    if(jsonData[i].isBranch == true){
                        treeObj={id:id,parent:nodeId,text:"...",state: { opened: false}};
                        childDummayDataArray.push(treeObj);
                    }
                }

				finalTreeDataArray = treeArray.concat(childDummayDataArray);
			    $rootScope.originalData = finalTreeDataArray;
                PHD.hideLoadingIndicator(load);

                ngDialog.open({
                            template: 'app/protect/file-browser-dialog/fileBrowserDialogTemplate.html',
                            scope: $rootScope,
                            overlay:false,
                            modelDialogId:'file-browserSetting-dailog',
							ngDialogStyle:'width:800px;height:650px;',
                            preCloseCallback: function (value) {}
            	});
            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'Retry',
                    scope: $rootScope,
                    dialogMessage:response.result[0].message,
                    preCloseCallback: function (value) {
                        // Special token that will indicate to the dataToBeShared watcher that there is no data.
                        dataToBeShared.objectList = "___no_data_2___";
                    }
                });
            });
		 };    
 }])

.controller('fileBrowserDialogCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','dataToBeShared', 'includeExcludeLabelService',
        function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,dataToBeShared,includeExcludeLabelService) {
	    var newId = 1;
        $scope.ignoreChanges = false;
        $scope.newNode = {};
		$scope.selectedNode;
        $scope.selectedTreeNode = [];
        var fileBrowserTreeObj={};
		$scope.fileBrowserTreeArray = [];
		$scope.MAX_FILES_TO_LOAD = 200;

		$scope.treeData = $rootScope.originalData;

        // To set includeExclude Label on browser tree window
        $scope.includeExcludeLabel = includeExcludeLabelService.getLabel();

		   
        $scope.treeConfig = {
            core : {
                multiple : true,
                animation: true,
                error : function(error) {console.log('treeCtrl: error from js tree - ' + angular.toJson(error));},
                check_callback : true,
                worker : true
            },
            version : 1,
            plugins : ['types','dnd']
        };

        this.applyModelChanges = function() {
            return !$scope.ignoreChanges;
        };


$scope.beforeOpen = function(e,item){
	var url ="";
	var abc = [];
	var jstreeDivId = $("#fileBrowserTreeId");

	if(item.node.data.expanded == false){
		$scope.nodeId=item.node.id;
		var ID = encodeURIComponent(item.node.id);
		var addCount = "&count=" + $scope.MAX_FILES_TO_LOAD;

        $scope.lastFile = item.node.original !== undefined && item.node.original.last !== undefined ? item.node.original.last : "";
        var addLast = "";
        if ($scope.lastFile !== "") {
            var moreFileCount = 100;
            addLast = "&last=" + encodeURIComponent($scope.lastFile);
            addCount = "&count=" + moreFileCount;
            ID = encodeURIComponent(item.node.parent);
        }

		url =$rootScope.fileBrowserTreeNodeUrl+ID+ addCount + addLast;

		var load=PHD.showLoadingIndicator(jstreeDivId);

		$http({
			method: 'get',
			url : url
		}).success(function(data, status, headers){
			var jsonData = data.data;
            if ($scope.lastFile != "") {
                var moreNode = $scope.nodeId;
                $('#fileBrowserTreeId').jstree().delete_node(item.instance.get_node(moreNode));
            }
			if(jsonData != null){
                $scope.fileBrowserTreeArray = [];
				var lengthOfJsonData= data.data.length;
				for(var i = 0;i < lengthOfJsonData;i++) {
                    var last = jsonData[i].last !== undefined ? jsonData[i].last : "";
					fileBrowserTreeObj = {id:jsonData[i].id,
						parent:jsonData[i].directory,
						text:jsonData[i].name,
                        icon: (last !== "") ? "icon-plussign" :
                            ((jsonData[i].isBranch == true) ? "icon-hv-folder icon" : "icon-file icon"),
                        state: { opened: false},
                        last: last,
						data:{expanded:false}};

					$scope.fileBrowserTreeArray.push(fileBrowserTreeObj);

					var id = jsonData[i].id+"...";
					if(jsonData[i].isBranch == true){
						fileBrowserTreeObj={id:id,parent:jsonData[i].id, text:"...",state: { opened: false}};
						$scope.fileBrowserTreeArray.push(fileBrowserTreeObj);
					}
				}

                //Array.prototype.push.apply($scope.treeData, fileBrowserTreeArray);
				angular.forEach($scope.fileBrowserTreeArray, function (e) { this.push(e); }, $scope.treeData);
				item.node.data.expanded =true;

				setTimeout(function(){
					var dummyNodeID = item.node.id+"...";
					var $dummy = document.getElementById(dummyNodeID);
					if ($dummy != null) {
                        $('#fileBrowserTreeId').jstree().delete_node($dummy);
                    }
					var focusNode = $scope.treeData[$scope.treeData.length - 1];
					var $node = document.getElementById(focusNode.id);
					if ($node != null) {
					    $node.scrollIntoView(false);
                    }
					PHD.hideLoadingIndicator(load);
					$(window).resize();
				}, 200);
			}else{
				var dummyNodeID = item.node.id+"...";
				$('#fileBrowserTreeId').jstree(true).delete_node(item.instance.get_node(dummyNodeID));
				PHD.hideLoadingIndicator(load);
			}
        }).error(function(response) {
            // On browse error, close node, show dialog with message.
            $('#fileBrowserTreeId').jstree(true).close_node(item.node);
            PHD.hideLoadingIndicator(load);
            ngDialog.open({
                dialogType: 'Error',
                modelDialogId: 'browse-error-dialog',
                scope: $scope,
                dialogMessage:response.result[0].message,
                onConfirmOkButtonClick: 'onConfirmBrowseError()'
            });
        });
	}

};

$scope.onConfirmBrowseError = function () {
    ngDialog.close('browse-error-dialog');
};

$scope.onConfirmStateWarning = function() {
    ngDialog.close('Information-child-dialog');
};

$scope.changedCB = function(e,item) {
            var i, j, r = [];
            for(i = 0, j = item.selected.length; i < j; i++) {
                r.push(item.instance.get_node(item.selected[i]).text);
            }
            angular.copy(r,$scope.selectedTreeNode);
            $scope.selectedItem = $scope.selectedTreeNode.toString();
			
};
	
$scope.nodeSelected = function(e,item){
	var i, j, r = [];
    if (item.node !== undefined && item.node.original !== undefined &&
        item.node.original.last !== undefined && (item.node.original.last != "")) {
        // This node has "last" set, it is special.  Get more files and leave (do not select it)
        //$('#fileBrowserTreeID').jstree('load_node', item.node);
        $scope.beforeOpen(e, item);
        return;
    }
	$scope.filePathArray = [];
    for(i = 0, j = item.selected.length; i < j; i++) {
        $scope.filePathArray.push(item.selected[i]);
    }
	
	console.log($scope.filePathArray);
};
$scope.nodeDeselected = function(node,item){
	console.log(item.node.text);
	var index = $scope.filePathArray.indexOf(item.node.text);
	$scope.filePathArray.splice(index, 1);
}
$scope.addItem = function(){
	var listbox = document.tree.inventoryListbox;
	for(var i=0; i<$scope.filePathArray.length;i++){
	  addOption(listbox, $scope.filePathArray[i]);
	}
};

$scope.$on('totalListItem', function (event){	
	var listbox = document.tree.inventoryListbox;
	$scope.totalListItem = listbox.options.length;
	$(window).resize();
	console.log($scope.totalListItem);
});
			
function addOption(selectbox,node){
		var optn = document.createElement("OPTION");
		optn.text = node;
		optn.value = node;

		var exists = false;
		$('#listboxId option').each(function(){
			if (this.value == node) {
				exists = true;
			}
		});
	   
	  if(!exists && !angular.isUndefined(node) && node !== null){
		   selectbox.options.add(optn);
	       $scope.$broadcast("totalListItem");
	  }
}
	
$scope.removeItem = function(){
	var listbox = document.tree.inventoryListbox;
	var listBoxItems=[];
	  for(var i = 0; i < listbox.options.length; i++) {
         //if the option is selected, delete the option
         if(listbox.options[i].selected == true) {
          listBoxItems.push(listbox.options[i].value);
          }
       }

    $(listbox.options).each(function(index) {
        var elem = $(this)[0];
        if (elem.selected) {
            $(elem).remove();
        }
    });
	   $scope.$broadcast("totalListItem");
   };
    
$scope.removeAllItem = function(){
	 var listbox = document.tree.inventoryListbox;
	 listbox.innerHTML = "";
	  $scope.$broadcast("totalListItem");
};

$scope.saveIncludeFiles = function(){
    var listbox = document.tree.inventoryListbox;
	
	$scope.inventoryListObj ={};
	$scope.inventoryListItems = [];

	for(var i = 0; i < listbox.options.length; i++) {
		$scope.inventoryListObj={ name: listbox.options[i].value};
		console.log($scope.inventoryListObj);
		$scope.inventoryListItems.push($scope.inventoryListObj);
	 }
	   dataToBeShared.objectList = $scope.inventoryListItems;
	
    listbox.innerHTML = "";
	ngDialog.close('file-browserSetting-dailog'); 
	
};

$scope.confirmDialog = function(){
    console.log($scope.totalListItem);
     if(parseInt($scope.totalListItem)>0){
         ngDialog.open({
             template: 'app/protect/file-browser-dialog/confirm-setting.html',
             scope: $scope,
             overlay: true,
             modelDialogId: 'confirmBrowserFileDlg',
             showHelpArticleButton: true,
             ngDialogStyle: 'width:46em; height:15em;  top: 70px;left: 27px;right: 27px;'
         });
    }else{
         $scope.closeThisDialog();
    }
};
$scope.closeDialogs = function(){
    ngDialog.close('file-browserSetting-dailog'); 
    ngDialog.close('confirmBrowserFileDlg'); 
};
$scope.cancellEvent = function(){
    ngDialog.close('confirmBrowserFileDlg'); 
};
 
/***************for Drag and Drop tree node******************/

  $(document).on('dnd_move.vakata', function (e, data) {
		      var t = $(data.event.target);
		       if(!t.closest('.jstree').length) {
                    if(t.closest('.treeListBox').length) {
				      data.helper.find('.jstree-icon').removeClass('jstree-er').addClass('jstree-ok');
                    }
                    else {
                        data.helper.find('.jstree-icon').removeClass('jstree-ok').addClass('jstree-er');
                    }
                }
	  
    }) .on('dnd_stop.vakata', function (e, data) {
				 var t = $(data.event.target);
                   if(!t.closest('.jstree').length) {
                     if(t.closest('.treeListBox').length) {
					      addDragNodesInList(data.data.nodes);
						  $(data.element).clone().appendTo(t.closest('.treeListBox'));
                     }
                }
     });


function addDragNodesInList(textArray){
    var listbox = document.tree.inventoryListbox;
	for(var i=0;i<textArray.length;i++){
	  if(textArray[i] != null){ 
		 addOption(listbox,textArray[i]);
	  } 
    }
}

}]); 			