//(function($, PHD, window, undefined) {

function processProtectPage(PHD, window, $scope, $rootScope, $compile, $analytics, inventorysvc, gettextCatalog) {
    var tabs = [],
        initialTab = $.cookie("initial_tab_protect") || 0,
        currentTabIndex = 0,
        $protectTreeContainer = $("#protect-treeview"),
        $copyTreeContainer = $("#copy-treeview"),
        TabTimer, UserPreference,
        slugs;

    if ($rootScope.isTarget) {
        slugs = ['inventory', 'copies'];
    } else {
        slugs = ['inventory'];
    }

    // lmc - add this.
    var refreshRate = refreshRates.page_protect_refresh;
    $rootScope.ProtectTimer.refreshControl = $("#protect-page-preferences .timer-refresh");
    TabTimer = $rootScope.ProtectTimer;

    var LARGE_INVENTORY = 2500;

    var weekday = [];
    weekday[0] = "Sunday";
    weekday[1] = "Monday";
    weekday[2] = "Tuesday";
    weekday[3] = "Wednesday";
    weekday[4] = "Thursday";
    weekday[5] = "Friday";
    weekday[6] = "Saturday";

    function getDay(day, dow) {
        var offset = day - dow;
        if (dow < day) {
            offset -= 7;    // go to prior week.
        }
        var date = moment().day(dow + offset);
        return weekday[day] + ", " + date.format(DATE_DISPLAY_FORMAT);
    }

    // lmc - move formatters to top of file, before they are referenced.
    var cellFormatter = {
        name: function (value, row) {
            return '<span class="truncates" title="' + value + '">' + value + '</span>';
        },
        controls: function (value, row) {
            // lmc - no state
            //var hvclass = getHypervisorClass(row.state.hypervisor);
            //return '<input class="inventory-checkbox '+hvclass+'" type="checkbox" name="inventory" value="' + row.state.id + '">';
            //console.log('row = ' + JSON.stringify(row));
            var hvclass = getHypervisorClass(row.hv);
            // lmc - encode name in row?
            // lmc - TODO hvclass?
            //return '<input class="inventory-checkbox '+hvclass+'" type="checkbox" name="inventory" value="' + row.id + '^' +  row.name +'">';
            return '<input class="inventory-checkbox ' + hvclass + '" type="checkbox" name="inventory" value="' + row.id + '">';
        },
        last_backups: function (value, row, key, area_type) {
            var output = "";
            var area = area_type || 'Backups';
            var dow = moment().day();
            for (i = 0; i < value.length; i++) {
                var status = "none";
                var status_summary = "";
                var obj = value[i];
                if (obj.successes !== undefined && obj.successes.count > 0) {
                    status = 'success';
                    status_summary += gettextCatalog.getString("Success");
                }
                if (obj.warnings !== undefined && obj.warnings.count > 0) {
                    status = 'warning';
                    status_summary += gettextCatalog.getString(" Warnings");
                }
                if (obj.failures !== undefined && obj.failures.count > 0) {
                    status = 'error';
                    status_summary += gettextCatalog.getString(" Failures");
                }
                output += '<i class="icon-phd-' + status + ' job-status-icon';
                if (status !== "none") output += ' day-result'; // so that it is clickable.
                output += '" title="';
                if (status_summary == "") {
                    output += "None" + '"';
                } else {
                    output += status_summary + '"';
                    output += '" data-day="' + getDay(obj.day, dow) + '"';
                    output += '" data-area="' + area + '"';
                    output += '" data-successes="' + (obj.successes !== undefined ? obj.successes.count : 0) + '"';
                    output += '" data-successes-ids="' + (obj.successes !== undefined ? obj.successes.ids.toString() : "") + '"';
                    if (area === 'Backups' && obj.warnings !== undefined) {
                        output += '" data-warnings="' + (obj.warnings !== undefined ? obj.warnings.count : 0) + '"';
                        output += '" data-warnings-ids="' + (obj.warnings !== undefined ? obj.warnings.ids.toString() : "") + '"';
                        if (obj.warnings.count > 0 && obj.day == dow) {
                            output += '" data-warnings-today="1"';
                        }
                    } else {
                        output += '" data-warnings="0"';
                        output += '" data-warnings-ids=""';
                    }
                    output += '" data-failures="' + obj.failures.count + '"';
                    if (obj.failures.count > 0 && obj.day == dow) {
                        output += '" data-failures-today="1"';
                    }

                    var failureIDs = obj.failures.ids;
                    failureIDs = failureIDs.sort(function (a, b) {  return b - a;  });
                    output += '" data-failures-ids="' + failureIDs.toString() + '"';

                    if (obj.incomplete !== undefined) {
                        output += '" data-incomplete="' + obj.incomplete.count + '"';
                        output += '" data-incomplete-ids="' + obj.incomplete.ids.toString() + '"';
                    } else {
                        output += '" data-incomplete="0"';
                        output += '" data-incomplete-ids=""';
                    }
                    if (row.name !== undefined) {
                        output += '" data-name="' + row.name + '"';
                    }
                    if (row.id !== undefined) {
                        var a = row.id.split('_');
                        var sid = a[0];
                        output += '" data-sid="' + sid + '"';
                    }
                    if (area === 'Backup Copies') {
                        var targets = obj.backup_copy_targets;
                        if (targets !== undefined) {
                            var target_count = 0;
                            for (var targetName in targets) {
                                var target = targets[targetName];
                                var success = target.successes !== undefined && target.successes.count > 0 ? target.successes.ids : [];
                                var failure = target.failures !== undefined && target.failures.count > 0 ? target.failures.ids : [];
                                var all = success.concat(failure);
                                output += '" data-tgt' + target_count + '="' + targetName + '"';
                                output += '" data-tgt' + target_count + 'successes="' + (target.successes !== undefined ? target.successes.count : 0) + '"';
                                output += '" data-tgt' + target_count + 'failures="' + target.failures.count + '"';
                                output += '" data-tgt' + target_count + 'ids="' + all.toString() + '"';
                                target_count++;
                            }
                        }
                    }
                }
                output += "></i>";
            }

            // lmc - no sort  from url
            //output += '<span class="item status-text">' + row.sort[key] + '</span>';
            return output;
        },
        last_backup_copies: function (value, row, key) {
            return this.last_backups(value, row, key, gettextCatalog.getString('Backup Copies'));
        },
        backup_jobs: function (value) {
            var jobs = $.map(value, function (val) {
                    return '<span class="item">' + val + '</span>';
                }),
                titles = value.length ? value.join("; ") : EMPTY_CELL_TEXT,
                output = jobs.length ? jobs.join("; ") : EMPTY_CELL_TEXT;
            return '<span class="truncates" title="' + titles + '">' + output + '</span>';
        }
    };

    var replicasFormatter = {
        backup: function (value, row) {
            return '<span class="truncates" title="' + value + '">' + value + '</span>';
        },
        finish_date: function (value, row) {
            return moment(value).format(DATE_DISPLAY_FORMAT + " h:mm A");
        }
    };

    var syncFormatter = {
        name: function (value, row) {
            return '<span class="truncates item-name" title="' + value + '">' + value + '</span>';
        },
        backup_date: function (value, row) {
            if (value && value !== EMPTY_CELL_TEXT) {
                return moment(value).zone(tz).format("M/D/YYYY h:mmA");
            }
            return value;
        },
        started: function (value, row) {
            if (value && value !== EMPTY_CELL_TEXT) {
                return moment.unix(value).zone(tz).format(DATE_DISPLAY_FORMAT + " h:mmA");
            }
            return value;
        }
    };

    function setPageRefresh(interval) {
        refreshRate = interval;
        tabs.forEach(function(tab) {
            if ( _.isFunction(tab.setTimerInterval)) {
                tab.setTimerInterval(refreshRate);
            }
        });
    }

    function initTabs() {

        if (!$scope.user.loggedIn) {
            TabTimer.rerun();
            return;
        }

        $(".page-tab").each(function (index) {
            if (index == 0) {
                tabs[index] = new ProtectInventoryTab(index, $(this), slugs[index]).init();                
            } else {
                tabs[index] = new CopyInventoryTab(index, $(this), slugs[index]).init();                
            }
        });
        tabs[currentTabIndex].activate();
    }

    var ProtectInventoryTab = function (index, panel, slug) {
        this.index = index;
        this.$panel = panel;
        this.namespace = "protect" + slug;

        this.$buttons = this.$panel.find(".button-bar");
        this.$buttons.find(".btn-group-recover").flyout();
        this.$buttons.find(".replicas-btn-group").flyout();

        this.$tabs = $('#protect-inventory-details');
        this.tabs = [];
        this.slugs = ['status'];

        this.TreeViewData = null;

        this.navGroups = null;

        this.inventoryTree = PHD.ProtectTreeView(
            $protectTreeContainer,
            $("#protect-treeview-selections")
        );

        this.inventoryTreeHeader = PHD.TreeViewHeader(
            $("#protect-treeview-header"),
            this.inventoryTree,
            "protect"
        );

        this.inventoryTreeSearch = null;
        this.currentTabIndex = 0;
        this.active = false;
    };

    ProtectInventoryTab.prototype.init = function () {
        var self = this;

        this.$tabs.tabs({
            active: 0,
            create: function (event, ui) {
                self.currentTabIndex = ui.tab.index();
                self.initTabs();
            },
            activate: function (event, ui) {
                self.currentTabIndex = ui.newTab.index();
                var selections = self.tabs[ui.oldTab.index()].deactivate();
                self.tabs[self.currentTabIndex].activate(selections);
            }
        });

        $(document)
            // Attach event handler to Hypervisor view select box changes
            .on("hypervisorviewchange.protect", function (event, views) {
                self.updateTreeView(false, views);
                self.inventoryTree.clearSelections();
            })
            .on("changeNavGroups", function (event) {
                self.updateTreeView(false);
                self.inventoryTree.clearSelections();
                self.inventoryTreeHeader.collapseTree();
            })
            .off("failedJobDeleted")
            .on("failedJobDeleted", function (event, failedBids, successCount, warningCount, sid) {
                event.stopPropagation();
                var failed = $("td").find("[data-failures-ids='" + failedBids + "'][data-sid='" + sid + "']");
                // warning trumps success
                if (warningCount > 0){
                    failed.toggleClass("icon-phd-error icon-phd-warning");
                } else if (successCount > 0){
                    failed.toggleClass("icon-phd-error icon-phd-success");
                } else {
                    failed.toggleClass("icon-phd-error icon-phd-none");
                }

            });

        return this;
    };

    ProtectInventoryTab.prototype.updateTreeView = function (views) {
        var self = this,
            load = PHD.showLoadingIndicator($protectTreeContainer),
            hypervisors = views || this.getHypervisorViews(),
            tvTask = PHD.TreeViewBuilder({
                hypervisorView: hypervisors,
                disks: 0,
                checkboxes: false,
                isCopy: 0,
                loader: load,
                uid: $rootScope.user.id     // user id for navigational groups (Protected Assets only, not Copied Assets).
            });

        tvTask
            .done(function (tree) {
                self.TreeViewData = tree.tree;
                $rootScope.treeDataCache = [tree.tree];
                console.log("nav groups: " + $rootScope.showNavGroups);
                if ($rootScope.showNavGroups) {
                    self.navGroups = inventorysvc.buildNavGroups(self.TreeViewData);
                }
                $protectTreeContainer.html(tree.html);

                self.inventoryTreeSearch = PHD.TreeViewSearch(
                    $("#protect-treeview-find"),
                    self.inventoryTree,
                    self.inventoryTree.$container,
                    self.inventoryTree.$container.find(".tree-universe")
                );
                self.tabs.forEach(function (tab) {
                    tab.clear();
                });
            })
            .always(function () {
                PHD.hideLoadingIndicator(load);
            });
    };

    ProtectInventoryTab.prototype.getHypervisorViews = function () {
        return $("#protect-treeview-header").find("select")
            .map(function () {
                return parseInt($(this).val(), 10);
            }).get();
    };

    ProtectInventoryTab.prototype.initTabs = function () {
        var self = this;
        this.$tabs.find(".ui-tabs-panel").each(function (index) {
            self.tabs[index] = new InventoryTab(index, $(this), self.slugs[index], self).init();
        });
    };

    ProtectInventoryTab.prototype.updateButtons = function (tab) {
        var tab = tab || this.tabs[this.currentTabIndex],
            selections = tab.$selected ? tab.$selected.serialize() : null;
        if (selections != null) $scope.selectedNode=JSON.stringify(tab.$selected.serialize());  
        if (selections != null) console.log("tab selected = " + $scope.selectedNode);
        
        this.$buttons.find("a").each(function () {
            var $but = $(this).data("selections", selections);
            PHD.buttonLogic($but, tab.$selected, tab, null, null, {provider: $analytics, source: 'Protect'});
        });
    };

    ProtectInventoryTab.prototype.activate = function () {
        this.active = true;
        this.updateTreeView();

        this.tabs[this.currentTabIndex].activate();
        this.updateButtons();
    };

    ProtectInventoryTab.prototype.deactivate = function () {
        this.active = false;
    };

    ProtectInventoryTab.prototype.setTimerInterval = function (interval) {
        TabTimer.setInterval(refreshRate);
        if (this.$panel.is(":visible")) {
            TabTimer.reset();
        }
    };

    /* Copy Inventory Tab for backup copied assets */
    var CopyInventoryTab = function (index, panel, slug) {
        this.index = index;
        this.$panel = panel;
        this.namespace = "copy" + slug;

        this.$buttons = this.$panel.find(".button-bar");
        this.$buttons.find(".btn-group-recover").flyout();

        this.$tabs = $('#copy-inventory-details');
        this.tabs = [];
        this.slugs = ['status'];

        this.TreeViewData = null;

        this.inventoryTree = PHD.ProtectTreeView(
            $copyTreeContainer,
            $("#copy-treeview-selections")
        );

        this.inventoryTreeHeader = PHD.TreeViewHeader(
            $("#copy-treeview-header"),
            this.inventoryTree,
            "copy"
        );

        this.inventoryTreeSearch = null;
        this.currentTabIndex = 0;
        this.active = false;
    };

    CopyInventoryTab.prototype.init = function () {
        var self = this;

        this.$tabs.tabs({
            active: 0,
            create: function (event, ui) {
                self.currentTabIndex = ui.tab.index();
                self.initTabs();
            },
            activate: function (event, ui) {
                self.currentTabIndex = ui.newTab.index();
                var selections = self.tabs[ui.oldTab.index()].deactivate();
                self.tabs[self.currentTabIndex].activate(selections);
            }
        });

        $(document)
            // Attach event handler to Hypervisor view select box changes
            .on("hypervisorviewchange.protect", function (event, views) {
                self.updateTreeView(false, views);
                self.inventoryTree.clearSelections();
            });

        return this;
    };

    CopyInventoryTab.prototype.updateTreeView = function (views) {
        var self = this,
            load = PHD.showLoadingIndicator($copyTreeContainer),
            hypervisors = views || this.getHypervisorViews(),
            tvTask = PHD.TreeViewBuilder({
                hypervisorView: hypervisors,
                disks: 0,
                checkboxes: false,
                isCopy: 1,
                loader: load
            });

        tvTask
            .done(function (tree) {
                self.TreeViewData = tree.tree;
                $copyTreeContainer.html(tree.html);

                self.inventoryTreeSearch = PHD.TreeViewSearch(
                    $("#copy-treeview-find"),
                    self.inventoryTree,
                    self.inventoryTree.$container,
                    self.inventoryTree.$container.find(".tree-universe")
                );
                self.tabs.forEach(function (tab) {
                    tab.clear();
                });
            })
            .always(function () {
                PHD.hideLoadingIndicator(load);
            });
    };

    CopyInventoryTab.prototype.getHypervisorViews = function () {
        return $("#copy-treeview-header").find("select")
            .map(function () {
                return parseInt($(this).val(), 10);
            }).get();
    };

    CopyInventoryTab.prototype.initTabs = function () {
        var self = this;
        this.$tabs.find(".ui-tabs-panel").each(function (index) {
            self.tabs[index] = new InventoryTab(index, $(this), self.slugs[index], self).init();
        });
    };

    CopyInventoryTab.prototype.updateButtons = function (tab) {
        var tab = tab || this.tabs[this.currentTabIndex],
            selections = tab.$selected ? tab.$selected.serialize() : null;
        if (selections != null) $scope.selectedNode=JSON.stringify(tab.$selected.serialize());
        if (selections != null) console.log("tab selected = " + $scope.selectedNode);

        this.$buttons.find("a").each(function () {
            var $but = $(this).data("selections", selections);
            PHD.buttonLogic($but, tab.$selected, tab, null, null, {provider: $analytics, source: 'Protect'});
        });
    };

    CopyInventoryTab.prototype.activate = function () {
        this.active = true;
        this.updateTreeView();

        this.tabs[this.currentTabIndex].activate();
        this.updateButtons();
    };

    CopyInventoryTab.prototype.deactivate = function () {
        this.active = false;
    };
    

    var InventoryTab = function (index, panel, slug, parent) {
        this.index = this.inventoryView = index;
        this.$panel = panel;
        this.namespace = "inventory" + slug;

        this.$table = this.$panel.find("table");

        /*
         * Check to see if this is the Copied Assets Tab or not.
         */
        this.isCopyTab = this.$panel.is("#copy-inventory-status");

        this.schema = this.$table.find("thead th").map(function () {
            return $(this).data("source");
        }).get();
        this.$checkSelectAll = this.$table.find(".check-select-all");

        this.Parent = parent;

        this.$tableMessage = this.$panel.find(".protect-inventory-message");

        this.data = null;

        this.InventoryTable = PHD.DataTable(this.$table, {
            select: false,
            placeholder: gettext("There are no items to display"),
            sortable: true,
            cellClasses: ["checkbox-cell", null, null, null, null],
            sortableCells: [false, true, false, false, false]
        }).registerFormatters(cellFormatter);

        this.$selected = null;
        this.selectedIDs = [];
        this.$selectedInventory = null;
        this.active = false;
        this.timestamp = 0;

        this.filterFields = [
            "backup_jobs",
            "replication_jobs",
            "archive_jobs",
            "priority",
            "bds",
            "retention",
            "credentials",
            "blocksize",
            "compression"
        ];

        this.$filters = {};
    };

    InventoryTab.prototype.init = function () {
        var self = this;

        // Show the general instruction message.
        this.$tableMessage.show();

        this.$table
            .on("change", ".inventory-checkbox", $.proxy(this.handleCheckboxChange, this))
            .on("aftercolumnfilter", $.proxy(this.handleColumnFilter, this))
            //.on("click", ".job-result", $.proxy(this.handleJobResult, this))
            .on("click", ".day-result", $.proxy(this.handleDayResult, this))
            .on("change", ".check-select-all", $.proxy(this.handleCheckSelectAll, this))
            .on("updatefinished", $.proxy(this.handleRowAddition, this))
            .on("loadfinished", $.proxy(this.handleTableLoad, this))
            .on("click", "[data-source=name] span", $.proxy(this.handleClickName, this))
            .sortTable()
            .filterTable();

        this.filterFields.forEach(function (value) {
            self.$filters[value] = self.$table.find('tfoot [data-source="' + value + '"] select.filter');
        });

        $(document)
            .on("inventoryselect", $.proxy(this.handleCheckboxChange, this))
            .on("inventorysettingsupdate", function (event, data) {
                if (self.active)
                    self.update();
            });

        this.Parent.inventoryTree.$container.on("nodeclick", ".checkable", $.proxy(this.handleTreeviewSelection, this));

        // This is the inventory loaded, at the appliance level.
        this.loadedInventory = [];
        this.loadedSystemID = 0;

        return this;
    };

    InventoryTab.prototype.clear = function () {
        this.$selectedInventory = null;
        this.InventoryTable.empty();
    };

    InventoryTab.prototype.update = function (selections) {
        if (this.$selectedInventory) {

            // Hide the general instruction message.
            this.$tableMessage.hide();

            var self = this,
                dbid = this.$selectedInventory.data("dbid"),
                type = this.$selectedInventory.data("type");

            var url = "/api/inventory/status";

            if (this.loadedInventory.length == 0 || this.loadedSystemID == 0 ||
                    (this.sid_of(dbid) !== this.loadedSystemID && this.sid_of(dbid) !== -1)) {
                var loadHash = PHD.showLoadingIndicator(this.$table.parent());
                //url += "/?sid=" + this.sid_of(dbid);
                if (this.isCopyTab) {
                    url += "/?grandclient=1";
                } else {
                    var sid = this.sid_of(dbid);
                    if (sid !== -1) {
                        url += "/?sid=" + sid;
                    } else {
                        // it is a group!
                    }
                }
                var resp = PHD.Ajax.get(url, loadHash);
                resp.done(function (data) {
                    PHD.hideLoadingIndicator(loadHash);
                    if (data !== undefined && data.inventory !== undefined) {
                        self.loadedInventory = data.inventory;
                        if (data.inventory.length > 0) {
                            self.loadedSystemID = self.sid_of(data.inventory[0].id);
                        } else {
                            self.loadedSystemID = 0;
                        }
                        self.loadTable(dbid, selections, type);
                    } else {
                        PHD.throwError({"result": [{"message": gettext("An error occurred while loading the status.")}]});
                    }
                });
            } else {
                self.loadTable(dbid, selections, type);
            }
        } else {
            this.$table
                //.sortTable() -- no sort here, will sort based on datatable loadfinished event.
                .scrollTable()
                .columnResize();
        }
    };

    InventoryTab.prototype.sid_of = function(dbid) {
        var str_dbid = String(dbid);
        var a = str_dbid.split('_');
        var sid = a[0];
        if (isNaN(sid)) {
            sid = -1;
        }
        return sid;
    };


    InventoryTab.prototype.loadTable = function (dbid, selections, nodeType) {
        
        var str_dib = String(dbid);
        var data = [];
        data.inventory = [];

        function isAChild(obj, item_id, data) {
            if (obj.id === item_id) {
                data.inventory.push(obj);
            } else {
                var nodeLength = item_id.length;
                if ((obj.id.substr(0, nodeLength) === item_id) && (obj.id.charAt(nodeLength) === '_')) {
                    data.inventory.push(obj);
                }
            }
        }

        // Filter to the item selected.
        $scope.selectedInventoryID = str_dib;
        var isGroupSelected = nodeType === INVENTORY_ID_NAVGROUP; // was inventorysvc.isGroup(str_dib);
        var isPoolOrvAppSelected = nodeType === INVENTORY_ID_VMWARE_RESOURCE_POOL || nodeType === INVENTORY_ID_VMWARE_V_APP;
        if (!isPoolOrvAppSelected) {
            for (var i = 0; i < this.loadedInventory.length; i++) {
                var obj = this.loadedInventory[i];
                if (obj.id !== undefined) {
                    if (!isGroupSelected) {
                        isAChild(obj, str_dib, data);
                    } else {
                        if (inventorysvc.isGroupMember(dbid, obj.id, this.Parent.navGroups)) {
                            data.inventory.push(obj);
                        }
                    }
                }
            }
        } else {
            // Handle pools by looking at their descendants in the tree; you cannot tell by the ID pieces only.
            var matches = this.Parent.inventoryTree.$container.find("[data-dbid=" + str_dib + "] .children .checkable");
            if (matches !== undefined) {
                for (var j = 0; j < matches.length; j++) {
                    var containerID = matches[j].dataset.dbid;
                    for (i = 0; i < this.loadedInventory.length; i++) {
                        obj = this.loadedInventory[i];
                        if (obj.id !== undefined) {
                            isAChild(obj, containerID, data);
                        }
                    }
                }
            }
        }

        this.InventoryTable.update(data.inventory, true);

        if (selections) {
            this.selectedIDs = selections;
            this.$table.find("[name=inventory]").prop("checked", false);
            this.selectedIDs.forEach(function (value) {
                self.$table.find("[value=" + value + "]").prop("checked", true);
            });
            this.updateSelections();
        }

        _.each(this.$filters, function ($input, key) {
            if ($input.length) {
                if (key.indexOf("_jobs") === -1) {
                    self.updateFilter(self.getFilterOptions("tbody td[data-source=" + key + "]"), $input);
                } else {
                    self.updateFilter(self.getJobFilterOptions("tbody td[data-source=" + key + "]"), $input);
                }
            }
        });

        this.$table
            //.sortTable() -- no sort here, will sort based on datatable updatefinished event.
            .scrollTable()
            .columnResize();

        this.Parent.updateButtons(this);
    };


    InventoryTab.prototype.updateFilter = function (options, $control) {
        $control.find("option:not(.option-all)").remove();
        options.sort().forEach(function (item, index) {
            $control.append('<option value="' + item + '">' + item + '</option>');
        });
    };

    InventoryTab.prototype.getFilterOptions = function (selector) {
        var options = [];
        this.$table.find(selector).each(function () {
            if ($.inArray($(this).text(), options) === -1) {
                options.push($(this).text());
            }
        });
        return options;
    };

    InventoryTab.prototype.getJobFilterOptions = function (selector) {
        var options = [];
        this.$table.find(selector).each(function () {
            $(this).text().split(";")
                .forEach(function (val) {
                    val = val.trim();
                    if (options.indexOf(val) === -1) {
                        options.push(val);
                    }
                });
        });
        return options;
    };

    InventoryTab.prototype.updateSelections = function () {
        this.$selected = this.$table.find("[name=inventory]:checked");
        this.selectedIDs = this.$table.find("tbody :checked").map(function () {
            return $(this).val();
        }).get();
        this.Parent.updateButtons(this);
    };

    InventoryTab.prototype.handleTreeviewSelection = function (event, id) {
        event.stopPropagation();
        this.$selectedInventory = $(event.target);
        if (this.active) {
            this.update();
        }
    };

    InventoryTab.prototype.handleDayResult = function (event) {
        var $anchor = $(event.target),
            day = $anchor.data("day"),
            area = $anchor.data("area"),
            successes = $anchor.data("successes"),
            warnings = $anchor.data("warnings"),
            failures = $anchor.data("failures"),
            incomplete = $anchor.data("incomplete"),
            successes_ids = $anchor.data("successes-ids"),
            warnings_ids = $anchor.data("warnings-ids"),
            failures_ids = $anchor.data("failures-ids"),
            incomplete_ids = $anchor.data("incomplete-ids"),
            name = $anchor.data("name"),
            sid = $anchor.data("sid");

        var data = {};
        data.day = day;
        data.formatted_day = day.split(',')[1];
        data.type = area;
        data.name = name;
        data.formatted_name = name.replace(/'/g, "\\'");
        data.successes = [];
        data.successes.count = successes;
        data.successes.ids = successes_ids;
        data.warnings = {};
        data.warnings.count = warnings;
        data.warnings.ids = warnings_ids;
        data.failures = {};
        data.failures.count = failures;
        data.failures.ids = failures_ids;
        data.incomplete = [];
        data.incomplete.count = incomplete;
        data.incomplete.ids = incomplete_ids;
        data.all_ids = '';
        if (successes_ids != "") {
            data.all_ids += successes_ids;
        }
        if (warnings_ids != "") {
            data.all_ids += ',' + warnings_ids;
        }
        if (failures_ids != "") {
            data.all_ids += ',' + failures_ids;
        }
        if (incomplete_ids != "") {
            data.all_ids += ',' + incomplete_ids;
        }
        data.sid = this.isCopyTab ? $rootScope.local.id : sid;
        data.override_copies = this.isCopyTab ? 1 : 0;

        var haveTargets = true;
        var i = 0;
        var targets = [];
        while (haveTargets) {
            var tgt = 'tgt' + i;
            var target = $anchor.data(tgt);
            if (target === undefined) {
                haveTargets = false;
            } else {
                var ids = 'tgt' + i + 'ids';
                var tgt_successes = 'tgt' + i + 'successes';
                var tgt_failures = 'tgt' + i + 'failures';
                var obj = { name: target, ids: $anchor.data(ids), successes: $anchor.data(tgt_successes), failures: $anchor.data(tgt_failures) };
                targets.push(obj);
            }
            i++;
        }
        data.targets = targets;

        var html = data.targets.length === 0 ? dayTmpl(data) : targetsTmpl(data);
        html = $compile(html)($scope);
        $("<div/>").html(html).popover({
            anchor: $anchor,
            autoOpen: true,
            popoverClass: 'job-inventory-result',
            destroyOnClose: true
        });
    };

    /*
     * Check/uncheck the row if the asset name is clicked.
     */
    InventoryTab.prototype.handleClickName = function (event) {
        var $row = $(event.currentTarget).parents("tr");
        if ($row !== undefined) {
            var $checkbox = $row.find(":checkbox");
            $checkbox.prop("checked", !$checkbox.prop("checked"));
            this.updateSelections();
        }
    };

    InventoryTab.prototype.handleCheckboxChange = function (event, $checkbox, checked) {
        this.updateSelections();
    };

    InventoryTab.prototype.handleCheckSelectAll = function (event) {
        event.preventDefault();
        this.$table.find("tbody tr:visible :checkbox")
            .prop("checked", this.$checkSelectAll.prop("checked")).trigger("change");
        this.updateSelections();
    };

    InventoryTab.prototype.handleColumnFilter = function (event) {
        this.$table.find("tbody tr:hidden :checkbox").prop("checked", false);
        this.updateSelections();
        this.Parent.updateButtons(this);
    };

    InventoryTab.prototype.handleRowAddition = function (event, newRows, DataTable) {
        if (newRows) {
            this.sortTableIfPossible();
        }
    };

    InventoryTab.prototype.handleTableLoad = function(event, hasRows, DataTable) {
        if (hasRows) {
            this.sortTableIfPossible();
        }
    };

    InventoryTab.prototype.sortTableIfPossible = function() {
        // lmc: Only sort inventories up to a certain size.  Workaround:  if too large, browser "hangs".
        var inventory_size = this.InventoryTable !== undefined ? this.InventoryTable.count() : 0;
        if (inventory_size <= LARGE_INVENTORY) {
            this.$table.sortTable();
        } else {
            var eventTag = 'Unsorted Inventory Size - ' + inventory_size;
            $analytics && $analytics.eventTrack(eventTag, {  category: 'Status', label: 'Protect' });
            console.log("Inventory too large to sort: " + inventory_size);
        }
    };

    InventoryTab.prototype.sortTableIfPossible = function() {
        // lmc: Only sort inventories up to a certain size.  Workaround:  if too large, browser "hangs".
        var inventory_size = this.InventoryTable !== undefined ? this.InventoryTable.count() : 0;
        if (inventory_size <= LARGE_INVENTORY) {
            this.$table.sortTable();
        } else {
            var eventTag = 'Unsorted Inventory Size - ' + inventory_size;
            $analytics && $analytics.eventTrack(eventTag, {  category: 'Status', label: 'Protect' });
            console.log("Inventory too large to sort: " + inventory_size);
        }      
    };

    InventoryTab.prototype.activate = function (selections) {
        this.active = true;
        this.update(selections);
    };

    InventoryTab.prototype.deactivate = function () {
        this.active = false;
        return this.selectedIDs;
    };

    $(document)
        .on("uinav.dashboard", stopAll)
        .on("uinav.jobs", stopAll)
        .on("uinav.recover", stopAll)
        .on("uinav.configure", stopAll)
        .on("uinav.reports", stopAll)
        .on("userpreferencesave.protectpage", function (event, key, value) {
            setPageRefresh(value);
        })
        .on("timersetmanual.protectpage", function (event, $control) {
            $control.show();
        })
        .on("timerunsetmanual.protectpage", function (event, $control) {
            $control.hide();
        });

    function stopAll(event) {
        console.log("===>In Stop All: Protect Tab, event " + event.namespace);
        TabTimer.stop();
        UserPreference.cancel();
        $(document).off("uinav.dashboard", stopAll);
        $(document).off("uinav.jobs", stopAll);
        $(document).off("uinav.recover", stopAll);
        $(document).off("uinav.configure", stopAll);
        $(document).off("uinav.reports", stopAll);
        $(document).off("userpreferencesave.protectpage");
        $(document).off("timertick.protectpage");
        $(document).off("timersetmanual.protectpage");
        $(document).off("timerunsetmanual.protectpage");
    }

    function handleTabChange() {
        $(document).trigger("tabchange", ["protect" + slugs[currentTabIndex]]);
    }

    /*
     *   DOM Ready Function
     */
    $(function () {
        // Quick and dirty way to change what tab opens by default via URL
        if (!isNaN(PHD.util.getHashInt())) {
            initialTab = PHD.util.getHashInt();
        }

        UserPreference = PHD.UserPreference($("#protect-page-preferences .preference-trigger"), {
            name: gettext("Protect Page"),
            namespace: "protectpage",
            key: "page_protect_refresh",
            defaultValue: refreshRate
        });

        /*TabTimer = PHD.Timer({
            namespace: "protectpage",
            interval: refreshRate,
            refreshControl: $("#protect-page-preferences .timer-refresh")
        });
        */

        $('.tabs-wrapper').tabs({
            active: initialTab,
            create: function (event, ui) {
                currentTabIndex = ui.tab.index();
                initTabs();
                handleTabChange();
            },
            activate: function (event, ui) {
                currentTabIndex = ui.newTab.index();
                $.cookie("initial_tab_protect", currentTabIndex, {expires: 365, path: '/'});
                tabs[ui.oldTab.index()].deactivate();
                tabs[currentTabIndex].activate();
                handleTabChange();
            }
        });
    });

    var dayTmpl = _.template(
        '<p><label class="day-status-day"><span><%= day %></span></label></p>' +
        '<p><label><%= type %></label></p>' +
        '<hr><label>Successes:</label><span><%= successes.count %></span>' +
        '<br/><label>Warnings:</label><span><%= warnings.count %></span>' +
        '<br/><label>Failures:</label><span><%= failures.count %></span>' +
        '<br/><label>In Progress:</label><span><%= incomplete.count %></span>' +
        '<hr>' +
        '<p><a href="" ng-click="loadStatus(<%= sid %>, \'<%= all_ids %>\', \'<%= formatted_day %>\', \'<%= formatted_name %>\', \'<%= type %>\', <%= override_copies %>)" class="job-log-link"><i class="icon-list-alt"></i>Details</a></p>'
    );

    var targetsTmpl = _.template(

        '<p><label class="day-status-day"><span><%= day %></span></label></p>' +
        '<p><label><%= type %></label></p>' +

        '<% for (var i = 0; i < targets.length; i++) { %>' +
        '<% var target = targets[i]; %>' +
            '<hr><label>Target:</label><span><%= target.name %></span>' +
            '<br/><label>Successes:</label><span><%= target.successes %></span>' +
            '<br/><label>Failures:</label><span><%= target.failures %></span>' +
            '<p><a href="" ng-click="loadStatus(<%= sid %>, \'<%= target.ids %>\', \'<%= formatted_day %>\', \'<%= formatted_name %>\', \'<%= type %>\')" class="job-log-link"><i class="icon-list-alt"></i>Details</a></p>' +
            '<br/>' +
        '<% } %>'
    );


    /*var jobInventoryTmpl = _.template(
        '<p><label>Job Name:</label><span><%= data.job_name %></span></p>' +
        '<p><label>Date:</label><span><%= data.start_date %></span></p>' +
        '<p><label>Mode:</label><span><%= data.type %></span></p>' +
        '<hr><div class="disks clearfix">' +
        '<label class="disk-status-label">Disk Status:</label>' +
        '<ul class="disk-statuses">' +
        '<% _.each(data.disks, function(disk) { %>' +
        '<li><span class="disk-name"><%= disk.data.name %></span> <span class="disk-job-status"><%= disk.data.job_status %></span></li>' +
        '<% }); %>' +
        '</ul></div>' +
        '<hr>' +
        '<p><a href="/jobs/<%= state.job_id %>/log/<%= state.id %>/" class="pop-out job-log-link"><i class="icon-list-alt"></i> View Log</a></p>'
    );*/

    var sort_duration = function (a, b) {
        if (a.value === EMPTY_CELL_TEXT || b.value === null) {
            return 1;
        }
        if (b.value === EMPTY_CELL_TEXT || a.value === null) {
            return -1;
        }
        var aVals = a.value.split(":").map(function (val) {
                return parseInt(val, 10);
            }),
            bVals = b.value.split(":").map(function (val) {
                return parseInt(val, 10);
            });

        a = (aVals[0] * 60 * 60) + (aVals[1] * 60) + aVals[2];
        b = (bVals[0] * 60 * 60) + (bVals[1] * 60) + bVals[2];
        return a - b;
    };

    function getHypervisorClass(hvtype) {
        switch (hvtype) {
            case HYPERVISOR_HYPERV:
                return "hv-type-hyperv";
            case HYPERVISOR_VMWARE:
                return "hv-type-vmware";
            case HYPERVISOR_XEN:
                return "hv-type-xen";
            case HYPERVISOR_AHV:
                return "hv-type-ahv";
            default:
                return "hv-type-unknown";
        }
    }
}
//})(jQuery, window.PHD || (window.PHD = {}), window);
