angular.module('protect', ['angulartics', 'angulartics.google.analytics','ngDialog','inventory'])
	
	.service('$protectService', function(){

		var iconFunc =function getIconForTreeNodeType(t) {
			if (t === INVENTORY_ID_CLIENT_AIX || t === INVENTORY_ID_CLIENT_DOS
				|| t === INVENTORY_ID_CLIENT_FREE_BSD || t === INVENTORY_ID_CLIENT_HPUX
				|| t === INVENTORY_ID_CLIENT_I_SERIES || t === INVENTORY_ID_CLIENT_LINUX
				|| t === INVENTORY_ID_CLIENT_MAC || t === INVENTORY_ID_CLIENT_NETWARE
				|| t === INVENTORY_ID_CLIENT_OES || t === INVENTORY_ID_CLIENT_OS2
				|| t === INVENTORY_ID_CLIENT_SGI || t === INVENTORY_ID_CLIENT_SCO
				|| t === INVENTORY_ID_CLIENT_SOLARIS || t === INVENTORY_ID_CLIENT_UNIX
				|| t === INVENTORY_ID_CLIENT_OTHER) {
				return "icon-uui-agent-asset";
			} else if (t === INVENTORY_ID_CLIENT_WINDOWS) {
				return "icon-uui-agent-asset-win";
			} else if (t === INVENTORY_ID_EXCHANGE_APPLICATION) {
				return "icon-uui-exchange-instance";
			} else if (t === INVENTORY_ID_SQL_SERVER) {
				return "icon-uui-sql-instance";
			} else if (t === INVENTORY_ID_ORACLE_APPLICATION) {
				return "icon-uui-oracle-instance";
			} else if (t === INVENTORY_ID_SHAREPOINT_APPLICATION) {
				return "icon-uui-sharepoint-instance";
			} else if (t === INVENTORY_ID_HYPER_V_SERVER) {
                return "icon-uui-hyperv-instance";
			} else if (t === INVENTORY_ID_VMWARE_VM || t === INVENTORY_ID_VMWARE_WIR_VM) {
				return "icon-uui-vmware-vm";
			} else if (t === INVENTORY_ID_HYPER_V_VM || t === INVENTORY_ID_HYPER_V_WIR_VM) {
				return "icon-uui-hyperv-vm";
			} else if (t === INVENTORY_ID_XEN_VM) {
				return "icon-uui-citrix-vm";
            } else if (t === INVENTORY_ID_AHV_VM) {
                return "icon-uui-nutanix-x";
			} else if (t === INVENTORY_ID_SQL_DATABASE) {
				return "icon-uui-sql-db";
			} else if (t === INVENTORY_ID_EXCHANGE_DATABASE) {
				return "icon-uui-exchange-db";
			} else if (t === INVENTORY_ID_ORACLE_DATABASE) {
				return "icon-uui-oracle-db";
			} else if (t === INVENTORY_ID_SHAREPOINT_FARM) {
				return "icon-uui-sharepoint-db";
			} else if (t === INVENTORY_ID_VMWARE_CLUSTER || t === INVENTORY_ID_XEN_POOL_MASTER) {
				return "icon-hv-cluster";
			} else if (t === INVENTORY_ID_XEN_STANDALONE_SERVER || t === INVENTORY_ID_XEN_SERVER_IN_A_POOL) {
				return "icon-uui-citrix-server";
            } else if (t === INVENTORY_ID_AHV_CLUSTER) {
                return "icon-hv-cluster";
			} else if (t === INVENTORY_ID_VMWARE_ESX_SERVER) {
				return "icon-uui-vmware-server";
			} else if (t === INVENTORY_ID_VMWARE_RESOURCE_POOL) {
				return "icon-uui-vmware-pool";
			} else if (t === INVENTORY_ID_SQL_INSTANCE) {
				return "icon-uui-sql-instance";
			} else if (t === INVENTORY_ID_VMWARE_V_APP) {
				return "icon-uui-vmware-vapp";
			} else if (t === INVENTORY_ID_VMWARE_TEMPLATE) {
				return "icon-uui-vmware-template";
			} else if (t === INVENTORY_ID_XEN_CUSTOM_TEMPLATE) {
				return "icon-uui-citrix-template";
			} else if (t === INVENTORY_ID_VMWARE_VM_DISK || t === INVENTORY_ID_XEN_VM_DISK || t === INVENTORY_ID_AHV_VM_DISK) {
				return "icon-hv-drive";
			} else if (t === INVENTORY_ID_SYSTEM) {
				return "icon-uui-unitrends-appliance2";
			} else if (t === INVENTORY_ID_CISCO_UCS_SERVICE_PROFILE) {
				return "icon-ram";
			} else if(t === INVENTORY_ID_NAVGROUP) {
				return "icon-hv-folder";
			} else if (t === INVENTORY_ID_NDMP_CLIENT) {
				return "icon-uui-agent-asset";
			} else if (t === INVENTORY_ID_NDMP_VOLUME) {
				return "icon-database";
			} else {
				return "icon-hv-folder";
			}
		};
		this.getIconForType = iconFunc;

    	var isValidNodeForNodeType =function filterNode(treeNode,nodeType){

    		if(treeNode.type_family === INVENTORY_TYPE_FAMILY_SYSTEM ||
				treeNode.type_family === INVENTORY_TYPE_FAMILY_NAVGROUP) {
    			return true;
    		}
    		switch (nodeType) {
			    case INVENTORY_TYPE_FAMILY_CLIENT:
		    		if(treeNode.type_family === INVENTORY_TYPE_FAMILY_CLIENT){
						if(!(treeNode.name.indexOf("-NAS-RRC")>-1)){
							if ((treeNode.is_sql_alwayson != undefined && treeNode.is_sql_alwayson !== false) || (treeNode.is_sql_cluster != undefined && treeNode.is_sql_cluster !== false)) {
								return false;
							}
							return true;
						}
					}
			    	return false;
			    case INVENTORY_TYPE_FAMILY_CLIENT_NAS:
			    	if(treeNode.type_family === INVENTORY_TYPE_FAMILY_CLIENT){
			    			if(treeNode.name.indexOf("-NAS-RRC")>-1){
                    			return true;
                			}
                		}
			    	return false;
			    case INVENTORY_TYPE_FAMILY_HYPER_V:
			    case INVENTORY_TYPE_FAMILY_VMWARE:
			    case INVENTORY_TYPE_FAMILY_XEN:
			    case INVENTORY_TYPE_FAMILY_EXCHANGE:
			    case INVENTORY_TYPE_FAMILY_ORACLE:
			    case INVENTORY_TYPE_FAMILY_SQL:
			    case INVENTORY_TYPE_FAMILY_SHAREPOINT:
				case INVENTORY_TYPE_FAMILY_CISCO_UCS:
				case INVENTORY_TYPE_FAMILY_NDMP:
				case INVENTORY_TYPE_FAMILY_AHV:
					return checkNodeAndChildren(treeNode, nodeType);
			}

    		return true;
    	};

		/*
		 * Given a tree node and an application family, see if the node should be included based on its family or that of its children.
		 * Returns true to include and false if not.
		 */
		var checkNodeAndChildren = function(treeNode, family) {
			if (treeNode.type_family === family) {
				return true;
			}
			if (treeNode.nodes !== undefined && Array.isArray(treeNode.nodes) && treeNode.nodes.length > 0) {
				var children = treeNode.nodes;
				for (var i = 0; i < treeNode.nodes.length; i++) {
					var node = treeNode.nodes[i];
					if (node.type_family === family) {
						return true;
					}
				}
			}
			return false;
		};

        var isNodeEnabledForBackupCopy = function filterNode (treeNode) {
            var enabled = true;
            /*if (treeNode.type === INVENTORY_ID_NAVGROUP) {
                enabled = false;
            }*/
            return enabled;
        };

    	var isNodeEnableForNodeType =function filterNode(treeNode,nodeType){

    		switch (nodeType) {
			    case INVENTORY_TYPE_FAMILY_CLIENT:
		    		if(treeNode.type === INVENTORY_ID_CLIENT_AIX || treeNode.type === INVENTORY_ID_CLIENT_DOS
		    			||treeNode.type === INVENTORY_ID_CLIENT_FREE_BSD || treeNode.type === INVENTORY_ID_CLIENT_HPUX
		    			||treeNode.type === INVENTORY_ID_CLIENT_I_SERIES || treeNode.type === INVENTORY_ID_CLIENT_LINUX
		    			||treeNode.type === INVENTORY_ID_CLIENT_MAC || treeNode.type === INVENTORY_ID_CLIENT_NETWARE
		    			||treeNode.type === INVENTORY_ID_CLIENT_OES || treeNode.type === INVENTORY_ID_CLIENT_OS2
		    			||treeNode.type === INVENTORY_ID_CLIENT_SGI || treeNode.type === INVENTORY_ID_CLIENT_SCO
		    			||treeNode.type === INVENTORY_ID_CLIENT_SOLARIS || treeNode.type === INVENTORY_ID_CLIENT_UNIX
		    			||treeNode.type === INVENTORY_ID_CLIENT_WINDOWS || treeNode.type === INVENTORY_ID_CLIENT_OTHER
		    			){
							return true;
					}
		    	
			    	return false;
			    case INVENTORY_TYPE_FAMILY_CLIENT_NAS:
			    	if(treeNode.type === INVENTORY_ID_CLIENT_AIX || treeNode.type === INVENTORY_ID_CLIENT_DOS
		    			||treeNode.type === INVENTORY_ID_CLIENT_FREE_BSD || treeNode.type === INVENTORY_ID_CLIENT_HPUX
		    			||treeNode.type === INVENTORY_ID_CLIENT_I_SERIES || treeNode.type === INVENTORY_ID_CLIENT_LINUX
		    			||treeNode.type === INVENTORY_ID_CLIENT_MAC || treeNode.type === INVENTORY_ID_CLIENT_NETWARE
		    			||treeNode.type === INVENTORY_ID_CLIENT_OES || treeNode.type === INVENTORY_ID_CLIENT_OS2
		    			||treeNode.type === INVENTORY_ID_CLIENT_SGI || treeNode.type === INVENTORY_ID_CLIENT_SCO
		    			||treeNode.type === INVENTORY_ID_CLIENT_SOLARIS || treeNode.type === INVENTORY_ID_CLIENT_UNIX
		    			||treeNode.type === INVENTORY_ID_CLIENT_WINDOWS || treeNode.type === INVENTORY_ID_CLIENT_OTHER
		    			){

			    			if(treeNode.name.indexOf("-NAS-RRC")>-1){
                    			return true;
                			}
                		}
		    	
			    	return false;
			    case INVENTORY_TYPE_FAMILY_HYPER_V:
		    		if(treeNode.type === INVENTORY_ID_HYPER_V_VM || treeNode.type ==  INVENTORY_ID_HYPER_V_SERVER || treeNode.type === INVENTORY_ID_HYPER_V_WIR_VM){
						return true;
					}
                    //Only for DCA Job wizard
                    if(treeNode.type === INVENTORY_ID_SYSTEM){
                        return true;
                    }
			        return false;
				case INVENTORY_TYPE_FAMILY_VMWARE:
			    	if(treeNode.type === INVENTORY_ID_VMWARE_VM || treeNode.type === INVENTORY_ID_VMWARE_TEMPLATE || treeNode.type === INVENTORY_ID_VMWARE_WIR_VM ) {
						return true;
					}
                    //Only for DCA Job wizard
                    if(treeNode.type === INVENTORY_ID_SYSTEM){
                        return true;
                    }
					// handle regex.
					if (treeNode.type === INVENTORY_ID_VMWARE_ESX_SERVER || treeNode.type === INVENTORY_ID_VMWARE_RESOURCE_POOL) {
						return true;
					}
			        return false;
			    case INVENTORY_TYPE_FAMILY_XEN:
			    	if(treeNode.type === INVENTORY_ID_XEN_VM || treeNode.type === INVENTORY_ID_XEN_CUSTOM_TEMPLATE){
						return true;
					}
			        return false;
                case INVENTORY_TYPE_FAMILY_AHV:
                    if(treeNode.type === INVENTORY_ID_AHV_VM || treeNode.type === INVENTORY_ID_AHV_CLUSTER){
                        return true;
                    }
                    return false;
                case INVENTORY_TYPE_FAMILY_EXCHANGE:
			    	if(treeNode.type === INVENTORY_ID_EXCHANGE_DATABASE ){
						return true;
					}
			        return false;
			    case INVENTORY_TYPE_FAMILY_ORACLE:
			    	if(treeNode.type === INVENTORY_ID_ORACLE_DATABASE ){
						return true;
					}
			        return false;
			    case INVENTORY_TYPE_FAMILY_SQL:
			    	if(treeNode.type === INVENTORY_ID_SQL_DATABASE || treeNode.type == INVENTORY_ID_SQL_INSTANCE){
						return true;
					}	
			        return false;
			    case INVENTORY_TYPE_FAMILY_SHAREPOINT:
			    	if(treeNode.type === INVENTORY_ID_SHAREPOINT_FARM ){
						return true;
					}	
			        return false;
				case INVENTORY_TYPE_FAMILY_CISCO_UCS:
					if(treeNode.type === INVENTORY_ID_CISCO_UCS_SERVICE_PROFILE ){
						return true;
					}
					return false;
				case INVENTORY_TYPE_FAMILY_NDMP:
					if(treeNode.type === INVENTORY_ID_NDMP_VOLUME ){
						return true;
					}
					return false;
			}


    		return true;
    	};
        var recurFunc =function getRecursivelyTreeData(data,nodeType, singleClient, backupCopyJob){
            var isDisabled =true;
            for(var j = 0; j< data.nodes.length;j++){
                if (backupCopyJob) {
                    isDisabled = !isNodeEnabledForBackupCopy(data.nodes[j]);
                } else {
                    isDisabled = singleClient || !isNodeEnableForNodeType(data.nodes[j],nodeType);
                    if(!isValidNodeForNodeType(data.nodes[j],nodeType)){
                        continue;
                    }
                }
                var nodeIcon = iconFunc(data.nodes[j].type)+" icon";

                var recoveryModel = "";
                if (data.nodes[j].recovery_model) {
                    recoveryModel = data.nodes[j].recovery_model;
                }

                var osTypeID = 0;
                if (data.nodes[j].os_type_id !== undefined && data.nodes[j].os_type_id !== 0) {
                    osTypeID = data.nodes[j].os_type_id;
                }

                // properties for SQL cluster and SQL availability groups
                var isSqlCluster = false;
                if (data.nodes[j].is_sql_cluster !== undefined && data.nodes[j].is_sql_cluster !== false) {
                    isSqlCluster = true;
                }
                var isSqlAlwayson = false;
                if (data.nodes[j].is_sql_alwayson !== undefined && data.nodes[j].is_sql_alwayson !== false) {
                    isSqlAlwayson = true;
                }

                rootNodeObj = {id:data.nodes[j].id, parent:data.id, text:data.nodes[j].name,
                    icon:nodeIcon, state: { opened: false,disabled: isDisabled}, data:{expanded:false, type:data.nodes[j].type,
                        recovery_model: recoveryModel, guest_os:data.nodes[j].guest_os,
                        os_type_id:osTypeID,
                        is_sql_cluster:isSqlCluster, is_sql_alwayson:isSqlAlwayson}};
                rootNodeArray.push(rootNodeObj);
                if(data.nodes[j].nodes instanceof Array){
                    getRecursivelyTreeData(data.nodes[j],nodeType, singleClient, backupCopyJob);
                }
            }
        };

        this.loadTreeData = function($http,$scope,$rootScope,nodeType,isEdit,jobId, isBackupCopy){
        	$rootScope.treeData =[];
            finalTreeDataArray = [];
			rootNodeArray = [];
			var singleClient = $scope.isSingleClient;
			var backupCopyJob = isBackupCopy || false;

			for(var k=0;k<$rootScope.treeDataCache.length;k++){   
				var nodeIcon = iconFunc($rootScope.treeDataCache[k].type)+" icon";
				rootNodeObj={id:$rootScope.treeDataCache[k].id,parent:"#",text:$rootScope.treeDataCache[k].name,
				icon:nodeIcon,state: { opened: true,disabled: true},data:{expanded:true,type:$rootScope.treeDataCache[k].type}};
				rootNodeArray.push(rootNodeObj);
				var isDisabled = true;
				var jsonTreeData = $rootScope.treeDataCache[k].nodes;

				var jsonData = this.getSortedJson(jsonTreeData,"name");
			
				for(var i = 0; i< jsonData.length;i++){
					if (backupCopyJob) {
						isDisabled = !isNodeEnabledForBackupCopy(jsonData[i]);
					} else {
                        isDisabled = singleClient || !isNodeEnableForNodeType(jsonData[i],nodeType);
					}
                    var osTypeID = 0;
                    if (jsonData[i].os_type_id != undefined && jsonData[i].os_type_id != 0) {
                        osTypeID = jsonData[i].os_type_id;
                    }

                    // properties for SQL cluster and SQL availability groups
                    var isSqlCluster = false;
                    if (jsonData[i].is_sql_cluster != undefined && jsonData[i].is_sql_cluster != false) {
                        isSqlCluster = true;
                    }
                    var isSqlAlwayson = false;
                    if (jsonData[i].is_sql_alwayson != undefined && jsonData[i].is_sql_alwayson != false) {
                        isSqlAlwayson = true;
                    }

                    if (!backupCopyJob) {
                        if(!isValidNodeForNodeType(jsonData[i],nodeType)){
                            continue;
                        }
					}
					nodeIcon = iconFunc(jsonData[i].type)+" icon";
					rootNodeObj={id:jsonData[i].id,parent:$rootScope.treeDataCache[k].id,text:jsonData[i].name,
					    icon:nodeIcon,state: { opened: false,disabled: isDisabled},data:{expanded:false,type:jsonData[i].type, os_type_id:osTypeID,
                            is_sql_cluster:isSqlCluster, is_sql_alwayson:isSqlAlwayson}};
					rootNodeArray.push(rootNodeObj);
					  
					if(jsonData[i].nodes instanceof Array){
						recurFunc(jsonData[i],nodeType, singleClient, backupCopyJob);
					}
				}
		 	}
            finalTreeDataArray = rootNodeArray;
            $rootScope.treeData = finalTreeDataArray;
            if(!isEdit){
                var nodeTree =$('#jstreeDivId').jstree(true);
                if (nodeTree.settings != undefined && nodeTree.settings.core !== undefined) {
                    nodeTree.settings.core.data=$rootScope.treeData;
                }
                if (nodeTree.refresh !== undefined) {
                    nodeTree.refresh();
                }
            }
        };

		this.getSortedJson = function(jsonData,key){
			jsonData.sort(function(a, b) {
				a = a[key].toLowerCase();
				b = b[key].toLowerCase();
				return (a < b) ? -1 : (a > b) ? 1 : 0;
			});
			return jsonData
		};

        this.loadCertifyTreeData = function($http,$scope,$rootScope,nodeType,isEdit,jobId){
            $rootScope.treeData =[];
            finalTreeDataArray = [];
            rootNodeArray = [];

            for(var k=0;k<$rootScope.treeDataCache.length;k++){

                var nodeIcon = iconFunc($rootScope.treeDataCache[k].type)+" icon";
                rootNodeObj={id:$rootScope.treeDataCache[k].id,parent:"#",text:$rootScope.treeDataCache[k].name,
                    icon:nodeIcon,state: { opened: true,disabled: true},data:{expanded:true,type:$rootScope.treeDataCache[k].type,rdr_supported:$rootScope.treeDataCache[k].rdr_supported}};
                rootNodeArray.push(rootNodeObj);
                var isDisabled = true;
                var jsonTreeData = $rootScope.treeDataCache[k].nodes;

                var jsonData = this.getSortedJson(jsonTreeData,"name");

                for(var i = 0; i< jsonData.length;i++){
                    //isDisabled = !isNodeEnableForNodeType(jsonData[i],nodeType);
                    if(!isValidNodeForNodeType(jsonData[i],nodeType)){
                        continue;
                    }
                    nodeIcon = iconFunc(jsonData[i].type)+" icon";
                    rootNodeObj={id:jsonData[i].id,parent:$rootScope.treeDataCache[k].id,text:jsonData[i].name,
                        icon:nodeIcon,state: { opened: false,disabled: false},data:{expanded:false,type:jsonData[i].type}};
                    rootNodeArray.push(rootNodeObj);

                    if(jsonData[i].nodes instanceof Array){
                        recurFunc(jsonData[i],nodeType, false, false);
                    }
                }
            }
            finalTreeDataArray = rootNodeArray;
            $rootScope.treeData = finalTreeDataArray;
            if(!isEdit){
                var nodeTree =$('#certifyBackupJstreeDivId').jstree(true);
                if (nodeTree.settings != undefined && nodeTree.settings.core !== undefined) {
                    nodeTree.settings.core.data=$rootScope.treeData;
                }
                if (nodeTree.refresh !== undefined) {
                    nodeTree.refresh();
                }
            }



        };

		this.openBackupDialog = function($http,$scope,$rootScope,ngDialog,isEdit,jobId,preSelect){
         var self = this;
			$scope.title = isEdit? gettext("Edit Backup Job") : gettext("Create Backup Job");
	   		$scope.isEdit = isEdit;
            $scope.preSelect =(preSelect == true)?true :false;
	   		$scope.jobId = jobId;
        	$rootScope.treeData =[];
            var OpenBackupJobIndicator = PHD.showLoadingIndicator("body", true, "Loading...");

            var sidString = "";
            if (jobId !== undefined) {
            	var sidIndex = jobId.indexOf('.');
            	if (sidIndex !== -1) {
            		sidString = "&sid=" + jobId.substring(sidIndex + 1);
				}
			}
		    $http({
				method: 'get',
				url : '/api/inventory/?uid=' + $rootScope.user.id + sidString
			}).success(function(data, status, headers){
				//$scope.backupDialogType = nodeType;
                $rootScope.treeDataCache=data.inventory;
                /*check for screen height*/
                var setTopvalue='top:75px;'
                if (screen.height >1024){
                    setTopvalue='top:10%;'
                }else if(screen.height == 1024){
                    setTopvalue='top:6%;'
                }
                ngDialog.open({
                    template: 'app/protect/backup-job/backupJob.html',
                    scope: $scope,
                    overlay:true,
                    data: OpenBackupJobIndicator,
                    modelDialogId:'backup-physical-dailog',
                    ngDialogPostionStyle:setTopvalue,
                    ngDialogStyle:'width:1000px;height:725px;',
                    preCloseCallback: function (value) {}
                });
        	}).error(function(response) {
                PHD.hideLoadingIndicator(OpenBackupJobIndicator);
			});

	   };

        this.openBackupCopyDialog = function($http,$scope,$rootScope,ngDialog,isEdit,jobId,preSelect,useCopiedAssets){
            var self = this;
            $scope.title = isEdit? gettext("Edit Backup Copy Job") : gettext("Create Backup Copy Job");
            $scope.isEdit = isEdit;
            $scope.preSelect =(preSelect == true)?true :false;
            $scope.jobId = jobId;
            $scope.useCopiedAssets = useCopiedAssets || false;
            $rootScope.treeData =[];
            var OpenBackupJobIndicator = PHD.showLoadingIndicator("body", true, "Loading...");

            var url = '/api/inventory/?uid='+ $rootScope.user.id;
            var sidString = "";
            if ($scope.useCopiedAssets) {
            	url += "&grandclient=1";
			} else {
                if (jobId !== undefined) {
                    var sidIndex = jobId.indexOf('.');
                    if (sidIndex !== -1) {
                        sidString = "&sid=" + jobId.substring(sidIndex + 1);
                    }
                }
			}
			url += sidString;
            $http({
                method: 'get',
                url : url
            }).success(function(data, status, headers){
                //$scope.backupDialogType = nodeType;
                $rootScope.treeDataCache=data.inventory;
                /*check for screen height*/
                var setTopvalue='top:75px;';
                if (screen.height >1024){
                    setTopvalue='top:10%;'
                }else if(screen.height == 1024){
                    setTopvalue='top:6%;'
                }
                ngDialog.open({
                    template: 'app/protect/backup-copy-job/backup-copy-job.html',
                    scope: $scope,
                    overlay:true,
                    data: OpenBackupJobIndicator,
                    modelDialogId:'backup-physical-dailog',
                    ngDialogPostionStyle:setTopvalue,
                    ngDialogStyle:'width:1000px;height:725px;',
                    preCloseCallback: function (value) {}
                });
            }).error(function(response) {
                PHD.hideLoadingIndicator(OpenBackupJobIndicator);
            });

        };


        this.openCertifyBackupDialog = function($http,$scope,$rootScope,ngDialog,isEdit,jobId,preSelect){
            var self = this;
            $scope.title = isEdit? gettext("Edit Data Copy Access Job"): gettext("Create Data Copy Access Job");
            $scope.isEdit = isEdit;
            $scope.preSelect =(preSelect == true)?true :false;
            $scope.jobId = jobId;
            $rootScope.treeData =[];
            var OpenDCAJobIndicator = PHD.showLoadingIndicator("body", true, "Loading...");
			var sidString = "";
			if (jobId !== undefined) {
				var sidIndex = jobId.indexOf('.');
				if (sidIndex !== -1) {
					sidString = "&sid=" + jobId.substring(sidIndex + 1);
				}
			}

            $http({
                method: 'get',
                url : '/api/inventory/rdr/?uid=' + $rootScope.user.id + sidString
            }).success(function(data, status, headers){
                //$scope.backupDialogType = nodeType;
                $rootScope.treeDataCache=data.inventory;
                /*if(isEdit){
                 self.loadTreeData($http,$scope,$rootScope,nodeType,isEdit,jobId);
                 }*/
                /*check for screen height*/
                var setTopvalue='top:75px;'
                if (screen.height >1024){
                    setTopvalue='top:10%;'
                }else if(screen.height == 1024){
                    setTopvalue='top:6%;'
                }
                ngDialog.open({
                    template: 'app/joborders/certify-backups/certifyBackupJob.html',
                    scope: $scope,
                    overlay:true,
                    data: OpenDCAJobIndicator,
                    modelDialogId:'backup-physical-dailog',
                    ngDialogPostionStyle:setTopvalue,
                    ngDialogStyle:'width:1200px;height:725px;',
                    preCloseCallback: function (value) {}
                });
            }).error(function(response) { PHD.hideLoadingIndicator(OpenDCAJobIndicator);});

        };



        this.openSLAPolicyDialog = function($http,$scope,$rootScope,ngDialog,isEdit,policyId,preSelect){
            var self = this;
            $scope.title = isEdit? gettext("Edit SLA Policy"):gettext("Create SLA Policy");
            $scope.isEdit = isEdit;
            $scope.preSelect =(preSelect == true)?true :false;
            $scope.policyId = policyId;
            $rootScope.treeData =[];

            $http({
                method: 'get',
				// TODO: Until SLA Policies APIs support managed appliances,k only pull the inventory from the local system.
                url : '/api/inventory/?uid=' + $rootScope.user.id + '&sid=' + $rootScope.local.id
            }).success(function(data, status, headers) {
                //$scope.backupDialogType = nodeType;
                $rootScope.treeDataCache = data.inventory;
				/*if(isEdit){
				 self.loadTreeData($http,$scope,$rootScope,nodeType,isEdit,jobId);
				 }*/
				/*check for screen height*/
                var setTopvalue = 'top:75px;'
                if (screen.height > 1024) {
                    setTopvalue = 'top:10%;'
                } else if (screen.height == 1024) {
                    setTopvalue = 'top:6%;'
                }
                ngDialog.open({
                    template: 'app/protect/sla-policy/sla-policy.html',
                    scope: $scope,
                    overlay: true,
                    modelDialogId: 'sla-policy-dialog',
                    ngDialogPostionStyle: setTopvalue,
                    ngDialogStyle: 'width:950px;height:650px;',
                    preCloseCallback: function (value) {
                    }
                });
            })};

		this.openVMReplicaDialog = function($http, $scope, $rootScope, ngDialog){
			var self = this;
			$rootScope.treeData =[];
			var loadIndicator = PHD.showLoadingIndicator("body", true, "Loading...");

			$http({
				method: 'get',
				//url : '/api/inventory/?uid=' + $rootScope.user.id // TODO change the API to the new replica inventory API
				url: '/api/inventory/replicas/?uid=' + $rootScope.user.id
			}).success(function(data, status, headers){
				$rootScope.treeDataCache=data.inventory;
				var setTopvalue = 'top:75px;';
				if (screen.height >1024){
					setTopvalue = 'top:10%;'
				}else if(screen.height == 1024){
					setTopvalue= 'top:6%;'
				}
				PHD.hideLoadingIndicator(loadIndicator);
				ngDialog.open({
					template: 'app/recover/replicas/replicasWizard.html',
					scope: $scope,
					overlay: true,
					modelDialogId: 'replicas-dialog',
					ngDialogStyle: 'width:82em; height:60em;top: -150px;left: 80px;'
				});
			}).error(function(response) { PHD.hideLoadingIndicator(loadIndicator);});
		};
		this.isWindowsAsset = function(os_type_id) {
			var win = false;
			switch (os_type_id) {
				case OS_WINDOWS_2000:
				case OS_WINDOWS_2003:
				case OS_WINDOWS_2008:
				case OS_WINDOWS_2012:
				case OS_WIN_2008_R2:
				case OS_WINDOWS_7:
				case OS_WINDOWS_8:
				case OS_WINDOWS_8_1:
				case OS_WINDOWS_10:
				case OS_WINDOWS_2012_R2:
				case OS_WINDOWS_2016:
				case OS_WINDOWS_VISTA:
				case OS_WINDOWS_XP:
					win = true;
			}
			return win;
		};

        this.isNixAsset = function(os_type_id) {
            var unix = false;
            switch (os_type_id) {
                case OS_UNIX3:
                case OS_UNIX4:
                case OS_SOLARIS:
                case OS_DGUX:
                case OS_HP_UX:
                case OS_LINUX:
                case OS_BSDI:
                case OS_USL:
                case OS_UNIXWARE:
                case OS_FREEBSD:
                case OS_MACOS:
                    unix = true;
            }
            return unix;
        };

        // Common Functions that were duplicated between Backup Job and SLA Policy Dialogs

		/*
		 * Given an array of metanames, returns a comma-separated list of names.
		 * Metaname 'registry' is coverted to 'system state' for user view.
		 */
        var getMetanames = function(metanames) {
            var names = "";
            var sep = "";
            for (var i = 0; i < metanames.length; i++) {
                if (metanames[i] === 'registry') {
                    names += sep + "system state";
                } else {
                    names += sep + metanames[i];
                }
                sep = ",";
            }
            return names.toString();
        };

        /*
         * Creates the rule string field given arrays of includes, excludes, and metanames.
         */
        this.setProtectionRule = function(incl_list, excl_list, metanames) {
            var protectionruleInclusion="Inclusions =[ ";
            var protectionruleExclusion="Exclusions =[ ";
            var protectionruleAdvanced="Advanced =[ ";
            var protectionRules ="";

            if(incl_list!=undefined && incl_list!=null &&incl_list.length>0){
                protectionruleInclusion = protectionruleInclusion+incl_list.toString()+" ] ";
                protectionRules = protectionRules + protectionruleInclusion;
            }

            if(excl_list!=undefined && excl_list!=null &&excl_list.length>0){
                protectionruleExclusion = protectionruleExclusion+excl_list.toString()+" ] ";
                protectionRules = protectionRules + protectionruleExclusion;
            }

            if (metanames !== undefined && metanames !== null && metanames.length > 0) {
                protectionruleAdvanced = protectionruleAdvanced+getMetanames(metanames)+" ] ";
                protectionRules = protectionRules + protectionruleAdvanced;
            }

            return protectionRules;
        };
	})

    .controller('ProtectCtrl', ['$scope', '$rootScope', '$http', 'Page','$compile', '$analytics','ngDialog',
		'wizardService', '$protectService','inventorysvc', 'tourFactory', 'gettextCatalog',
			function($scope, $rootScope, $http, Page, $compile, $analytics,ngDialog,wizardService,$protectService,inventorysvc, tourFactory,gettextCatalog) {

        Page.setTitle('Protect');

        $scope.$on('$viewContentLoaded', function() {
            processProtectPage(PHD, window, $scope, $rootScope, $compile, $analytics, inventorysvc, gettextCatalog);
        });

        $scope.loadStatus = function(sid, bid, date, name, type, change_copies) {
            $(".job-inventory-result").hide();
            var override_copies = change_copies === 1;

            PHD.appliance_sid = sid;
            if (type == 'Backups') {
                backup_ids = bid;
                copies = false;
                ngDialog.open({
                    template: 'app/inventory/details/status.html',
                    scope: $scope,
                    overlay:true,
                    data: {'backup_ids': backup_ids, 'copies': copies, 'title': name + " " + gettextCatalog.getString("Backup Status:") + " " + date},
                    modelDialogId: 'backup-status-dialog',
                    name: 'backup-status-dialog',
                    ngDialogStyle: 'height:500px;width:1200px',
                    preCloseCallback: function (value) {
                    }
                });
            } else {
                console.log("in load backup copy detail status");
                if (bid.indexOf('a') === -1) {
                    // load backup copies with same API as backups but with an additional option.
                    backup_ids = bid;
                    copies = !override_copies;
                    ngDialog.open({
                        template: 'app/inventory/details/status.html',
                        scope: $scope,
                        overlay:true,
                        data: {'backup_ids': backup_ids, 'copies': copies, 'title': name + " " + gettextCatalog.getString("Backup Copy Status:") + " " + date},
                        modelDialogId: 'backup-status-dialog',
                        name: 'backup-status-dialog',
                        ngDialogStyle: 'height:500px;width:1200px',
                        preCloseCallback: function (value) {
                        }
                    });
                } else {
                    copy_ids = bid;
                    copies = true;
                    ngDialog.open({
                        template: 'app/inventory/backup-copy-details/status.html',
                        scope: $scope,
                        overlay:true,
                        data: {'copy_ids': copy_ids, 'copies': copies, 'title': name + " " + gettextCatalog.getString("Backup Copy Status:") + " " + date},
                        modelDialogId: 'backup-copy-status-dialog',
                        name: 'backup-copy-status-dialog',
                        ngDialogStyle: 'height:400px;width:1200px',
                        preCloseCallback: function (value) {
                        }
                    });
                }
            }
        };

		$scope.onChangeGroups = function() {
			$rootScope.showNavGroups = !$rootScope.showNavGroups;
			var prefURL = '/api/preferences/' ;
			var putData = {};
			putData['ShowGroups'] = $rootScope.showNavGroups ? 'true' : 'false';
			prefURL = prefURL + encodeURI($rootScope.user.name)+"/";
			tourFactory.sync('put',prefURL,1,putData).then(function(result){
				console.log("success >> showGroups");
				var e = $.Event('changeNavGroups');
				$(document).trigger(e);
			});
		};

		$scope.manageGroups = function() {
			//console.log($scope.selectedInventoryID);
			var url = "/api/inventory/nav-groups";
			var resp = PHD.Ajax.get(url);
			resp.done(function (data) {
				var navgroup = data.navgroup;
				ngDialog.open({
					template: 'app/protect/groups/groups.html',
					scope: $scope,
					data: {navgroup: navgroup, preSelected: $scope.selectedInventoryID},
					overlay:true,
					modelDialogId:'groups-manager-dialog',
					ngDialogStyle:'width:600px; height:410px;'
				});
			});
		};

	/*******************On clcik of backup physical button open dialog with job wizard*****************/
		   var rootNodeObj={};
	       var rootNodeArray=[];
		   var finalTreeDataArray = [];

		$scope.openNASDialog = function(){
			$protectService.openBackupDialog($http,$scope,$rootScope,ngDialog,false);
        };
		
	    $scope.openBackupPhysicalDialog = function(){
	    	$protectService.openBackupDialog($http,$scope,$rootScope,ngDialog,false);
		};
	    $scope.openBackupJobDialog = function() {
            $scope.beforeOpenJobDialog();
            $protectService.openBackupDialog($http, $scope, $rootScope, ngDialog, false);
        };
		$scope.openBackupCopyJobDialog = function() {
			$scope.beforeOpenCopyJobDialog();
			$protectService.openBackupCopyDialog($http, $scope, $rootScope, ngDialog, false);
		};
		$scope.openCopiedBackupCopyJobDialog = function() {
			// Called from the copied-assets tab.
            $scope.beforeOpenCopyJobDialog();
            $protectService.openBackupCopyDialog($http, $scope, $rootScope, ngDialog, false, undefined, false, true);
		};
		$scope.openSLAPolicyDialog = function(){
            $scope.beforeOpenJobDialog();
			$protectService.openSLAPolicyDialog($http,$scope,$rootScope,ngDialog, false);
		};

		$scope.openWindowsReplicaDialog = function(){
			if (!$('#winIRBtn').hasClass("disabled")) {
				ngDialog.open({
					template: 'app/recover/wir/windowRecoveryWizard.html',
					scope: $scope,
					overlay: true,
					modelDialogId: 'window-instant-recover-dialog',
					ngDialogStyle: 'width:82em; height:60em;  top: -150px;left: 80px;'
				});
			}
		};

		$scope.openVMReplicaDialog = function(){
			$scope.beforeOpenJobDialog();
			$protectService.openVMReplicaDialog($http, $scope, $rootScope, ngDialog);
		};
        
        $scope.beforeOpenJobDialog = function(){
            var assetType =INVENTORY_TYPE_FAMILY_CLIENT;
            $scope.selectedAssetType = assetType;
            $scope.selectedNodeList = [];
            console.log($scope.selectedNode);
            console.log(($scope.selectedNode !=""));
            if(typeof($scope.selectedNode) != 'undefined' && $scope.selectedNode !="\"\""){
                var selectedNodeArray=$scope.selectedNode.replace(/["]/g, "").split("&");
                for(var i =0; i< selectedNodeArray.length; i++){
                    var parsedNodeId = selectedNodeArray[i].replace('inventory=','');
                    var inventoryNodeObject = inventorysvc.nodeToObject(parsedNodeId);
                    var parsedAssetType = inventorysvc.getAssetType(parseInt(inventoryNodeObject.app_id));

                    if(i == 0){
                        $scope.selectedAssetType = parsedAssetType;
                        $scope.selectedNodeList.push(parsedNodeId);
                        continue;
                    }

                    if($scope.selectedAssetType === parsedAssetType){
                        $scope.selectedNodeList.push(parsedNodeId);
                    }
                }
            }
        };

        /*
         * Add all preselected assets to the selected node list.  Unlike backup jobs, backup copy jobs
         * can contain assets of multiple types.
         */
		$scope.beforeOpenCopyJobDialog = function(){
			$scope.selectedNodeList = [];
			console.log($scope.selectedNode);
			console.log(($scope.selectedNode !== ""));
			if ($scope.selectedNode !== undefined && $scope.selectedNode !== '""'){
				var selectedNodeArray = $scope.selectedNode.replace(/["]/g, "").split("&");
				for(var i =0; i< selectedNodeArray.length; i++){
					var parsedNodeId = selectedNodeArray[i].replace('inventory=','');
					$scope.selectedNodeList.push(parsedNodeId);
				}
			}
		};

        $scope.openCertifyBackupJobDialog = function(){
            if (!$('#dcaJobID').hasClass('disabled')) {
                $scope.beforeOpenCertifyJobDialog();
                $protectService.openCertifyBackupDialog($http, $scope, $rootScope, ngDialog, false);
            }
        };

                $scope.beforeOpenCertifyJobDialog = function(){
                    var assetType =INVENTORY_TYPE_FAMILY_CLIENT;
                    $scope.selectedAssetType = assetType;
                    $scope.selectedNodeList = [];
                    console.log($scope.selectedNode);
                    console.log(($scope.selectedNode !=""));
                    if(typeof($scope.selectedNode) != 'undefined' && $scope.selectedNode !="\"\""){
                        var selectedNodeArray=$scope.selectedNode.replace(/["]/g, "").split("&");
                        for(var i =0; i< selectedNodeArray.length; i++){
                            var parsedNodeId = selectedNodeArray[i].replace('inventory=','');
                            var inventoryNodeObject = inventorysvc.nodeToObject(parsedNodeId);
                            var parsedAssetType = inventorysvc.getAssetType(parseInt(inventoryNodeObject.app_id));

                            if(i == 0){
                                $scope.selectedAssetType = parsedAssetType;
                                $scope.selectedNodeList.push(parsedNodeId);
                                continue;
                            }

                            if($scope.selectedAssetType === parsedAssetType){
                                $scope.selectedNodeList.push(parsedNodeId);
                            }
                        }
                    }
                }

	  
    }]);
