var protectTourModel =  angular.module('tourProtectedModel',['tour-module']);

protectTourModel.controller('tourProtectCtrl', function ($scope, $rootScope, tourFactory){

    var $tour = $("#protect-tour"),
        $toolbar = $("#tour-toolbar"), 
        $inventory = $("#tour-inventory"),
        $status = $("#tour-status"),
        $filters = $("#tour-filters");
    
        var $toolbarTarget = $("#widget-tour");
        $scope.$currentStep = $rootScope.user.tourStep;


    $scope.initTour = function() {
        $(window).off("resize.tour");
        $(window).on("resize.tour",  PHD.util.debounce($scope.positionTour));
        $scope.positionTour();
        $("#protect-tour").addClass("active");
    }


    $scope.positionTour = function() {
        if ($toolbarTarget.length > 0) {
            $toolbar.position({
                my: "top center",
                at: "top+284",
                of: $toolbarTarget,
                using: positionElement
            });
            $inventory.position({
                my: "left+160 ",
                at: "left center",
                of: $toolbarTarget,
                using: positionElement
            });
            $status.position({
                my: "center",
                at: "center",
                of: $toolbarTarget,
                using: positionElement
            });
            $filters.position({
                my: "left+450 bottom-50",
                at: "left+20 bottom",
                of: $toolbarTarget,
                using: positionElement
            });
        } else {
            console.log("protect tour init issue");
        }
    }

    function positionElement(attr, obj) {
        obj.element.element.css({
            top: attr.top,
            left: attr.left,
            position: 'absolute'
        });
    }

    $scope.endTour = function() {
        $(window).off("resize.tour");
        $(".tour-position").css("z-index", "auto");
        $("#protect-tour").remove();
        $scope.$currentStep = $rootScope.user.tourStep = 1;
    
        var putData = {};
        putData['show_help_overlay'] = 'false';
        
        var prefURL = '/api/preferences/' ;
            prefURL = prefURL + encodeURI($rootScope.user.name)+"/";
            tourFactory.sync('put',prefURL,1,putData).then(function(result){
                console.log("success >> Protect");
            });
        
        $rootScope.user.showTour= false; 
        $scope.refreshPage();
    };

    /* 
     * Refresh App-main page
     */
     $scope.refreshPage = function(){
        var currentPage = angular.element(document.getElementById("app"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    $scope.reloadContent = function(){
        var currentPage = angular.element(document.getElementById("protect-tour"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    $scope.setNextTourStep = function() {
        if($scope.$currentStep === TOUR_STEP_PROTECT_END) {
            if ($rootScope.recoverDisabled) {
                $scope.$currentStep = $rootScope.user.tourStep = TOUR_STEP_JOBS_START;
                //go to the jobs page
                window.location.href = "#/jobs/";
                setTimeout(function () {
                    $("#activeJob a").trigger('click');
                    $("#jobPane").addClass("tourHilighter");
                }, 700);
            } else {
                //have to set the step before moving to the next page
                $scope.$currentStep = $rootScope.user.tourStep += 1;
                //go to the protect page
                window.location.href = "#/recover/";
                setTimeout(function(){

                    $("#recover-backup-table").addClass("tourHilighter");
                }, 1000);
            }
        }else{
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep+=1; //$scope.$parent.user.tourStep += 1;
            $scope.positionTour();
            
             switch(parseInt($scope.$currentStep)) {
                    case 7:
                        setTimeout(function(){
                            $("#protect-inventory-buttons").addClass("tourHilighter");
                        }, 500); 
                        break;
                    case 8:
                        setTimeout(function(){
                            //$("#protectInventoryPane").addClass("tourHilighter");
                            //$("#protect-inventory").addClass("tourHilighter");
                            $("#protect-inventory-treeview").addClass("tourHilighter");
                        }, 500);
                        break;
                    case 9:
                        setTimeout(function(){
                            $("#protect-status-table").addClass("tourHilighter");
                        }, 500);
                        break;
                    case 10:
                        setTimeout(function(){
                            $("#protect-status-table > tfoot ").addClass("tourHilighter");
                        }, 500);
                        break;
                     default: $scope.reloadContent();
                        break;
                }
             
        }
        
    }

    $scope.setPreviousTourStep = function() {
        if(parseInt($scope.$currentStep) === TOUR_STEP_PROTECT_START) {
            //have to set step change before going back
            $scope.$currentStep = $rootScope.user.tourStep -=1; 
            //go back to the dashboard
            window.location.href = "#/dashboard/";
            setTimeout(function(){
                $("[id='toruidACTIVE JOBS']").addClass("tourHilighter");
            }, 500);
        } else {
            
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep -=1; //$scope.$parent.user.tourStep -= 1;
            $scope.positionTour();
                       
            switch(parseInt($scope.$currentStep)) {
                    case 7:
                        setTimeout(function(){
                            $("#protect-inventory-buttons").addClass("tourHilighter");
                        }, 600); 
                        break;
                    case 8:
                        setTimeout(function(){
                            //$("#protectInventoryPane").addClass("tourHilighter");
                            //$("#protect-inventory").addClass("tourHilighter");
                            $("#protect-inventory-treeview").addClass("tourHilighter");
                        }, 500);
                        break;
                    case 9:
                        setTimeout(function(){
                            $("#protect-status-table").addClass("tourHilighter");
                        }, 500);
                        break;
                    case 10:
                        setTimeout(function(){
                            $("#protect-status-table > tfoot ").addClass("tourHilighter");
                        }, 500);
                        break;
                     default: $scope.reloadContent();
                        break;
                }
        }
    }

    
    angular.element(document).ready(function () {
        $scope.initTour();
        $scope.positionTour();
    });
});

    
