var optimizerApp = angular.module('optimizerWizard', ['mgo-angular-wizard', 'ngGrid', 'ui.bootstrap', 'angulartics', 'angulartics.google.analytics']);

/* Creating factory for optimizerWizard
 **Input Params:
 *method
 *url
 *Sid
 *dataObj for put request.
 **Output
 *JSON object from requested URL
 */
/* Creating Controller for optimizerWizard
 *All the business logic goes here
 */
optimizerApp.controller('optimizerCtrl', ['quickStartFactory', '$scope', '$http', 'Page', '$rootScope', '$route', '$analytics', '$location', 'ngDialog',
    function (quickStartFactory, $scope, $http, Page, $rootScope, $route, $analytics, $location, ngDialog) {
        $scope.optimizer = {};

        function displayOptimalSettings(data) {

            $scope.optimize = data.data;

            console.log("current dedupe: " + $scope.optimize.current_dedup_level);
           // console.log("mux max: " + $scope.optimize.recommended_mux_max);

            ngDialog.open({
                template: 'app/options/dedupe-settings.html',
                scope: $scope,
                overlay: true,
                ngDialogStyle: 'width: 550px'
            });

        }

        $scope.runOptimizer = function () {
            console.info("in runOptimizer");
            var load = PHD.showLoadingIndicator('body', true, 'Checking current settings...');

            quickStartFactory.async('get', '/api/optimize/1,3', "", {}).then(function (data) {
                PHD.hideLoadingIndicator(load);

                displayOptimalSettings(data.data);

            });
        };

        $scope.saveOptimizationSettings = function () {
            var putOptimizationURL = "/api/optimize/";
            var newOptimizationSettings = {};

            newOptimizationSettings.mux = $scope.optimize.current_mux;
            newOptimizationSettings.deduplevel = parseInt($scope.optimize.current_dedup_level);

            var params = {};
            $http({
                method: 'put',
                url: putOptimizationURL,
                params: params,
                data: JSON.stringify(newOptimizationSettings)
            }).success(function () {
                    quickStartFactory.async('put', putOptimizationURL, 1, newOptimizationSettings, $analytics, "Optimize Settings");
                    PHD.hideLoadingIndicator(load);
                    ngDialog.open({
                        dialogType: 'Information',
                        scope: $scope,
                        dialogMessage: "Settings applied successfully."

                    });
                console.log("new dedupe level:" + $scope.optimize.current_dedup_level);
                }).error(function (response) {
                PHD.hideLoadingIndicator(load);
                load = null;
                var message = response.result[0].message;
                $analytics && $analytics.eventTrack('Failure: ' + message, {
                    category: 'Auto Tune'
                });
                ngDialog.open({
                    dialogType: 'Error',
                    scope: $scope,
                    dialogMessage: message
                })
            })
        };
     /*
      11/7/2016 - mmb
      $scope.moveDBLocation = function () {
            console.info("...moving database...");
            var putDatabaseURL = "/api/optimize/movedb/";
            console.log(putDatabaseURL);
            var newDatabaseLocation = {};
            newDatabaseLocation.movedb = $scope.optimize.recommended_movedb;
            console.log(newDatabaseLocation.movedb);
            var load = PHD.showLoadingIndicator("body", true, "Moving database...");

            var params = {};
            $http({
                method: 'put',
                url: putDatabaseURL,
                params: params,
                data: JSON.stringify(newDatabaseLocation)
            }).success(function (data, status, headers) {
                quickStartFactory.async('put', putDatabaseURL, 1, newDatabaseLocation, $analytics, "Move Database");
                PHD.hideLoadingIndicator(load);
                load = null;
                ngDialog.open({
                    dialogType: 'Information',
                    scope: $scope,
                    dialogMessage: "Database moved successfully."
                });
                console.log(newDatabaseLocation.movedb);
            }).error(function (response) {
                PHD.hideLoadingIndicator(load);
                load = null;
                var message = response.result[0].message;
                $analytics && $analytics.eventTrack('Failure: ' + message, {
                    category: 'Auto Tune',
                    label: 'Move Database'
                });
                ngDialog.open({
                    dialogType: 'Error',
                    scope: $scope,
                    dialogMessage: message
                })
            })
        };*/

    }]);

