var quickStartApp = angular.module('quickStartWizard', ['mgo-angular-wizard', 'ngGrid', 'ui.bootstrap', 'angulartics', 'angulartics.google.analytics']);
var passwordMatchFlag = true;

//Wizard steps titles.
var DATE_TIME_WIZARD = "Date & Time";
var HOSTNAME_PASSWORD_WIZARD = "Host Name & Password";
var EMAIL_WIZARD = "Email";
var BACKUP_STORAGE_WIZARD = "Backup Storage";
var EULA = "EULA";
var FORUM_ACCOUNT_WIZARD = "Forum Account";
//var OPTIMIZE_WIZARD = "Optimize Settings";
// End Title 		
var isValidationDone = true;
var load;
var isReportingChecked = false;
var isChecked = false;
var isNext = false;
totalStorageDiskSize = 0;
var enviornmentID = 1;
disks = {};

/* Creating factory for QuickStartWizard
 **Input Params:
 *method
 *url
 *Sid
 *dataObj for put request.
 **Output
 *JSON object from requested URL
 */
var loadWizard = null;
quickStartApp.factory('quickStartFactory', function ($http) {

    function getErrorMessage(response, method, url) {
        var message = response.result[0].message;
        // If PUT users API with a specific message, customize.
        if ((method === 'put') && (url.indexOf('/api/users') !== -1)&& (message.indexOf('Incorrect password.') !== -1)) {
            message += "  Your password was previously changed from the default.  Please clear your browser cache and reload so that you can login ";
            message += " with the correct credentials.  You will then be able to change the password during appliance setup.";
        }
        return message;
    };

    return {
        async: function (method, url, enviornmentID, dataObj, analytics, action) {
            console.log(method, url, disks);
            var params = {};
            isError = false;
            if (enviornmentID != 0) {
                params.sid = enviornmentID;
            }
            var $analytics = analytics || false;
            var analyticsEvent = action || url;
            $analytics && $analytics.eventTrack(analyticsEvent, {category: 'Configure', label: 'Quick Start'});
            var promise = $http({
                url: url,
                data: JSON.stringify(dataObj),
                method: method,
                params: params
            }).success(function (data, status, headers) {
                //console.log("success");
                //PHD.hideLoadingIndicator(load);
                //loadWizard=null;
            }).error(function (response) {
                isError = true;
                if (method === "post" && url === "/api/storage/") {
                    var scope = angular.element(document).scope();
                    scope.storageError = true;
                    if (response !== undefined && response.result !== undefined && response.result[0] !== undefined) {
                        var error = response.result[0].message;
                        console.log("The error is:" + error);

                        if (error.indexOf("Storage configuration failed - this volume contains existing data, are you sure you want to format it?") > -1) {               //Check if storage contains existing data, so we can show user option to recover.
                            var storageObj = {},
                                newurl = "/api/storage/" + "?sid=" + PHD.appliance_sid;
                            $("#confirm_storage_dialog").dialog({
                                modal: true,
                                buttons: {
                                    Recover: function () {
                                        storageObj.name = "_Stateless";
                                        storageObj.build_filesystem = 0;    // create stateless storage
                                        storageObj.usage = "stateless";
                                        storageObj.type = STORAGE_ADDED_INTERNAL;
                                        storageObj.properties = disks;
                                        storageObj = JSON.stringify(storageObj);
                                        var load = PHD.showLoadingIndicator("body", true, "Recovering Storage...");
                                        var scope = angular.element(document).scope();
                                        scope.disableTimers();
                                        PHD.Ajax
                                            .post(url, storageObj, load, null)
                                            .done(function (data) {
                                                PHD.hideLoadingIndicator(load);
                                                // create stateless - turn off timers.

                                                scope.enableTimers();
                                            });
                                        $(this).dialog("close");
                                    },
                                    "Erase Data": function () {
                                        storageObj.name = "_Stateless";
                                        storageObj.build_filesystem = 2;    // create stateless storage
                                        storageObj.usage = "stateless";
                                        storageObj.type = STORAGE_ADDED_INTERNAL;
                                        storageObj.properties = disks;
                                        storageObj = JSON.stringify(storageObj);
                                        var load = PHD.showLoadingIndicator("body", true, "Erasing Storage...");
                                        var scope = angular.element(document).scope();
                                        scope.disableTimers();
                                        PHD.Ajax
                                            .post(url, storageObj, load, null)
                                            .done(function (data) {
                                                PHD.hideLoadingIndicator(load);
                                                // create stateless - turn off timers.
                                                scope.enableTimers();
                                            });
                                        $(this).dialog("close");
                                    },
                                    Cancel: function () {
                                        $(this).dialog("close");
                                    }

                                }
                            });
                        }
                        else {
                            PHD.throwError(data);
                        }
                    } else {
                        PHD.throwError(data);
                    }
                }
                else {
                    var errorMessage = getErrorMessage(response, method, url);
                    window.PHD.throwError({"result": [{"message": gettext(errorMessage)}]});
                }
                PHD.hideLoadingIndicator(load);
                loadWizard = null;

            });
            return promise;
        }
    };
});
//CellFilter for Storage Grid
quickStartApp.filter('convertMBtoGBFilter', function ($filter) {
    return function (input) {
        return (input / 1024).toFixed(2);

    };
});

/* Creating Controller for QuickStartWizard
 *All the business logic goes here
 */
quickStartApp.controller('quickStartCtrl', ['quickStartFactory', '$scope', '$http', 'Page', '$rootScope', '$route', '$analytics', '$location', 'ngDialog',
    function (quickStartFactory, $scope, $http, Page, $rootScope, $route, $analytics, $location, ngDialog) {
        $scope.dateTimeWizardObj = {};
        $scope.backupStorage = {};
         $scope.optimizer = {};
        $scope.hostURL = $location.host(); //returns the url of the host

        //hide the move database option during setup wizard
        $scope.showMoveDatabase = false;

        var DATE_FORMAT = 'mm/dd/yy', timeZoneWiz = "";
        var DATE_DISPLAY_FORMAT = "MM/DD/YYYY";

        //function to load default data from backend for Datea&time wizard on load
        $rootScope.loadDateTimeWizardData = function () {
            // open License Agreement dialog once the user login successfully.
            if ($rootScope.user.eulaWizardFlag) createDialog($scope, $rootScope, $http);

            var url = "/api/date-time/";
            quickStartFactory.async('get', url, 1, "").then(function (resultData) {
                // For NTP Server Field

                var ntpServerData = [];
                //var ntpServerData = []
                // Changes for ntp server dropdown.
                $scope.dateTimeWizardObj.ntpServer = resultData.data.ntp.servers;
                $scope.dateTimeWizardObj.backendNTPServers = resultData.data.ntp.servers;
                for (var i = 0; i < $scope.dateTimeWizardObj.ntpServer.length; i++) {
                    ntpServerData.push($scope.dateTimeWizardObj.ntpServer[i]);
                }

                $scope.dateTimeWizardObj.ntpServerData = ntpServerData; // dropdown data for ntp server

                // Inititlize the NTP servver input for additional servers to an empty string.
                $scope.dateTimeWizardObj.ntpServerSelect = '';  // $scope.dateTimeWizardObj.ntpServerData[$scope.dateTimeWizardObj.ntpServer.length -1]; // model

                //var ntpServer = resultData.data.ntp.servers;
                //$scope.dateTimeWizardObj.ntpServer = ntpServer[ntpServer.length -1];
                //$scope.dateTimeWizardObj.backendNTPServers = resultData.data.ntp.servers;

                var ntpServerEnabled = resultData.data.ntp.enabled;
                $scope.dateTimeWizardObj.ntpServerEnabled = ntpServerEnabled;
                console.log($scope.dateTimeWizardObj.ntpServerEnabled);
                if ($scope.dateTimeWizardObj.ntpServerEnabled) {
                    document.getElementById("dateTimeRadioId").checked = false;
                    document.getElementById("ntpServerRadioId").checked = true;
                    $('#ntpServerText').removeAttr('disabled');
                    $('#ntptablefieldset').removeClass('ntp-server-disabled');
                    $('#date').attr('disabled', 'disabled');
                    $('#time').attr('disabled', 'disabled');
                    $('#timeZone').attr('disabled', 'disabled');
                    //$('.ui-datepicker-trigger').attr('disabled','disabled');
                } else {
                    document.getElementById("dateTimeRadioId").checked = true;
                    document.getElementById("ntpServerRadioId").checked = false;
                    $('#ntpServerText').attr('disabled', 'disabled');
                    $('#ntptablefieldset').addClass('ntp-server-disabled');
                    $('#date').removeAttr('disabled');
                    $('#time').removeAttr('disabled');
                    $('#timeZone').removeAttr('disabled');
                    //$('.ui-datepicker-trigger').removeAttr('disabled');
                }
                // For Date and Time Field
                var year = resultData.data.year;
                var month = resultData.data.month;
                var day = resultData.data.day;
                $scope.dateTimeWizardObj.date = month + "/" + day + "/" + year;
                // For Time Field
                var hourData = resultData.data.hour;
                var minData = resultData.data.minute;
                var secData = resultData.data.second;

                var hour = wizardTimeFormat(hourData.toString());
                var min = wizardTimeFormat(minData.toString());
                var sec = wizardTimeFormat(secData.toString());

                $scope.dateTimeWizardObj.time = hour + ":" + min + ":" + sec;
                // For TimeZone
                timeZoneWiz = resultData.data.tz;
                $scope.timeZoneWiz = timeZoneWiz;
                $scope.myselect = timeZoneWiz;
            });

            var timeZoneUrl = "/api/date-time/timezones/";
            quickStartFactory.async('get', timeZoneUrl, 1, "").then(function (result) {
                var timeZoneData = [];
                $scope.timeZoneData = result.data.timezone;
            });


            //for Date calender
            $(".datepicker input:text").datepicker({
                showOn: "both",
                buttonText: '<img src="assets/images/calendar.png" width="24" height="24">',
                dateFormat: DATE_FORMAT
            }).attr("placeholder", DATE_DISPLAY_FORMAT);

        }

        //watch on TZ value change.

        $scope.timeZoneUpdate = function (item) {
            saveTimeZone($rootScope, $scope, quickStartFactory, item);
        }

        //function to enable and disable Ntp server textbox depends upon checkbox field
        $scope.ntpServerchange = function () {
            if ($scope.dateTimeWizardObj.ntpServerEnabled) {
                document.getElementById("dateTimeRadioId").checked = false;
                document.getElementById("ntpServerRadioId").checked = true;
                $('#ntpServerText').removeAttr('disabled');
                $('#ntptablefieldset').removeClass('ntp-server-disabled');
                $('#date').attr('disabled', 'disabled');
                $('#time').attr('disabled', 'disabled');
                $('#timeZone').attr('disabled', 'disabled');
                //$('.ui-datepicker-trigger').attr('disabled','disabled');
            } else {
                document.getElementById("dateTimeRadioId").checked = true;
                document.getElementById("ntpServerRadioId").checked = false;
                $('#ntpServerText').attr('disabled', 'disabled');
                $('#ntptablefieldset').addClass('ntp-server-disabled');
                $('#date').removeAttr('disabled');
                $('#time').removeAttr('disabled');
                $('#timeZone').removeAttr('disabled');
                //$('.ui-datepicker-trigger').removeAttr('disabled');
            }
        }

        //function to enable and disable checkAgreement check box.
        $scope.checkAgreementchange = function () {
            if ($scope.backupStorage.checkAgreement) {
                document.getElementById("eulaNextButton").disabled = false;
            } else {
                document.getElementById("eulaNextButton").disabled = true;
            }
        }


        //BackupStorage Grid Creation
        $scope.model = {};
        $scope.mySelections = [];
        $scope.storageDataArray = [];
        $scope.gridOptions = {
            selectedItems: $scope.mySelections,
            data: 'storageDataArray',
            columnDefs: [{
                field: '',
                width: '20%',
                cellTemplate: '<div class="ngSelectionCell"><input tabindex="-1" class="ngSelectionCheckbox" type="checkbox" ng-checked="row.selected" /> </div>'
            }, {field: 'name', displayName: 'Name', width: '40%'}, {
                field: 'mb_size',
                displayName: 'Size (GB)',
                width: '40%',
                cellFilter: 'convertMBtoGBFilter'
            }],
            afterSelectionChange: function () {
                $scope.selectedIDs = [];
                $scope.selectedGBsize = 0;
                angular.forEach($scope.mySelections, function (item) {
                    $scope.selectedIDs.push(item.name)
                    console.log("selected::::::" + parseInt($scope.selectedGBsize));
                    var diskSizeInGB = parseInt((item.mb_size / 1024).toFixed(2));
                    $scope.selectedGBsize = parseInt($scope.selectedGBsize) + parseInt(diskSizeInGB);
                    totalStorageDiskSize = $scope.selectedGBsize;
                });
                console.log("::::::" + totalStorageDiskSize);

            }
        };
        // Email Add receipent code
        $scope.recipientsDetails = [];
        $scope.modelReporting = [
            {emailReporting: false},
            {email_auth: false}
        ];
        $scope.enableCheckBoxToggle = function () {
            isReportingChecked = $scope.modelReporting.emailReporting;
            if (isReportingChecked) {
                if (isChecked) {
                    $scope.modelReporting.email_auth = false;
                }
            }
            makeDisableEmailFields($scope, isReportingChecked);

        } // End Enable email Reporting checkbox coding

        $scope.enableAuth = function () {
            isChecked = $scope.modelReporting.email_auth;
            makeDisableEnableReporting($scope, isChecked);
        }// End authentication Required.

        $scope.addRecipient = function () {
            var recipientInfo = {
                "email": "",
                "system": false,
                "job": false,
                "failure": false
            };

            $scope.listRecipients.push(recipientInfo);
            if ($scope.listRecipients.length === 5)
                $('#add_recipient_btn').attr('disabled', 'disabled');

        };

        $scope.removeRecipients = function (index) {
            $scope.listRecipients.splice(index, 1);
            if ($scope.listRecipients.length !== 5)
                $('#add_recipient_btn').removeAttr('disabled');
        };

        //for refresh backup storage Grid.
        $scope.refreshBackupStorageGrid = function () {
            $scope.getBackupStorageDetails();
        };


        //for saving and getting wizard data.
        $rootScope.nextWizard = function () {
            switch (wizardTitle) {
                case DATE_TIME_WIZARD:
                    $scope.saveDateAndTimeDetails();
                    $scope.getHostNamedetails();
                    break;
                case HOSTNAME_PASSWORD_WIZARD:
                    $scope.saveHostNameAndPasswordDetails();
                    $scope.getEmailConfig();
                    break;
                case EMAIL_WIZARD:
                    $scope.saveEmailWizardDetails(isReportingChecked);
                    //$scope.getBackupStorageDetails();
                    //	$scope.getOptimizerWizard();
                    break;
                /*  TODO when Auto Tune is enabled
                 case OPTIMIZE_WIZARD:
                 console.info("Case OPTIMIZE_WIZARD");
                 if($scope.storageDataArray.length > 0){
                 $scope.saveBackupStorageDetails($scope.storageDataArray[0].name);
                 }
                 else{
                 $scope.removeLoadingIndicator();
                 }
                 break;*/
                // The following step will not be seen, but storage set up for the user automatically.
                case BACKUP_STORAGE_WIZARD:
                    $scope.saveBackupStorageDetails($scope.selectedIDs, $scope.selectedGBsize);
                    $scope.getForumAccountDetails();
                    break;
            }
        };


        // Wizard finish functionality.
        $scope.finishedWizard = function () {
            /* saveForumDetails();
             perform storage steps here.
             getBackupStorageDetails($scope,quickStartFactory, finalize);
             $('#loadingWizard').removeClass("hidden");
             $('.mainWizardDiv').addClass("hidden");
             setTimeout(function(){
             $('#loading').hide();
             $scope.user.showSetupWizFlag = false;
             setQuickSetupWizardFlag($scope,$http); //Call function for setting QuickSetupWizardFlag in backend.

             var page = angular.element(document.getElementById("app"));
             var injector = page.injector();
             var route = injector.get('$route');
             route.reload();
             },3000);
             */
        };

        // For Saving date and time field wizard data
        $scope.saveDateAndTimeDetails = function saveDateAndTimeDetails() {
            if (checkWizardValidation(wizardTitle)) {
                var dateTimeWizardData = {};
                var ntpServerObj = {};
                if ($scope.dateTimeWizardObj.ntpServerEnabled) {
                    dateTimeWizardData.tz = wizardform.timeZoneHide.value;
                    ntpServerObj.enabled = $scope.dateTimeWizardObj.ntpServerEnabled;//Boolean
                    ntpServerObj.servers = [];
                    for (i = 0; i < $scope.dateTimeWizardObj.backendNTPServers.length; i++) {
                        if ($scope.dateTimeWizardObj.ntpServerSelect !== $scope.dateTimeWizardObj.backendNTPServers[i]) {
                            ntpServerObj.servers.push($scope.dateTimeWizardObj.backendNTPServers[i]);
                        }
                    }
                    if ($scope.dateTimeWizardObj.ntpServerSelect !== '') {
                        ntpServerObj.servers.push($scope.dateTimeWizardObj.ntpServerSelect);
                    }
                    dateTimeWizardData.ntp = ntpServerObj;
                } else {
                    var dateData = wizardform.date.value;
                    var dateDataField = dateData.split("/");
                    dateTimeWizardData.year = parseInt(dateDataField[2]);
                    dateTimeWizardData.month = parseInt(dateDataField[0]);
                    dateTimeWizardData.day = parseInt(dateDataField[1]);


                    var timeData = wizardform.time.value;
                    var timeDataField = timeData.split(":");
                    dateTimeWizardData.hour = parseInt(timeDataField[0]);
                    dateTimeWizardData.minute = parseInt(timeDataField[1]);
                    dateTimeWizardData.second = parseInt(timeDataField[2]);
                    dateTimeWizardData.tz = wizardform.timeZoneHide.value;
                    ntpServerObj.enabled = $scope.dateTimeWizardObj.ntpServerEnabled;//Boolean
                    dateTimeWizardData.ntp = ntpServerObj;

                }
                load = PHD.showLoadingIndicator("body", true, "Saving...");
                var url = "/api/date-time/";
                quickStartFactory.async('put', url, 1, dateTimeWizardData, $analytics, "Configure Date and Time").then(function (data) {
                    console.log(isError);
                    PHD.hideLoadingIndicator(load);
                    if (!isError) $rootScope.$root.$broadcast("nextBtnClick");
                });
            }
        };

        // For Saving date and time field wizard data
        function saveTimeZone($rootScope, $scope, quickStartFactory, selectedTZ) {
            var dateTimeWizardData = {};
            dateTimeWizardData.tz = selectedTZ;
            var url = "/api/date-time/";
            var ntpServerObj = {};
            ntpServerObj.enabled = $scope.dateTimeWizardObj.ntpServerEnabled;//Boolean
            dateTimeWizardData.ntp = ntpServerObj;
            quickStartFactory.async('put', url, 1, dateTimeWizardData, $analytics, "Configure Timezone").success(function (data) {
                $rootScope.loadDateTimeWizardData();
            });
        }

        $scope.getHostNamedetails = function () {
            if (checkWizardValidation(wizardTitle)) {
                //Host name and Password
                $scope.model = {};
                var arr = [];
                var domainNameforUI = "";
                var url = "/api/hostname/";
                /* Call for retriving detail of Host name and Passwr*/
                quickStartFactory.async('get', url, 1).then(function (resultData) {
                    if (resultData.data != undefined || resultData.data != null || resultData.data == "") {
                        $scope.model.host_name = resultData.data.data.name;
                        if (resultData.data.data.long_name !== undefined && resultData.data.data.long_name !== null && resultData.data.data.long_name != "") {
                            var domainNameFromServer = resultData.data.data.long_name.split(".");
                            console.log(domainNameFromServer + " >>> Before remove")
                            domainNameFromServer.splice(0, 1);
                            console.log(domainNameFromServer + " After Remove");

                            for (var i = 0; i < domainNameFromServer.length; i++) {
                                arr.push(domainNameFromServer[i]);
                            }
                            domainNameforUI = arr.join(".");
                            console.log(domainNameforUI + " :: domain ");
                            $scope.model.domain_name = domainNameforUI;
                        } else {
                            $scope.model.domain_name = "";
                        }
                    }
                });
            }
        }

        /* Function to modify details of Hostname and Password */
        $scope.saveHostNameAndPasswordDetails = function () {
            var putHostnameURL = "/api/hostname/"; // URL for Hostname and Domain fields.
            var putPasswordURL = "/api/users/1/"; // URL for Password Modification

            /* Hostname and Domain name modification >> start coding*/
            var hostModel = {};
            var domain = $scope.model.domain_name;
            if (domain !== undefined && domain !== null && domain !== "") {
                hostModel.long_name = $scope.model.host_name + "." + $scope.model.domain_name;
            }
            hostModel.name = $scope.model.host_name;

            var setHostPassword = {};
            // Get the current password, either from the user, if set, or the default.
            setHostPassword.current_password = ($rootScope.passwd !== undefined) ? $rootScope.passwd : DEFAULT_PW;
            setHostPassword.password = $scope.model.root_password;//New Password set.
            console.log("validation:::" + checkWizardValidation(wizardTitle));
            if (checkWizardValidation(wizardTitle)) {// Checking validation.
                /* Factory to Save Hostname and Domain name */
                /* quickStartFactory.async('put',putHostnameURL,1,hostModel).then(function(data) {
                 console.log(data);
                 }); */
                load = PHD.showLoadingIndicator("body", true, "Saving...");

                var params = {};
                if (enviornmentID != 0) {
                    params.sid = enviornmentID;
                }
                $http({
                    method: 'put',
                    url: putHostnameURL,
                    params: params,
                    data: JSON.stringify(hostModel)
                }).success(function (data, status, headers) {
                    quickStartFactory.async('put', putPasswordURL, 1, setHostPassword, $analytics, "Set Hostname and Password").then(function (data) {
                        $rootScope.passwd = setHostPassword.password;
                        PHD.hideLoadingIndicator(load);
                        load = null;
                        if (!isError) $rootScope.$root.$broadcast("nextBtnClick");
                    });
                }).error(function (response) {
                    isError = true;
                    PHD.hideLoadingIndicator(load);
                    load = null;
                    window.PHD.throwError({"result": [{"message": gettext(response.result[0].message)}]});

                });

            }
        }

        function findRecipient(recipientEmail) {
            if (listRecipients != null && listRecipients.length == 0) {
                return null;
            }
            var fetchedRecipient = null;
            for (var i = 0; i < listRecipients.length; i++) {
                if (recipientEmail !== undefined) {
                    if (listRecipients[i].email === recipientEmail) {
                        fetchedRecipient = listRecipients[i];
                        return fetchedRecipient;
                        break;
                    }
                }
            }
            return fetchedRecipient;
        }

        var listRecipients = [];
        /* var recipient = {
         email:"",
         system:false,
         job:false,
         failure:false
         }; */

        $scope.getEmailConfig = function () {
            $scope.model.confirm_password_n = "";
            $scope.model.password_n = "";
            var url = "/api/mail-config/";
            quickStartFactory.async('get', url, 1).then(function (emailData) {

                $scope.model.smtp_server = emailData.data.data.smtp;
                if ($scope.model.smtp_server !== "" && $scope.model.smtp_server !== undefined && $scope.model.smtp_server != null) {
                    $scope.modelReporting.emailReporting = true;
                    $('#smtp_server').removeAttr('disabled');
                    $('#add_recipient_btn').removeAttr('disabled');
                    $('.removeBtn').removeAttr('disabled');
                    isReportingChecked = true;
                } else {
                    $scope.modelReporting.emailReporting = false;
                    $('#smtp_server').attr('disabled', 'disabled');
                    $('#add_recipient_btn').attr('disabled', 'disabled');
                    $('.removeBtn').attr('disabled', 'disabled');
                    isReportingChecked = false;
                }

                $scope.model.user_name = emailData.data.data.user; //setting data for user name.
                $scope.modelReporting.email_auth = emailData.data.data.authinfo; //setting data for auth info

                if ($scope.modelReporting.email_auth) {
                    $('#email_user_name').removeAttr('disabled');
                    $('#email_password').removeAttr('disabled');
                    $('#email_confirm_pwd').removeAttr('disabled');
                } else {
                    $('#email_user_name').attr('disabled', 'disabled');
                    $('#email_password').attr('disabled', 'disabled');
                    $('#email_confirm_pwd').attr('disabled', 'disabled');
                }

                if (emailData.data.data.bp !== undefined && emailData.data.data.bp != "" && emailData.data.data.bp !== null) {

                    var systemList = emailData.data.data.bp;
                    var systemRecipients = systemList.split(" ");

                    angular.forEach(systemRecipients, function (systemRecipient, key) {
                        var fetchedRecipient = findRecipient(systemRecipient);
                        if (fetchedRecipient != null) {
                            fetchedRecipient.system = true;
                        } else {
                            fetchedRecipient = {
                                email: systemRecipient,
                                system: true,
                                job: false,
                                failure: false
                            };
                            listRecipients.push(fetchedRecipient);
                        }
                    });
                }
                //setting info of Schedule/JOB
                if (emailData.data.data.schedule !== undefined && emailData.data.data.schedule != "" && emailData.data.data.schedule !== null) {
                    var scheduleList = emailData.data.data.schedule;
                    var scheduleRecipients = scheduleList.split(" ");
                    // use for each whenever you dont want index
                    angular.forEach(scheduleRecipients, function (scheduleRecipient, key) {
                        var fetchedRecipient = findRecipient(scheduleRecipient);
                        if (fetchedRecipient != null) {
                            fetchedRecipient.job = true;
                        } else {
                            fetchedRecipient = {
                                email: scheduleRecipient,
                                system: false,
                                job: true,
                                failure: false
                            };
                            listRecipients.push(fetchedRecipient);
                        }
                    });
                }
                //setting info of failure.
                if (emailData.data.data.failure !== undefined && emailData.data.data.failure != "" && emailData.data.data.failure !== null) {
                    var failureList = emailData.data.data.failure;
                    var failureRecipients = failureList.split(" ");
                    // use for each whenever you dont want index
                    angular.forEach(failureRecipients, function (failureRecipient, key) {
                        var fetchedRecipient = findRecipient(failureRecipient);

                        if (fetchedRecipient != null) {
                            fetchedRecipient.failure = true;
                        } else {
                            fetchedRecipient = {
                                email: failureRecipient,
                                system: false,
                                job: false,
                                failure: true
                            };
                            listRecipients.push(fetchedRecipient);
                        }
                    });
                }
            });
            $scope.listRecipients = listRecipients;
        }//End retriving email config method


        //Updating all details email config.
        $scope.saveEmailWizardDetails = function (isReportingChecked) {

            var emailObject = {};
            var modelReporting = {};
            var emailPutURL = "/api/mail-config/";
            var failureDetails = "";
            var systemDetails = "";
            var jobDetails = "";

            if (isReportingChecked) {//if email reporting checkbox is checked.

                if (checkWizardValidation(wizardTitle)) {// Checking validation.

                    if (isChecked) {//if Auth ifo checkbox is checked
                        emailObject.user = $scope.model.user_name;
                        emailObject.password = $scope.model.password_n;
                    }
                    emailObject.smtp = $scope.model.smtp_server;//assign value for smtp from UI.
                    emailObject.authinfo = isChecked; // assign auth info from UI.

                    angular.forEach($scope.listRecipients, function (recipientsInfo, key) {

                        if (recipientsInfo.failure === "true" || recipientsInfo.failure == true) {
                            failureDetails = failureDetails + recipientsInfo.email + " ";
                        }
                        if (recipientsInfo.job === "true" || recipientsInfo.job === true) {
                            jobDetails = jobDetails + recipientsInfo.email + " ";
                        }
                        if (recipientsInfo.system === "true" || recipientsInfo.system === true) {
                            systemDetails = systemDetails + recipientsInfo.email + " ";
                        }
                    });

                    emailObject.bp = systemDetails;
                    emailObject.schedule = jobDetails;
                    emailObject.failure = failureDetails;

                    load = PHD.showLoadingIndicator("body", true, "Saving...");

                    var params = {};
                    if (enviornmentID != 0) {
                        params.sid = enviornmentID;
                    }

                    $analytics && $analytics.eventTrack('Configure Email', {
                        category: 'Configure',
                        label: 'Quick Start'
                    });
                    $http({
                        method: 'put',
                        url: emailPutURL,
                        params: params,
                        data: JSON.stringify(emailObject)
                    }).success(function (data, status, headers) {
                        PHD.hideLoadingIndicator(load);
                            $scope.getBackupStorageDetails(finalize);
                    }).error(function (response) {
                        isError = true;
                        PHD.hideLoadingIndicator(load);
                        load = null;
                        window.PHD.throwError({"result": [{"message": gettext(response.result[0].message)}]});
                    });
                }

            } else {
                $scope.getBackupStorageDetails(finalize);
                //else $scope.getOptimizerWizard();
            }
        };

        /*
         TODO when Auto Tune is enabled
         Go to the Optimize Settings screen and get the Backup Storage Details
         */
        /*  $scope.getOptimizerWizard = function () {

         //checking validation
         console.log("validation:::" + checkWizardValidation(wizardTitle));
         if (checkWizardValidation(wizardTitle)) {
         PHD.hideLoadingIndicator(load);
         load = null;
         $('#moveDatabase').addClass("hidden");
         if (!isError) $rootScope.$root.$broadcast("nextBtnClick");
         }
         };*/

        $scope.getBackupStorageDetails = function (follow_function) {
            //var $backupStorageGrid = $("#backupStorageGrid"); //,
            //load = PHD.showLoadingIndicator($backupStorageGrid);
            var url = '/api/storage/available-disks/';
            quickStartFactory.async('get', url, 1, "").then(function (resultData) {
                $scope.storageDataArray = [];
                var storageData = resultData.data.attached_disks;
                // one disk only;
                if (storageData.length > 0) {
                    $scope.storageDataArray.push(storageData[0]);
                }
                if (follow_function != undefined) {
                    follow_function();
                }
                /*for (var i=0; i<storageData.length;i++)
                 {
                 $scope.storageDataArray.push(storageData[i]);
                 if (follow_function != undefined) {
                 follow_function();
                 }
                 }*/
                //PHD.hideLoadingIndicator(load);
            });

        };

        function finalize() {
            var disk = $scope.storageDataArray[0];
            if (disk !== undefined && disk.name !== undefined) {
                $scope.saveBackupStorageDetails(disk.name, 150);
            } else {
                PHD.hideLoadingIndicator(load);
                load = null;
                $scope.removeLoadingIndicator();
            }
        }


        $scope.removeLoadingIndicator = function () {
            $('#loadingWizard').removeClass("hidden");
            $('.mainWizardDiv').addClass("hidden");
            setTimeout(function () {
                $('#loading').hide();
                $scope.user.showSetupWizFlag = false;
                $rootScope.globalPreference.showSetupWizard = false;
                $scope.showMoveDatabase = true;
                setQuickSetupWizardFlag($scope, $http); //Call function for setting QuickSetupWizardFlag in backend.
                $rootScope.enableTimers();
                // lmc - brute force; turn off the tour, wait to reload so it will center.
                $rootScope.user.showTour = false;
                setTimeout(function () {
                    if ($scope.storageError === undefined) {
                        $rootScope.user.showTour = true;
                    }
                    else if ($scope.storageError !== undefined && $scope.storageError === true) {
                        $rootScope.user.showTour = false;
                    }
                    var page = angular.element(document.getElementById("app"));
                    var injector = page.injector();
                    var route = injector.get('$route');
                    route.reload();
                }, 250);
            }, 3000);
        };

        $scope.saveBackupStorageDetails = function (internalStoreNamelist, totalDiskSize) {
            var postBackupStoreURL = "/api/storage/";
            if (internalStoreNamelist != undefined) {
                disks.internal_name = internalStoreNamelist.toString();
            }

            var backupStoreData = {};
            backupStoreData.name = "_Stateless";    // Always use this name.
            backupStoreData.build_filesystem = 1;	// Use this for "init".
            backupStoreData.type = 5;               // Always use added internal, type 5.
            backupStoreData.usage = "stateless";    // Always usage "stateless"
            backupStoreData.properties = disks;
            console.log(backupStoreData);
            if (checkWizardValidation(wizardTitle)) {// Checking validation.
                console.log("in valid");
                load = PHD.showLoadingIndicator("body", true, "Saving...");
                quickStartFactory.async('post', postBackupStoreURL, 1, backupStoreData, $analytics, "Configure Storage")
                    .then(function () {
                        PHD.hideLoadingIndicator(load);
                        load = null;
                        var ir_url = "/api/storage/ir/";
                        var disk = $scope.storageDataArray[0];
                        var size_GB = disk.mb_size / 1024;
                        var ir = Math.round(size_GB * 0.02);  // default to 2% in GB.
                        var obj = {};
                        obj.allowed = ir;
                        quickStartFactory.async('put', ir_url, 1, obj); // $analytics, "Configure IR Space");
                        $rootScope.tourHostDisabled = false; //on successful storage add, remove storage link from tour
                        $scope.removeLoadingIndicator();
                    })
                    .catch(function () {
                        $scope.removeLoadingIndicator();
                    })
            }
        };

        $scope.getForumAccountDetails = function () {

            //if(checkWizardValidation(wizardTitle)){
            //Host name and Password
            //$scope.model={};
            var url = "/api/forum/users/1/";
            /* Call for retriving detail of Forum account details*/
            quickStartFactory.async('get', url, 1).then(function (accData) {
                if (accData.data !== undefined && accData.data.data != undefined && accData.data[0] != undefined) {
                    $scope.model.forum_acccount_email = accData.data.data[0].credentials.username;
                }
            });
            //}
        }


        $scope.saveForumDetails = function () {
            var url = "/api/forum/users";

            var forumAcData = {};
            forumAcData.forum_username = $scope.model.forum_acccount_email;
            forumAcData.forum_password = $scope.model.forum_account_password;

            console.log(forumAcData);
            if (checkWizardValidation(wizardTitle)) {// Checking validation.
                console.log(forumAcData);
                quickStartFactory.async('post', url, 1, forumAcData, $analytics, "Create Forum Account").then(function () {
                    console.log(forumAcData);
                    console.log("save successfully");
                });
            }
        }


        $scope.iconHelp = function () {
            var div = document.getElementById('forumAccountModel.html');
            $(div).dialog({
                modal: true,
                draggable: true,
                resizable: true,
                width: 325,
                height: 250,
                dialogClass: 'ui-dialog-osx',
                buttons: {
                    "Close": function () {
                        $(this).dialog("close");
                    }
                }
            });
        }
    }]);


//function for saving EULA Flag in backend. 
function saveEulaFlag($scope, $rootScope, $http) {
    console.log($scope.user.name);
    $url = '/api/preferences/' + $scope.user.name + '/';
    var eulaFlagDataObj = {};
    //set EULA Flag.
    eulaFlagDataObj.show_eula = "false";
    $http({
        method: 'put',
        url: $url,
        data: JSON.stringify(eulaFlagDataObj)
    }).success(function (data, status, headers) {
    }).error(function (data, status, headers) {
    })

    setStorage($rootScope, $scope);

}

//function for saving QuickSetupWizardFlag in backend.
function setQuickSetupWizardFlag($scope, $http) {
    $url = '/api/preferences/' + $scope.user.name + '/';
    var quickStartPutDataObj = {};
    //set quickSetupWizardFlag
    quickStartPutDataObj.show_setup_wizard = "false";

    $http({
        method: 'put',
        url: $url,
        data: JSON.stringify(quickStartPutDataObj)
    })
        .success(function (data, status, headers) {
        }).error(function (data, status, headers) {
    })
}
function wizardTimeFormat(time) {
    if (time.charAt(1) == '') {
        time = "0" + time;
        return time;
    }
    return time;
}

function setStorage($rootScope, $scope) {
    console.log($rootScope.identity);
    if ($rootScope.identity === "") {
        var url = "/api/systems/identity";
        var obj = {};
        obj.Identity = "DPU";               //set as dpu explicitly
        obj.force = 1;
        obj = JSON.stringify(obj);
        var resp = PHD.Ajax.put(url, obj);
        resp.done(function (data) {
            // self.$form.trigger("formsubmit", [data, self.$form, self]);
            var result = data.result[0];
            if (result !== undefined) {
                if (parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                    console.log("SUCCESS");
                } else if (parseInt(result.code) === AJAX_RESULT_ERROR) {
                    console.log("FAILURE");
                    PHD.throwError(data);
                }
            }
        });
    }
    else if ($rootScope.identity !== "DPU") {
        var confirm = PHD.confirmDialog(
            "<p>" + gettext("This appliance is configured as a backup-copy target.") + "<br>" +
            gettext("Continuing with this wizard will configure this appliance as a backup appliance.") + "<br>" +
            gettext("Do you wish to continue?") + "</p>" +
            "<p>" + gettext("(If you cancel, you will not be able to continue with this setup wizard and will be able to use the legacy UI only)") + "</p>",
            {title: gettext("Information")}
        );

        confirm.done(function () {
            var url = "/api/systems/identity";
            var obj = {};
            obj.Identity = "DPU";               //set as dpu explicitly
            obj.force = 1;
            obj = JSON.stringify(obj);
            var resp = PHD.Ajax.put(url, obj);
            resp.done(function (data) {
                // self.$form.trigger("formsubmit", [data, self.$form, self]);
                var result = data.result[0];
                if (result !== undefined) {
                    if (parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                        console.log("SUCCESS");
                    } else if (parseInt(result.code) === AJAX_RESULT_ERROR) {
                        console.log("FAILURE");
                        PHD.throwError(data);
                    }
                }
            });
        });

        confirm.fail(function () {
            $("#confirm_logout_legacy_dialog").dialog({
                modal: true,
                buttons: {
                    "Log out": function () {
                        $(this).dialog("close");
                        $scope.user.logout();
                    },
                    "Open legacy interface": function () {
                        $(this).dialog("close");
                        var link = "https://" + $scope.hostURL + "/recoveryconsole/";
                        var switchInterface = $('<form></form>');
                        switchInterface.attr('action', link);
                        switchInterface.attr('method', 'post');
                        switchInterface.attr('target', '_blank');
                        // append to body (required by some browsers.
                        switchInterface.appendTo('body').submit();
                        $scope.user.logout();
                    }

                }
            });
        });
    }

    var vc = {};
    vc.allowed = 0;

    var ir = {};
    ir.allowed = 2;

    var d2d = {};
    var $D2Dsize;

    if ($rootScope.isRecoverySeries) {

        var tokenArray = $rootScope.featureString.split(',');
        tokenArray.forEach(function (param) {
            var newTokenArray = param.split('=');
            if (newTokenArray.length > 0) {
                switch (newTokenArray[0]) {
                    case "D2D":
                        var $temp = newTokenArray[1].split("G");
                        $D2Dsize = parseInt($temp[0]);
                        break;
                }
            }
        });
        if (!isNaN($D2Dsize)) {
            d2d.allowed = $D2Dsize - ir.allowed;             //D2d will be total size of device minus IR size
        }
    }
    else {
        d2d.allowed = 0;
    }

    var url = "/api/storage/vc";
    obj = JSON.stringify(vc);
    var resp = PHD.Ajax.put(url, obj);
    resp.done(function (data) {
        // self.$form.trigger("formsubmit", [data, self.$form, self]);
        var result = data['allowed'];
        if (result !== undefined) {
            console.log("SUCCESS");
        } else {
            console.log("FAILURE");
            PHD.throwError(data);
        }
    });

    url = "/api/storage/ir";
    obj = JSON.stringify(ir);
    var resp = PHD.Ajax.put(url, obj);
    resp.done(function (data) {
        // self.$form.trigger("formsubmit", [data, self.$form, self]);
        var result = data['allowed'];
        if (result !== undefined) {
            console.log("SUCCESS");
        } else {
            console.log("FAILURE");
            PHD.throwError(data);
        }
    });

    url = "/api/storage/d2d";
    obj = JSON.stringify(d2d);
    var resp = PHD.Ajax.put(url, obj);
    resp.done(function (data) {
        // self.$form.trigger("formsubmit", [data, self.$form, self]);
        var result = data['allowed'];
        if (result !== undefined) {
            console.log("SUCCESS");
        } else {
            console.log("FAILURE");
            PHD.throwError(data);
        }
    });

}

