angular.module('searchFLRModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','ngGrid','ui.bootstrap','inventory','checklist-model','ui.grid.selection'])
.directive('angularDatepicker', function ($parse) {
    return function (scope, element, attrs, controller) {
        var ngModel = $parse(attrs.ngModel);
        $(function(){
            element.datepicker({
               showOn: "both",
                buttonText: '<img src="assets/images/calendar.png" width="24" height="24">',
                dateFormat: DATE_FORMAT,
                onSelect:function (dateText, inst) {
                    scope.$apply(function(scope){
                        // Change binded variable
                        ngModel.assign(scope, dateText);
                    });
                }
            });
        });
    }
})
.directive('loading', function () {
      return {
        restrict: 'E',
        replace:true,
        template: '<span  class="loading" alt="Loading..."><i class="icon-restart icon-spin"></i></span>',
        link: function (scope, element, attr) {
              scope.$watch('loading', function (val) {
                  if (val)
                      $(element).show();
                  else
                      $(element).hide();
              });
        }
      }
  })
.directive('running', function () {
    return {
        restrict: 'E',
        replace:true,
        template: '<span style="padding-top:38%;display:block;width:80px;margin: 0 auto"><p style="font-size:1.4em"><translate>Searching...</translate></p><span class="loading" style="padding-left:20px"><i class="icon-restart icon-spin"></i></span></span>',
        link: function (scope, element, attr) {
            scope.$watch('running', function (val) {
                if (val)
                    $(element).show();
                else
                    $(element).hide();
            });
        }
    }
})
.filter('fixedDecimalPointTo2', function($filter) {
  return function(input) {
      return (input).toFixed(2);
  };
})
.controller('searchFLRController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics',
    'fileBrowserDialogService','sharedGridData','$protectService','inventorysvc','$timeout', 'rolesSvc', 'gettextCatalog',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,
             fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,$timeout,rolesSvc,gettextCatalog) {
        $scope.showgrid = false;
        $scope.sizeLimit = false;
        $scope.noRemote = false;
        $scope.showCheckError = false;
        $scope.noResults = false;
        $scope.showOptions = true;
        $scope.emptyString = false;
        $scope.invalidDate = false;
        $scope.emptyAsset = false;
        $scope.searchOption = {};
        $scope.recoverOption = {};
        $scope.searchOption.case = true;
        $scope.searchOption.expression = false;
        $scope.advance = {};
        $scope.advance.open = false;
        $scope.search = {};
        $scope.hideString = gettext("Hide");
        $scope.showString = gettext("Show");
        $scope.typeOptions = [
            {id: "0", name: gettextCatalog.getString("Backup")},
            {id: "1", name: gettextCatalog.getString("Backup Copy (Cold)")},
            {id: "2", name: gettextCatalog.getString("Backup Copy (Hot)")}
        ];
        $scope.checkId = true;
        $scope.gridSelectedItems = 0;
        $scope.nextValue = "Next";
        $scope.showSecondStep = true;
        $scope.ClientNameList = [];
        $scope.gridSelectedArray = [];
        $scope.columnDefinitions = [[
            // Backups search results
            /*{ field: 'id', displayName:"Path",width:"**" ,cellTooltip: true},*/
            {
                field: 'name',
                displayName: gettext("Filename"),
                cellTooltip: function (row, col) {
                    return 'Path: ' + row.entity.id;
                },
                headerCellFilter: 'translate'
            },
            {
                field: 'date_string',
                displayName: gettext("File Date"),
                cellTooltip: true,
                headerCellFilter: 'translate',
                width: "20%"
            },
            {
                field: 'backup_id',
                displayName: gettext("Backup ID"),
                visible: true,
                headerCellFilter: 'translate',
                width: "10%"
            },
            {
                field: 'backup_date',
                displayName: gettext("Backup Date"),
                cellTooltip: true,
                headerCellFilter: 'translate',
                width: "20%"
            },
            {
                field: 'size',
                displayName: gettext("Size (KB)"),
                cellFilter: 'fixedDecimalPointTo2',
                cellTooltip: true,
                width: "10%",
                headerCellFilter: 'translate',
                cellClass: 'ui-grid-numerical'
            }
        ], [
            // Cold Backup Copy Search results
            {
                field: 'filename',
                displayName: gettext("Path"),
                headerCellFilter: 'translate',
                cellTooltip: true
            },
            {
                field: 'archive_date',
                displayName: gettext("Archive Date"),
                cellTooltip: true,
                headerCellFilter: 'translate',
                width: "20%"
            },
            {
                field: 'date',
                displayName: gettext("Date"),
                cellTooltip: true,
                headerCellFilter: 'translate',
                width: "20%"
            },
            {
                field: 'size',
                displayName: gettext("Size (KB)"),
                cellFilter: 'fixedDecimalPointTo2',
                cellTooltip: true,
                headerCellFilter: 'translate',
                width: "10%",
                cellClass: 'ui-grid-numerical'
            },
            {
                field: 'media_serial',
                displayName: gettext("Serial #"),
                headerCellFilter: 'translate',
                cellTooltip: true
            },
            {
                field: 'id',
                displayName: gettext("BackupCopyId"),
                headerCellFilter: 'translate',
                visible: false
            }
        ], [
            // Hot Backup Copy on Target Search Results (same as Backups)
            {
                field: 'name',
                displayName: gettext("Filename"),
                headerCellFilter: 'translate',
                cellTooltip: function (row, col) {
                    return 'Path: ' + row.entity.id;
                }
            },
            {
                field: 'date_string',
                displayName: gettext("File Date"),
                cellTooltip: true,
                headerCellFilter: 'translate',
                width: "20%"
            },
            {
                field: 'backup_id',
                displayName: gettext("Backup ID"),
                visible: true,
                headerCellFilter: 'translate',
                width: "10%"
            },
            {
                field: 'type',
                displayName: "type",
                visible: false
            },
            {
                field: 'backup_date',
                displayName: gettext("Backup Date"),
                cellTooltip: true,
                headerCellFilter: 'translate',
                width: "20%"
            },
            {
                field: 'size',
                displayName: gettext("Size (KB)"),
                cellFilter: 'fixedDecimalPointTo2',
                cellTooltip: true,
                headerCellFilter: 'translate',
                width: "10%",
                cellClass: 'ui-grid-numerical'
            }
        ]
        ];
        $scope.loading = true;
        $scope.selectedId = 0;
        $scope.MAX_TO_SELECT_ALL = 1000;
        $scope.MAX_FILE_SIZE = 2000000000;
        /*set Defaults for recoverOptions*/
        $scope.recoverOption.target = {};
        $scope.recoverOption.target.flat = false;
        $scope.recoverOption.target.non_destructive = true;
        $scope.recoverOption.target.newer = false;
        $scope.recoverOption.target.today = false;
        $scope.recoverOption.target.unix = true;
        $scope.recoverOption.target.directory = '';
        $scope.recoverOption.before_cmd = '';
        $scope.recoverOption.after_cmd = '';
        $scope.synthCapable = "files";
        $scope.exclusionData = [];
        $scope.ckeckedIdList = [];
        $scope.excludeFlrOptionsColumnDefs = [
            {
                field: 'name',
                displayName: '',
                width: 300
            },
            {
                field: 'delete',
                displayName: '',
                width: 30,
                cellTemplate: '<div><img src="assets/images/delete.png" style="height:14px;cursor:pointer;padding-left:15px;" ng-click="deleteRow(row.entity)"/></div>'
            }];
        $scope.excludeFlrOptions = {
            columnDefs: $scope.excludeFlrOptionsColumnDefs, data: 'exclusionData', enableHorizontalScrollbar: 0, headerRowHeight: 0
        };

        $scope.preSetArray = [];
        $scope.preSetExclusions = function(){
            $scope.preSetArray = [];
            var suffixArray = rolesSvc.getSuffixArray($rootScope.user.role_recover_options);
            for (var j = 0; j < suffixArray.length; j++) {
                $scope.recoverOption.excludeText = suffixArray[j];
                $scope.addExcludeText();
                $scope.preSetArray.push(suffixArray[j]);
            }
            $scope.recoverOption.excludeText = "";
        };

        $scope.deleteRow = function (row) {
            if ($scope.preSetArray.indexOf(row.name) == -1) {
                var index = $scope.exclusionData.indexOf(row);
                $scope.exclusionData.splice(index, 1);
            } else {
                ngDialog.open({
                    dialogType: 'Error',
                    modelDialogId: 'recovery-blocked-dialog',
                    scope: $scope,
                    dialogMessage: row.name + " is a pre-set exclusion and cannot be removed.",
                    onConfirmOkButtonClick: 'onConfirmError()'
                });
            }
        };

        $scope.addExcludeText = function () {
            console.log($scope.recoverOption.excludeText);
            var obj = {name: String($scope.recoverOption.excludeText.trim())};
            var uniqueFlag = containsObject(obj, $scope.exclusionData);
            if (uniqueFlag != true && $scope.exclusionData != undefined) {
                if (obj.name !== "") {
                    $scope.exclusionData.push(obj);
                }
            }
            $(window).resize();
            $scope.recoverOption.excludeText = "";
            console.log($scope.exclusionData);
        }
        function containsObject(obj, list) {
            if (!angular.isUndefined(list)) {
                var i;
                for (i = 0; i < list.length; i++) {
                    if (list[i].name === obj.name) {
                        return true;
                    }
                }
            }
            return false;
        }

        $scope.changeNextTabSettings = function () {
            console.log($scope.searchOption.type);
            $scope.ClientNameList = [];
            $scope.loading = true;
            $scope.remote = false;
            var url = '';
            if ($scope.searchOption.type == 1) {
                $scope.nextValue = "Save";
                $scope.showSecondStep = false;
                url = '/api/assets/archive'
            } else if ($scope.searchOption.type == 2) {
                $scope.nextValue = "Save";
                $scope.showSecondStep = false;
                $scope.remote = true;
                url = '/api/clients/target-list'
            } else {
                $scope.nextValue = "Next";
                $scope.showSecondStep = true;
                url = '/api/assets'
            }
            if ($rootScope.user.role_scope !== undefined) {
                // Use role scope if set.
                url += '?use_role_scope=true';
            }
            $http({
                method: 'get',
                url: url
            }).success(function (data, status, headers) {
                $scope.loading = false;
                for (var i = 0; i < data.data.length; i++) {
                    if (data.data[i].name !== undefined) {
                        var Obj = {
                            name: data.data[i].name,
                            id: data.data[i].id,
                            sid: data.data[i].system_id,
                            client_os: data.data[i].os_type,
                            remote: $scope.remote,
                            view_name: (data.data[i].name + ' (' + data.data[i].system_name + ')')
                        };
                        $scope.ClientNameList.push(Obj);
                    }

                }
                $scope.searchOption.client = $scope.ClientNameList[0];
            }).error(function (data, status, headers) {
                $scope.loading = false;
                console.log(data);

            });
        };
        $scope.changeNextTabSettings();
        $scope.gridOptionsFLRSearch = {
            multiSelect: true,
            selectionRowHeaderWidth: 26,
            rowHeight: 28,
            enableFullRowSelection: true,
            gridMenuShowHideColumns: false,
            enableColumnMenus: false
        };
        $scope.toggleOptions = function (setValue) {
            if (setValue === undefined) {
                $scope.showOptions = !$scope.showOptions;
                $('#search-toggler').blur();
            } else {
                $scope.showOptions = setValue;
            }
            var newWidth = $scope.showOptions ? '400' : '800';
            angular.element(document.getElementById('searchResultsGrid')).css('width', newWidth + 'px');
        };
        $scope.toggleOptions(true);
        /*Post Data for FlR*/
        $scope.postDataforBackupCopyFLR=function(){
             var load = PHD.showLoadingIndicator("body", true, "Starting File Level Recovery...");
             var archive_id=$scope.gridSelectedArray[0].id;
             var backupCopyRestoreObj = {};
             backupCopyRestoreObj.archive_ids=archive_id;
             backupCopyRestoreObj.association = "dr";
             var includes_list = [];
             for (var i =0 ; i <  $scope.gridSelectedArray.length;i++){
                 includes_list[i] = $scope.gridSelectedArray[i].filename;
             }
             backupCopyRestoreObj.inclusions = includes_list;
             backupCopyRestoreObj.exclusions = [];
             backupCopyRestoreObj.restore_backup = true;
             backupCopyRestoreObj = JSON.stringify(backupCopyRestoreObj);
             url = "/api/restore/archive/files/?sid="+$scope.searchOption.client.sid;
             $http ({
            method: 'post',
            url : url,
            data: backupCopyRestoreObj
            }).success(function(data){
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                                    template: 'app/recover/filerecovery/searchFLR/viewJobs.html',
                                    scope: $scope,
                                    overlay:true,
                                    modelDialogId:'window-flr-view-jobs-dialog',
                                    ngDialogStyle:'width:82em; height:20em; left: 80px;'
                });
               
                //ngDialog.close('flr-search-dialog');

            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                })
            });
        };

        $scope.onConfirmError = function() {
            ngDialog.close("recovery-blocked-dialog");

        };

        $scope.postDataForHotBackupCopyFLR = function() {
            var load = PHD.showLoadingIndicator("body", true, "Starting File Level Recovery on the Target...");
            var backup_id = $scope.gridSelectedArray[0].backup_id;
            var restoreObj = {};
            restoreObj.backup_id = backup_id;
            var includes_list = [];
            var size_KB = 0;
            var dirList = [];
            for (var i =0 ; i <  $scope.gridSelectedArray.length;i++){
                includes_list.push($scope.gridSelectedArray[i].id);
                size_KB += $scope.gridSelectedArray[i].size;
                var dir = ($scope.gridSelectedArray[i].type === 'volume' || $scope.gridSelectedArray[i].type === 'directory');
                if (dir === true) {
                    dirList.push($scope.gridSelectedArray[i].name);
                     // UNIBP-12843 commenting out the code to restrict folder download
                     //PHD.hideLoadingIndicator(load);
                     //var message = 'Volumes or directories cannot be selected for recovery from the target.  Please uncheck ' + $scope.gridSelectedArray[i].name + '.';
                     //ngDialog.open({
                     //    dialogType: 'retry',
                     //    dialogMessage: message
                     //});
                     //// Get out, we can't restore...
                     //return;
                }
            }
            if (dirList.length > 0) {
                restoreObj.dir_list = dirList;
                restoreObj.backup_size = $scope.gridSelectedArray[0].backup_size;
            }
            restoreObj.includes = includes_list;
            restoreObj.excludes = [];
            restoreObj.before_cmd = '';
            restoreObj.after_cmd = '';
            var target = {};
            target.flat = false;
            target.non_destructive = false;
            target.newer = false;
            target.today = false;
            target.unix = true;
            restoreObj.target = target;
            restoreObj.client_id = 1; // get system client id.
            if ($scope.synthCapable === "synthesized-files") {
                restoreObj.synthesis = true;
            } else {
                restoreObj.synthesis = false;
            }
            restoreObj.size_KB = size_KB;
            var url = "/api/restore/target-full/?sid="+ 1;
            $http ({
                method: 'post',
                url : url,
                data: restoreObj
            }).success(function(data){
                PHD.hideLoadingIndicator(load);
                var jobID = data.id;
                ngDialog.open({
                    template: 'app/recover/filerecovery/searchFLR/viewTargetFileRecovery.html',
                    scope: $scope,
                    overlay:true,
                    name: 'MonitorFileRecovery',
                    data: {jobID: jobID, includes: includes_list},
                    modelDialogId:'flr-view-jobs-target-dialog',
                    ngDialogStyle:'width:64em; height:22em; left: 80px;'
                });

            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                })
            });
        };

        $scope.nextWizard = function($event){

            if(wizardTitle === gettextCatalog.getString("Search Files")){
                if( $scope.gridSelectedItems <= 0){
                    $scope.showCheckError=true;
                    return;
                }else{
                    var restoreBlocked = $scope.searchOption.client.client_os == 'iSeries';
                    if($scope.searchOption.type == 1){
                        if (restoreBlocked) {
                            var blockedOS = $scope.searchOption.client.client_os;
                            var message = "Selected files from " + blockedOS + " backup copies cannot be recovered using the web-based user interface.  " +
                                " To recover an " + blockedOS + " backup copy, click the 'Import to Source' button, then recover the imported backup " +
                                " using the menu-based console interface.";
                            ngDialog.open({
                                dialogType: 'Error',
                                modelDialogId: 'recovery-blocked-dialog',
                                scope: $scope,
                                dialogMessage: message,
                                onConfirmOkButtonClick: 'onConfirmError()'
                            });
                        } else {
                            $scope.postDataforBackupCopyFLR();
                        }
                    } else if ($scope.searchOption.type == 2) {
                        if (restoreBlocked) {
                            var blockedOS = $scope.searchOption.client.client_os;
                            var message = "Selected files from " + blockedOS + " backups on a target cannot be recovered using the web-based user interface.  " +
                                "To recover an " + blockedOS + " backup, log into the target and recover using the menu-based console interface.";
                            ngDialog.open({
                                dialogType: 'Error',
                                modelDialogId: 'recovery-blocked-dialog',
                                scope: $scope,
                                dialogMessage: message,
                                onConfirmOkButtonClick: 'onConfirmError()'
                            });
                        } else {
                            console.log("on target, next is check size and restore to temp location, then download");
                            $scope.postDataForHotBackupCopyFLR();
                        }
                    }else{
                        if (restoreBlocked) {
                            blockedOS = $scope.searchOption.client.client_os;
                            message = "Selected files from " + blockedOS + " backups cannot be recovered using the web-based user interface.  " +
                                " To recover an " + blockedOS + " backup, use the menu-based console interface.";
                            ngDialog.open({
                                dialogType: 'Error',
                                modelDialogId: 'recovery-blocked-dialog',
                                scope: $scope,
                                dialogMessage: message,
                                onConfirmOkButtonClick: 'onConfirmError()'
                            });
                        } else {
                            $scope.getRestoreFLRBackupTarget();
                            $rootScope.$broadcast("nextBtnClick");
                            console.log($scope.searchOption);
                            console.log('BackUp Coming Soon');
                        }
                    }
                    $scope.preSetExclusions();
                }
            }
            if(wizardTitle === gettextCatalog.getString("Recover Options")){
                var excludes_list = [];
                console.log($scope.exclusionData);
                for (var i =0 ; i <  $scope.exclusionData.length;i++){
                    excludes_list.push($scope.exclusionData[i].name);
                }
                var includes_list = [];
                for (var i =0 ; i <  $scope.gridSelectedArray.length;i++){
                    includes_list.push($scope.gridSelectedArray[i].id);
                }
                $scope.recoverOption.includes=includes_list;
                $scope.recoverOption.excludes=excludes_list;
                $scope.recoverOption.isPhysicalServer=true;
                $scope.recoverOption.client_id=$scope.recoverOption.targetClient.client_id;
                if ($scope.synthCapable === "synthesized-files") {
                    $scope.recoverOption.synthesis = true;
                } else {
                    $scope.recoverOption.synthesis = false;
                }
                console.log($scope.recoverOption);
                var url="/api/restore/full/?sid="+$scope.searchOption.client.sid;
                var load = PHD.showLoadingIndicator("body", true, "Starting File Level Recovery...");
                $http ({
                    method: 'post',
                    url : url,
                    data:  JSON.stringify($scope.recoverOption)

                }).success(function(data){
                    PHD.hideLoadingIndicator(load);
                    data = {};
                    data.result = [{'message': 'File level recovery job successfully started.'}];
                    var options = {};
                    if (window.location.href.indexOf("#/protect") !== -1 || window.location.href.indexOf("#/jobs") !== -1) {
                        options.buttons = [
                            {
                                text: gettext("View FLR"),
                                click: function () {
                                    window.location.href = "#/recover/#1";
                                    $(this).dialog("destroy").remove();
                                }
                            }
                        ];
                    }
                    PHD.throwNotice(data, options);
                    ngDialog.close('flr-search-dialog');
                }).error(function(response) {
                    PHD.hideLoadingIndicator(load);
                    ngDialog.open({
                        dialogType:'retry',
                        dialogMessage:response.result[0].message
                    })
                });
            }

        };
        $scope.getRestoreFLRBackupTarget = function(){
            console.log($scope.gridOptionsFLRSearch.data[0].backup_id);
            var backup_id=$scope.gridSelectedArray[0].backup_id;
            $scope.recoverOption.backup_id=$scope.gridSelectedArray[0].backup_id;
            var url="/api/restore/targets/?backup_id=" + backup_id + "&sid=" + $scope.searchOption.client.sid;
             $http({
                method: 'get',
                url   : url
            }).success(function(data, status, headers) {
                 $scope.targetNameList = data.targets;
                 $scope.recoverOption.targetClient =$scope.targetNameList[0];
                 
            }).error(function(data, status, headers) {
                
                
            });
            
        }
        $scope.viewJobs = function(){
            ngDialog.close('window-flr-view-jobs-dialog');
            ngDialog.close('flr-search-dialog');
            window.location.href = "#/jobs/#0";
            
            
        }
        $scope.closeDialog = function(){
            ngDialog.close('window-flr-view-jobs-dialog');
            ngDialog.close('flr-search-dialog');
            
        }
        $scope.clearSearchModel = function(){
            $scope.advance.open=false;
            $scope.showgrid = false;
            $scope.noResults =false;
            $scope.running = false;
            $scope.noRemote = false;
            $scope.invalidDate = false;
            $scope.searchOption={};
            $scope.searchOption.case=true;
            if ($scope.typeOptions !== undefined && $scope.typeOptions instanceof Array && $scope.typeOptions.length > 0) {
                $scope.searchOption.type = $scope.typeOptions[0].id;
            }
            $scope.changeNextTabSettings();
            $scope.search.name = undefined;
            $scope.search.start_date = undefined;
            $scope.search.end_date = undefined;
            // set this so the user cannot go to th next screen if a prior search had results.
            $scope.checkId = true;
        };

        $scope.handleRowSelection = function(row) {
            var rowId=($scope.searchOption.type == 0 || $scope.searchOption.type == 2) ? row.entity.backup_id : row.entity.id;
            var titleString=($scope.searchOption.type == 0) ? gettextCatalog.getString('Select files from one backup') :
                                                                gettextCatalog.getString('Select files from one backup copy');
            $scope.synthCapable = row.entity.synth_capable ? "synthesized-files":"files";
            if($scope.selectedId==0 || $scope.ckeckedIdList.length ==0){
                $scope.selectedId =rowId;
                $scope.checkId=false;
                $scope.ckeckedIdList.push(rowId);
                document.getElementById("save-Next-Button").title='';
            }
            if (row.isSelected){
                if ($scope.ckeckedIdList.indexOf(rowId) > -1){
                    $scope.showCheckError=false;
                }else{
                    $scope.checkId=true;
                    document.getElementById("save-Next-Button").title=titleString;
                    $scope.ckeckedIdList.push(rowId);
                }
            }else{
                if ($scope.ckeckedIdList.length > 1){
                    var newIDArray = [];
                    $scope.gridSelectedItems = $scope.gridApi.selection.getSelectedRows().length;
                    $scope.gridSelectedArray = $scope.gridApi.selection.getSelectedRows();
                    for (var i = 0; i < $scope.ckeckedIdList.length; i++){
                        if ($scope.inArray($scope.gridSelectedArray, $scope.ckeckedIdList[i])) {
                            newIDArray.push($scope.ckeckedIdList[i]);
                        }
                    }
                    $scope.ckeckedIdList = newIDArray;

                }
                if ( $scope.ckeckedIdList.length ==1 ){
                    $scope.checkId=false;
                    document.getElementById("save-Next-Button").title='';
                }else{
                    $scope.checkId=true;
                    document.getElementById("save-Next-Button").title=titleString;
                }
            }
            $scope.gridSelectedItems =$scope.gridApi.selection.getSelectedRows().length;
            $scope.gridSelectedArray=$scope.gridApi.selection.getSelectedRows();
            if($scope.gridSelectedItems==0){
                $scope.checkId=true;
                $scope.ckeckedIdList=[];
            }
        };

        $scope.inArray = function(selectedGrid, value){
            var i;
            var found = false;
            for ( i=0; i < selectedGrid.length; i++){
                if (selectedGrid[i].backup_id == value){
                    found = true;
                    break;
                }
            }
            return found;
        };

        $scope.gridOptionsFLRSearch.onRegisterApi = function(gridApi){
            //set gridApi on scope
            $scope.gridApi = gridApi;
            gridApi.selection.on.rowSelectionChanged($scope, $scope.handleRowSelection);
            gridApi.selection.on.rowSelectionChangedBatch($scope, function (rows) {
                rows.forEach($scope.handleRowSelection);
            });
        };

        $scope.loadBackupSearchData = function(pid , timestr){
            var pid =pid;
            var timestr =timestr;
            var url;
            if ($scope.searchOption.type == 2) {
                url ='/api/backups/target-search/'+pid+'/?sid='+$scope.searchOption.client.sid+'&timestr='+timestr + "&lang=" + $rootScope.userLanguageCode;
            } else {
                url ='/api/backups/search/'+pid+'/?sid='+$scope.searchOption.client.sid+'&timestr='+timestr  + "&lang=" + $rootScope.userLanguageCode;
            }
            $http({
                method: 'get',
                url   : url
            }).success(function(data, status, headers) {
                if(data.results instanceof Array){
                    $scope.running = false;
                    $scope.isRemote = data.remote !== undefined ? data.remote : false;
                    $scope.source_id = data.source_id !== undefined ? data.source_id : false;
                    $scope.setGridDataForBackup(data.results);
                }else{
                    if(data.results =='running'){
                        $timeout(function() {
                            $scope.loadBackupSearchData(pid,timestr);
                        }, 3000);
                    }else{
                        $scope.showgrid = false;
                        $scope.noResults=true;
                        $scope.running = false;
                    }
                }
            }).error(function(data, status, headers) {
                //$scope.noResults=true;
                //$scope.showgrid = false;
                $scope.running = false;
                var message = data.result[0].message;
                ngDialog.open({
                    dialogType:'retry',
                    scope: $scope,
                    modelDialogId:'backup-search-dialog',
                    dialogMessage: message
                });
            });
        };
        $scope.advanceOpen = function(){
            $scope.advance.open = !$scope.advance.open;
            if($scope.advance.open){
                $("#expandId-advaceSearch").removeClass("reportExpand");
                $("#expandId-advaceSearch").addClass("reportExpanded");
            }else{
                $("#expandId-advaceSearch").removeClass("reportExpanded");
                $("#expandId-advaceSearch").addClass("reportExpand");
            }
        }
        $scope.searchFLR = function(){
            $scope.noResults=false;
            if (rolesSvc.noDownloads($rootScope.user.role_recover_options)) {
                if ($scope.searchOption.type == 2) {
                    $scope.noRemote = true;
                    return;
                }
            }
            if($('#start_size_spinner_field').val() >= $scope.MAX_FILE_SIZE || $('#end_size_spinner_field').val() >= $scope.MAX_FILE_SIZE){
                $scope.sizeLimit=true; 
                return;   
            }
            var convertedStartTimestamp = DateTimeHandler.getUSDateTimestamp($rootScope.userLanguageCode, $scope.search.start_date);
            var convertedEndTimestamp = DateTimeHandler.getUSDateTimestamp($rootScope.userLanguageCode, $scope.search.end_date);

            if ($scope.searchOption.client === undefined) {
                $scope.emptyAsset = true;
                return;
            }

            $scope.searchOption.name=($scope.searchOption.expression)?$scope.search.regexName:$scope.search.name;
            if((typeof($scope.searchOption.name) === 'undefined' || $scope.searchOption.name == "") &&
                ((typeof($scope.search.end_date) === 'undefined' || isNaN(convertedEndTimestamp) || $scope.search.end_date === "") &&
                    (typeof($scope.searchOption.end_size) === 'undefined' || $scope.searchOption.end_size == null) &&
                    (typeof($scope.search.start_date) === 'undefined' || isNaN(convertedStartTimestamp) || $scope.search.start_date === "") &&
                    (typeof($scope.searchOption.start_size) === 'undefined' || $scope.searchOption.start_size == null)))  {
                $scope.emptyString = true;
                return;
            }

            if ((!angular.isUndefined($scope.search.start_date) && !($scope.search.start_date === "") && DateTimeHandler.dateNotValid($scope.search.start_date, $rootScope.userLanguageCode)) ||
                (!angular.isUndefined($scope.search.end_date) && !($scope.search.end_date === "") && DateTimeHandler.dateNotValid($scope.search.end_date, $rootScope.userLanguageCode))){
                $scope.invalidDate = true;
                return;
            }

            $scope.invalidDate = false;
            $scope.sizeLimit=false;
            $scope.noRemote = false;
            $scope.emptyString = false;
            $scope.emptyAsset = false;
            var url;

            $scope.showgrid = false;
            $scope.running = true;
            if ($scope.searchOption.type == 0) {
                url="/api/backups/search/?sid="+$scope.searchOption.client.sid+"&cid="+$scope.searchOption.client.id;
            } else if ($scope.searchOption.type == 1) {
                url="/api/archive/search/?sid="+$scope.searchOption.client.sid + "&lang=" + $rootScope.userLanguageCode;
            } else {
                url="/api/backups/target-search/?sid="+$scope.searchOption.client.sid+"&cid="+$scope.searchOption.client.id;
            }
            if(typeof($scope.search.start_date) !== 'undefined'){
                if($scope.searchOption.type == 0 || $scope.searchOption.type == 2){
                    $scope.searchOption.start_date = convertedStartTimestamp;
                }else{
                    $scope.searchOption.start_date = DateTimeHandler.getUSDateString($rootScope.userLanguageCode, $scope.search.start_date);
                }
            }
            if(typeof($scope.search.end_date) !== 'undefined'){
                if($scope.searchOption.type == 0 || $scope.searchOption.type == 2){
                    $scope.searchOption.end_date = convertedEndTimestamp;
                }else{
                    $scope.searchOption.end_date = DateTimeHandler.getUSDateString($rootScope.userLanguageCode, $scope.search.end_date);
                }
            }
            $scope.searchOption.client_name=$scope.searchOption.client.name;
            $scope.searchOption.id=$scope.searchOption.client.id;
            $scope.gridOptionsFLRSearch.data=[];
            $scope.gridOptionsFLRSearch.columnDefs=[];
            $scope.gridSelectedItems=0;
            $http({
                method: 'POST',
                url   : url,
                data  : JSON.stringify($scope.searchOption)
            }).success(function(data, status, headers) {
               
               
                if ($scope.searchOption.type == 0 || $scope.searchOption.type == 2){
                     $scope.loadBackupSearchData(data.pid,data.timestr);
                 }else{
                    $scope.running = false;
                    $scope.setGridDataForBackupCopy(data.files);
                     
                     
                 }
            }).error(function(data, status, headers) {
                 //$scope.showgrid = false;
                 //$scope.noResults=true;
                $scope.running = false;
                var message = data.result[0].message;
                ngDialog.open({
                    dialogType:'retry',
                    scope: $scope,
                    modelDialogId:'backup-search-dialog',
                    dialogMessage: message
                });
            });
        }
        $scope.setGridDataForBackupCopy = function(data){
            //var id=data[0].id;
            $scope.selectedId=0;
            $scope.ckeckedIdList=[];
            var dataArray=[];
            for (var i=0;i<data.length;i++){
                dataArray.push(data[i]);

            }
            if(dataArray.length >0){
                $scope.toggleOptions(false);
                $scope.showgrid = true;
                $scope.noResults=false;
                $scope.gridOptionsFLRSearch.columnDefs= $scope.columnDefinitions[$scope.searchOption.type];
                $scope.gridOptionsFLRSearch.data=dataArray;
                $scope.setEnableAllOrWarn(dataArray);
            }else{
                $scope.toggleOptions(true);
                $scope.gridSelectedItems=0;
                $scope.showgrid = false;
                $scope.noResults=true;
            }
        };
        $scope.setEnableAllOrWarn = function(results) {
            if (results.length > $scope.MAX_TO_SELECT_ALL) {
                $scope.gridOptionsFLRSearch.enableSelectAll = false;
                ngDialog.open({
                    dialogType:'Information',
                    scope: $scope,
                    modelDialogId: 'no-select-all-dialog',
                    dialogMessage:gettextCatalog.getString("Due to the large number of files that were found") +
                    " (" + results.length + ")," + " " +
                    gettextCatalog.getString( "you cannot click the top row to select all files at once.") + "  " +
                    gettextCatalog.getString("However, you can select one or more files individually to be restored."),
                    onConfirmOkButtonClick:'onConfirmNoSelectAll()'
                })
            } else {
                $scope.gridOptionsFLRSearch.enableSelectAll = true;
            }
        };
        $scope.onConfirmNoSelectAll = function() {
            ngDialog.close('no-select-all-dialog');
        };
        $scope.setGridDataForBackup = function(data){
            //var id=data[0].backup_id;
            $scope.selectedId=0;
            $scope.ckeckedIdList=[];
            var dataArray=[];
            for (var i=0;i<data.length;i++){
                dataArray.push(data[i]);

            }
            if(dataArray.length >0){
                $scope.toggleOptions(false);
                $scope.showgrid = true;
                $scope.noResults=false;
                $scope.gridOptionsFLRSearch.columnDefs= $scope.columnDefinitions[$scope.searchOption.type];
                $scope.gridOptionsFLRSearch.data=dataArray;
                $scope.setEnableAllOrWarn(dataArray);
            }else{
                $scope.toggleOptions(true);
                $scope.gridSelectedItems=0;
                $scope.showgrid = false;
                $scope.noResults=true;
            }
        }
        
}]);
