var virtual_id;
var wirMode;
var jobType;
var replicaValid;
var recovery_point;
var goLive = false;
var goAudit = false;
var sid;
var local_sid;
var virtualId = 0;
var replicaID = 0;
var virtualType = "";
var hypervisorType = "";
var mode = "";
var liveTime = "";
var backupUrl="";
var recoveryPointURL="";
var detailUrl = "";
var vmName ="";
var app_type = "";
var selectedBackup = {};
var selectedFLR = {};
var selectedNodeDataArray = [];
var selectedBackupsForMultipleRestore = {};


function processRecoverPage(PHD, window, $rootScope, $analytics, $scope, gettextCatalog) {
    var isWirJob = false;  
    var isReplicaJob = false;
    var tabs = [],
        initialTab = $.cookie("initial_tab_recover") || 0,
        currentTabIndex = 0,
        backupCatalog, backupFilter,
        pageRefresh = null,
        $backupCatalog = $("#recover-backup-table"),
        $backupFilter = $("#recover-backup-catalog-filter"),
        backupSelections,
        backupCatalogView = BACKUP_CATALOG_VIEW_VM,
        // lmc - change back to original (VM view)
        //backupCatalogView = BACKUP_CATALOG_VIEW_DATE,
        RECOVER_TAB_BACKUPS = 0,
        RECOVER_TAB_FLR = 1,
        RECOVER_TAB_IR = 2,
        RECOVER_TAB_REPLICAS = 3,       // 3 tabs on WIR page.
        DETAIL_TABLE_HEIGHT = 250,
        slugs = ['backups', 'flr', 'ir', 'replicas'],
        $flrTable = $("#recover-flr-table"),
        flrTreeTable,
        $flrTableMessage = $("#recover-flr-table-message"),
        $irTableMessage = $("#recover-ir-table-message");

    // lmc - add this.
    var RecoverTimer = $rootScope.RecoverTimer;

    var options = {};
    options[BACKUP_CATALOG_VIEW_VM] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: false, expandonselect: true},
        2: {multiselect: true, childselect: false}
    };
    options[BACKUP_CATALOG_VIEW_DATE] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: "all", expandonselect: true},
        2: {multiselect: true, childselect: false, expandonselect: true},
        3: {multiselect: true, childselect: false}
    };
    options[BACKUP_CATALOG_VIEW_BDS] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: "all", expandonselect: true},
        2: {multiselect: true, childselect: false, expandonselect: true},
        3: {multiselect: true, childselect: false}
    };

    options[BACKUP_CATALOG_VIEW_APPLIANCE] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: "all", expandonselect: true},
        2: {multiselect: true, childselect: false, expandonselect: true},
        3: {multiselect: true, childselect: false}
    };

    $(document).on("ajaxaborted ajaxtimeout", function () {
        if (pageRefresh !== null) {
            clearInterval(pageRefresh);
        }
    });

    $(document)
        .on("timertick.recoverpage", $.proxy(refreshPage, this));

    $(document)
        .on("uinav.dashboard", stopAll)
        .on("uinav.protect", stopAll)
        .on("uinav.jobs", stopAll)
        .on("uinav.configure", stopAll)
        .on("uinav.reports", stopAll);


    $backupFilter.on("needMoreData",function(event,ui) {
        updateCatalog(true);
    });

    // Allow users to manually refresh the catalog.
    $scope.refreshEnabled = true;

    function stopAll(event) {
        console.log("===>In Stop All: Recover Tab, event " + event.namespace);
        RecoverTimer.stop();
        $(document).off("uinav.dashboard", stopAll);
        $(document).off("uinav.protect", stopAll);
        $(document).off("uinav.jobs", stopAll);
        $(document).off("uinav.configure", stopAll);
        $(document).off("uinav.reports", stopAll);
        $(document).off("timertick.recoverpage");
    }

    function refreshPage(manual) {
        var manual = (manual === true),
            tab = tabs[currentTabIndex];
        if (manual) {
            tab.update(manual);
        } else {
            tab.update(false);
        }
    }

    function resizeTable() {
        this.adjustTableHeight(this.getAvailableVerticalSpace(".full-height"));
        this.adjustTableWidth();
    }

    function initTabs() {
        $(".page-tab.ui-tabs-panel").each(function (index) {
            tabs[index] = new RecoverTab(index, $(this));
            tabs[index].initButtons();

            if (index === RECOVER_TAB_BACKUPS) {
                initBackupsTab(tabs[index]);
            } else if (index === RECOVER_TAB_FLR) {
                initFLRTab(tabs[index]);
            } else if (index === RECOVER_TAB_IR) {
                initIRTab(tabs[index]);
            } else if (index === RECOVER_TAB_REPLICAS) {
                initIRTab(tabs[index]);
            }
        });

    }

    var IRFormatter = {
		type:function (value, row) {
			var icon_name="";
			var title="";
		 	if(value == "wir"){
			    icon_name = "instant-recover" ;	
				title= gettext("Windows Replica");
			}else if(value == "vm_ir"){
			    icon_name = "backup" ;
				title= gettext("VM Instant Recovery");
            }else if(value === VMWARE_REPLICA_JOB_TYPE){
		 	    icon_name = "backup";
		 	    title = "VM Replica";
			}else{
			    icon_name = "backup" ;
			    title=gettext("HV Instant Recovery");
			}
			var icon = '<i class="icon-uui-' + icon_name + ' icon-large" title="' + title + '"></i>';
                return icon;
		},
        alert: function (value, row) {
            var icon = "";
            if (value != "" && value != "--") {
                icon = '<i class="icon-warningsign icon-large" title="' + value + '"></i>';
                $('id_alert').show();
            } else {
                $('id_alert').hide();
            }
            return icon;
        }

    };

    var IRDetailsFormatter = {
        comment: function (value, row) {
            return '<span class="truncates item-name" title="' + value + '">' + value + '</span>';
        }
    };

    function initIRTab(tab) {
        tab.$details = tab.$panel.find(".job-detail").hide();

        tab.$sessionTable = tab.$panel.find("#ir-session-table");
        tab.$lastBackupTable = tab.$panel.find("#id_last_backup_table");
        tab.$pendingBackupTable = tab.$panel.find("#id_pending_backup_table");
        tab.$replicaLastBackupTable = tab.$panel.find("#id_replica_last_backup_table");
        tab.$replicaPendingBackupTable = tab.$panel.find("#id_replica_pending_backup_table");
        tab.$recoveryPointsTable = tab.$panel.find("#id_recovery_points_table");

        //tab.$jobTable = tab.$panel.find("#ir-session-jobs-table");

        tab.$selected = $();
        tab.selectedID = null;

        tab.$selectedJob = $();
        tab.selectedJobID = null;
        tab.rowData = null;

        tab.SessionTable = PHD.DataTable(tab.$sessionTable, {
            select: true,
            placeholder: getPlaceholderString(tab.index),
            sortable: true,
            integerIDs: false   //lmc - e.g., 65.ir
        }).registerFormatters(IRFormatter);

        tab.LastBackupTable = PHD.DataTable(tab.$lastBackupTable, {
            select: true,
            placeholder: gettext("There are no completed restores"),
            sortable: true,
            integerIDs: false
        });

        tab.PendingBackupTable = PHD.DataTable(tab.$pendingBackupTable, {
            select: true,
            placeholder: gettext("There are no pending restores"),
            sortable: true,
            integerIDs: false
        });

        tab.ReplicaLastBackupTable = PHD.DataTable(tab.$replicaLastBackupTable, {
            select: true,
            placeholder: gettext("There are no completed restores"),
            sortable: true,
            integerIDs: false
        });

        tab.ReplicaPendingBackupTable = PHD.DataTable(tab.$replicaPendingBackupTable, {
            select: true,
            placeholder: gettext("There are no pending restores"),
            sortable: true,
            integerIDs: false
        });

        tab.RecoveryPointsTable = PHD.DataTable(tab.$recoveryPointsTable, {
            select: true,
            placeholder: gettext("There are no recovery points"),
            sortable: true,
            integerIDs: false
        });

        /*tab.JobTable = PHD.DataTable(tab.$jobTable, {
            select: true,
            placeholder: gettext("There are no jobs to display"),
            sortable: false,
            cellClasses: [null, null, null, "long-text truncate"]
        }).registerFormatters(IRDetailsFormatter);*/

        tab.timestamp = 0;
        tab.inventoryTimestamp = 0;
        tab.inventoryOpen = false;

        tab.$recoveryPointsTable.on("rowselect", function(event, dbid, $row, DataTable, Datarow){
            recovery_point = DataTable.data[$row.context.sectionRowIndex].snap_id;
            tab.rowData = Datarow;
            if (wirMode === MODE_NEW || wirMode === MODE_HALTED || wirMode === MODE_AUDIT || wirMode === "stopAudit" || $scope.user.monitor) {
                $("#replica_btn_live").addClass("disabled");
            }

            //go live is only valid from the local system.
            if ((wirMode === MODE_IDLE || wirMode === MODE_RESTORE || wirMode === "off") && sid === local_sid) {
                $("#replica_btn_live").html('<i class="icon-binoculars icon-large"></i> ' + gettext('Go Live'));
                $("#replica_btn_live").removeClass("disabled");
                $("#replica_btn_live").prop("title", "");
                goLive = true;
                $("#replica_btn_audit").html('<i class="icon-rawaccesslogs icon-large"></i> ' + gettext('Audit'));
                $("#replica_btn_audit").removeClass("disabled");
                $("#replica_btn_audit").prop("title", "");
                goAudit = true;
            }
        });

        tab.$sessionTable.on("rowselect", function (event, dbid, $row, DataTable, DataRow) {
            wirMode = DataTable.data[$row.context.sectionRowIndex].mode;
            jobType = DataTable.data[$row.context.sectionRowIndex].type;
            replicaValid = DataTable.data[$row.context.sectionRowIndex].valid;
            replicaID = DataTable.data[$row.context.sectionRowIndex].replica_id;
            virtual_id = DataTable.data[$row.context.sectionRowIndex].virtual_id;
            sid = DataTable.data[$row.context.sectionRowIndex].sid;
            local_sid = DataTable.data[$row.context.sectionRowIndex].local_sid;

            // monitor users cannot tear down/edit IR sessions
            var elem = angular.element(document.querySelector('[ng-controller=GlobalCtrl]'));
            var $gloablScope = $("[ng-controller=GlobalCtrl]").scope();
            $scope.resetButtons();
            if (!$gloablScope.user.monitor) {
                if (jobType === VMWARE_REPLICA_JOB_TYPE || jobType === 'wir') {
                    $("#tearDownReplica").removeClass("disabled");
                } else {
                    if (recoverFilesOnly(elem, $gloablScope)) {
                        $('#tearDownBtnId').addClass("disabled");
                        $('#tearDownBtnId').prop("title", gettext("This operator can only recover files"));
                    } else {
                        $("#tearDownBtnId").removeClass("disabled");
                    }
                }
                if (DataTable.data[$row.context.sectionRowIndex].type === "wir" || wirMode === MODE_LIVE || wirMode === MODE_AUDIT) {

                    isWirJob = jobType !== VMWARE_REPLICA_JOB_TYPE;
                    virtualId = 0;
                    virtualType = "";
                    virtualId = DataTable.data[$row.context.sectionRowIndex].virtual_id;
                    virtualType = DataTable.data[$row.context.sectionRowIndex].type;
                    hypervisorType = DataTable.data[$row.context.sectionRowIndex].hypervisor_type;
                    mode = DataTable.data[$row.context.sectionRowIndex].mode;
                    vmName = DataTable.data[$row.context.sectionRowIndex].vm_name;
                    if (DataTable.data[$row.context.sectionRowIndex].hasOwnProperty('live_time')) {
                        liveTime = DataTable.data[$row.context.sectionRowIndex].live_time;
                    } else {
                        liveTime = "";
                    }

                    if (wirMode === MODE_NEW || wirMode === MODE_HALTED || $scope.user.monitor) {
                        $("#replica_btn_live").addClass("disabled");
                        $("#editReplicaBtn").addClass("disabled");
                    } else if (wirMode === MODE_AUDIT && sid === local_sid){
                        $scope.resetButtons();
                        $("#editReplicaBtn").removeClass("disabled");
                        $("#replica_btn_audit").removeClass("disabled");
                        $("#replica_btn_audit").html('<i class="icon-rawaccesslogs icon-large"></i> ' + gettext('End Audit'));
                        $("#replica_btn_audit").prop("title", "");
                        $("#tearDownReplica").removeClass("disabled");
                        goAudit = false;

                    } else if (wirMode === MODE_LIVE) {
                        if(jobType === VMWARE_REPLICA_JOB_TYPE){
                            $scope.resetButtons();
                            $("#editReplicaBtn").removeClass("disabled");
                            $("#replica_btn_live").html('<i class="icon-binoculars icon-large"></i> ' + gettext('Go Live'));
                            $("#tearDownReplica").removeClass("disabled");
                            goLive = true;
                        } else {
                            $scope.resetButtons();
                            $("#replica_btn_live").html('<i class="icon-binoculars icon-large"></i> ' + gettext('End Live'));
                            $("#replica_btn_live").removeClass("disabled");
                            $("#tearDownReplica").removeClass("disabled");
                            goLive = false;
                        }
                    } else {
                        if (wirMode === MODE_IDLE || wirMode === MODE_RESTORE || wirMode === "off" && sid === local_sid) {
                            $scope.resetButtons();
                            $("#editReplicaBtn").removeClass("disabled");
                            $("#tearDownReplica").removeClass("disabled");
                            $("#replica_btn_live").html('<i class="icon-binoculars icon-large"></i> ' + gettext('Go Live'));
                            $("#replica_btn_live").removeClass("disabled");
                            $("#replica_btn_live").prop("title", "");
                            goLive = true;
                            $("#replica_btn_audit").html('<i class="icon-rawaccesslogs icon-large"></i> ' + gettext('Audit'));
                            $("#replica_btn_audit").removeClass("disabled");
                            $("#replica_btn_audit").prop("title", "");
                            goAudit = true;
                        }
                    }
                } else {
                    isWirJob = false;
                    if (jobType === VMWARE_REPLICA_JOB_TYPE) {
                        $scope.resetButtons();
                        $("#tearDownReplica").removeClass("disabled");
                        $("#replica_btn_live").prop("title", "Please click \'View Details'\ and select a recovery point from  the \'Recovery Points'\ tab");
                        $("#replica_btn_audit").prop("title", "Please click \'View Details'\ and select a recovery point from  the \'Recovery Points'\ tab");

                    }


                    if(DataTable.data[$row.context.sectionRowIndex].type === VMWARE_REPLICA_JOB_TYPE){
                        hypervisorType = DataTable.data[$row.context.sectionRowIndex].hypervisor_type;
                        mode = DataTable.data[$row.context.sectionRowIndex].mode;
                        vmName = DataTable.data[$row.context.sectionRowIndex].replica_name;
                        if (DataTable.data[$row.context.sectionRowIndex].hasOwnProperty('live_time')) {
                            liveTime = DataTable.data[$row.context.sectionRowIndex].live_time;
                        } else {
                            liveTime = "";
                        }
                        if (~wirMode.indexOf("uninitialized") || ~wirMode.indexOf(MODE_HALTED)) {
                            $scope.resetButtons();
                            $("#tearDownReplica").removeClass("disabled");

                        } else {
                            $("#editReplicaBtn").removeClass("disabled");
                        }
                    }
                }
            } else {

                $("#tearDownBtnId").addClass("disabled");
                $("#tearDownBtnId").prop("title", gettext("Monitor users cannot tear down Instant Recovery"));

            }

            tab.$selected = $row;
            tab.selectedID = dbid;
            tab.rowData = DataRow.data;
            tab.updateButtons();


            detailUrl = "";
            if (jobType === VMWARE_REPLICA_JOB_TYPE){
                detailUrl = "/api/replicas/" + replicaID + "/details/?type=" + jobType + "&sid=" + sid
            } else {
                detailUrl = "/api/virtual_clients/" + virtual_id + "/details/?type=" + jobType +"&sid=" + sid
            }

            var updateDetails = PHD.Ajax.get(detailUrl);

            updateDetails.done(function(data) {
                updateDetailedInfo(data, tab);
            });

            if (tab.inventoryOpen) {
                tab.showJobDetails();
            }
        });

        tab.showJobDetails = $.proxy(showIRJobs, tab);
        tab.hideJobDetails = $.proxy(hideIRJobs, tab);
        tab.updateJobs = $.proxy(updateIRJobs, tab);
    }

     /*
     * Updates detailed info in bottom of IR tab.
     */
    var updateDetailedInfo = function(data, tab) {
        if(data.hasOwnProperty('type') && data.type !== "wir" && data.type !== "replica") {
            isWirJob = false;
            $('#id_vir_vc_name').text("");
            $('#id_vir_vc_created').text("");
            $('#id_vir_vc_duration').text("");
            $('#id_vir_vc_sname').text("");
            $('#id_vir_vc_message').text("");

            $('#id_vir_vc_name').text(data.vm_name);
            $('#id_vir_vc_created').text(data.created);
            $('#id_vir_vc_duration').text(data.duration);
            $('#id_vir_vc_status').text(data.status);
            $('#id_vir_vc_message').text(data.comment);

            tab.LastBackupTable.update(data.last, true);
            tab.PendingBackupTable.update(data.pending, true)

        } else {
            backupUrl = "";
            recoveryPointURL = "";
            if (data.type === 'replica') {
                jobType = 'replica'
                backupUrl = "/api/replicas/" + replicaID + "/backup_history/?sid=" + sid;
                if (replicaValid) {
                    recoveryPointURL = "/api/replicas/" + replicaID + "/recovery_points/?sid=" + sid;

                    var updateRecoveryPoints = PHD.Ajax.get(recoveryPointURL);

                    updateRecoveryPoints.done(function (data) {
                        tab.RecoveryPointsTable.load(data.recovery_points, true);
                    });
                } else {
                    tab.RecoveryPointsTable.load("", true);
                }
            } else {
                isWirJob = true;
                backupUrl = "/api/virtual_clients/" + virtual_id + "/backup_history/?sid=" + sid  + "&lang=" + $rootScope.userLanguageCode;
            }

            var updateBackups = PHD.Ajax.get(backupUrl);
            updateBackups.done(function (data) {
                console.log(data);
                if (jobType === "replica"){
                    tab.ReplicaLastBackupTable.update(data.last, true);
                    tab.ReplicaPendingBackupTable.update(data.pending, true);
                } else {
                    tab.LastBackupTable.update(data.last, true);
                    tab.PendingBackupTable.update(data.pending, true);
                }
            });

            if (jobType === "replica") {
                $('#id_replica_name').text("");
                $('#id_replica_processors').text("");
                $('#id_replica_memory').text("");
                $('#id_replica_snaps').text("");
                $('#id_replica_comment').text("");

                if (data.details != undefined) {
                    $('#id_replica_name').text(data.details.replica_name);
                    $('#id_replica_processors').text(data.details.processors);
                    $('#id_replica_memory').text(data.details.memory);
                    $('#id_replica_snaps').text(data.details.number_of_snaps);
                    $('#id_replica_message').text(data.details.last_message);
                }
            } else {

                $('#id_wir_vc_name').text("");
                $('#id_wir_vc_processors').text("");
                $('#id_wir_vc_memory').text("");
                $('#id_wir_vc_incvolumes').text("");
                $('#id_wir_vc_message').text("");

                if (data.virtual_client != undefined) {
                    $('#id_wir_vc_name').text(data.virtual_client.vm_name);
                    $('#id_wir_vc_processors').text(data.virtual_client.processors);
                    $('#id_wir_vc_memory').text(data.virtual_client.memory);
                    var included_volumes = "";
                    var delim = "";
                    for (var i = 0; i < data.virtual_client.included_volumes.length; i++) {
                        included_volumes += delim + data.virtual_client.included_volumes[i];
                        delim = ", ";
                    }
                    $('#id_wir_vc_incvolumes').text(included_volumes);


                    if ("excluded_volumes" in data.virtual_client) {
                        $('#wir_excvolumes_group').show();
                        var excluded_volumes = "";
                        var delim = "";
                        for (var j = 0; j < data.virtual_client.excluded_volumes.length; j++) {
                            excluded_volumes += delim + data.virtual_client.excluded_volumes[j];
                            delim = ", ";
                        }
                        $('#id_wir_vc_excvolumes').text(excluded_volumes);
                    } else {
                        $('#wir_excvolumes_group').hide();
                    }
                    if ("port" in data.virtual_client) {
                        $('#wir_port_group').show();
                        $('#id_wir_port').text(data.virtual_client.port);
                    } else {
                        $('#wir_port_group').hide();
                    }
                    if ("ip_address" in data.virtual_client) {
                        $('#wir_ip_address_group').show();
                        $('#id_wir_ip_address').text(data.virtual_client.ip_address);
                    } else {
                        $('#wir_ip_address_group').hide();
                    }

                    if ("last_message" in data.virtual_client) {
                        $('#id_wir_vc_message').text(data.virtual_client.last_message);
                    }
                }
            }

        }
    };

    var updateIRJobs = function (reset, sessionID) {
        if (this.inventoryOpen && this.selectedID && this.selectedID === sessionID) {
            var self = this;
            var detailUrl = jobType === "replica" ? "/api/replicas/" + replicaID + "/details/?type=" + jobType +"&sid=" + sid :
                    "/api/virtual_clients/" + virtual_id + "/details/?type=" + jobType + "&sid=" +sid,
                updateDetails = PHD.Ajax.get(detailUrl);

            updateDetails.done(function(data) {
                updateDetailedInfo(data, self);
                self.updateButtons();
            });
        }
    };

    var showIRJobs = function () {
        this.inventoryTimestamp = 0;
        if (this.$details.is(":hidden")) {
            this.$sessionTable
                .adjustTableHeight(this.$sessionTable.getAvailableVerticalSpace(".full-height") - DETAIL_TABLE_HEIGHT);
            if(isWirJob) {
                $( "#virTabs" ).hide();
                $( "#replicasTabs").hide();
                $( "#wirTabs" ).show();
            } else {
                $( "#virTabs" ).show();
                $( "#replicasTabs").show();
                $( "#wirTabs" ).hide();
            }
            this.$details.show("slide", {direction: "down"});
            this.inventoryOpen = true;
            this.updateJobs(true, this.selectedID);
        } else {
            if(isWirJob) {
                $( "#virTabs" ).hide();
                $( "#replicasTabs").hide();
                $( "#wirTabs" ).show();
            } else if(!isWirJob){
                $( "#virTabs" ).show();
                $( "#replicasTabs").show();
                $( "#wirTabs" ).hide();
            }
            this.updateJobs(true, this.selectedID);
        }
        this.updateButtons();
    };

    var hideIRJobs = function () {
        var self = this;
        this.$details.hide("slide", {direction: "down"}, function () {
            self.$sessionTable
                .adjustTableHeight(self.$sessionTable.getAvailableVerticalSpace(".full-height"));
            self.inventoryOpen = false;
            self.updateButtons();
        });
    };

    // check if all the selected backups belong to SQL and whether they aren't replicated or imported
    function checkAttributes(selectedArray, attribute) {
        for (var i = 0; i < selectedArray.length; i++) {
            if (attribute == 'app-type') {
                var appType = selectedArray[i].getAttribute("app-type");
                if (appType !== APPLICATION_TYPE_NAME_SQL_SERVER) {
                    return false;
                }
            }
            if (attribute == 'replicated') {
                var replicated = selectedArray[i].getAttribute("replicated");
                if (replicated == 'true') {
                    return false;
                }
            }
            if (attribute == 'imported') {
                var imported = selectedArray[i].getAttribute("imported");
                if (imported == 'true') {
                    return false;
                }
            }
        }
        return true;
    }

    // check if selected backups are across various systems
    function isSameAppliance(selectedArray) {
        for (var i = 0; i < selectedArray.length; i++) {
            var initialSid = selectedArray[0].getAttribute("system-id");
            var system_id = selectedArray[i].getAttribute("system-id");
            if (system_id !== initialSid) {
                return false;
            }
        }
        return true;
    }

    // check to see if recover_options are set for file only
    function recoverFilesOnly(elem, globalScope) {
        var injector = elem.injector();
        var rolesSvc = injector.get('rolesSvc');
        var recoverOptions = globalScope.user.role_recover_options;
        return rolesSvc.filesOnly(recoverOptions);
    }

    // check to see if recover_options are set for no downloads
    function recoverNoDownloads(elem, globalScope) {
        var injector = elem.injector();
        var rolesSvc = injector.get('rolesSvc');
        var recoverOptions = globalScope.user.role_recover_options;
        return rolesSvc.noDownloads(recoverOptions);
    }

    function getPlaceholderString(tab){
        var text = "";
        if (tab === RECOVER_TAB_REPLICAS){
            text = gettext("There are no active Replica VMs");
        } else if ( tab === RECOVER_TAB_IR){
            text = gettext("There are no active Instant Recovery VMs");
        }
        return text;
    }

    function initBackupsTab(tab) {
        backupCatalog = PHD.BackupCatalog($backupCatalog, options[backupCatalogView]);
        backupFilter = PHD.BackupFilter($backupFilter, backupCatalog);
        $scope.recoveryBackupFilter = backupFilter;
        var archiveIdList=[];
        initFilters();

       backupCatalog.$table
           .on("treeselect", ".row-select", function (node, checked, self) {

                backupSelections = backupCatalog.getSelections();
                selectedNodeDataArray = backupCatalog.getSelectedNodes(["backup_id", "archive_id"]);

                // monitor user cannot restore or start IR
                var elem = angular.element(document.querySelector('[ng-controller=GlobalCtrl]'));
                var $gloablScope = elem.scope();
                if (!$gloablScope.user.monitor) {

                    var $selected = backupCatalog.$table.find(".row-select:checked").closest("tr");
                    var selectedRowData;
                    if (selectedNodeDataArray && selectedNodeDataArray.length > 1 && checkAttributes(selectedNodeDataArray, 'app-type')) {
                        //we have a multiple sql restore request!
                        for (var i = 0; i < selectedNodeDataArray.length; i++) {
                            var delim = "";
                            selectedRowData = selectedNodeDataArray[i];
                            //selectedBackup.app_type = selectedRowData.getAttribute("app-type");
                            app_type = selectedRowData.getAttribute("app-type");
                            //selectedBackup.instance_id = selectedRowData.getAttribute("instance-id");
                            //selectedBackup.backup_id = selectedRowData.getAttribute("backup_id");
                            selectedBackup.sid = selectedRowData.getAttribute("system-id");

                        }
                        if (recoverFilesOnly(elem, $gloablScope)) {
                            $('#restoreBtn').addClass("disabled");
                            $('#restoreBtn').prop("title", gettext("This operator can only recover files"));
                        } else if (!isSameAppliance(selectedNodeDataArray) || !checkAttributes(selectedNodeDataArray, 'replicated') || !checkAttributes(selectedNodeDataArray, 'imported')) {
                            // if backups belong to different appliance or if any are replicated or imported, disable 'Recover'
                            $('#restoreBtn').addClass("disabled");
                            if (!isSameAppliance(selectedNodeDataArray)) {
                                $('#restoreBtn').prop("title", gettext("Backups selected for multiple restore must be from the same appliance"));
                            }
                            if (!checkAttributes(selectedNodeDataArray, 'replicated')) {
                                $('#restoreBtn').prop("title", gettext("Backup copies must be restored one at a time"));
                            }
                            if (!checkAttributes(selectedNodeDataArray, 'imported')) {
                                $('#restoreBtn').prop("title", gettext("Imported backups must be restored one at a time"));
                            }
                        } else {
                            $('#restoreBtn').removeClass("disabled");
                            $('#restoreBtn').prop("title", "");
                        }

                    } else {

                        var lastSelectedRowData = selectedNodeDataArray[selectedNodeDataArray.length - 1];

                        if (selectedNodeDataArray && selectedNodeDataArray.length > 0) {
                            app_type = lastSelectedRowData.getAttribute("app-type");
                            selectedBackup.instance_id = lastSelectedRowData.getAttribute("instance-id") != undefined ? lastSelectedRowData.getAttribute("instance-id") : lastSelectedRowData.getAttribute("data-id");
                            selectedBackup.client_id = lastSelectedRowData.getAttribute("client-id") != undefined ? lastSelectedRowData.getAttribute('client-id') : "";
                            selectedBackup.backup_id = lastSelectedRowData.getAttribute("backup_id");
                            selectedBackup.archive_id = lastSelectedRowData.getAttribute("archive_id");
                            selectedBackup.sid = lastSelectedRowData.getAttribute("system-id");
                            selectedBackup.local_system_id = lastSelectedRowData.getAttribute("local-system-id");
                            selectedBackup.replicated = lastSelectedRowData.getAttribute("replicated");
                            selectedBackup.remote = lastSelectedRowData.getAttribute("data-remote");
                            selectedBackup.app_id = lastSelectedRowData.getAttribute("app-id");
                            if ($rootScope.userLanguageCode === 'en') {
                                selectedBackup.starttime_backup = moment(lastSelectedRowData.getAttribute("data-date")).format("MM/DD/YYYY");
                            } else {
                                // If not English, reverse, the dates in the catalog are day before month, convert to US format.
                                selectedBackup.starttime_backup = moment(lastSelectedRowData.getAttribute("data-date"), 'DD/MM/YYYY HH:mm:ss');
                                selectedBackup.starttime_backup = moment(selectedBackup.starttime_backup).format("MM/DD/YYYY");
                            }

                            if (typeof (selectedBackup.archive_id) != 'undefined' && selectedBackup.archive_id != null) {
                                //  console.log('archiveIdList');
                                if (self) {
                                    archiveIdList.push(node.target.defaultValue);
                                } else {
                                    var index = archiveIdList.indexOf(node.target.defaultValue);
                                    if (index > -1) {
                                        archiveIdList.splice(index, 1);
                                    }
                                }

                            }
                            if (archiveIdList.length > 0) {
                                $('.btn-create-recovery-job').addClass("disabled");
                            } else {
                                $('.btn-create-recovery-job').removeClass("disabled");
                            }
                            if (selectedBackup.archive_id != null || selectedNodeDataArray.length != 1 || selectedBackup.remote === 'true') {
                                $('#restoreBtn').addClass("disabled");
                            } else {
                                if (recoverFilesOnly(elem, $gloablScope)) {
                                    $('#restoreBtn').addClass("disabled");
                                    $('#restoreBtn').prop("title", gettext("This operator can only recover files"));
                                } else {
                                    $('#restoreBtn').removeClass("disabled");
                                    $('#restoreBtn').prop("title", "");
                                }
                            }

                            if (selectedBackup.backup_id != null) {
                                var url = "/api/backups/?sid=" + ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid)
                                    + "&bid=" + selectedBackup.backup_id + "&end_date=" + selectedBackup.starttime_backup + "&lang=" + $rootScope.userLanguageCode;
                                if (selectedBackup.remote === 'true') {
                                    url += "&remote=true";
                                }
                                PHD.Ajax
                                    .get(url)
                                    .done(function (data) {
                                        if (data.BackupStatus !== undefined && Array.isArray(data.BackupStatus)) {
                                            data = data.BackupStatus[0];
                                            selectedBackup.vm_name = (data.vm_name != null) ? data.vm_name : (data.database_name != null) ? data.database_name : data.client_name;
                                            selectedBackup.vmware_template = data.vmware_template !== undefined && data.vmware_template;
                                            selectedBackup.synth_capable = (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER && data.synth_capable !== undefined && data.synth_capable != null) ? data.synth_capable : false;
                                            selectedBackup.backup_size = data.size;
                                            selectedBackup.backup_date = data.start_time;
                                            selectedBackup.datbase_name = data.database_name;
                                            selectedBackup.server_instance_name = data.server_instance_name;
                                            selectedBackup.backup_type = data.type;
                                            selectedBackup.client_name = data.client_name;
                                            selectedBackup.client_os = data.client_os;
                                            // check for SQL Availability group
                                            selectedBackup.is_sql_alwayson = (app_type === APPLICATION_TYPE_NAME_SQL_SERVER && data.is_sql_alwayson !== undefined && data.is_sql_alwayson) ? true : false;
                                        }
                                        if ((selectedBackup.vmware_template !== undefined && selectedBackup.vmware_template) ||
                                                selectedNodeDataArray.length !== 1 ||
                                            (app_type !== APPLICATION_TYPE_NAME_HYPER_V && app_type !== APPLICATION_TYPE_NAME_VMWARE) ||
                                            (selectedBackup.remote === 'true')) {
                                            $('#irBtn').addClass("disabled");
                                            $('#vmIRBtn').addClass("disabled");
                                        } else {
                                            if (recoverFilesOnly(elem, $gloablScope)) {
                                                $('#irBtn').addClass("disabled");
                                                $('#irBtn').prop("title", gettext("This operator can only recover files"));
                                            } else {
                                                $('#irBtn').removeClass("disabled");
                                                $('#vmIRBtn').removeClass("disabled");
                                            }
                                        }
                                        if ((selectedBackup.vmware_template !== undefined && selectedBackup.vmware_template) || selectedNodeDataArray.length != 1 || app_type === APPLICATION_TYPE_NAME_SQL_SERVER ||
                                            (selectedBackup.app_id != 1 && selectedBackup.archive_id != null) || Number(selectedBackup.app_id) === APP_ID_CISCO_UCS_SERVICE_PROFILE) {
                                            $('#restoreFilesBtn').addClass("disabled");
                                        } else {
                                            $('#restoreFilesBtn').removeClass("disabled");
                                            $('#restoreFilesBtn').prop("title", "");
                                        }
                                        // Disable restore button for iSeries.  Allow restore files for browsing.
                                        if (selectedBackup.client_os === "iSeries") {
                                            $('#restoreBtn').addClass("disabled");
                                            $('#restoreFilesBtn').addClass("disabled");
                                        }
                                        // Disable recover files for remote NDMP backups
                                        if (app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE && selectedBackup.remote === 'true') {
                                            $('#restoreFilesBtn').addClass("disabled");
                                        }
                                        // Disable SQL Restores if in-place is restricted and multiple backups are selected.
                                        if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER && selectedNodeDataArray.length > 1) {
                                            var injector = elem.injector();
                                            var rolesSvc = injector.get('rolesSvc');
                                            if (rolesSvc.noInPlace($gloablScope.user.role_recover_options)) {
                                                $('#restoreBtn').addClass("disabled");
                                                $('#restoreBtn').prop("title", gettext("This operator cannot perform in-place restore, which is used when restoring multiple SQL backups."));
                                            }
                                        }
                                        if (selectedBackup.remote === 'true' && recoverNoDownloads(elem, $gloablScope)) {
                                            $('#restoreFilesBtn').addClass("disabled");
                                            $('#restoreFilesBtn').prop("title", gettext("This operator cannot download files from a target"));
                                        }
                                    });
                            } else {
                                var aurl = "/api/archive/status/?sid=" + ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid) +
                                    "&lang=" + $rootScope.userLanguageCode;
                                var idJSON = {'archive_ids': [parseInt(selectedBackup.archive_id, 10)]};
                                idJSON = JSON.stringify(idJSON);
                                PHD.Ajax
                                    .post(aurl, idJSON)
                                    .done(function (data) {
                                        if (data.status !== undefined && Array.isArray(data.status)) {
                                            data = data.status[0];
                                            selectedBackup.vm_name = (data.vm_name != null) ? data.vm_name : (data.database_name != null) ? data.database_name : data.client_name;
                                            selectedBackup.vmware_template = data.vmware_template !== undefined && data.vmware_template;
                                            selectedBackup.synth_capable = (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER && data.synth_capable !== undefined && data.synth_capable != null) ? data.synth_capable : false;
                                            selectedBackup.backup_size = data.size;
                                            selectedBackup.backup_date = data.backup_date;
                                            selectedBackup.datbase_name = data.database_name;
                                            selectedBackup.server_instance_name = data.server_instance_name;
                                            selectedBackup.backup_type = data.type;
                                            selectedBackup.client_name = data.client_name;
                                            selectedBackup.client_os = data.os_type;
                                        }
                                        if ((selectedBackup.vmware_template !== undefined && selectedBackup.vmware_template) || selectedNodeDataArray.length != 1 || app_type === APPLICATION_TYPE_NAME_SQL_SERVER ||
                                            (selectedBackup.app_id != 1 && selectedBackup.archive_id != null) || Number(selectedBackup.app_id) === APP_ID_CISCO_UCS_SERVICE_PROFILE || app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE) {
                                            $('#restoreFilesBtn').addClass("disabled");
                                        } else {
                                            $('#restoreFilesBtn').removeClass("disabled");
                                        }
                                    });
                            }
                        } else {
                            $('#restoreBtn').addClass("disabled");
                            $('#restoreFilesBtn').addClass("disabled");
                            $('#irBtn').addClass("disabled");
                            $('#vmIRBtn').addClass("disabled");
                            selectedBackup.local_system_id = $selected.attr('local-system-id');
                            selectedBackup.replicated = $selected.attr('replicated');
                            if (typeof (selectedBackup.archive_id) != 'undefined' && selectedBackup.archive_id != null) {
                                var index = archiveIdList.indexOf(node.target.defaultValue);
                                if (index > -1) {
                                    archiveIdList.splice(index, 1);
                                }
                            }
                            if (archiveIdList.length > 0) {
                                $('.btn-create-recovery-job').addClass("disabled");
                            } else {
                                $('.btn-create-recovery-job').removeClass("disabled");
                            }
                        }
                    }
                } else {
                    $('#restoreBtn').addClass("disabled");
                    $('#restoreBtn').prop("title", gettext("Monitor users cannot Recover"));

                    $('#restoreFilesBtn').addClass("disabled");
                    $('#restoreFilesBtn').prop("title", gettext("Monitor users cannot Recover Files"));

                    $('#irBtn').addClass("disabled");
                    $('#irBtn').prop("title", gettext("Monitor users cannot start VM Instant Recovery"));
                    $('#vmIRBtn').addClass("disabled");
                    $('#vmIRBtn').prop("title", gettext("Monitor users cannot start VM Instant Recovery"));
                }
                tab.$buttons.find("a").each(function () {
                    var $but = $(this);
                    $but.data("selections", backupSelections);
                    PHD.buttonLogic($but, $selected, tab, null, null, {provider: $analytics, source: 'Recover'});
                });
            })

            .on("backupcatalogloadchildren", function () {
                $(this).scrollTable({"height": "article"});
            });

        tab.TreeTable = backupCatalog;
		selectedNodeDataArray = [];

    }

    function update(tab, init) {
        init = (init === true);
        if (tab.index === RECOVER_TAB_BACKUPS) {
            updateCatalog(init);
        } else if (tab.index === RECOVER_TAB_FLR) {
            updateFLR(init, tab);
        } else if (tab.index === RECOVER_TAB_IR) {
            updateIR(init, tab);
        } else if (tab.index === RECOVER_TAB_REPLICAS) {
            updateReplicas(init, tab);
    }
        tab.updateButtons();
    }

    function updateReplicas(init, tab) {
        var url = "/api/replicas",
            update = PHD.Ajax.get(url);

        update.done(function (data) {
            if (data.timestamp === tab.timestamp) {
                tab.timestamp += 1;
            } else {
                tab.timestamp = data.timestamp;
            }

            var replicaData = formatReplicasData(data.data);
            $scope.$apply(function() {
                $scope.irTableData = Array.isArray(replicaData) && replicaData.length > 0;
            });
            tab.SessionTable.load(replicaData);
            tab.$sessionTable.scrollTable();
            RecoverTimer.stop();
            RecoverTimer.start();

           /* tab.$sessionTable.on("loadfinished updatefinished", function(event, newRows, DataTable) {
               tab.$sessionTable.sortTable();
            });*/



            tab.updateJobs(false, tab.selectedID);

            $(window)
                .off("resize.ir")
                .on("resize.ir", PHD.util.debounce($.proxy(resizeTable, tab.$sessionTable)));

            tab.updateButtons();
        });
    }

    function updateIR(init, tab) {
        var url = "/api/virtual_clients",
            update = PHD.Ajax.get(url);

        update.done(function (data) {
            if (data.timestamp === tab.timestamp) {
                tab.timestamp += 1;
            } else {
                tab.timestamp = data.timestamp;
            }

            var irData = formatIRData(data.data);
            $scope.$apply(function() {
                $scope.irTableData = Array.isArray(irData) && irData.length > 0;
            });
            tab.SessionTable.load(irData);
            tab.$sessionTable.scrollTable();
            RecoverTimer.stop();
            RecoverTimer.start();

            tab.updateJobs(false, tab.selectedID);

            $(window)
                .off("resize.ir")
                .on("resize.ir", PHD.util.debounce($.proxy(resizeTable, tab.$sessionTable)));

            tab.updateButtons();
        });
    }

    function formatReplicasData(data){
        var virtual_clients_data = [];
       // var wir_data = [];
        for (var x = 0; x < data.length; x++) {
            var sid = data[x].system_id;
            var local_sid = data[x].local_sid;
            var appliance_name = data[x].system_name;
            if (data[x].wir) {
                var wir_data = data[x].wir;
                if (wir_data.length > 0) {
                    for (var i = 0; i < wir_data.length; i++) {
                        wir_data[i].id = wir_data[i].virtual_id;
                        wir_data[i].sid = sid;
                        wir_data[i].local_sid = local_sid;
                        wir_data[i].appliance_name = appliance_name;
                        wir_data[i].type = wir_data[i].type;
                        wir_data[i].mode = wir_data[i].mode === 'audit-rdr' ? 'audit' : wir_data[i].mode;
                        if ("pending_state" in wir_data[i]) {
                            wir_data[i].pending_state = wir_data[i].pending_state === 'audit-rdr' ? 'audit' : wir_data[i].pending_state;
                            wir_data[i].mode += "(pending: " + wir_data[i].pending_state + ")";
                        }
                        if ("grandclient" in wir_data[i]) {
                            if (wir_data[i].grandclient) {
                                if ("vm_name" in wir_data[i]) {
                                    wir_data[i].vm_name = wir_data[i].vm_name + COPIED_ASSET;
                                }
                                wir_data[i].appliance_name = wir_data[i].system_name;
                            }
                        }
                        if (wir_data[i].hypervisor_type === HYPERVISOR_UNITRENDS_APPLIANCE) {
                            wir_data[i].server_name = HYPERVISOR_UNITRENDS_APPLIANCE;
                        } else {
                            wir_data[i].server_name = wir_data[i].server_name;
                        }
                        wir_data[i].alert = "";
                        if (wir_data[i].valid) {
                            if (wir_data[i].mode === MODE_HALTED) {
                                wir_data[i].alert = "This client is halted. If this persists, ";
                                if (wir_data[i].hypervisor_type === HYPERVISOR_UNITRENDS_APPLIANCE) {
                                    wir_data[i].alert += "reduce allocation of virtual processors and memory or increase replica storage.";
                                } else {
                                    wir_data[i].alert += "check network connectivity between the Unitrends system and the IP address, " +
                                        wir_data[i].ip_address + ".";
                                }
                            }
                        } else {
                            if (wir_data[i].live_time && wir_data[i].live_time !== "") {
                                wir_data[i].alert = "This client is marked invalid, since it first went live on " + wir_data[i].live_time + ".";
                            } else {
                                wir_data[i].alert = "This client is invalid; please see the Alerts or Recovery Report for more details.";
                            }
                        }
                        virtual_clients_data.push(wir_data[i]);
                    }
                }
            }
            if (data[x].replicas) {
                var replicas_data = data[x].replicas;
                if (replicas_data.length > 0) {
                    for (var j = 0; j < replicas_data.length; j++) {
                        replicas_data[j].id = replicas_data[j].replica_id + ".replica";
                        replicas_data[j].sid = sid;
                        replicas_data[j].local_sid = local_sid;
                        replicas_data[j].appliance_name = replicas_data[j].grandclient !== undefined && replicas_data[j].grandclient === true ? replicas_data[j].system_name + ' -> ' + appliance_name : appliance_name;
                        replicas_data[j].server_name = replicas_data[j].hypervisor_name;
                        replicas_data[j].type = replicas_data[j].hypervisor_type;
                        replicas_data[j].mode = replicas_data[j].current_state === 'audit-rdr' ? 'audit' : replicas_data[j].current_state;
                        replicas_data[j].vm_name = replicas_data[j].replica_name;
                        if ("pending_state" in replicas_data[j]) {
                            replicas_data[j].pending_state = replicas_data[j].pending_state === 'audit-rdr' ? 'audit' : replicas_data[j].pending_state;
                            replicas_data[j].mode += "(pending: " + replicas_data[j].pending_state + ")";
                        }
                        virtual_clients_data.push(replicas_data[j]);
                    }
                }
            }
        }
        return virtual_clients_data;

    }
    function formatIRData(data) {
        var virtual_clients_data = [];
        for (var i = 0; i < data.length; i++) {
             var sid = data[i].system_id;
			 var appliance_name = data[i].system_name;
            if(data[i].hv_ir){
                var hv_ir_data = data[i].hv_ir;
                if (hv_ir_data.length > 0) {
                    for (var j = 0; j < hv_ir_data.length; j++) {
                        hv_ir_data[j].id = hv_ir_data[j].virtual_id;
                        hv_ir_data[j].sid = sid;
                        hv_ir_data[j].appliance_name = appliance_name;
                        hv_ir_data[j].alert = hv_ir_data[j].status === 'error' ?  "Instant Recovery error; see Details for more information." : "";
                        virtual_clients_data.push(hv_ir_data[j]);
                    }
                }
            }
            if(data[i].vm_ir){
                var vm_ir_data = data[i].vm_ir;
                if (vm_ir_data.length > 0) {
                    for (var k = 0; k < vm_ir_data.length; k++) {
                        vm_ir_data[k].id = vm_ir_data[k].virtual_id;
                        vm_ir_data[k].sid = sid;
                        vm_ir_data[k].appliance_name = appliance_name;
                        vm_ir_data[k].alert = vm_ir_data[k].status === 'error' ?  "Instant Recovery error; see Details for more information." : "";
                        virtual_clients_data.push(vm_ir_data[k]);
                    }
                }
            }
        }
        return virtual_clients_data;
    }

    function toUSDate(nonUSDate) {
        // dd/mm/yyyy
        // If not English, convert date to US format.
        var dateMoment = moment(nonUSDate, 'DD/MM/YYYY');
        return dateMoment.format("MM/DD/YYYY");
    }

    function updateCatalog(init) {
        if (init) {
            var startDate = backupFilter.getStartDate();
            var endDate = backupFilter.getEndDate();
            var selections = backupCatalog.getSelectionObject();
            var load_level = backupFilter.getLoadLevel();
            var sid = backupFilter.getSystemID();
            var catalogOptions = {
                "view": backupCatalogView,
                "checked": selections,
                "loader": load,
                "load_level": load_level,
                "sid": sid
            };
            var MAX_TRIES = 5;

            var mStart = moment(startDate, DATE_DISPLAY_FORMAT);
            var mEnd = moment(endDate, DATE_DISPLAY_FORMAT);
            if (mEnd.diff(mStart, 'days') >= 0 && backupFilter.getRetries() < MAX_TRIES) {
                var load = PHD.showLoadingIndicator($backupCatalog.parent());

                // After loaded, use these dates to set the start and end of loaded data.
                $scope.catalogDataStart = startDate !== null ? startDate : moment().subtract(1, 'd').format('L');
                $scope.catalogDataEnd = endDate !== null ? endDate : moment().format('L');

                // convert start date to US format if not English
                var lang = $scope.userLanguageCode;
                if (lang !== 'en') {
                    startDate = toUSDate(startDate);
                    endDate = toUSDate(endDate);
                    catalogOptions['lang'] = lang;
                }
                catalogOptions['start_date'] = startDate;
                catalogOptions['end_date'] = endDate;

                var task = PHD.BackupCatalogBuilder(catalogOptions);
                task
                    .done(function (data) {
                        backupFilter.setDataRange($scope.catalogDataStart, $scope.catalogDataEnd);
                        backupFilter.setLoadLevel(load_level);
                        backupFilter.setSystemID(sid);
                        backupFilter.setRetries(0);
                        updateBackupsTable(data);
                        tabs[currentTabIndex].updateButtons();
                    })
                    .always(function () {
                        PHD.hideLoadingIndicator(load);
                        $scope.refreshEnabled = true;       // Allow the refresh button to be used again.
                    });
            } else {
                backupFilter.setRetries(backupFilter.getRetries() + 1);
                backupCatalog.refresh(options[backupCatalogView]);
                backupFilter.refresh([]).submitFilter();
                tabs[currentTabIndex].updateButtons();
            }
        } else {
            console.log("BC inc update");
            // TODO: Backup Catalog incremental update?
        }
    }

    function updateBackupsTable(data) {
        backupCatalog.load(data);
        backupCatalog.refresh(options[backupCatalogView]);
        backupFilter.setShowPinned(data.legal_hold);
        backupFilter.refresh(data.tree).submitFilter();
    }

    function updateFLR(init, tab) {
        var url = "/api/jobs/active/flr/?lang=" + $rootScope.userLanguageCode;
        var update = PHD.Ajax.get(url);
        update.done(function (data) {
            $scope.$apply(function() {
                $scope.flrTableData = Array.isArray(data.data) && data.data.length > 0;
            });
            if (init === true) {
                initFLRTable(data);
                RecoverTimer.stop();
                RecoverTimer.start();
            } else {
                var ids = tab.getFLRIds();
                updateFLRTable(data, ids);
                RecoverTimer.resume();
            }
        });
    }

    var flrTmpl = _.template(
        '<% for (var i = 0; i < data.length; i++) { %>' +
            '<% var flr = data[i]; %>' +
            '<% flr.iSCSI = (flr.available_targets !== null && flr.available_targets.indexOf("iscsi") != -1) ? "Yes" : "No"; %>' +
            '<% flr.CIFS = (flr.available_targets !== null && flr.available_targets.indexOf("smb") != -1) ? "Yes" : "No"; %>' +
            '<tr data-type="flr" data-remote="<%= flr.remote %>" restore_path="<%= flr.restore_path %>" flr_id="<%= flr.id %>" system-id="<%= flr.system_id %>" ' +
                'cifs="<%=flr.CIFS %>" data-depth="0" class="level-0">' +
            '<td>' +
                '<input type="checkbox" name="flr" id="id_flr_<%= flr.id %>" value="<%= flr.id %>" class="row-select"> ' +
                '<i title="<%= flr.app_title %>" class="<%= flr.icon %> icon"></i>' +
                '<span class="item-name"><%= flr.asset_name %></span>' +
            '</td>' +
            '<td class="job-status-display" data-source="status"><%= flr.status %></td>' +
            '<td data-source="start_date"><%= flr.start_date %></td>' +
            '<td data-source="duration"><%= flr.duration %></td>' +
            '<td data-source="available_targets"><%= flr.iSCSI %></td>' +
            '<td data-source="available_targets"><%= flr.CIFS %></td>' +
            '</tr>' +
        '<% } %>'
    );


    // if ids are passed in, we could optionally look to add just these.
    function getNewFLR(ids) {
        var html = "",
            url = "/api/jobs/active/flr/?lang=" + $rootScope.userLanguageCode;
            update = PHD.Ajax.get(url);

        update.done(function (data) {
            $scope.$apply(function() {
                $scope.flrTableData = Array.isArray(data.data) && data.data.length > 0;
            });
            if (ids !== undefined && ids.length > 0) {
                var new_items = [];
                data.data.forEach(function(obj, index) {
                    ids.forEach(function(id, index) {
                        if (obj.id == id) {
                            new_items.push(obj);
                        }
                    });
                });
                data.data = new_items;
            } else {
                data.objects = data.data;
            }
            //console.log("JSON return on flr is " + JSON.stringify(data.data));
            data = formatFLR(data);
            html = flrTmpl(data) + $flrTable.find("tbody").html();
            $flrTable.find("tbody").html(html);
            $flrTable.scrollTable({"height": "section"});
            flrTreeTable.refresh();
        });
    }

    function initFLRTable(data) {
        data = formatFLR(data);
        $flrTable.find("tbody").html(flrTmpl(data));
        $flrTable.scrollTable({"height": "section"});
        flrTreeTable.refresh();
    }

    function formatFLR(data) {
        var flr_data = {};
        var flr_items = [];
        data.data.forEach(function(obj, index) {
            obj.icon = getFLRIcon(obj.app_type);
            if (obj.app_type ===APPLICATION_TYPE_NAME_HYPER_V || obj.app_type === APPLICATION_TYPE_NAME_VMWARE) {
                obj.app_title = gettext('Virtual Machine');
            } else {
                obj.app_title = obj.app_type;
            }
            flr_items.push(obj);
        });
        flr_data.data = flr_items;
        return flr_data;
    }

    function getFLRIcon(app_type) {
        var icon = "icon-";
        switch (app_type) {
            case 'VMware':
                icon += "uui-vmware-vm";
                break;
            case 'AHV':
                icon += "uui-nutanix-x";
                break;
            case 'Hyper-V':
                icon += "uui-hyperv-vm";
                break;
            case 'Exchange':
                icon += "uui-exchange-db";
                break;
            case 'SQL Server':
                icon += "uui-sql-db";
                break;
            case 'SharePoint':
                icon += "uui-sharepoint-db";
                break;
            case 'Oracle':
                icon += "uui-oracle-db";
                break;
            case 'Xen':
                icon += "uui-citrix-vm";
                break;
            default:
                icon += "uui-vm";
                break;
        }
        return icon;
    }

    function updateFLRTable(data, ids) {
        var flrs = data.data,
            create = [];

        flrs.forEach(function (flr, index) {
            var id = flr.id,
                status = flr.status,
                stateTxt = flr.status,
                detailsTxt = flr.share_details,
                durationTxt = flr.duration;

            if (detailsTxt == 'null') {
                detailsTxt = 'None';
            }

            if (!_.contains(ids, id)) {
                create.push(id);
            } else {
                $node = flrTreeTable.getNodeById("flr", id);
                if ($node !== undefined) {
                    $node.find("[data-source=status]").html(stateTxt);
                    $node.find("[data-source=duration]").html(durationTxt);
                    $node.find("[data-source=share_details]").html(detailsTxt);
                }
            }
        });

        if (create.length) {
            getNewFLR(create);
        }
    }

    function initFLRTab(tab) {
        var options = {
            0: {multiselect: false, childselect: "all"}
        }
        flrTreeTable = PHD.TreeTable($flrTable, options);
        var browseBtn = $("a.btn-flr-browse")[0];
        tab.$buttons.find(browseBtn).disableButton();

        flrTreeTable.$table.on("treeselect", ".row-select", function (event, $row, checked) {
            var queryString = flrTreeTable.getSelections();
            if (!checked) {
                $row = null;
            }
            updateBrowseButton($row, tab);

            tab.$buttons.find("a").each(function () {
                var $but = $(this);
                $but.data("selections", queryString);
                PHD.buttonLogic($but, $row, tab, null, null, {provider: $analytics, source: 'Recover'});
            });
        });

        tab.TreeTable = flrTreeTable;
        //updateFLR();
    }

    function updateBrowseButton($row, tab) {
        var browseBtn = $("a.btn-flr-browse")[0];
        var $browseFLRBtn = tab.$buttons.find(browseBtn);

        // monitor user cannot browse/download
        var elem = angular.element(document.querySelector('[ng-controller=GlobalCtrl]'));
        var $gloablScope = elem.scope();

        if (!$gloablScope.user.monitor) {
            if ($row !== null && $row.length) {
                selectedFLR.id = $row.attr("flr_id");
                selectedFLR.system_id = $row.attr("system-id");
                selectedFLR.restore_path = $row.attr("restore_path");
                selectedFLR.remote = $row.attr("data-remote");
                // true if selected FLR has 'smb' available target
                selectedFLR.cifs = ($row.attr("cifs") == "Yes");

                // See if remote and noDownloads is set for this user.
                var injector = elem.injector();
                var rolesSvc = injector.get('rolesSvc');
                if (selectedFLR.remote === 'true' && rolesSvc.noDownloads($gloablScope.user.role_recover_options)) {
                    $browseFLRBtn.disableButton();
                    $browseFLRBtn.prop("title", gettext("This user cannot Browse/Download files from a remote FLR object"));
                } else {
                    if (selectedFLR.restore_path != undefined && selectedFLR.restore_path != null && selectedFLR.restore_path != "") {
                        $browseFLRBtn.removeClass("disabled");
                        $browseFLRBtn.prop("title", "");
                    } else {
                        $browseFLRBtn.disableButton();
                        var msg = gettext("There is no restore path available for browsing.  Please use iSCSI or the Samba share to restore files.");
                        $browseFLRBtn.prop("title", msg);
                    }
                }
            } else {
                selectedFLR = {};
                $browseFLRBtn.disableButton();
                $browseFLRBtn.prop("title", "");
            }
        } else {
            $browseFLRBtn.disableButton();
            $browseFLRBtn.prop("title", gettext("Monitor users cannot Browse/Download files"));
        }
    }

    var RecoverTab = function (index, panel) {
        this.index = index;
        this.$panel = panel;
        this.$buttons = this.$panel.find(".button-bar");
        this.$buttons.find(".btn-group-recover").flyout();
    };

    RecoverTab.prototype.update = function (init) {
        update(this, init);
    };

    RecoverTab.prototype.initButtons = function () {
        var tab = this;

        this.$buttons.find("a").each(function (index) {
            var $but = $(this);
            $but.data("selections", null);
            $but.data("catalog-view", backupCatalogView);
            PHD.buttonLogic($but, null, tab, null, null, {provider: $analytics, source: 'Recover'});
        });
    };

    RecoverTab.prototype.updateButtons = function ($button) {
        var $rows,
            tab = this,
            $catalog = tab.index === RECOVER_TAB_BACKUPS ? $backupCatalog : $flrTable;

        if ($button !== void 0) {
            if (tab.index === RECOVER_TAB_IR || tab.index === RECOVER_TAB_REPLICAS) {
                PHD.buttonLogic($button, $row, tab, null, tab.rowData, {provider: $analytics, source: 'Recover'});
            } else {
                PHD.buttonLogic($button, $row, tab, null, null, {provider: $analytics, source: 'Recover'});
                if (tab.index === RECOVER_TAB_FLR) {
                    updateBrowseButton($row, tab);
                }
            }
        } else {
            this.$buttons.find("a").each(function (index) {
                var $but = $(this);
                if (tab.TreeTable !== void 0) {
                    $rows = $catalog.find(".row-select:checked").closest("tr");
                    $but.data("selections", tab.TreeTable.getSelections());
                } else {
                    $rows = tab.$selected;
                    $but.data("selections", "");
                }
                $but.data("catalog-view", backupCatalogView);
                if (tab.index === RECOVER_TAB_IR || tab.index === RECOVER_TAB_REPLICAS) {
                    PHD.buttonLogic($but, $rows, tab, null, tab.rowData, {provider: $analytics, source: 'Recover'});
                } else {
                    PHD.buttonLogic($but, $rows, tab, null, null, {provider: $analytics, source: 'Recover'});
                    if (tab.index === RECOVER_TAB_FLR) {
                        updateBrowseButton($rows, tab);
                    }
                }
            });
        }
    };

    RecoverTab.prototype.getSelections = function () {
        var selections = this.TreeTable.getSelections();
        return selections;
    };

    RecoverTab.prototype.pinRows = function (id, action) {
        var ids = [id];
        if (action === "pin") {
            backupCatalog.pin(ids);
        } else {
            backupCatalog.unpin(ids);
        }

        backupCatalog.deselectAll();
    };

    var backupTmpl = _.template(
        '<table class="backup-list user-backups data-table dashboard-table">' +
        '<thead><tr>' + '<th> </th>' +
        '<th>' + gettextCatalog.getString("Host/Server") + '</th>' +
        '<th>' + gettextCatalog.getString("Asset") + '</th>' +
        '<th>' + gettextCatalog.getString("Type") + '</th>' +
        '<th>' + gettextCatalog.getString('Status') + '</th>' +
        '<th>' + gettextCatalog.getString("Date") + '</th>' +
        '</tr></thead>' +
        '<tbody>' +
        '<% for(var i=0;i<data.length;i++) { %>' +
            '<% data[i].client_name = data[i].client_name ; %>' +
            '<% data[i].asset_name = data[i].asset_name; %>' +
            '<tr>' +
            '<td>' +
            '<% if(data[i].gfs_rp_type !== "") { %>' +
                '<div class="help-trigger"><i class="icon-infosign"></i></div>' +
                '<span class="definition"><translate>This backup was kept due to a retention policy.</translate></span>' +
            '<% } %>' + '</td>' +
            '<td><span class="truncates"><%= data[i].client_name %></span></td>' +
            '<td><%= data[i].asset_name %></td>' +
            '<td><%= data[i].type %></td>' +
            '<td><%= data[i].status %></td>' +
            '<td><%= data[i].start_time %></td>' +
            '</tr>' +
        '<% } %>' +
        '</tbody></table>'
    );

    var heldBackupTmpl = _.template(
        '<table class="backup-list held-backups data-table dashboard-table">' +
        '<thead><tr>' +
        '<th>' + gettextCatalog.getString("Name") + '</th>' +
        '<th>' + gettextCatalog.getString("Secondary Name") + '</th>' +
        '<th>' + gettextCatalog.getString("Type") + '</th>' +
        '<th>' + gettextCatalog.getString('Date') + '</th>' +
        '<th>' + gettextCatalog.getString("Reason") + '</th>' +
        '</tr></thead>' +
        '<tbody>' +
        '<% for(var i=0;i<data.length;i++) { %>' +
        '<% data[i].primary_name = data[i].primary_name == undefined ? (data[i].server_instance_name == undefined ? data[i].client_name : data[i].server_instance_name) : data[i].primary_name; %>' +
        '<% data[i].secondary_name = data[i].secondary_name == undefined ? data[i].database_name : data[i].secondary_name; %>' +
        '<tr>' +
        '<td><span class="truncates"><%= data[i].primary_name %></span></td>' +
        '<td><%= data[i].secondary_name %></td>' +
        '<td><%= data[i].type %></td>' +
        '<td><%= data[i].start_time %></td>' +
        '<td>Held</td>' +
        '</tr>' +
        '<% } %>' +
        '</tbody></table>'
    );


    RecoverTab.prototype.confirmDelete = function (data, isRemote) {
        var self = this;
        var remote = isRemote || false;
        var message = gettextCatalog.getString("The following backups will be deleted") + (isRemote ? " " + gettextCatalog.getString("from the target:") : ":");
        message = '<h4 class="text-ok">' + message + '</h4>';
        var system_id  = selectedBackup.replicated == "true" ? selectedBackup.local_system_id : selectedBackup.sid;    // lmc - TODO for grid.

        // add in original backup info.
        var backups = data.data;

        var holdArray = [];     // backups that are on hold
        var deleteArray = [];   // backups that are not on hold
        var idsArray = [];
        for (var i = 0; i < backups.length; i++) {
            if (backups[i].legalhold === true) {
                holdArray.push(backups[i]);
            } else {
                // Do not return duplicate backup IDs
                if (idsArray.indexOf(backups[i].id) < 0) {
                    idsArray.push(backups[i].id);
                    deleteArray.push(backups[i]);
                }
            }
        }
        var backupsToHold = {};
        backupsToHold.data = holdArray;
        var backupsToDelete = {};
        backupsToDelete.data = deleteArray;

        var deleteBackups = backupsToDelete.data;
        var holdBackups = backupsToHold.data;
        if (backups && backups.length) {
            var backupsHeldMessage = '';
            if (holdBackups && holdBackups.length) {
                backupsHeldMessage += '<h4 class="text-ok">' + gettextCatalog.getString("The following backups cannot be deleted:") + '</h4>';
                backupsHeldMessage += heldBackupTmpl(backupsToHold);
            }

            // Both backups that are on hold and those that are not on hold are selected
            if (deleteBackups && deleteBackups.length) {
                ids = _.pluck(deleteBackups, 'id');
                message += backupTmpl(backupsToDelete);
                message += backupsHeldMessage;

                PHD.appliance_sid = system_id;

                confirm = PHD.confirmDialog(
                    message,
                    {
                        title: gettextCatalog.getString("Confirm Backup Deletion"),
                        open: function (event, ui) {
                            var $dialog = $(this);
                            $dialog.find("table.data-table").scrollTable({"height": 240, "resize": false});
                            $dialog.find(".ui-dialog-buttonset button:last-child").focus();
                            $dialog.dialog("option", "position", {my: "center", at: "center", of: window});
                            $dialog.find(".definition").popover({
                                appendTo: $dialog,
                                position: {
                                    my: "left-30 bottom",
                                    at: "right bottom+40",
                                    within: $dialog
                                }
                            });
                        }
                    }
                );

                confirm.done(function () {
                    var str_ids = ids.toString();
                    var sid = (PHD.appliance_sid === null) ? "" : "/?sid=" + PHD.appliance_sid;
                    var url = "/api/backups/" + str_ids + sid;
                    var resp = PHD.Ajax.delete(url);

                    resp.done(function(data) {
                        console.log("done with backup deletion, clearing ids: " + str_ids);
                        self.deleteRows('backup', ids);
                        self.updateButtons();
                    });
                    backupCatalog.deselectAll();
                });
            } else {
                // Only backups that are on hold are selected
                if (holdBackups && holdBackups.length) {
                    var option = PHD.dialogs.alert;
                    $("<div/>", {
                        id: "dialog-ajax-error",
                        title: gettextCatalog.getString("Error deleting backups"),
                        "class": "dialog-box"
                    })
                        .hide()
                        .appendTo("body")
                        .html(backupsHeldMessage)
                        .dialog(option);
                }
            }

        } else {
            message = '<h4 class="text-ok">' + gettextCatalog.getString("There are no backups to delete.") + '</h4>';
            var options = PHD.dialogs.alert;
            $("<div/>", {
                id: "dialog-ajax-error",
                title:  gettextCatalog.getString("Error deleting backups"),
                "class": "dialog-box"
            })
                .hide()
                .appendTo("body")
                .html(message)
                .dialog(options);
        }
    };

    RecoverTab.prototype.deleteRows = function (node_type, ids) {
         ids.forEach(function (id) {
            backupCatalog.deleteNodeById(node_type, id);
         });
     };


    RecoverTab.prototype.deleteFLR = function (flr_id) {
        flrTreeTable.deleteNodeById("flr", flr_id);
        $flrTable.scrollTable({"height": "section"});
        flrTreeTable.refresh();
    };

    RecoverTab.prototype.getFLRIds = function () {
        return $flrTable
            .find("[data-type=flr]")
            .map(function () {
                //return parseInt($(this).attr("flr_id"), 10);
                //lmc - not numeric
                return $(this).attr("flr_id");
            })
            .get();
    };

    var flrDetailTmpl = _.template(
        '<table style="font-size:12px;max-width:100%;width:100%;line-height:29px">' +
        '<tr>' +
        '<td style="width:100px">' + '<strong>' + gettextCatalog.getString('Name') + '</strong>:' + '</td>' +
        '<td> <%= instance_name %> (<%= application %> VM)' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettextCatalog.getString('Host/Server') + '</strong>:' + '</td>' +
        '<td> <%= client_name %> ' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettextCatalog.getString('Created') + '</strong>:' + '</td>' +
        '<td> <%= start_date %> ' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettextCatalog.getString('Appliance') + '</strong>:' + '</td>' +
        '<td> <%= system_name %> ' + '</td>' +
        '</tr>' +
        '<tr><td>&nbsp;</td></tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettextCatalog.getString('CIFS Path') + '</strong>:' + '</td>' +
        '<td> <%= share_details %> ' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td style="vertical-align:top">' + '<strong>' + gettextCatalog.getString('iSCSI (Windows)') + '</strong>:' + '</td>' +
        '<td style="white-space:normal;word-wrap:break-word;vertical-align:top;line-height:20px;padding-top:6px;"> <%= str_iscsi_win_details %> ' + '</td>' +
        '</tr>' +
        '<tr><td></td></tr>' +
        '<tr>' +
        '<td style="vertical-align:top">' + '<strong>' + gettextCatalog.getString('iSCSI (Linux)') + '</strong>:' + '</td>' +
        '<td style="white-space:normal;word-wrap:break-word;vertical-align:top;line-height:20px;padding-top:6px;"> <%= str_iscsi_linux_details %> ' + '</td>' +
        '</tr>' +
        '<tr><td>&nbsp;</td></tr>' +
        '<% if (str_admin_url && str_admin_url != null) { %>' +
            '<tr>' +
            '<td style="vertical-align:top">' + '<strong>' + gettextCatalog.getString('Administration URL') + '</strong>:' + '</td>' +
            '<td> <%= str_admin_url %> ' + '</td>' +
            '</tr>' +
            '<tr><td>&nbsp;</td></tr>' +
        '<% } %>' +
        '<tr>' +
        '<td style="vertical-align:top">' + '<strong>' + gettextCatalog.getString('Messages') + '</strong>:' + '</td>' +
        '<td style="white-space:normal;word-wrap:break-word;vertical-align:top"> <%= comment %> ' + '</td>' +
        '</tr>' +
        '</table>'
    );

    RecoverTab.prototype.showFLRDetails = function (id, system_id) {
        var resp, options;

        options = {
            modal: true,
            draggable: true,
            resizable: false,
            width: 550,
            height: 400,
            dialogClass: "dialog-flr-detail",
            title: gettextCatalog.getString("File Level Recovery Details"),
            buttons: [
                {
                    text: gettextCatalog.getString("Close"),
                    click: function () {
                        $(this).dialog("destroy").remove();
                    }
                }
            ]
        };

        resp = PHD.Ajax.get("/api/jobs/active/flr/" + id + "/?sid=" + system_id + "&lang=" + $rootScope.userLanguageCode);

        resp.done(function (data) {
            if (data && data.data !== undefined) {
                var obj = data.data;
                if (obj.share_details === null) {
                    obj.share_details = gettextCatalog.getString("None");
                }
                if (obj.iscsi_details === null) {
                    obj.str_iscsi_win_details = "N/A";
                    obj.str_iscsi_linux_details = "N/A";
                } else {
                    obj.str_iscsi_win_details = gettextCatalog.getString("On the machine to which you want to restore files, use the Windows ISCSI Initiator.") + "  " +
                                            gettextCatalog.getString("The iSCSI target identifier includes the VM name at the end") + " " +
                                            '<br>' +
                                            "(e.g:iqn.1995-21.com.unitrends.dpu:flr.89fb.VMNAME)." +
                                            '<br><br>' +
                                            gettextCatalog.getString("For details, see") + " " +
                        '<a href="http://www.unitrends.com/documents/rs-ueb-admin-guide/#satori/recovering_files_from_virtual_.htm%3FTocPath%3DRecovering%2520Host-level%2520Backups%7CRecovering%2520files%2520from%2520virtual%2520machine%2520backups%7C_____0" target="_blank"><strong>' +
                        gettextCatalog.getString("Recovering files using iSCSI on windows.") +
                                            '</strong></a>';

                    obj.str_iscsi_linux_details = gettextCatalog.getString("Login to server or VM to which you want to copy files and download and run the script located at") + " " + obj.iscsi_details + '.';
                }
                if (obj.comment === null) {
                    obj.comment = "None";
                }
                obj.str_admin_url = null;
                if (obj.admin_url && obj.admin_url != null) {
                    obj.str_admin_url = obj.admin_url;
                }
                $("<div>", {
                    id: "flr-detail-" + id,
                    "class": "flr-detail"
                })
                    .html(flrDetailTmpl(obj))
                    .dialog(options);

                $(".flr-detail").css("overflow","hidden");
                $(".flr-detail").height(400);
            }
        });
    };

    function initFilters() {
        $backupCatalog.find(".btn-dateview").on("click", function (event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_DATE;
            updateCatalog(true);
        });

        $backupCatalog.find(".btn-vmview").on("click", function (event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_VM;
            updateCatalog(true);
        });

        $backupCatalog.find(".btn-bdsview").on("click", function (event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_APPLIANCE;
            updateCatalog(true);
        });

        $backupCatalog.find(".check-select-all").on("change", function (event) {
            if ($(this).prop("checked")) {
                backupCatalog.selectAll();
            } else {
                backupCatalog.deselectAll();
            }
        });

        $backupCatalog.on("afterfilter backupcatalogload", function () {
            tabs[0].updateButtons();
            $backupCatalog.scrollTable({"height": "article"});
        });
    }

    /* If the user clicks refresh, re-initialize the catalog with the current filter settings
     * This will allow us to pick up new backups w/o having to leave the Recover subsystem.
     */
    $scope.onCatalogRefresh = function() {
        $scope.refreshEnabled = false;
        updateCatalog(true);
        // updateCatalog will set $scope.refreshEnabled to true once data is loaded.
    };

    function handleTabChange() {
        tabs[currentTabIndex].update(true);
        $(document).trigger("tabchange", ["recover" + slugs[currentTabIndex]]);
    }

    function initializePage(PHD) {
        console.log('phd is ' + PHD + ' and jquery is ' + jQuery + ' and window is ' + window);
        if (!isNaN(PHD.util.getHashInt())) {
            initialTab = PHD.util.getHashInt();
        }
        $(".with-tooltip").tooltip({
            position: {
                "my": "left top",
                "at": "left bottom",
                "collision": "flip"
            },
            tooltipClass: "button-help"
        });
        $('.tabs-wrapper').tabs({
            active: initialTab,
            create: function (event, ui) {
                currentTabIndex = ui.tab.index();
                initTabs();
                handleTabChange();
            },
            activate: function (event, ui) {
                $(".loading").hide();
                currentTabIndex = ui.newTab.index();
                $.cookie("initial_tab_recover", currentTabIndex, {expires: 365, path: '/'});
                handleTabChange();
            }
        });
    }

    initializePage(PHD);
}
