angular.module('singleFileBrowserDialogApp', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','backupJobModule'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
		  });
    	}])


.controller('singleFileBrowserDialogCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','dataToBeShared', 'includeExcludeLabelService',
        function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,dataToBeShared,includeExcludeLabelService) {
            var newId = 1;
            $scope.ignoreChanges = false;
            $scope.newNode = {};
            $scope.selectedNode;
            $scope.selectedTreeNode = [];
            var fileBrowserTreeObj={};
            var singleFileBrowserTreeObj={};
            $scope.fileBrowserTreeArray = []; 

           $scope.treeData = $rootScope.originalData;

            // To set includeExclude Label on browser tree window		
            $scope.includeExcludeLabel = includeExcludeLabelService.getLabel();

            $scope.treeConfig = {
                core : {
                    multiple : false,
                    multiple : false,
                    animation: true,
                    error : function(error) {console.log('treeCtrl: error from js tree - ' + angular.toJson(error));},
                    check_callback : true,
                    worker : true
                },
                version : 1,
                plugins : ['types','dnd']
            };

            this.applyModelChanges = function() {
                return !$scope.ignoreChanges;
            };
 	
            $scope.beforeOpen = function(e,item){
                var url ="";
                var abc = [];
                var jstreeDivId = $("#singleFileBrowserTreeId");

                if(item.node.data.expanded == false){
                    var ID = item.node.id;
                    url =$rootScope.singleFileBrowserTreeNodeUrl+ID;
                    load=PHD.showLoadingIndicator(jstreeDivId);

                    $http({
                        method: 'get',
                        url : url
                    }).success(function(data, status, headers){
                        var jsonData = data.data;

                        if(jsonData != null){
                           for(var i=0;i<jsonData.length;i++){
                           fileBrowserTreeObj = {id:jsonData[i].id, parent:jsonData[i].directory,text:jsonData[i].name,icon:(jsonData[i].isBranch == true)? "icon-hv-folder icon" : "icon-file icon",
                                                 state: { opened: false},data:{expanded:false}}
                            $scope.fileBrowserTreeArray.push(fileBrowserTreeObj);

                            var id = jsonData[i].id+"...";
                            if(jsonData[i].isBranch == true){
                                fileBrowserTreeObj={id:id,parent:jsonData[i].id, text:"...",state: { opened: false}};
                                $scope.fileBrowserTreeArray.push(fileBrowserTreeObj);
                              }

                            }

                            angular.forEach($scope.fileBrowserTreeArray, function (e) { this.push(e); }, $scope.treeData)
                            item.node.data.expanded =true;

                            setTimeout(function(){  
                                var dummyNodeID = item.node.id+"...";
                                $('#singleFileBrowserTreeId').jstree(true).delete_node(item.instance.get_node(dummyNodeID));
                                PHD.hideLoadingIndicator(load); 
                                $(window).resize(); 
                            }, 200);
                        }else{
                            var dummyNodeID = item.node.id+"...";
                            $('#singleFileBrowserTreeId').jstree(true).delete_node(item.instance.get_node(dummyNodeID));
                            PHD.hideLoadingIndicator(load); 
                        }
                     }).error(function(response) { console.log(response);}); 
               }
	
            };

            $scope.changedCB = function(e,item) {
                var i, j, r = [];
                for(i = 0, j = item.selected.length; i < j; i++) {
                    r.push(item.instance.get_node(item.selected[i]).text);
                }
                angular.copy(r,$scope.selectedTreeNode);
                $scope.selectedItem = $scope.selectedTreeNode.toString();
            };

            $scope.nodeSelected = function(e,item){
                var i, j, r = [];
                $scope.filePathArray = [];
                for(i = 0, j = item.selected.length; i < j; i++) {
                    $scope.filePath = item.selected[i];
                    $scope.filePathArray.push($scope.filePath);
                }
            };

            $scope.getSingleFilePath = function(){
                $rootScope.$broadcast('singleFilesBrowseSelected', $scope.filePath);
                $scope.closeThisDialog();

            }
}]); 			