var replicasModule = angular.module('replicasModule', []);

replicasModule.controller('replicasCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics', '$protectService', 'inventorysvc', 'gettextCatalog',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics, $protectService, inventorysvc, gettextCatalog) {
        $scope.replica = {};
        $scope.replica.location = "";
        $scope.replica.resourcePool = "";
        $scope.replica.datastore = "";
        $scope.replica.name = "";
        $scope.replica.recoveryPoints = 1;

        $scope.locations = [];
        $scope.dataStores = [];
        $scope.dataStoresPools = [];
        $scope.maxRecoveryPoints = $rootScope.maxRecoveryPoints;

        $rootScope.treeData = [];
        $scope.selectedAsset = [];
        $scope.hypervisorTypeObj = {};
        $scope.instanceID = "";
        $scope.createMultipleReplicas = [];  //for the datagrid view
        $scope.multipleReplicas = []; //for passing to the api
        $scope.isMultiple = false;
        $scope.isReplicated = false;

        $scope.errorField = false;
        $scope.locationError = false;
        $scope.datastoreError = false;

        $scope.errorOptionsField = false;
        $scope.nameError = false;
        $scope.recoveryPointsError = false;

        $scope.loadTreeData = function($http, $scope, $rootScope) {
            $rootScope.treeData = [];
            finalTreeDataArray = [];
            rootNodeArray = [];

            for (var k = 0; k < $scope.treeDataCache.length; k++) {
                var nodeIcon = $protectService.getIconForType($scope.treeDataCache[k].type) + " icon";
                rootNodeObj = {id:$scope.treeDataCache[k].id,parent:"#",text:$scope.treeDataCache[k].name,
                    icon:nodeIcon,state: { opened: true,disabled: true},data:{expanded:true,type:$scope.treeDataCache[k].type}};
                rootNodeArray.push(rootNodeObj);
                var isDisabled = true;
                var jsonTreeData = $scope.treeDataCache[k].nodes;

                var jsonData = $protectService.getSortedJson(jsonTreeData,"name");

                for (var i = 0; i < jsonData.length; i++) {
                    isDisabled = false;
                    nodeIcon = $protectService.getIconForType(jsonData[i].type)+" icon";
                    rootNodeObj = {id:jsonData[i].id,parent:$scope.treeDataCache[k].id,text:jsonData[i].name,
                        icon:nodeIcon,state: { opened: false,disabled: isDisabled},data:{expanded:false,type:jsonData[i].type}};
                    rootNodeArray.push(rootNodeObj);

                    if (jsonData[i].nodes instanceof Array) {
                        $scope.getRecursivelyTreeData(jsonData[i]);
                    }
                }
            }
            finalTreeDataArray = rootNodeArray;
            $rootScope.treeData = finalTreeDataArray;
            var nodeTree = $('#replicaCandidatesJstree').jstree(true);
            if (nodeTree.settings != undefined && nodeTree.settings.core !== undefined) {
                nodeTree.settings.core.data = $rootScope.treeData;
            }
            if (nodeTree.refresh !== undefined) {
                nodeTree.refresh();
            }
        };

        $scope.getRecursivelyTreeData = function(data) {
            var isDisabled = false;
            for (var j = 0; j< data.nodes.length;j++) {
                var nodeIcon = $protectService.getIconForType(data.nodes[j].type)+" icon";
                rootNodeObj = {id:data.nodes[j].id, parent:data.id, text:data.nodes[j].name,
                    icon:nodeIcon, state: { opened: false,disabled: isDisabled}, data:{expanded:false, type:data.nodes[j].type, recovery_model: "hello", gc:data.nodes[j].gc}};
                rootNodeArray.push(rootNodeObj);
                if (data.nodes[j].nodes instanceof Array) {
                    $scope.getRecursivelyTreeData(data.nodes[j]);
                }
            }
        };

        $scope.inventoryData =[];
        $scope.loadTreeData($http, $scope, $rootScope);

        $scope.treeConfig = {
            core : {
                multiple : true,
                animation: true,
                error : function(error) {$log.error('treeCtrl: error from js tree - ' + angular.toJson(error));},
                check_callback : true,
                worker : true
            },
            types : {
                default : {icon : 'icon-hv-datacenter icon'},
                star : {icon : 'icon-hv-host icon'},
                cloud : {icon : 'icon-hv-host icon'}
            },
            version : 1,
            plugins : ['types','checkbox','search']
        };

        $scope.deselectNodeFun = function(e,item) {
            if (item.node.data.type === INVENTORY_ID_NAVGROUP || item.node.data.type === INVENTORY_ID_SYSTEM || item.node.data.type === INVENTORY_ID_VMWARE_ESX_SERVER) {
                for (var k = 0; k < item.node.children_d.length; k++) {
                    if ($scope.selectedAsset[item.node.children_d[k]] != null || $scope.selectedAsset[item.node.children_d[k]] != undefined) {
                        delete $scope.selectedAsset[item.node.children_d[k]];
                    }
                }
                $scope.refreshInventoryData();
            } else {
                if (item.selected.length == 0) {
                    $scope.replica.clients = [];
                    $scope.selectedAsset = [];
                }
                var currentParentNodeArray = item.node.parent.split("_");
                var selectedAssetsSystem = inventorysvc.nodeToObject(item.node.id).system_id;
                if (currentParentNodeArray.length > 2) {
                    selectedAssetsSystem = currentParentNodeArray[0];
                }
                if ($scope.replica.sid == selectedAssetsSystem) {
                    delete $scope.selectedAsset[item.node.id];
                }
                $scope.refreshInventoryData();
            }
        };

        $scope.selectNodeFun = function(e,item) {
            var currentParentNodeArray = item.node.parent.split("_");
            if (item.node.data.type === INVENTORY_ID_NAVGROUP || item.node.data.type === INVENTORY_ID_SYSTEM || item.node.data.type === INVENTORY_ID_VMWARE_ESX_SERVER || item.node.data.type === INVENTORY_ID_VMWARE_RESOURCE_POOL) {
                if (item.node.data.expanded == false) {
                    $('#replicaCandidatesJstree').jstree(true).open_all(item.node);
                    item.node.data.expanded = true;
                }
                for (var k = 0; k < item.node.children_d.length; k++) {
                    var id = '#' + item.node.children_d[k] + '_anchor';
                    if ($scope.selectedAsset[item.node.children_d[k]] == null || $scope.selectedAsset[item.node.children_d[k]] == undefined) {
                        if (inventorysvc.isGroup(item.node.children_d[k]) || inventorysvc.isPoolOrVApp(item.node.children_d[k])) {
                            continue;
                        }
                        $scope.selectedAsset[item.node.children_d[k]] = {
                            nodeId: item.node.children_d[k],
                            name: $(id).text(),
                            id: inventorysvc.nodeToObject(item.node.children_d[k]).client_id
                        };
                        $scope.isReplicated = item.node.data.gc !== undefined && item.node.data.gc === true;
                    }
                }
                $scope.refreshInventoryData();
            } else {
                if (item.selected.length > 1) {
                    var selectedAssetsSystem = inventorysvc.nodeToObject(item.node.id).system_id;
                    $scope.isReplicated = item.node.data.gc !== undefined && item.node.data.gc === true;
                    if(item.node.parent.split("_").length > 2) {
                        selectedAssetsSystem = currentParentNodeArray[0];
                    }
                    if ($scope.replica.sid == selectedAssetsSystem) {
                        if ($scope.selectedAsset[item.node.id] == null || $scope.selectedAsset[item.node.id] == undefined) {
                            $scope.selectedAsset[item.node.id] = {nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id};
                        }
                    } else {
                        $scope.uncheckNotEligibleNode(item.node.id);
                    }
                } else {
                    if (item.node.parent.split("_").length > 2) {
                        $scope.replica.sid = currentParentNodeArray[0];
                    } else {
                        $scope.replica.sid = inventorysvc.nodeToObject(item.node.id).system_id;
                    }
                    $scope.replica.app_id = inventorysvc.nodeToObject(item.node.id).app_id;
                    $scope.isReplicated = item.node.data.gc !== undefined && item.node.data.gc === true;
                    if ($scope.selectedAsset[item.node.id] == undefined || $scope.selectedAsset[item.node.id] == null) {
                        $scope.selectedAsset[item.node.id] = {nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id};
                    }
                }
                $scope.refreshInventoryData();
            }
        };

        // TODO to be uncommented after the replicas inventory API is implemented
        $scope.hoverNode = function(e, item){
            // if (item.node.data.replicas_supported !== undefined && item.node.data.replicas_supported === false) {
            //     var hoverTip = "VM Replicas are not supported for this appliance";
            //     var $el = $(document.getElementById(item.node.id));
            //     $el.prop('title', hoverTip);
            // }
        };

        $scope.uncheckNotEligibleNode = function(uncheckNodeId) {
            var node_id = 'li#' + uncheckNodeId;
            $('#replicaCandidatesJstree').jstree(true).uncheck_node(node_id);
        };

        $scope.refreshInventoryData = function(){
            $scope.inventoryData = [];
            var nodeIdArray = Object.keys($scope.selectedAsset);
            for (var j = 0; j < nodeIdArray.length; j++) {
                var obj = $scope.selectedAsset[nodeIdArray[j]];
                $scope.inventoryData.push(obj);
            }

            $scope.isMultiple = $scope.inventoryData.length > 1;

            if ($scope.isMultiple) {
                var instanceID;
                var nodeIDArray;
                $scope.createMultipleReplicas.splice(0,$scope.createMultipleReplicas.length);
                for (var k = 0; k < $scope.inventoryData.length; k++) {
                    nodeIDArray = $scope.inventoryData[k].nodeId.split('_');
                    instanceID = nodeIDArray[4];

                    var multiObj = _.omit($scope.inventoryData[k], 'nodeId');
                    multiObj.name = multiObj.name + "_replica";
                    multiObj.instanceID = instanceID;
                    $scope.createMultipleReplicas.push(multiObj);
                }
            }

            $(window).resize();
        };

        $scope.searchIndex = 0;

        $scope.search = function(){
            setTimeout(function () {
                var v = $('#inventorySearchInputId').val();
                $('#replicaCandidatesJstree').jstree(true).search(v);
            }, 200);
        };

        $scope.goToSearchResult = function() {
            var el =  $('#replicaCandidatesJstree').jstree(true).get_node($scope.searchResults[$scope.searchIndex], true);
            if (el !== undefined) {
                el.children('.jstree-anchor').focus();
            }
            el.focus();
        };

        $scope.getSearchResults = function(event, obj) {
            setTimeout(function () {
                $scope.$apply(function() {
                    $scope.searchResults = obj.nodes;
                    $scope.searchIndex = 0;
                });
            });
        };

        $scope.next = function() {
            var len = $scope.searchResults.length;
            if ($scope.searchIndex + 1 > len - 1) {
                $scope.searchIndex = 0;
            } else {
                $scope.searchIndex++;
            }
            $scope.goToSearchResult();
        };

        $scope.previous = function() {
            var len = $scope.searchResults.length;
            if ($scope.searchIndex - 1 < 0) {
                $scope.searchIndex = len - 1;
            } else {
                $scope.searchIndex--;
            }
            $scope.goToSearchResult();
        };

        $scope.clearSearch = function() {
            $('#replicaCandidatesJstree').jstree(true).clear_search();
            $('#inventorySearchInputId').val("");
        };

        $scope.clearSearchResults = function() {
            $scope.searchIndex = 0;
            $scope.searchResults = undefined;
        };

        $scope.isSelected = function(checkTab) {
            return $scope.tab === checkTab;
        };

        $scope.getTargetLocationDetails = function() {

            // reset everything
            $scope.locations        = [];
            $scope.dataStores       = [];
            $scope.dataStoresPools  = [];
            $scope.replica.location = "";
            $scope.replica.datastore = "";
            $scope.replica.resourcePool = "";

            var nodeIDArray = $scope.inventoryData[0].nodeId.split('_');
            $scope.instanceID = nodeIDArray[4]; //in case of Hyper-V, nodeIdArray[3]

            //if a parent node is selected, we have selected multiple vms, but have no sid - need one for location
            //is this a grandclient?  these nodes have '0001' appended to the id
            if(~nodeIDArray[0].indexOf("0001")){
                $scope.isReplicated = true;
            } else {
                if ($scope.inventoryData.length > 1) {
                    $scope.replica.sid = nodeIDArray[0];
                }
            }

            var load = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Loading..."));
            sid = $scope.isReplicated || $scope.replica.sid === undefined ? $rootScope.local.id : $scope.replica.sid;

            var resp = PHD.Ajax.get('/api/restore/targets/?sid=' + sid + "&instance_id=" + $scope.instanceID);

            resp.done(function (data) {
                var locations = [];
                for (var i = 0; i < data.targets.length; i++) {
                    var value = data.targets[i];
                    $scope.hypervisorTypeObj.locationName = value.name;
                    var locationTempObj = {};

                    locationTempObj.value = value.id;
                    locationTempObj.name = value.name;
                    locations.push(locationTempObj);

                    $scope.hypervisorTypeObj = {};
                    $scope.hypervisorId = value.id;

                    $scope.collectDataStore = data.targets;
                    if (typeof(value.groups) !== "undefined") {
                        $scope.collectVMwareLocation = value;
                    }
                }

                setTimeout($scope.$apply(function () {
                    $scope.locations = locations;
                }), 0);

                PHD.hideLoadingIndicator(load);

            });// End target location retrieving.
        };

        $scope.locationChange = function(location){
            $scope.dataStoresPools = [];
            if ($scope.replica.location !== "" && typeof($scope.replica.location) !== "undefined") {
                $scope.dataStoresPools = [];
                for (var i = 0; i < $scope.collectDataStore.length; i++) {
                    if (typeof($scope.collectDataStore[i].groups) !== "undefined") {
                        if ($scope.collectDataStore[i].id  == location) {
                            $scope.replica.resourcePool = "";
                            angular.forEach($scope.collectDataStore[i].groups.VG, function(value, key) {
                                var obj = {
                                    name: value.Name,
                                    value:value.Key
                                };
                                $scope.dataStoresPools.push(obj);
                            });
                        }
                    }
                }

                $scope.dataStores = [];
                if (typeof($scope.collectDataStore) !== "undefined") {
                    for (var i = 0; i < $scope.collectDataStore.length; i++) {
                        if ($scope.collectDataStore[i].id == location) {
                            $scope.replica.datastore = "";
                            if (typeof($scope.collectDataStore[i].datastores) !== "undefined") {
                                for (var j = 0; j < $scope.collectDataStore[i].datastores.length; j++) {
                                    $scope.dataStores.push($scope.collectDataStore[i].datastores[j].name + ' (' + addFreeSize($scope.collectDataStore[i].datastores[j].free_size_gb) + ')');

                                }
                            }
                        }
                    }
                }
            }
        };

        /********************* For Multiple VM Replica creation ******************************/
        var databasesTemplate = '<div ng-repeat="(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name" ' +
            'class="ui-grid-cell" ng-class="{ \'ui-grid-row-header-cell\': col.isRowHeader }" ui-grid-cell></div></div>';


        $scope.createMultipleReplicasGridData = {
            multiSelect: false,
            selectionRowHeaderWidth: 35,
            rowHeight: 24,
            enableFullRowSelection : true,
            gridMenuShowHideColumns:false,
            enableColumnMenus:false,
            enableHorizontalScrollbar: 0,
            rowTemplate: databasesTemplate,
            data: $scope.createMultipleReplicas
        };

        $scope.createMultipleReplicasGridData.columnDefs = [
            {
                field: "name",
                displayName: gettextCatalog.getString("Replica Name"),
                type: "string",
                headerCellFilter: "translate"
            }
        ];


        $scope.saveReplicas = function() {
            var url= "/api/replicas/";

            var hypervisor_info = {};

            //we added the ds size for usability.  need to strip it off before sending in payload
            if ($scope.replica.datastore !== null) {
                var lastIndex = $scope.replica.datastore.lastIndexOf("(");
                $scope.replica.datastore = $scope.replica.datastore.substring(0, lastIndex - 1);
            }

            hypervisor_info.vm_location = $scope.replica.datastore;
            hypervisor_info.esx_host = $scope.replica.location;
            if ($scope.replica.resourcePool !== null && $scope.replica.resourcePool !== undefined && $scope.replica.resourcePool !== "") {
                hypervisor_info.container = $scope.replica.resourcePool;
            }

            var dataObject = {};
            var createMultiObj = [];

            if ($scope.isMultiple){
                dataObject.replicas = {};
                dataObject.replicas.replica = {};

                for (var i = 0; i < $scope.createMultipleReplicas.length; i++){
                    var obj = {};
                    obj.instance_id = $scope.createMultipleReplicas[i].instanceID;
                    obj.name = $scope.createMultipleReplicas[i].name;

                    createMultiObj.push(obj);

                }
                dataObject.replicas.replica = createMultiObj;
                dataObject.replicas.multiple = true;
                dataObject.replicas.hypervisor_info = hypervisor_info;
                dataObject.replicas.number_of_snaps = $("#replica-recovery-points").val();
            } else {

                dataObject.replica = {};
                dataObject.replica.instance_id = $scope.instanceID;
                dataObject.replica.replica_name = $scope.replica.name;
                dataObject.replica.number_of_snaps = $("#replica-recovery-points").val();
                dataObject.replica.hypervisor_info = hypervisor_info;
            }

            var params = {};
            params.sid = $scope.isReplicated || $scope.replica.sid === undefined ? $rootScope.local.id : $scope.replica.sid;
            var load = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Creating Replicas..."));
            $http({
                method: 'post',
                url : url,
                data: JSON.stringify(dataObject),
                params: params
            }).success(function(data, status, headers){
                PHD.hideLoadingIndicator(load);
                ngDialog.close('replicas-dialog');
                //TODO add job IDs and Active Jobs button in a success dialog

            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                })
            });
        };

        $scope.nextStepWizard = function($event) {
            if (wizardTitle === gettextCatalog.getString("Select Virtual Machine")) {
                if (!$scope.validateInventory()) {
                    return;
                }
                var load = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Loading..."));
                $scope.getTargetLocationDetails();

                $rootScope.$broadcast("nextBtnClick");
                PHD.hideLoadingIndicator(load);

            } else if(wizardTitle === gettextCatalog.getString("Define Location")) {
                if ($scope.validateLocation()) {
                    var load = PHD.showLoadingIndicator("body", true, gettextCatalog.getString("Loading..."));

                    $scope.replica.name = $scope.inventoryData[0].name + '_replica';
                    $rootScope.$broadcast("nextBtnClick");

                    PHD.hideLoadingIndicator(load);
                }

            } else if(wizardTitle === gettextCatalog.getString("Define Replica Options")) {
                if ($scope.validateOptions()) {
                    $scope.saveReplicas();
                }
            }
        };

        // At least one VM must be selected.
        $scope.validateInventory = function() {
            var valid = true;
            var selectedCount = Object.keys($scope.selectedAsset).length;
            if (selectedCount == 0){
                valid = false;
            }
            return valid;
        };

        $scope.validateLocation = function() {
            $scope.errorField = false;
            $scope.locationError = false;
            $scope.datastoreError = false;

            if ($scope.replica == undefined) {
                return false;
            }
            if (typeof($scope.replica.location) == "undefined" || $scope.replica.location == "" || $scope.replica.location == null) {
                $scope.errorField = true;
                $scope.locationError = true;
            }
            if (typeof($scope.replica.datastore) == "undefined" || $scope.replica.datastore == "" || $scope.replica.datastore == null) {
                $scope.errorField = true;
                $scope.datastoreError = true;
            }

            return !$scope.errorField;
        };

        $scope.validateOptions = function() {
            $scope.errorOptionsField = false;
            $scope.nameError = false;
            $scope.recoveryPointsError = false;

            if ($scope.replica == undefined) {
                return false;
            }
            if (typeof($scope.replica.name) == "undefined" || $scope.replica.name == "" || $scope.replica.name == null) {
                $scope.errorOptionsField = true;
                $scope.nameError = true;
            }

            var recoveryPoints = $("#replica-recovery-points").val();
            if (typeof($scope.replica.recoveryPoints) == "undefined" || $scope.replica.recoveryPoints == "" || $scope.replica.recoveryPoints == null ||
                    recoveryPoints < 1 || recoveryPoints > $scope.maxRecoveryPoints) {
                $scope.errorOptionsField = true;
                $scope.recoveryPointsError = true;
            }

            return !$scope.errorOptionsField;
        }

        // converting the free size to a string of the form 'xxx.x GB' or 'xxx.x TB'
        function addFreeSize(sizeInGb) {
            var textSize = '';
            if (sizeInGb > 1000) {
                textSize = (sizeInGb / 1024).toFixed(1) + gettextCatalog.getString(' TB free');
            } else {
                textSize = sizeInGb + gettextCatalog.getString(' GB free');
            }
            return textSize;
        }

}]);
