var windowRecoverModule = angular.module('windowRecoveryModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid.selection']);

windowRecoverModule.config(['ngDialogProvider', function (ngDialogProvider) {
    ngDialogProvider.setDefaults({
        plain: false,
        closeByDocument: true,
        closeByEscape: true,
        appendTo: false,
        preCloseCallback: function (value) {

        }
    });
}]);


windowRecoverModule.factory('wirFactory', function($http,ngDialog) {
    return {
        getWIRDetail: function(method, url, sid,dataObj, hypervisor_type, hypervisor) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;

                if(hypervisor_type !== "" && hypervisor!==""){
                    params.type = hypervisor_type;
                    params.os_id = parseInt(hypervisor);
                }                }
            var promise = $http({
                url: url,
                data: dataObj,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });
            });
            return promise;
        }
    };
});

windowRecoverModule.factory('networkDataFactory', function($http,ngDialog) {
    return {
        getWIRNetWorkDetails: function(method, url, sid,dataObj, hypervisor_type, hypervisor) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;

                if(hypervisor_type !== "" && hypervisor!==""){
                    params.hypervisor_type = hypervisor_type;
                    params.hypervisor = hypervisor;
                }

            }
            var promise = $http({
                url: url,
                data: dataObj,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });

            });
            return promise;
        }
    };
});
windowRecoverModule.filter('getInstance', function($filter) {
    return function(input) {
        if(input.indexOf('::') > -1){
            return input.substring(0, input.indexOf('::'));
        }else{
            return input;
        }

    };
});
windowRecoverModule.filter('getDatabase', function($filter) {
    return function(input) {
        if(input.indexOf('::') > -1){
            return input.substring(input.indexOf('::')+2,input.length );
        }else{
            return input;
        }

    };
});
windowRecoverModule.controller('windowRecoveryCtrl', ['$scope', '$rootScope', '$http', '$timeout', 'ngDialog', 'wizardService', '$analytics', 'wirFactory', 'networkDataFactory', 'uiGridConstants', 'gettextCatalog',
    function($scope, $rootScope, $http, $timeout, ngDialog, wizardService, $analytics, wirFactory, networkDataFactory, uiGridConstants, gettextCatalog) {
        $scope.gridList=[];
        $scope.vc = {};
        $scope.isRowSelected = false;
        $scope.isNextButtonClicked = false;
        $scope.hideRSP = false;
        $scope.isUnitrendAppliance = false;
        $scope.selectedCandidate = null;

        $scope.vfc_memory=0;
        $scope.processors = 0;

        $scope.osId = 0;
        $scope.hypervisorId = 0;

        $scope.selectedType ="";
        $scope.hypervisor_type="";

        $scope.locationTypes=[];
        $scope.locations = [];
        $scope.dataStores = [];
        $scope.dataStoresPools = [];
        $scope.networks = [];

        $scope.vc.wirNetworkIP ="";
        $scope.vc.wirNetworkNetMask ="255.255.255.0";
        $scope.vc.wirNetworkGateway = "";
        $scope.vc.selectedNetwork ="";
        $scope.vc.selecteddataStorePool="";
        $scope.vc.locationObj="";
        $scope.vc.selecteddataStore="";
        $scope.vc.selectedNetwork="";
        $scope.candidateConfig ={};
        $scope.candidateVFCConfig ={};
        $scope.selectedVolumes =[];
        $scope.vc.auditVerify = false;
        $scope.isSelecetedTypeVMware = false;

        $scope.tabsList = ["Volumes"];
        $scope.vfcOptionsGridDataArray=[];
        $scope.vfccolumnDefintion=[];
        $scope.wirVfcObject={
            tabs:["Volumes"]/*,
             applications:["GridOptions0"],
             gridOptions:["$scope.GridOptions0"]*/
        }
        $scope.dataGrids=[];
        $scope.dataGridOption={};
        $scope.getGridData = [];

        $scope.gridExchangeOptions={};

        $scope.hyperVisorTypeObj = {};

        $scope.viewSourceDetails = function() {
            ngDialog.open({
                template: 'app/recover/wir/sourceDetail.html',
                scope: $scope,
                overlay:true,
                modelDialogId:'window-instant-recover-dialog',
                ngDialogStyle:'width:320px'
            });
        };

        $scope.protectedAssetGridOptions = {
            exporterMenuCsv: false,
            enableFullRowSelection : true,
            enableRowHeaderSelection: false,
            enableHorizontalScrollbar:0,
            multiSelect: false,
            columnDefs: [
                { name: 'client_name', displayName:gettextCatalog.getString("Asset Name") },
                { name: 'client_os', displayName:gettextCatalog.getString("Description")}
            ]
        };

        $scope.protectedAssetGridOptions.onRegisterApi = function(gridApi){
            //set gridApi on scope
            $scope.gridApi = gridApi;
            gridApi.selection.on.rowSelectionChanged($scope,function(row){
                $scope.isRowSelected = row.isSelected;
                var msg = 'row selected ' + row.isSelected;
                $scope.osId = row.entity.client_os_id;
                $scope.selectedCandidate = row.entity;
                //console.log(msg);
            });
        };

        $scope.protectedAssetGridOptions.isRowSelectable =function(row){
            if(row.entity.grandclient){
                row.entity.client_name = row.entity.client_name + COPIED_ASSET;
            }
            return true;
        };


        //API call for step first "Select Protected Asset".
        var assetURL = "/api/virtual_clients/candidates/";
        wirFactory.getWIRDetail('get',assetURL,1,"","","").then(function(data){
            $scope.protectedAssetGridOptions.data =[];
            for(var i=0; i<data.data.data.length; i++){
                if(data.data.data[i].candidates !== null && data.data.data[i].candidates!== undefined){
                    for(var j=0; j<data.data.data[i].candidates.length; j++){
                        $scope.flatCandidateObject = data.data.data[i].candidates[j];
                        $scope.flatCandidateObject.sid = data.data.data[i].system_id;
                        //SJ: include candidates if Backup_id is undefined
                        if($scope.flatCandidateObject.virtual_id == undefined ){
                            $scope.protectedAssetGridOptions.data.push($scope.flatCandidateObject);
                            $scope.flatCandidateObject={};
                        }
                    }
                }
            }
        });// End

        //API call for step first "Define Location".
        $scope.getLocationTypeDetails = function(selectedType){
            var locationTypeURL =  "/api/virtual_clients/supported/";
            wirFactory.getWIRDetail('get',locationTypeURL,$scope.selectedCandidate.sid,"","","").then(function(data){
                $scope.locationTypes=[];//if user press priviouse and come back then dropdown reset.
                $scope.selectedType = "";
                console.log($scope.selectedType);
                for(var j=0; j<data.data.wir.length; j++){
                    for(var i=0; i<data.data.wir[j].supported.length; i++){
                        $scope.locationTypes.push(data.data.wir[j].supported[i]);
                    }
                }

                if (selectedType=="" || typeof(selectedType)== "undefined") {
                    $scope.selectedType = $scope.locationTypes[0];    
                } else {
                    $scope.selectedType = selectedType;
                }

                $scope.selectedTypeChange($scope.selectedType);

            });// End Location type retrieving.
        };// End of Method.

        //API execute after selection type.

        /********************************************/
        $scope.tab = 0;
        $scope.currentTab = 0;

        $scope.showCurrentTab = function(currentTab){
            $scope.currentTab = currentTab;
            $scope.tab = currentTab;

            //$scope.volumeGridOptions.data= $scope.vfcOptionsGridDataArray[$scope.tab];
            $(window).resize();
        }

        $scope.isSelected = function(checkTab) {
            return $scope.tab === checkTab;
        };


        $scope.rspoolTempObj={};
        $scope.collectDataStore = [];
        $scope.collectVMwareLocation = [];
        //Retriving data as per Type selection.
        $scope.selectedTypeChange = function(selectedType){
            var load = PHD.showLoadingIndicator("body", true, "Loading...");

            $scope.locations        = []; //reset combo before get data .
            $scope.dataStores       = []; //reset combo before get data .
            $scope.dataStoresPools  = []; //reset combo before get data .
            $scope.networks         = []; //reset combo before get data .
            $scope.collectDataStore = [];
            $scope.collectVMwareLocation = [];
            $scope.isSelecetedTypeVMware = false;

            $scope.vc.locationObj = "";

            if(selectedType !=="" && typeof(selectedType) !== "undefined" && selectedType !== null){
                $scope.selectedType = selectedType;
            }else {
                $scope.selectedType = null;
                $scope.hypervisor_type = null;
            }

            if($scope.selectedType === HYPERVISOR_VMWARE_HOST){
                $scope.hypervisor_type = "VMware";
                $scope.hideRSP = false;
                $scope.isUnitrendAppliance = false;
                $scope.isSelecetedTypeVMware = true;
            }else if($scope.selectedType === HYPERVISOR_HYPERV_HOST){
                $scope.hypervisor_type = "Hyper-V";
                $scope.hideRSP = true;
                $scope.isUnitrendAppliance = false;
            }else{
                $scope.hideRSP = false;
            }

            if(angular.lowercase($scope.selectedType) === angular.lowercase(HYPERVISOR_UNITRENDS_APPLIANCE)){
                $scope.isUnitrendAppliance = true;
            }else if(angular.lowercase($scope.selectedType) !== angular.lowercase(HYPERVISOR_UNITRENDS_APPLIANCE)){
                $scope.isUnitrendAppliance = false;
            }

            // API Call for retrieving data for target details.
            if(!$scope.isUnitrendAppliance && $scope.hypervisor_type !== null){
                var locationURL =  "/api/virtual_clients/targets/";

                wirFactory.getWIRDetail('get',locationURL,$scope.selectedCandidate.sid,"", $scope.hypervisor_type, $scope.osId).then(function(data){

                    $scope.locations        = []; //reset combo before get data .
                    $scope.dataStores       = []; //reset combo before get data .
                    $scope.dataStoresPools  = []; //reset combo before get data .
                    $scope.networks         = []; //reset combo before get data .

                    angular.forEach(data.data.targets, function(value, key) {
                        $scope.hyperVisorTypeObj.locationName = value.name;
                        var locationTempObj = {};
                        locationTempObj.value = value.id;
                        locationTempObj.name = value.name;
                        $scope.locations.push(locationTempObj);
                        $scope.hyperVisorTypeObj={};

                        if($scope.hypervisor_type === "Hyper-V")
                            $scope.hypervisorId = value.name;
                        else if($scope.hypervisor_type === "VMware")
                            $scope.hypervisorId = value.id;

                        $scope.collectDataStore = data.data.targets;
                        if( typeof(value.groups) !=="undefined"){
                            $scope.collectVMwareLocation = value;
                        }
                    });

                    PHD.hideLoadingIndicator(load);
                });// End target Location retriving.
            }else{
                PHD.hideLoadingIndicator(load);
            }
        };

        $scope.locationChange = function(location){
            $scope.dataStoresPools=[];

            if($scope.vc.locationObj!=="" && typeof($scope.vc.locationObj) !== "undefined"){
                $scope.dataStoresPools=[];
                for(var i=0; i<$scope.collectDataStore.length; i++){

                    if(typeof($scope.collectDataStore[i].groups) !== 'undefined'){
                        if($scope.collectDataStore[i].id  == location){
                            $scope.vc.selecteddataStorePool="";
                            angular.forEach($scope.collectDataStore[i].groups.VG, function(value, key) {
                                var obj={
                                    name:value.Name,
                                    value:value.Key
                                };
                                $scope.dataStoresPools.push(obj);

                            });
                        }
                    }
                }
                $scope.networkCheck=false;
                $scope.dataStores=[];
                if(typeof($scope.collectDataStore) != "undefined")
                    for(var i=0; i<$scope.collectDataStore.length; i++){
                        console.log($scope.collectDataStore[i].id);
                        if($scope.collectDataStore[i].id  == location){
                            console.log($scope.collectDataStore[i]);
                            if(typeof($scope.collectDataStore[i].datastores) != "undefined"){
                                $scope.networkCheck=true;
                                console.log('collectDataStore[i].datastores');
                                for(var j=0; j<$scope.collectDataStore[i].datastores.length; j++){
                                    $scope.dataStores.push($scope.collectDataStore[i].datastores[j].name);

                                }
                            }
                        }
                    }
            }

            //API Call for retrieving data of Network as per selection type.
            if($scope.vc.locationObj){

                var load = PHD.showLoadingIndicator("body", true, "Loading...");
                $scope.vc.locationName = $.grep($scope.locations, function (location) {
                    return location.value == $scope.vc.locationObj;
                })[0].name;

                var networkURL ="/api/networks/hypervisor-switch/";
                if($scope.hypervisor_type === "Hyper-V"){
                    $scope.hypervisorId = $scope.vc.locationName;
                }else if($scope.hypervisor_type === "VMware"){
                    $scope.hypervisorId = $scope.vc.locationObj;
                }

                if($scope.networkCheck){
                    networkDataFactory.getWIRNetWorkDetails('get',networkURL,$scope.selectedCandidate.sid,"",$scope.hypervisor_type,$scope.hypervisorId).then(function(data){
                        PHD.hideLoadingIndicator(load);
                        $scope.networks =[];
                        angular.forEach(data.data.names, function(value, key) {
                            $scope.networks.push(value);
                        });
                    });
                }else{
                    PHD.hideLoadingIndicator(load);

                }


            }
        };

        /************************ On click of wizard next button ***************************/


        $scope.nextStepWizard = function($event){
            //Step 1st
            if(wizardTitle == gettextCatalog.getString("Select Protected Asset")){

                $scope.isNextButtonClicked = true;
                if($scope.isRowSelected){
                    var load = PHD.showLoadingIndicator("body", true, "Loading...");
                  
                    $scope.getLocationTypeDetails($scope.selectedType);
                    
                    $rootScope.$broadcast("nextBtnClick");
                    PHD.hideLoadingIndicator(load);

                }
            } else if(wizardTitle === gettextCatalog.getString("Define Location")){
                $scope.min_memory = 1,
                    $scope.max_memory = 99999,
                    $scope.memory_step = 1,
                    $scope.min_processors = 1,
                    $scope.max_processors = 99;
                if ($scope.selectedType === HYPERVISOR_VMWARE_HOST) {
                    $scope.min_memory = 1024;
                    $scope.memory_step = 4;
                    $( "#wir-vfc-processors" ).spinner({min: $scope.min_processors, max: $scope.max_processors});
                    $( "#wir-vfc-memory" ).spinner({min: $scope.min_memory, max: $scope.max_memory, step: $scope.memory_step});

                } else if ($scope.selectedType === HYPERVISOR_HYPERV_HOST) {
                    $scope.min_memory = 1024;
                    $scope.memory_step = 2;
                    $( "#wir-vfc-processors" ).spinner({min: $scope.min_processors, max: $scope.max_processors});
                    $( "#wir-vfc-memory" ).spinner({min: $scope.min_memory, max: $scope.max_memory, step: $scope.memory_step});

                } else if ($scope.selectedType === HYPERVISOR_UNITRENDS_APPLIANCE) {
                    $scope.max_processors = 4;
                    $scope.max_memory = 8192;
                    var params = {};
                    params.sid = $scope.selectedCandidate.sid;
                    var promise = $http({
                        url: "/api/systems/details/",
                        method: "get",
                        params: params
                    }).success(function (data) {
                        console.log(data.appliance.processors);
                        $scope.max_processors = data.appliance.processors;
                        var str_memory = data.appliance.memory.toString();
                        str_memory.replace(" GB", "");
                        $scope.max_memory = parseInt(str_memory, 10) * 1000;
                        $( "#wir-vfc-processors" ).spinner({min: $scope.min_processors, max: $scope.max_processors});
                        $( "#wir-vfc-memory" ).spinner({min: $scope.min_memory, max: $scope.max_memory, step: $scope.memory_step});

                    })
                }

                $('#wir-vfc-name').prop('disabled', ($scope.isUnitrendAppliance));
                if(validateWIR()){
                    var load = PHD.showLoadingIndicator("body", true, "Retrieving asset details...");

                    //$scope.getVFCOptionDetails();
                    //Below code should get data and assign to $scope.candidateConfig
                    var params = {};
                    params.sid = $scope.selectedCandidate.sid;
                    if($scope.selectedCandidate.backup_id !== undefined){
                        params.bid= $scope.selectedCandidate.backup_id;
                    }else {
                        params.cid= $scope.selectedCandidate.client_id;
                    }
                    var promise = $http({
                        url: "/api/clients/config/",
                        method: "get",
                        params: params
                    }).success(function(data, status, headers){
                        PHD.hideLoadingIndicator(load);
                        if(data != null && data.data != null){
                            $rootScope.$broadcast("nextBtnClick");
                            if ($scope.selectedCandidate.client_name.indexOf(COPIED_ASSET) > -1) {
                                $scope.selectedCandidate.client_name = $scope.selectedCandidate.client_name.replace(COPIED_ASSET, "");
                            }
                            $scope.candidateConfig =data.data;
                            $scope.candidateConfig.nameSource = $scope.selectedCandidate.client_name;
                            $scope.candidateConfig.os = $scope.selectedCandidate.client_os;
                            $scope.candidateConfig.sourceMemory =$scope.candidateConfig.memory;
                            $scope.candidateConfig.sourceProcessors = $scope.candidateConfig.processors;
                            $scope.candidateVFCConfig =data.data;
                            $scope.candidateVFCConfig.nameTarget ="";
                            if(!$scope.isUnitrendAppliance){
                                $scope.candidateVFCConfig.nameTarget = "Unitrends_" + $scope.selectedCandidate.client_name;
                            }
                            $scope.vfcOptionsGridDataArray[0]=$scope.candidateVFCConfig.volumes;
                            $scope.vfccolumnDefintion.push([{ field: 'label', showHeader: false}]);
                            $scope.getApplicationsData();
                            //$scope.volumeGridOptions.data = $scope.vfcOptionsGridDataArray[0];
                        }
                    }).error(function(response){
                        PHD.hideLoadingIndicator(load);
                        ngDialog.open({
                            dialogType:'retry',
                            dialogMessage:response.result[0].message
                        });

                    });

                    /**************** Retriving Tab data  ******************/



                    /**********************************************/

                }

            }else if(wizardTitle === gettextCatalog.getString("Define Replica Options")){
                if(checkedValidationVPCOption($scope.isUnitrendAppliance,$scope.min_processors,$scope.max_processors,$scope.min_memory,$scope.max_memory,$scope.selectedType,$scope.memory_step)){

                    var url="/api/virtual_clients/";
                    var dataObject ={};
                    dataObject.client ={};
                    dataObject.client.client_id = $scope.selectedCandidate.client_id;
                    //dataObject.client.processors = $scope.candidateVFCConfig.processors;

                    dataObject.client.processors = $("#wir-vfc-processors").val();

                    //dataObject.client.memory = $scope.candidateVFCConfig.memory;
                    //console.log("Memory :::: "+$("#wir-vfc-memory").val());
                    dataObject.client.memory = $("#wir-vfc-memory").val();

                    dataObject.client.efi = $scope.candidateVFCConfig.efi;

                    if(typeof($scope.candidateVFCConfig.disks)!="undefined") {
                        dataObject.client.disks = $scope.candidateVFCConfig.disks.join();
                    }

                    dataObject.client.boot = $scope.candidateVFCConfig.boot_disk;

                    $scope.selectedVolumes = eval($scope.gridList[0]).selection.getSelectedRows();
                    var selectedVol = [];
                    for(var i=0;i<$scope.selectedVolumes.length;i++){
                        var vol = $scope.selectedVolumes[i].label.replace("(critical) ","");
                        selectedVol.push(vol);
                    }

                    /**** for ExcludeList****************/

                    var excludeArray = [];
                    var VolumeGridData = $scope.dataGrids[0].data;
                    console.log($scope.dataGrids[0].data);
                    var filterExcludeVolumeArray = VolumeGridData.filter(function(obj) { return $scope.selectedVolumes.indexOf(obj) == -1; })
                    //console.log(filterExcludeVolumeArray);
                    for(var i=0;i<filterExcludeVolumeArray.length;i++){
                        excludeArray.push(filterExcludeVolumeArray[i].label);
                    }
                    //console.log(excludeArray.toString());

                    /**** End ofExcludeList****************/

                    dataObject.client.include = selectedVol.join();
                    dataObject.client.exclude = excludeArray.toString();
                    dataObject.client.audit_verify = $scope.vc.auditVerify;

                    databaseArray =[];
                    for(var i=1; i<$scope.gridList.length;i++){
                        var selectedDB = eval($scope.gridList[i]).selection.getSelectedRows();
                        if(selectedDB!= undefined || selectedDB!= null){
                            for(var j=0;j<selectedDB.length;j++){
                                if(selectedDB[j].is_system_db != undefined){ // As per businesslogic that do not include system DB
                                    if(selectedDB[j].is_system_db){
                                        continue;
                                    }
                                }
                                databaseArray.push(selectedDB[j].id);
                            }
                        }
                    }

                    if(databaseArray.length>0){
                        dataObject.client.instances = databaseArray.toString();
                    }

                    if(!$scope.isUnitrendAppliance){
                        var network_info = {};
                        network_info.switch = $scope.vc.selectedNetwork;
                        network_info.gateway = $scope.vc.wirNetworkGateway;
                        network_info.subnet = $scope.vc.wirNetworkNetMask;
                        network_info.ip_addr =  $scope.vc.wirNetworkIP;
                        dataObject.client.network_info = network_info;
                        var hypervisor_info ={};
                        // selecteddataStorePool locationObj selected dataStore selectedNetwork
                        hypervisor_info.vm_name = $scope.candidateVFCConfig.nameTarget;

                        if($scope.selectedType==="VMware host"){
                            hypervisor_info.vm_location = $scope.vc.selecteddataStore;
                            hypervisor_info.esx_host = $scope.vc.locationObj;
                            if($scope.vc.selecteddataStorePool !== null || $scope.vc.selecteddataStorePool !== undefined){
                                hypervisor_info.pool = $scope.vc.selecteddataStorePool;
                            }

                        }else if($scope.selectedType==="Hyper-V host"){
                            hypervisor_info.vm_location = $scope.vc.selecteddataStore;
                            hypervisor_info.hyperv_host = parseInt($scope.vc.locationObj);
                        }
                        dataObject.client.hypervisor_info = hypervisor_info;
                    }


                    var params = {};
                    params.sid = $scope.selectedCandidate.sid;
                    var load = PHD.showLoadingIndicator("body", true, "Creating Windows Replica...");
                    $http({
                        method: 'post',
                        url : url,
                        data: JSON.stringify(dataObject),
                        params: params
                    }).success(function(data, status, headers){
                        PHD.hideLoadingIndicator(load);
                        ngDialog.close('window-instant-recover-dialog');

                        $timeout(function() {
                            $rootScope.RecoverTimer.stop();
                            $(document).off("timertick.recoverpage");
                            delete $(document);

                            var eventsTab = angular.element(document.getElementById("recover-ir"));
                            var injector = eventsTab.injector();
                            var route = injector.get('$route');
                            route.reload();
                        }, 500);

                    }).error(function(response) {
                        PHD.hideLoadingIndicator(load);
                        ngDialog.open({
                            dialogType:'retry',
                            dialogMessage:response.result[0].message
                        })
                    });
                }
            }
        }

        $scope.getApplicationsData = function(){
            var tabParams = {};
            tabParams.sid = $scope.selectedCandidate.sid;
            tabParams.client_id = $scope.selectedCandidate.client_id;


            $http({
                url: "/api/applications/",
                method: "get",
                params: tabParams
            }).success(function(data, status, headers){
                console.log("************************");

                var applicationData = data.data[0].applications;
                if(typeof(data.data[0].applications)!="undefined"){
                    for(var i=0; i<data.data[0].applications.length; i++){
                        if(data.data[0].applications[i].id === APP_ID_EXCHANGE_2003
                            ||data.data[0].applications[i].id === APP_ID_EXCHANGE_2007
                            ||data.data[0].applications[i].id === APP_ID_EXCHANGE_2010
                            ||data.data[0].applications[i].id === APP_ID_EXCHANGE_2013
                            ||data.data[0].applications[i].id === APP_ID_EXCHANGE_2016
                            ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2005
                            ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2008
                            ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2008_R2
                            ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2012
                            ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2014
                            ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2016
                            ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2017){

                            $scope.wirVfcObject.tabs.push(data.data[0].applications[i].name);
                            $scope.vfcOptionsGridDataArray.push(data.data[0].applications[i].children);
                            if(data.data[0].applications[i].id === APP_ID_SQL_SERVER_2005
                                ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2008
                                ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2008_R2
                                ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2012
                                ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2014
                                ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2016
                                ||data.data[0].applications[i].id === APP_ID_SQL_SERVER_2017){
                                console.log('data.data[0].applications[i].id'+data.data[0].applications[i].id);
                                $scope.vfccolumnDefintion.push([{ field: 'name',displayName: 'Instance', showHeader: false,cellFilter:'getInstance'},{ field: 'name',displayName: 'Database', showHeader: false,cellFilter:'getDatabase'}]);
                            }else{
                                $scope.vfccolumnDefintion.push([{ field: 'name',displayName: 'Database', showHeader: false}]);
                            }

                        }
                    }
                }

                console.log($scope.vfcOptionsGridDataArray);
                $scope.createGrid();
            }).error(function(response){
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                });
            });


        }
        $scope.createGrid= function(){
            $scope.dataGridOption=
            {
                columnDefs:$scope.vfccolumnDefintion[0],
                data:$scope.vfcOptionsGridDataArray[0],
                onRegisterApi: function(gridApi) {
                    //set gridApi on scope
                    $scope.gridApi = gridApi;
                    $scope.gridList.push(gridApi)
                    gridApi.selection.on.rowSelectionChanged($scope,function(row){
                        if((!row.isSelected) && row.entity.critical){
                            row.setSelected(true);
                        }
                    });
                },
                isRowSelectable :function(row){
                    if(row.entity.critical){
                        row.setSelected(true);
                        row.entity.label = (row.entity.label.indexOf("(critical)") == -1)?row.entity.label + "(critical) ":row.entity.label;
                    }
                    return true;
                }
            };
            $scope.dataGrids.push($scope.dataGridOption);
            for (var i =1 ; i <$scope.vfcOptionsGridDataArray.length;i++ ){
                $scope.dataGridOption=
                {
                    columnDefs:$scope.vfccolumnDefintion[i],
                    data:$scope.vfcOptionsGridDataArray[i],
                    onRegisterApi: function(gridApi) {
                        //set gridApi on scope
                        $scope.gridApi = gridApi;
                        $scope.gridList.push(gridApi)
                        gridApi.selection.on.rowSelectionChanged($scope,function(row){
                            if(row.entity.is_system_db != undefined){
                                if((!row.isSelected) && row.entity.is_system_db){
                                    row.setSelected(true);
                                }
                            }
                        });
                    },
                    isRowSelectable :function(row){
                        if(row.entity.is_system_db != undefined){
                            if(row.entity.is_system_db){
                                row.setSelected(true);
                            }
                        }
                        return true;
                    }
                };


                $scope.dataGrids.push($scope.dataGridOption);

            }
        }
        $scope.showtoolTipForEmailVerification = function(){
            var form = angular.element("#wir-vfc-form");
            console.log(form)
            form.find(".definition").popover({
                position: {
                    my: "left top",
                    at: "right+20 top"
                },
                appendTo: form
            });
        }
    }]);