angular.module('release-notes', ['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])
    .controller('releaseNotesCtrl', ['$scope', '$rootScope', '$http','ngDialog', '$window', '$timeout', 'tourFactory',
        function($scope, $rootScope, $http, ngDialog, $window, $timeout, tourFactory) {

            $scope.suppressReleaseNotes = false;

            $scope.closeThisDialog = function() {
                console.log($scope.suppressReleaseNotes);
                if ($scope.suppressReleaseNotes === true) {
                    $scope.turnOffReleaseNotes();
                }
                ngDialog.close('release-notes-dialog');
            };

            $scope.turnOffReleaseNotes = function() {
                var prefURL = '/api/preferences/' ;
                var putData = {};
                putData['show_release_notes'] = 'false';
                prefURL = prefURL + encodeURI($rootScope.user.name)+"/";
                tourFactory.sync('put',prefURL,1,putData).then(function(result){
                    console.log("success >> turned off release notes");
                });
            };

        }]);