var protectTourModel =  angular.module('tourReportsModel',['tour-module']);

protectTourModel.controller('tourReportsCtrl', function ($scope, $rootScope, tourFactory){

    var $tour           = $("#reports-tour"),
        $categories     = $("#tour-report-categories"), 
        $reports        = $("#tour-reports");
    
    var $jobTarget  = $("#widget-reports-tour");
    $scope.$currentStep = $rootScope.user.tourStep;


    $scope.initTour = function() {
        $(window).off("resize.tour");
        $(window).on("resize.tour",  PHD.util.debounce($scope.positionTour));
        $scope.positionTour();
        $tour.addClass("active");
    }


    $scope.positionTour = function() {
        if ($jobTarget.length > 0) {
            $categories.position({
                my: "left+78 top+100 ",
                at: "left+78 top+214",
                of: $jobTarget,
                using: positionElement
            });
            $reports.position({
                my: "left-576 top+175",
                at: "top+135",
                of: $jobTarget,
                using: positionElement
            });
        } else {
            console.log("reports tour init issue");
        }
        
    }

    function positionElement(attr, obj) {
        obj.element.element.css({
            top: attr.top,
            left: attr.left,
            position: 'absolute'
        });
    }

    $scope.endTour = function() {
        $(window).off("resize.tour");
        $(".tour-position").css("z-index", "auto");
        $tour.remove();
        $scope.$currentStep = $rootScope.user.tourStep = 1;
    
        var putData = {};
        putData['show_help_overlay'] = 'false';

        var prefURL = '/api/preferences/';
        prefURL = prefURL + encodeURI($rootScope.user.name)+"/";
        tourFactory.sync('put',prefURL,1,putData).then(function(result){
            console.log("success >> Recover");
        });
        
        $rootScope.user.showTour= false; 
        $scope.refreshPage();
    };

    /* 
     * Refresh App-main page
     */
     $scope.refreshPage = function(){
        var currentPage = angular.element(document.getElementById("app-main"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    $scope.reloadContent = function(){
        var currentPage = angular.element(document.getElementById("reports-tour"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    
    $scope.setNextTourStep = function() {
        if($scope.$currentStep === TOUR_STEP_REPORTS_END) {
            if ($rootScope.configureDisabled) {
                $scope.endTour();
                refreshPage();
                $scope.user.showTour = true;
                window.location.href = "#/dashboard/";
                setTimeout(function(){
                    $("#header-nav").removeClass("tourHilighter");
                }, 500);
            } else {
                //have to set the step before moving to the next page
                $scope.$currentStep = $rootScope.user.tourStep += 1;
                //go to the protect page
                window.location.href = "#/configure/";
                setTimeout(function(){
                    $("#configAppliance a").trigger('click');
                    $("#appliancetable").addClass("tourHilighter");
                }, 1000);
            }
        }else{
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep+=1; 
            $scope.positionTour();
            
             switch(parseInt($scope.$currentStep)) {
                    case 20:
                        setTimeout(function(){
                           $("#reprotCategories").addClass("tourHilighter");
                        }, 500); 
                        break;
                    case 21:
                        setTimeout(function(){
                            $(".report-section-right").addClass("tourHilighter");
                        }, 500);
                        break;
                    
                     default: $scope.reloadContent();
                        break;
                }
             
        }
        
    }

    $scope.setPreviousTourStep = function() {
        if(parseInt($scope.$currentStep) === TOUR_STEP_REPORTS_START) {
            //have to set step change before going back
            $scope.$currentStep = $rootScope.user.tourStep -=1; 
            
            //go back to the protect page
            window.location.href = "#/jobs/";
            
            setTimeout(function(){
                $("#recentJob a").trigger('click');
                $("#recentJob").addClass("tourHilighter");
                $("#jobs-history").addClass("tourHilighter");
            }, 500);
        } else {
            
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep -=1; 
            $scope.positionTour();
            
                switch(parseInt($scope.$currentStep)) {
                    case 20:
                        setTimeout(function(){
                           $("#reprotCategories").addClass("tourHilighter");
                        }, 500); 
                        break;
                    case 21:
                        setTimeout(function(){
                            $(".report-section-right").addClass("tourHilighter");
                        }, 500);
                        break;
                     default: $scope.reloadContent();
                        break;
                }
                       
        }
    }
    angular.element(document).ready(function () {
        $scope.initTour();
        $scope.positionTour();
    });
});

    
