angular.module('screen-resolution', ['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])
    .controller('resolutionCtrl', ['$scope', '$rootScope', '$http','ngDialog', '$window', '$timeout', 'tourFactory',
        function($scope, $rootScope, $http, ngDialog, $window, $timeout, tourFactory) {

            $scope.screenWidth = $scope.ngDialogData.width;
            $scope.screenHeight = $scope.ngDialogData.height;

            $scope.suppressWarning = false;

            $scope.closeThisDialog = function() {
                console.log($scope.suppressWarning);
                if ($scope.suppressWarning === true) {
                    $scope.turnOffWarning();
                }
                ngDialog.close('resolution-warning-dialog');
            };

            $scope.turnOffWarning = function() {
                var prefURL = '/api/preferences/' ;
                var putData = {};
                putData['show_resolution_warning'] = 'false';
                prefURL = prefURL + encodeURI($rootScope.user.name)+"/";
                tourFactory.sync('put',prefURL,1,putData).then(function(result){
                    console.log("success >> turned off screen resolution warning");
                });
            };

        }]);