<?php

header( 'Expires: -1' ); 
header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s' ) . ' GMT' ); 
header( 'Cache-Control: no-store, no-cache' ); 
header( 'Cache-Control: post-check=0, pre-check=0', false ); 
header( 'Pragma: no-cache' ); 

//
// Is this a Unitrends Free or Google Edition?
//
bp_bypass_cookie(2);
$Capabilities = bp_get_capabilities(NULL);
if ($Capabilities !== -1) {
	$isCE = isset($Capabilities['CE']) && $Capabilities['CE'] ? 1 : 0;
	$isGoogle = isset($Capabilities['google']) && $Capabilities['google'] ? 1 : 0;
	$isVirtual = isset($Capabilities['virtual_machine']) && $Capabilities['virtual_machine'] ? 1 : 0;
    $isXen = isset($Capabilities['Xen']) && $Capabilities['Xen'] ? 1 : 0;
    $isKumo = isset($Capabilities['kumo']) && $Capabilities['kumo'] ? 1 : 0;
    $showArchiving = isset($Capabilities['no_archiving']) && $Capabilities['no_archiving'] ? 0 : 1;
    $showRetention = isset($Capabilities['global_retention']) && $Capabilities['global_retention'] ? 0 : 1;
} else {
	$isCE = 0;
	$isGoogle = 0;
	$isVirtual = 0;
    $isXen = 0;
    $isKumo = 0;
    $showArchiving = 1;
    $showRetention = 1;
}

$licenseClass = "";
$license = bp_get_license_info();
if ($license !== false) {
    $licenseClass = $license['class'];
    $mktString = isset($license['mkt_name']) ? $license['mkt_name']: "";
    $featureString = isset($license['feature_string']) ? $license['feature_string'] : "";
}

$assetTag = "";
$asset = bp_get_asset_tag();
if ($asset !== false) {
    $assetTag = $asset;
}

$appVersion = shell_exec('rpm -q --queryformat "%{version}.%{release}" unitrends-ui 2>&1');
if ($appVersion === NULL) {
    $appVersion = "10.1.0";
}

//
// If the portal server package is installed, show Networked/Loosely Coupled functionality
//
system('rpm -q --quiet xg-portal-server', $portalReturnValue);
$showLooselyCoupled = $portalReturnValue === 0 ? 1 : 0;

$localID = 1;
$local = bp_get_local_system_id();
if ($local !== false) {
    $localID = $local;
}
$localName = "local";
$local = bp_get_system_info($localID);
if ($local !== false && isset($local['name'])) {
    $localName = $local['name'];
}

$licenseType = bp_run_command("Appliance", "", NULL);

$isTarget = 0;
$identity = 'DPU';
$nvpConfig = bp_get_nvp_list("RRC", "configuration");
if ($nvpConfig !== false && isset($nvpConfig['Identity'])) {
    $identity = $nvpConfig['Identity'];
    if ($identity === 'DPV' || $identity === 'DPXV') {
        $isTarget = 1;
    }
}

// Global Preferences for setup wizard.  These are on a per-user basis, so we look to root's preferences.
$showWizard = -1;
$showEULA = -1;
$defaultLanguage = "en";
$preferences = rest_get_preferences('root');
if ($preferences !== false) {
    $showWizard = isset($preferences['show_setup_wizard']) ? $preferences['show_setup_wizard'] : -1;
    $showEULA = isset($preferences['show_eula']) ? $preferences['show_eula'] : -1;
    $showTour = isset($preferences['show_help_overlay']) ? $preferences['show_help_overlay'] : -1;
    isset($preferences['language']) ? $defaultLanguage = $preferences['language'] : false;
}

// Satori needs to *not* force the setup wizard on an upgrade where the user has already set up through the RRC.
$nvp = bp_get_nvp_list("preferences", "root");
if ($nvp !== false && isset($nvp['SetupWizardPopup']) && $nvp['SetupWizardPopup'] === "false") {
    $showWizard = $nvp['SetupWizardPopup'];
    $showEULA = $nvp['SetupWizardPopup'];
}

//Need to check if current version of Satori supports RDR.
$rdr = bp_rdr_supported($localID);
if ($rdr !== null) {
    $rdrSupported = $rdr ? 1 : 0;
} else {
    $rdrSupported = 0;
}

$vmReplicas = function_exists('bp_replica_vms_supported') ? bp_replica_vms_supported($localID) : -1;

$hypervReplicasSupported = 0;
$vmWareReplicasSupported = 0;

if ($vmReplicas !== -1 && is_array($vmReplicas)){
    foreach ($vmReplicas as $id => $hypervisor){
        if ($hypervisor == 'Hyper-V host'){
            $hypervReplicasSupported = 1;
        }
        if ($hypervisor == 'VMware host'){
            $vmWareReplicasSupported = 1;
         }
    }
}

// for new simple gateway platform, always show SLA Policies.
if ($isKumo) {
    $showSLAPolicies = 1;
} else {
    $showSLAPolicies = bp_get_ini_value("CMC", "showSLAPolicies");
    if ($showSLAPolicies !== false) {
        $showSLAPolicies = (strtolower($showSLAPolicies) == 'true') ? 1 : 0;
    } else {
        $showSLAPolicies = 0;
    }
}

// AHV
$showAHV = 1; // NO LONGER USED: bp_get_ini_value("CMC", "showAHV");

//get maximum vm replica recovery point
$maxRecoveryPoints = 0;
$maxReplicaSnapshots = function_exists('bp_get_max_replica_snapshots') ? bp_get_max_replica_snapshots() : false;
if ( $maxReplicaSnapshots !== false ) {
    $maxRecoveryPoints = $maxReplicaSnapshots['VMware host'];
}

bp_destroy_cookie();
?>
<!DOCTYPE html>
<html ng-app="uiApp" ng-controller="GlobalCtrl">
  <head>
    <title ng-bind="Unitrends + Page.title()">Unitrends</title>

    <!-- social media tags -->
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- font awesome from BootstrapCDN - This breaks the css of the UI app at this time -->
    <!--<link href="http://netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css" rel="stylesheet">-->

    <!-- styles -->
    <link rel="shortcut icon" href="assets/images/favicon.ico">

    <!--ngdialog style-->
    <link rel="stylesheet" href="assets/css/ngDialog/ngDialog.css">
    <link rel="stylesheet" href="assets/css/ngDialog/ngDialog-theme-default.css">

    <link rel="stylesheet" href="assets/css/lib/normalize.css">
    <link rel="stylesheet" href="assets/css/lib/jquery-ui-1.10.3.custom.css">

    <link rel="stylesheet" href="assets/css/font/fonts.css">
    <link rel="stylesheet" href="assets/css/color.css">
    <link rel="stylesheet" href="assets/css/base.css">
    <link rel="stylesheet" href="assets/css/layout.css">
    <link rel="stylesheet" href="assets/css/forms.css">
    <link rel="stylesheet" href="assets/css/tables.css">
        <link rel="stylesheet" href="assets/css/style.css">
    <link rel="stylesheet" href="assets/css/ng-grid.css">
      <link rel="stylesheet" href="assets/css/tour.css">
     <link rel="stylesheet"  href="assets/css/ng-custom-tab.css">

    <link rel="stylesheet" href="assets/css/ui/ui-widgets.css">
    <link rel="stylesheet" href="assets/css/ui/ui-selectmenu.css">
    <link rel="stylesheet" href="assets/css/ui/ui-timeslider.css">
    <link rel="stylesheet" href="assets/css/ui/treeview.css">

    <link rel="stylesheet" href="assets/css/pages.css">
    <link rel="stylesheet" href="assets/css/dialogs.css">

    <!--Popover support css file-->
    <link rel="stylesheet" href="assets/css/nspopup/nsPopover.css">
    <link rel="stylesheet" href="assets/css/nspopup/custom.css">

    <link rel="stylesheet" type="text/css" href="assets/css/quicksetup/angular-wizard.css">
    <link rel="stylesheet" type="text/css" href="assets/css/quicksetup/quickSetup.css">
    <!-- dashboard css -->
      <link rel="stylesheet" href="app/dynamic-dashboard/assets/css/angular-ui-dashboard.css">
      <link rel="stylesheet" href="app/dynamic-dashboard/assets/css/dynamicDashboard.css">


    <!-- tour css -->
      <link rel="stylesheet" href="vendor/angular-tour/angular-tour.css">

	  <!-- ui-grid -->
	  <link rel="stylesheet" href="assets/css/ui-grid/ui-grid.css" type="text/css">
	  <link rel="stylesheet" href="assets/css/ui-grid/customgrid.css" type="text/css">

    <!-- spectrum color picker -->
    <link rel="stylesheet" href="vendor/spectrum/spectrum.css" type="text/css">

	<!-- Replication Add Target css -->
    <link rel="stylesheet" href="app/configure/appliances/configure-target-wizard/configureTarget.css">

	<!--angular js tree -->
	<link rel="stylesheet" href="assets/css/angular-jstree/angularJsTree.css">
	<link rel="stylesheet" href="assets/css/angular-jstree/angularJsCustomTree.css">
    <link rel="stylesheet" href="app/protect/file-browser-dialog/fileBrowserDialog.css">

    <!--updates dialog -->
    <link rel="stylesheet" href="app/options/updates.css">

    <!-- vendor scripts -->
    <script type="text/javascript" src="vendor/bowser/bowser.min.js"></script>
    <script type="text/javascript" src="vendor/jquery/dist/jquery.min.js"></script>

    <script type="text/javascript" src="vendor/jquery-ui/jquery-ui.min.js"></script>
    <!-- i18n specific files for jquery-ui -->
    <script type="text/javascript" src="vendor/jquery-ui/i18n/datepicker-fr.js"></script>
    <script type="text/javascript" src="vendor/jquery-ui/i18n/datepicker-en-gb.js"></script>

    <script type="text/javascript" src="vendor/jquery-ui-touch-punch/jquery.ui.touch-punch.min.js"></script>
    <script type="text/javascript" src="vendor/jquery.validate/dist/jquery.validate.min.js"></script>
    <script type="text/javascript" src="vendor/jquery.cookie/jquery.cookie.js"></script>
    <script type="text/javascript" src="vendor/jquery.timeentry/jquery.timeentry.min.js"></script>

	<script type="text/javascript" src="vendor/angular-jstree/jstree.min.js"></script>

    <script type="text/javascript" src="vendor/form2js/form2js.js"></script>

    <script type="text/javascript" src="vendor/underscore/underscore-min.js"></script>
    <script type="text/javascript" src="vendor/moment/min/moment-with-locales.min.js"></script>
    <script type="text/javascript" src="vendor/angular/angular.min.js"></script>
    <script type="text/javascript" src="vendor/angular-tour/angular-tour-tpls.min.js"></script>

    <script type="text/javascript" src="vendor/angular-grid/ng-grid.debug.js"></script>
    <script type="text/javascript" src="vendor/angular-grid/ui-bootstrap-tpls-0.7.0.js"></script>
    <script type="text/javascript" src="vendor/angular-grid/ng-grid-flexible-height.js"></script>

    <script type="text/javascript" src="vendor/angular-route/angular-route.min.js"></script>
    <script type="text/javascript" src="vendor/angular-cookies/angular-cookies.min.js"></script>
    <script type="text/javascript" src="vendor/angular-gettext/dist/angular-gettext.min.js"></script>
    <script type="text/javascript" src="vendor/angular-local-storage/angular-local-storage.min.js"></script>
    <script type="text/javascript" src="vendor/angular-idle/angular-idle.min.js"></script>

    <!--ngDialog JS-->
    <script type="text/javascript" src="vendor/ngdialog/ngDialog.js"></script>

	<!--      ui-grid    -->
	<script type="text/javascript" src="vendor/ui-grid/angular-touch.js"></script>
	<script type="text/javascript" src="vendor/ui-grid/angular-animate.js"></script>
	<script type="text/javascript" src="vendor/ui-grid/csv.js"></script>
	<script type="text/javascript" src="vendor/ui-grid/pdfmake.js"></script>
	<script type="text/javascript" src="vendor/ui-grid/vfs_fonts.js"></script>

	<script type="text/javascript" src="vendor/ui-grid/ui-grid.js"></script>
	<!--<script type="text/javascript" src="vendor/ui-grid/ui-grid-header.js"></script> -->


    <!-- ng-jsTree-->

	<script type="text/javascript" src="vendor/angular-jstree/ngJsTree.min.js"></script>

	<!-- spectrum color picker -->
	<script type="text/javascript" src="vendor/spectrum/spectrum.js"></script>
    <script type="text/javascript" src="vendor/spectrum/spectrum.i18n.js"></script>
	<script type="text/javascript"  src="vendor/angular-spectrum/angular-spectrum.min.js"></script>

    <!-- calendar-->
    <script type="text/javascript" src="vendor/fullcalendar/fullcalendar.min.js"/></script>
    <!-- i18n specific files for fullcalendar -->
    <script type="text/javascript" src="vendor/fullcalendar/locale-all.js"></script>
    <script type="text/javascript" src="vendor/fullcalendar/gcal.js"/></script>
    <link rel="stylesheet" href="vendor/fullcalendar/fullcalendar.css">
    <script type="text/javascript" src="vendor/ui-calendar/calendar.js"/></script>
    <script type="text/javascript" src="vendor/ical/ical.js"/></script>
    <script type="text/javascript" src="vendor/angular-ical/angular-ical.js"/></script>

    <!-- flip animation -->
    <link rel="stylesheet" href="vendor/angular-flippy/css/angular-flippy.css">
    <link rel="stylesheet" href="vendor/angular-flippy/css/angular-flippy-fancy.css">
    <script type="text/javascript" src="vendor/angular-flippy/js/angular-flippy.js"></script>

    <!-- Libraries for QuickSetup Wizard -->
    <script type="text/javascript" src="vendor/lodash/lodash.min.js"></script>
    <script type="text/javascript" src="app/common/angular-wizard.js"></script>
    <script type="text/javascript" src="app/quick-setup/quickstart.js"></script>
    <script type="text/javascript" src="app/quick-setup/quickstartUtil.js"></script>
    <script type="text/javascript" src="app/common/wizardvalidation.js"></script>
    <script type="text/javascript" src="app/quick-setup/optimizer.js"></script>

      <script type="text/javascript" src="app/tour/tour-module.js"></script>

    <!-- not needed at this time, loading datepicker direction in jQuery
    <script type="text/javascript" src="vendor/angular-ui-date/src/date.js"></script>
    -->
    <!-- for dashboard charts and graphs -->
    <script type="text/javascript" src="vendor/raphael/Raphael.js"></script>
    <script type="text/javascript" src="vendor/g.raphael/g.raphael-min.js"></script>
    <script type="text/javascript" src="vendor/g.raphael/g.line-min.js"></script>
    <!-- for the reports subsystem -->
    <script type="text/javascript" src="vendor/g.raphael/g.pie-min.js"></script>
    <script type="text/javascript" src="vendor/g.raphael/g.bar-min.js"></script>

    <!--Popover model support file-->
      <script type="text/javascript" src="vendor/nspopup/nsPopover.js"></script>
      <!--angular checklist selection model-->
	  <script type="text/javascript" src="vendor/angular-checklist-model/checklist-model.js"></script>
	  <!--d3 chart library-->
	 <script type="text/javascript" src="vendor/d3-chart/d3.min.js"></script>
	 <script type="text/javascript" src="vendor/d3-chart/d3-tip.js"></script>

      <!-- tree-grid -->
      <script type="text/javascript" src="vendor/tree-grid/tree-grid-directive.js"></script>
      <link rel="stylesheet" href="vendor/tree-grid/treeGrid.css" type="text/css">

    <script type="text/javascript" src="vendor/tree-grid-job-progress/tree-grid-directive-job-progress.js"></script>

    <!-- the UI application in Angularjs -->
    <!--<script type="text/javascript" src="common/dialog-service.js"></script>-->
    <!-- lmc - still using old dialogs w/o wrapper -->
	<script type="text/javascript" src="app/protect/backup-job/backupJobCtrl.js"></script>
    <script type="text/javascript" src="app/protect/backup-job/backupJobController.js"></script>
    <script type="text/javascript" src="app/protect/backup-job/backupNowDialogController.js"></script>
    <script type="text/javascript" src="app/protect/backup-copy-job/backup-copy-module.js"></script>
    <script type="text/javascript" src="app/protect/custom-schedule/custom.js"></script>
    <script type="text/javascript" src="app/protect/page.protect.js"></script>
    <script type="text/javascript" src="app/protect/protect.js"></script>
    <script type="text/javascript" src="app/configure/appliances/appliances.js"></script>
    <script type="text/javascript" src="app/configure/appliances/dialog.edit-appliance.js"></script>
    <script type="text/javascript" src="app/configure/appliances/dialog.config-appliance.js"></script>
    <script type="text/javascript" src="app/configure/backupcopy/dialog.config-advancedBackupCopyEdit.js"></script>
    <script type="text/javascript" src="app/configure/appliances/dialog.config-datetime.js"></script>
    <script type="text/javascript" src="app/configure/encryption/dialog.config-encryption.js"></script>
    <script type="text/javascript" src="app/configure/appliances/dialog.config-license.js"></script>
    <script type="text/javascript" src="app/configure/notifications/dialog.config-email.js"></script>
    <script type="text/javascript" src="app/configure/appliances/dialog.config-users.js"></script>
    <script type="text/javascript" src="app/configure/protected-assets/protected-assets.js"></script>
    <script type="text/javascript" src="app/configure/copied-assets/copied-assets.js"></script>
    <script type="text/javascript" src="app/configure/networked-appliances/networked-appliances.js"></script>
    <script type="text/javascript" src="app/configure/networked-appliances/customers/dialog.customers.js"></script>
    <script type="text/javascript" src="app/configure/networked-appliances/options/dialog.portal-settings.js"></script>
    <script type="text/javascript" src="app/configure/configure.js"></script>
    <script type="text/javascript" src="app/configure/retention/retentionpolicy.js"></script>
    <script type="text/javascript" src="app/jobs/jobinventory.js"></script>
    <script type="text/javascript" src="app/jobs/page.jobs.js"></script>
    <script type="text/javascript" src="app/jobs/jobs.js"></script>
    <script type="text/javascript" src="app/jobs/jobsCalendar.js"></script>
    <script type="text/javascript" src="app/common/download.js"></script>
    <script type="text/javascript" src="app/common/datetime.js"></script>
    <script type="text/javascript" src="app/common/utility.js"></script>
    <script type="text/javascript" src="app/common/inventory-service.js"></script>
    <script type="text/javascript" src="app/common/cookie-service.js"></script>
    <script type="text/javascript" src="app/common/date-range/date-range.js"></script>
    <script type="text/javascript" src="app/common/retention-period/retention-period.js"></script>
    <script type="text/javascript" src="app/common/string-service.js"></script>
    <script type="text/javascript" src="app/common/sort-service.js"></script>
    <script type="text/javascript" src="app/reports/reports.js"></script>
    <script type="text/javascript" src="app/reports/reportsUtil.js"></script>
    <script type="text/javascript" src="app/reports/services/distributed-report-utils.js"></script>
    <script type="text/javascript" src="app/recover/recover.js"></script>
    <script type="text/javascript" src="app/recover/page.recover.js"></script>
    <script type="text/javascript" src="app/recover/backupfilter.js"></script>
    <script type="text/javascript" src="app/recover/ir/ir-controller.js"></script>
    <script type="text/javascript" src="app/recover/recoveryOptions/singleFileBrowserController.js"></script>
    <script type="text/javascript" src="app/recover/backup-copy/dialog.backup-copy.js"></script>
    <script type="text/javascript" src="app/common/utility.js"></script>
    <script type="text/javascript" src="app/inventory/details/page.status.js"></script>
    <script type="text/javascript" src="app/recover/replicas/replicas-module.js"></script>


    <script type="text/javascript" src="app/login/login.js"></script>
    <script type="text/javascript" src="app/help/help.js"></script>
    <script type="text/javascript" src="app/help/dialog.feedback.js"></script>
    <script type="text/javascript" src="app/options/options.js"></script>
    <script type="text/javascript" src="app/app.js"></script>
    <script type="text/javascript" src="common/graphs.js"></script>
    <script type="text/javascript" src="scripts/help-constants.js"></script>
    <!--<script type="text/javascript" src="common/modal-service.js"></script>-->

    <!-- analytics -->
      <script type="text/javascript" src="vendor/angulartics/angulartics.min.js"></script>
      <script type="text/javascript" src="vendor/angulartics/angulartics-ga.js"></script>

    <script>
      (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
          (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
              m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
      })(window,document,'script','//www.google-analytics.com/analytics.js','ga');

      var localID = <?php echo $localID ?>;
      var localName = <?php echo '"' . $localName . '"' ?>;

      var maxRecoveryPoints = <?php echo $maxRecoveryPoints ?>;
      //ga('create', 'UA-59340304-5', gaObj);

      var isCE = <?php echo $isCE ?>;
      var isGoogle = <?php echo $isGoogle ?>;
      var isVirtual = <?php echo $isVirtual ?>;
      var isXenUEB = <?php echo $isXen ?>;
      var isTarget = <?php echo $isTarget ?>;
      var isKumo = <?php echo $isKumo ?>;
      var appName = isCE ? (isGoogle ? "Unitrends Free Google" : "Unitrends Free") : (isVirtual ? "UEB" : "RecoverySeries");
      var trackingCode = isCE ? (isGoogle ? "UA-66229629-2" : "UA-66229629-1") : (isVirtual ? "UA-66229629-3" : "UA-66229629-4");
      var appVersion = <?php echo '"' . $appVersion . '"' ?>;
      var identity = <?php echo '"'. $identity. '"'?>;
      var featureString = <?php echo '"'. $featureString. '"'?>;
      var showWizard = <?php echo $showWizard ?>;
      var showEULA = <?php echo $showEULA ?>;
      var showTour = <?php echo $showTour ?>;
      var showLooselyCoupled = <?php echo $showLooselyCoupled ?>;
      var rdrSupported = <?php echo $rdrSupported ?>;
      var showSLAPolicies = <?php echo $showSLAPolicies ?>;
      var showAHV = <?php echo $showAHV ?>;
      var showArchiving = <?php echo $showArchiving ?>;
      var showRetention = <?php echo $showRetention ?>;
      var defaultLanguage = <?php echo '"' . $defaultLanguage . '"'?>;
      var vmWareReplicasSupported = <?php echo $vmWareReplicasSupported ?>;
      var hypervReplicasSupported = <?php echo $hypervReplicasSupported ?>;

      var gaCode = <?php echo '"' . $assetTag . '"' ?>;
      var gaObj = "auto";
      if (gaCode !== "") {
        gaObj = { 'userId': gaCode };
      }
      ga('create', trackingCode, gaObj);
      ga('set', {
        'appName': appName,
        'appVersion': appVersion
      });
    </script>

        <link rel="stylesheet" href="assets/css/tooltips/tooltipster.css">
        <link rel="stylesheet" href="assets/css/tooltips-custom-style.css">
        <script type="text/javascript" src="vendor/tooltips/jquery.tooltipster.min.js"></script>
      <script type="text/javascript">
        $(document).ready(function() {
              // setTimeout(function(){
				   $('.tooltip').tooltipster({
						theme: 'tooltips-custom-theme'
                });
			  // }, 2000);
         });
</script>
    </head>

  <body ng-class="{ 'intro': !user.loggedIn,
                    'dashboard': user.loggedIn ,
                    'quickSetupWizard': user.loggedIn && (user.showSetupWizFlag || globalPreference.showSetupWizard) }" data-ng-element-ready="bodyIsReady()">

    <!-- intro -->
    <div ng-show="!user.loggedIn" ng-include="'app/login/login.html'"></div>
    <!-- dashboard -->
    <div ng-show="user.loggedIn && !(user.showSetupWizFlag || globalPreference.showSetupWizard)" ng-include="'app.html'" class="app-loggedin" ng-cloak></div>
    <!-- quick setup wizard -->
    <div ng-show="user.loggedIn && (user.showSetupWizFlag || globalPreference.showSetupWizard)" ng-include="'app/quick-setup/quickWizardIndex.html'" ng-cloak></div>

	<!-- this is needed for dialogs and errors -->
    <div id="form-errors"><p class="summary error"></p><ul id="form-error-list" class="errorlist" ng-cloak></ul></div>
    <div id="dialogs" ng-cloak></div>

    <script>
		// TODO:- i18n functions using {% trans - moving to angular-gettext
		function gettext(val) {return val};

		function ngettext(singular, plural, count) {
			var text = (count > 1) ? plural : singular;
			return text;
		}

		/**
		 * Provides python-like string interpolation.
		 * It supports value interpolation either by keys of a dictionary or
		 * by index of an array.
		 *
		 * Examples::
		 *
		 *      interpolate("Hello %s.", ["World"]) == "Hello World."
		 *      interpolate("Hello %(name)s.", {name: "World"}) == "Hello World."
		 *      interpolate("Hello %%.", {name: "World"}) == "Hello %."
		 *
		 * This version doesn't do any type checks and doesn't provide
		 * formating support.
		 */
		function interpolate(s, args) {
			var i = 0;
			return s.replace(/%(?:\(([^)]+)\))?([%diouxXeEfFgGcrs])/g, function (match, v, t) {
				if (t == "%") return "%";
				return args[v || i++];
			});
		}

		// TODO: globals that will eventually be moved into scope and preferences
        var DATE_DISPLAY_FORMAT = "MM/DD/YYYY";
		var performing_maintenance = false;
	</script>

    <!-- init -->
    <script type="text/javascript" src="scripts/constants.js"></script>

	<script>
         var refreshRates = {};
		var DEFAULT_REFRESH = 5000;
        refreshRates.dash_backup_refresh = DEFAULT_REFRESH;
        refreshRates.dash_replication_refresh = DEFAULT_REFRESH;
        refreshRates.dash_restore_refresh = DEFAULT_REFRESH;
        refreshRates.dash_active_job_refresh = DEFAULT_REFRESH;
        refreshRates.dash_alert_refresh = DEFAULT_REFRESH;
        refreshRates.dash_storage_refresh = DEFAULT_REFRESH;
		refreshRates.page_protect_refresh = DEFAULT_REFRESH;
		refreshRates.page_restore_refresh = DEFAULT_REFRESH;
        refreshRates.page_jobs_refresh = DEFAULT_REFRESH;
        refreshRates.dash_forum_posts_refresh = DEFAULT_REFRESH;
        refreshRates.dash_daily_feed_refresh = DEFAULT_REFRESH;
        refreshRates.dash_recovery_assurance_refresh = DEFAULT_REFRESH;

        var global_user = {};
        var licenseClass = <?php echo '"' . $licenseClass . '"' ?>;
        var assetTag = <?php echo '"' . $assetTag . '"' ?>;
        var licenseType = <?php echo '"'. $licenseType . '"'?>;
        var mktString = <?php echo '"'. $mktString .'"'?>;

    </script>

    <!-- Jquery/JqueryUI Plugins -->
    <script type="text/javascript" src="scripts/components/jquery.fns.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.validation.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.scrolltable.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.filtertable.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.sorttable.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.pagetable.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.columnresize.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.wizard.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.popover.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.flyout.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.dragdelta.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.selectmenu.js"></script>
    <script type="text/javascript" src="scripts/components/jquery.multiselect.js"></script>
    <!-- loaded in app.html <script type="text/javascript" src="scripts/common/emailtable.js"></script> -->

   <!-- dashboard Lib -->
    <script type="text/javascript" src="vendor/angular-sanitize/angular-sanitize.js"></script>
    <script type="text/javascript" src="vendor/markdown/markdown.js"></script>
    <script type="text/javascript" src="vendor/lodash/lodash.min.js"></script>
    <script type="text/javascript" src="vendor/showdown/showdown.min.js"></script>
    <script type="text/javascript" src="vendor/sortable/sortable.min.js"></script>
    <script type="text/javascript" src="vendor/ui-bootstrap-tpls/ui-bootstrap-tpls.min.js"></script>

    <script type="text/javascript" src="app/dynamic-dashboard/angular-ui-dashboard.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/dynamicDashboardController.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/dashboard-utils.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/archivesummary/archiveSummaryWidget.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/backup/backupWidget.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/activejobs/activeJobsWidget.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/topforumposts/topForumPostsWidget.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/storage/storageWidget.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/alertDailog/alertsWidget.js"></script>
	<script type="text/javascript" src="app/dynamic-dashboard/dailyfeed/dailyFeedWidget.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/backupCopyTarget/backupCopyTargetWidgetContorller.js"></script>
	<script type="text/javascript" src="app/dynamic-dashboard/topforumposts/dialogvalidations.js"></script>
	<script type="text/javascript" src="app/dynamic-dashboard/networked-appliances/networked-appliances-tile-controller.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/rdr/rdrWidget.js"></script>
    <script type="text/javascript" src="app/dynamic-dashboard/tour/tour-dashboard.js"></script>
    <script type="text/javascript" src="app/protect/tour/tour-protect.js"></script>
    <script type="text/javascript" src="app/recover/tour/tour-recover.js"></script>
    <script type="text/javascript" src="app/jobs/tour/jobs-tour.js"></script>
    <script type="text/javascript" src="app/reports/tour/reports-tour.js"></script>
    <script type="text/javascript" src="app/configure/tour/tour-config.js"></script>
	<script type="text/javascript" src="app/configure/appliances/replicationThrottleController.js"></script>
    <script type="text/javascript" src="app/configure/appliances/BackupCopyOptionDialogController.js"></script>
    <script type="text/javascript" src="app/configure/backupcopy/BackupCopyConfigController.js"></script>
    <script type="text/javascript" src="app/configure/appliances/add-appliance.js"></script>
    <script type="text/javascript" src="app/configure/storage/cifs/dialog.cifs.js"></script>
    <script type="text/javascript" src="app/configure/storage/nfs/dialog.nfs.js"></script>
    <script type="text/javascript" src="app/configure/storage/iscsi/dialog.iscsi.js"></script>
    <script type="text/javascript" src="app/configure/storage/fc/dialog.fc.js"></script>
    <script type="text/javascript" src="app/configure/credentials/dialog.config-credentials.js"></script>
	<script type="text/javascript" src="app/protect/file-browser-dialog/fileBrowserDialogTemplateController.js"></script>
	<script type="text/javascript" src="app/protect/groups/dialog.groups.js"></script>
	<script type="text/javascript" src="app/dynamic-dashboard/backupCopy/backupCopyWidgetContorller.js"></script>
	<script type="text/javascript" src="app/dynamic-dashboard/recovery/recoverTileContorller.js"></script>
    <script type="text/javascript" src="app/recover/wir/windowRecoveryController.js"></script>
    <script type="text/javascript" src="app/recover/flr/flrRecoveryController.js"></script>
	<script type="text/javascript" src="app/recover/recoveryController.js"></script>
    <script type="text/javascript" src="app/configure/appliances/editNonManagedResourceApplianceController.js"></script>
	<script type="text/javascript" src="app/dynamic-dashboard/backupCopyStorage/backupCopyStorageWidgetContorller.js"></script>
    <script type="text/javascript" src="app/configure/environments/EditAssetScript.js"></script>
    <script type="text/javascript" src="app/configure/environments/AddAssetScript.js"></script>
    <script type="text/javascript" src="app/configure/environments/AssetService.js"></script>
    <script type="text/javascript" src="app/configure/environments/AddCiscoUCSScript.js"></script>
    <script type="text/javascript" src="app/configure/environments/CiscoUCSService.js"></script>
    <script type="text/javascript" src="app/recover/filerecovery/fileLevelRecoveryController.js"></script>
    <script type="text/javascript" src="app/recover/filerecovery/searchFLR/searchFLRController.js"></script>
    <script type="text/javascript" src="app/configure/retention/min-max-config.js"></script>
    <script type="text/javascript" src="app/configure/environments/multipleErrorController.js"></script>
    <script type="text/javascript" src="app/configure/backupcopy/media/media-handler.js"></script>
    <script type="text/javascript" src="app/options/dialog.updates.js"></script>
    <script type="text/javascript" src="app/configure/environments/dialog.hypervisor.js"></script>
    <script type="text/javascript" src="app/configure/environments/addEditNasModuleController.js"></script>
    <script type="text/javascript" src="app/configure/global-vm-settings/global-vm-settings.js"></script>
    <script type="text/javascript" src="app/configure/advanced-toolbox/dialog.toolbox.js"></script>
    <script type="text/javascript" src="app/configure/active-directory/dialog.active-directory.js"></script>
    <script type="text/javascript" src="app/configure/os-password/dialog.os-password.js"></script>
    <script type="text/javascript" src="app/configure/iscsi-chap/dialog.iscsi-chap.js"></script>
    <script type="text/javascript" src="app/configure/replica-config/dialog.replica-config.js"></script>
    <script type="text/javascript" src="app/configure/advanced-settings/dialog.advanced-settings.js"></script>
    <script type="text/javascript" src="app/configure/networks/hosts/dialog.hosts-file.js"></script>
    <script type="text/javascript" src="app/configure/backupcopy/appliance/editFromSource.js"></script>
    <script type="text/javascript" src="app/configure/networks/ports/dialog.ports.js"></script>
    <script type="text/javascript" src="app/configure/networks/dialog.nic.js"></script>
    <script type="text/javascript" src="app/configure/notifications/snmp/dialog.snmp.js"></script>
    <script type="text/javascript" src="app/configure/license/resources.js"></script>
    <script type="text/javascript" src="app/configure/appliances/dialog.shutdown-restart.js"></script>
    <script type="text/javascript" src="app/reports/details/dialog.backup-drilldown.js"></script>
    <script type="text/javascript" src="app/resolution/resolution.js"></script>
    <script type="text/javascript" src="app/configure/interactions/dialog.interactions.js"></script>
    <script type="text/javascript" src="app/configure/users/roles/roles-access-module.js"></script>
    <script type="text/javascript" src="app/configure/users/edit.js"></script>
    <script type="text/javascript" src="app/configure/san-direct/san-direct-module.js"></script>
    <script type="text/javascript" src="app/joborders/certify-backups/certifyBackupJobController.js"></script>
    <script type="text/javascript" src="app/joborders/failover/failoverJobController.js"></script>
    <script type="text/javascript" src="app/joborders/certify-backups/dialog.config-profiles.js"></script>
    <script type="text/javascript" src="app/joborders/certify-backups/reconfigureIPController.js"></script>
    <script type="text/javascript" src="app/joborders/certify-backups/certifyJobDetailsController.js"></script>
    <script type="text/javascript" src="app/protect/sla-policy/sla-policy-module.js"></script>
    <script type="text/javascript" src="app/reports/services/report_details.js"></script>
    <script type="text/javascript" src="app/preferences/user-preferences.js"></script>
    <script type="text/javascript" src="app/preferences/language_select.js"></script>
    <script type="text/javascript" src="app/release-notes/release-notes.js"></script>
  </body>
</html>
