(function($, undefined) {

    $.widget("phd.multiselect", {
        options: {
            widgetClass: '',
            zIndex: 2000,
        },

        _create: function() {
            var self = this,
                options = self.options,
                defaultClass = 'ui-multiselect';

            this.multiselect = $("<ul>", {
                "class": defaultClass + " " + this.options.widgetClass
            });

            this._selectOptions = this.element.find("option").detach();

            this._newOptions = this._createOptions();

            this.multiselect.html(this._newOptions).insertAfter(this.element.hide());

            this.multiselect.on("change", "input", function() {
                $(this).closest("li").toggleClass("ui-multiselect-selected", $(this).prop("checked"));
            });
        },

        _createOptions: function() {
            var $el = this.element;
            return this._selectOptions.map(function() {
                var $option = $(this),
                    checked = $option.is(":selected") ? "checked " : "",
                    item = checked ? " ui-multiselect-selected" : "",
                    label = '<label class="ui-multiselect-label">'
                    input = '<input type="checkbox" '+checked+'value="'+$option.val()+'" name="'+$el.attr("name")+'">';

                return '<li class="ui-multiselect-item'+item+'">'+label+input+$option.text()+'</label></li>';
            }).get().join("");
        },

        widget: function() {
            return this.multiselect;
        },
        
        destroy: function() {
            this._selectOptions.appendTo(this.element);
        },

    });

}(jQuery));