var TreeViewData, nodeTmpl, headerTmpl, childTmpl, 
    checkboxes = true,
    output = "",
    INV_TYPE_UNIVERSE           = 8,
    INV_TYPE_LOOKUP = {};


// Inventory ID - System Nodes
var INVENTORY_ID_SYSTEM = 1001;
var INVENTORY_ID_NAVGROUP = 1002;

// Inventory ID - Client Nodes
var INVENTORY_ID_CLIENT_AIX       = 2001;
var INVENTORY_ID_CLIENT_DOS       = 2002;
var INVENTORY_ID_CLIENT_FREE_BSD  = 2003;
var INVENTORY_ID_CLIENT_HPUX      = 2004;
var INVENTORY_ID_CLIENT_I_SERIES  = 2005;
var INVENTORY_ID_CLIENT_LINUX     = 2006;
var INVENTORY_ID_CLIENT_MAC       = 2007;
var INVENTORY_ID_CLIENT_NETWARE   = 2008;
var INVENTORY_ID_CLIENT_OES       = 2009;
var INVENTORY_ID_CLIENT_OS2       = 2010;
var INVENTORY_ID_CLIENT_SGI       = 2011;
var INVENTORY_ID_CLIENT_SCO       = 2012;
var INVENTORY_ID_CLIENT_SOLARIS   = 2013;
var INVENTORY_ID_CLIENT_UNIX      = 2014;
var INVENTORY_ID_CLIENT_WINDOWS   = 2015;
var INVENTORY_ID_CLIENT_OTHER     = 2016;

// Inventory ID - Cisco UCS Nodes
var INVENTORY_ID_CISCO_UCS_CLIENT             = 101001;
var INVENTORY_ID_CISCO_UCS_SERVICE_PROFILE    = 101002;

// Inventory ID - Exchange Nodes
var INVENTORY_ID_EXCHANGE_APPLICATION     = 102001;
var INVENTORY_ID_EXCHANGE_DATABASE        = 102002;

// Inventory ID - Hyper-V Nodes
var INVENTORY_ID_HYPER_V_SERVER           = 201002;  //Application Node
var INVENTORY_ID_HYPER_V_VM               = 201003;
var INVENTORY_ID_HYPER_V_WIR_VM           = 201007;

// Inventory ID - Oracle Nodes
var INVENTORY_ID_ORACLE_APPLICATION      = 104001;
var INVENTORY_ID_ORACLE_DATABASE         = 104002;

// Inventory ID - SharePoint Nodes
var INVENTORY_ID_SHAREPOINT_APPLICATION   = 105001;
var INVENTORY_ID_SHAREPOINT_FARM          = 105002;

// Inventory ID - SQL Nodes
var INVENTORY_ID_SQL_SERVER               = 106003; //Application Node
var INVENTORY_ID_SQL_DATABASE             = 106004;
var INVENTORY_ID_SQL_INSTANCE             = 106006;

// Inventory ID - NDMP Nodes
var INVENTORY_ID_NDMP_CLIENT              = 103001;
var INVENTORY_ID_NDMP_VOLUME              = 103002;

// Inventory ID - VMware Nodes
var INVENTORY_ID_VMWARE_CLUSTER           = 202004;
var INVENTORY_ID_VMWARE_ESX_SERVER        = 202005;
var INVENTORY_ID_VMWARE_FOLDER            = 202006;
var INVENTORY_ID_VMWARE_RESOURCE_POOL     = 202007;
var INVENTORY_ID_VMWARE_V_APP             = 202008;
var INVENTORY_ID_VMWARE_VM                = 202009;
var INVENTORY_ID_VMWARE_TEMPLATE          = 202010;
var INVENTORY_ID_VMWARE_VM_DISK           = 202011;
var INVENTORY_ID_VMWARE_WIR_VM            = 202012;

//XEN
var INVENTORY_ID_XEN_POOL_MASTER          = 203001;
var INVENTORY_ID_XEN_STANDALONE_SERVER    = 203002;
var INVENTORY_ID_XEN_SERVER_IN_A_POOL     = 203003;
var INVENTORY_ID_XEN_VM                   = 203007;
var INVENTORY_ID_XEN_VM_DISK              = 203008;
var INVENTORY_ID_XEN_CUSTOM_TEMPLATE      = 203009;

//AHV
var INVENTORY_ID_AHV_CLUSTER              = 204001;
var INVENTORY_ID_AHV_VM                   = 204002;
var INVENTORY_ID_AHV_VM_DISK              = 203003;

// Inventory Type Family
var INVENTORY_TYPE_FAMILY_SYSTEM      = 1000;
var INVENTORY_TYPE_FAMILY_CLIENT      = 2000;
var INVENTORY_TYPE_FAMILY_CISCO_UCS   = 101000;
var INVENTORY_TYPE_FAMILY_EXCHANGE    = 102000;
var INVENTORY_TYPE_FAMILY_HYPER_V     = 201000;
var INVENTORY_TYPE_FAMILY_ORACLE      = 104000;
var INVENTORY_TYPE_FAMILY_SHAREPOINT  = 105000;
var INVENTORY_TYPE_FAMILY_SQL         = 106000;
var INVENTORY_TYPE_FAMILY_VMWARE      = 202000;
var INVENTORY_TYPE_FAMILY_XEN         = 203000;
var INVENTORY_TYPE_FAMILY_AHV         = 204000;
var INVENTORY_TYPE_FAMILY_NDMP        = 103000;

    INV_TYPE_LOOKUP[INVENTORY_ID_SYSTEM] = ["icon-uui-unitrends-appliance2", "Appliance"];
    INV_TYPE_LOOKUP[INVENTORY_ID_NAVGROUP] = ["icon-hv-folder", "Group"];

    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_OTHER] = ["icon-uui-agent-asset", "Compute Resource"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_WINDOWS] = ["icon-uui-agent-asset-win", "Windows"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_LINUX] = ["icon-uui-agent-asset", "Linux"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_AIX] = ["icon-uui-agent-asset", "AIX"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_DOS] = ["icon-uui-agent-asset", "DOS"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_FREE_BSD] = ["icon-uui-agent-asset", "Free BSD"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_HPUX] = ["icon-uui-agent-asset", "HP/UX"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_I_SERIES] = ["icon-uui-agent-asset", "iSeries"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_MAC] = ["icon-uui-agent-asset", "Mac"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_NETWARE] = ["icon-uui-agent-asset", "Netware"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_OES] = ["icon-uui-agent-asset", "OES"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_OS2] = ["icon-uui-agent-asset", "OS/2"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_SGI] = ["icon-uui-agent-asset", "SGI"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_SCO] = ["icon-uui-agent-asset", "SCO"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_SOLARIS] = ["icon-uui-agent-asset", "Solaris"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_UNIX] = ["icon-uui-agent-asset", "Unix"];

    INV_TYPE_LOOKUP[INVENTORY_ID_CISCO_UCS_SERVICE_PROFILE] = ["icon-ram", "UCS Service Profile"];

    INV_TYPE_LOOKUP[INVENTORY_ID_EXCHANGE_APPLICATION] = ["icon-uui-exchange-instance", "Exchange"];
    INV_TYPE_LOOKUP[INVENTORY_ID_EXCHANGE_DATABASE] = ["icon-uui-exchange-db", "Database"];

    INV_TYPE_LOOKUP[INVENTORY_ID_HYPER_V_SERVER] = ["icon-uui-hyperv-instance", "Host"];
    INV_TYPE_LOOKUP[INVENTORY_ID_HYPER_V_VM] = ["icon-uui-hyperv-vm", "Virtual Machine"];

    INV_TYPE_LOOKUP[INVENTORY_ID_SQL_SERVER] = ["icon-uui-sql-instance", "SQL Server"];
    INV_TYPE_LOOKUP[INVENTORY_ID_SQL_DATABASE] = ["icon-uui-sql-db", "Database"];
    INV_TYPE_LOOKUP[INVENTORY_ID_SQL_INSTANCE] = ["icon-uui-sql-instance", "Instance"];

    INV_TYPE_LOOKUP[INVENTORY_ID_ORACLE_APPLICATION] = ["icon-uui-oracle-instance", "Oracle"];
    INV_TYPE_LOOKUP[INVENTORY_ID_ORACLE_DATABASE] = ["icon-uui-oracle-db", "Database"];

    INV_TYPE_LOOKUP[INVENTORY_ID_SHAREPOINT_APPLICATION] = ["icon-uui-sharepoint-instance", "Sharepoint"];
    INV_TYPE_LOOKUP[INVENTORY_ID_SHAREPOINT_FARM] = ["icon-uui-sharepoint-db", "Farm"];

    INV_TYPE_LOOKUP[INVENTORY_ID_NDMP_CLIENT] = ["icon-uui-agent-asset", "NDMP"];
    INV_TYPE_LOOKUP[INVENTORY_ID_NDMP_VOLUME] = ["icon-database", "Volume"];

    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_CLUSTER] = ["icon-hv-cluster", "Cluster"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_VM_DISK] = ["icon-hv-drive", "Disk"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_VM] = ["icon-uui-vmware-vm", "Virtual Machine"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_FOLDER] = ["icon-hv-folder", "Folder"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_RESOURCE_POOL] = ["icon-uui-vmware-pool", "Resource Pool"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_V_APP] = ["icon-uui-vmware-vapp", "vApp"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_ESX_SERVER] = ["icon-uui-vmware-server", "Host"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_TEMPLATE] = ["icon-uui-vmware-template", "Template"];

    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_POOL_MASTER] = ["icon-hv-cluster", "Pool Master"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_VM_DISK] = ["icon-hv-drive", "Disk"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_VM] = ["icon-uui-citrix-vm", "Virtual Machine"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_STANDALONE_SERVER] = ["icon-uui-citrix-server", "Host"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_SERVER_IN_A_POOL] = ["icon-uui-citrix-server", "Host"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_CUSTOM_TEMPLATE] = ["icon-uui-citrix-template", "Template"];

    INV_TYPE_LOOKUP[INVENTORY_ID_AHV_CLUSTER] = ["icon-hv-cluster", "AHV Cluster"];
    INV_TYPE_LOOKUP[INVENTORY_ID_AHV_VM_DISK] = ["icon-hv-drive", "Disk"];
    INV_TYPE_LOOKUP[INVENTORY_ID_AHV_VM] = ["icon-uui-nutanix-x", "Virtual Machine"];

    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_SYSTEM] = ["icon-uui-unitrends-appliance2", "Appliance"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_CLIENT] = ["icon-uui-agent-asset", "Server"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_CISCO_UCS] = ["icon-ram", "UCS Service Profile"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_EXCHANGE] = ["icon-uui-exchange-instance", "Exchange"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_HYPER_V] = ["icon-uui-hyperv-instance", "Hyper-V"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_SHAREPOINT] = ["icon-uui-sharepoint-instance", "Sharepoint"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_SQL]= ["icon-uui-sql-instance", "SQL Server"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_VMWARE] = ["icon-uui-vmware-server", "VMware"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_NDMP] = ["icon-uui-agent-asset", "NDMP Device"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_AHV] = ["icon-uui-agent-asset", "AHV"];
    INV_TYPE_LOOKUP[INV_TYPE_UNIVERSE] = ["icon-hv-universe", "Global"];

self.addEventListener('message', function(e) {
    importScripts('../../vendor/underscore/underscore-min.js');
    initTemplates();
    var root;
    // Morph the inventory based on how many nodes are returned.
    if (e.data.inventory != null && e.data.inventory.length > 0) {
        if (e.data.inventory.length == 1) {
            root = e.data.inventory[0];
        } else {
            root = { "type_family": 0, "id": "0_0", "name": "Global", "type": INV_TYPE_UNIVERSE, "nodes": e.data.inventory};
        }
    } else {
        root = { "type_family": 0, "id": "0_0", "name": "Empty", "type": INV_TYPE_UNIVERSE, "nodes": []};
    }

    TreeViewData = root;
    // driven by protect vs restore.  On protect, false.
    //checkboxes = e.data.inventory.checkboxes;
    checkboxes = e.data.checkboxes;
    output = render({ "node": TreeViewData, "children": (TreeViewData.nodes !== null) }, 0);
    self.postMessage({
        "html": output,
        "tree": TreeViewData
    });
}, false);

function render(item, depth, last, dots) {
    var html = "",
        last = (typeof last === 'undefined') ? true : last,
        dots = (typeof dots === 'undefined') ? [] : dots;

    //console.log("item = " + JSON.stringify(item));
    item.node.depth = depth;
    item.node.t = nodeType(item.node.type);
   // console.log("item.node.type = " + item.node.type);
    item.node.type = [item.node.type, INV_TYPE_LOOKUP[item.node.type][0], INV_TYPE_LOOKUP[item.node.type][1]];
    item.node.dots = dots;
    item.last = last;

    /*
     * If an item defines a color, use it, otherwise use the standard colors.
     */
    item.node.color = false;
    if (item.node.group !== undefined && item.node.group['@attributes'] !== undefined && item.node.group['@attributes']['color'] !== undefined) {
        item.node.color = item.node.group['@attributes']['color'];
    }

    // setting up properties for SQL clusters and SQL availability groups
    if (item.node.is_sql_cluster !== undefined && item.node.is_sql_cluster !== false) {
        item.node.sql_type = "SQL Cluster";
    } else if (item.node.is_sql_alwayson !== undefined && item.node.is_sql_alwayson !== false) {
        item.node.sql_type = "SQL Availability Group";
    } else {
        item.node.sql_type = "";
    }

    // Don't show checkbox on Universe node.
    item.checkboxes = (checkboxes && (item.node.type_family != 0));

    item.node.cache = "";

    item.node.cache += nodeTmpl(item.node);

    item.node.cache += headerTmpl(item);

    html += item.node.cache;

    if(item.node.nodes) {
        var childContainer = childTmpl({expand: (!depth)});
        html += childContainer;
        item.node.cache += (childContainer + "</div>");
        dots = buildDots(item, dots.slice(0,depth), depth);
        _.each(item.node.nodes, function(value, index, arr) {
            var last = (arr.length - index === 1);
            html += render({
                "node":value, 
                "children": (value.nodes !== null && value.nodes.length > 0),   // null or empty array means no children.
                "last": last
            }, depth+1, last, dots);
        });
        html += "</div>";
    }

    item.node.cache += "</div>";
    html += "</div>";
    return html;
}

function initTemplates() {
    // if the disk is excluded, start the display this way.
    nodeTmpl = _.template(
    '<div class="checkable<% if(!type_family || type_family == INVENTORY_TYPE_FAMILY_SYSTEM) { %> tree-universe<% } else if (type[0] == INVENTORY_ID_VMWARE_VM_DISK && is_excluded) { %> expl-excluded<% } %>" data-dbid="<%= id %>" data-node="<%= t %>" data-type="<%= type[0] %>">'
    );

    headerTmpl = _.template(
        '<div class="header clearfix">' +
        '<% for(var i=0;i<(node.depth-1);i++) { %><i class="dots <%= node.dots[i] %>"></i><% } %>' +
        '   <% if (last && node.depth) { %><i class="dots last"></i><% } else if(node.depth) { %><i class="dots full"></i><% } %>' +
        '   <% if (children) { %><i class="expand-ctrl<% if(!node.depth){ %> expanded<% } %>"></i><% } else { %><i class="dots straight"></i><% } %>' +
        '   <% if (checkboxes) { %><i class="checkbox"></i><% } %>' +
        '   <% if (node.color) { %>' +
        '   <i class="<%= node.type[1] %> icon" alt="<%= node.type[2] %>" title="<%= node.type[2] %>" style="color:<%= node.color %>"></i>' +
        '   <% } else { %>' +
        '   <i class="<%= node.type[1] %> icon" alt="<%= node.type[2] %>" title="<%= node.type[2] %>"></i>' +
        '   <% } %>' +
        '   <span class="item-name" <% if (node.sql_type && node.sql_type != "") { %> title="<%= node.sql_type %>" <% } %> ><%= node.name %></span>' +
        '</div>'
        );

    childTmpl = _.template(
        '<div class="children<% if(expand) { %> open<% } %>">'
        );
}

function buildDots(parent, dots, depth) {
    if(dots.length < depth) {
        if(parent.last) {
            dots.push("no-fill");
        }
        else {
            dots.push("left");
        }
    }
    return dots;
}

function nodeType(t) {
    var type = "container";
    switch (t) {
        case INVENTORY_ID_VMWARE_VM:
        case INVENTORY_ID_VMWARE_TEMPLATE:
        case INVENTORY_ID_XEN_VM:
        case INVENTORY_ID_XEN_CUSTOM_TEMPLATE:
        case INVENTORY_ID_HYPER_V_VM:
        case INVENTORY_ID_AHV_VM:
            type = "vm";
            break;
        case INVENTORY_ID_VMWARE_VM_DISK:
        case INVENTORY_ID_XEN_VM_DISK:
        case INVENTORY_ID_AHV_VM_DISK:
            type = "disk";
            break;
        default:
            break;
    }
    return type;
}
